"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var os_1 = require("os");
var parseArgv_1 = __importDefault(require("./utils/parseArgv"));
var program = (0, parseArgv_1.default)([], ['config']);
function findConfig() {
    var e_1, _a;
    var foundConfig;
    var envConfigPath = process.env.BITCORE_CONFIG_PATH;
    var argConfigPath = program.config;
    var configFileName = 'bitcore.config.json';
    var bitcoreConfigPaths = [
        "".concat((0, os_1.homedir)(), "/").concat(configFileName),
        "../../../../".concat(configFileName),
        "../../".concat(configFileName)
    ];
    var overrideConfig = argConfigPath || envConfigPath;
    if (overrideConfig) {
        bitcoreConfigPaths.unshift(overrideConfig);
    }
    try {
        // No config specified. Search home, bitcore and cur directory
        for (var bitcoreConfigPaths_1 = __values(bitcoreConfigPaths), bitcoreConfigPaths_1_1 = bitcoreConfigPaths_1.next(); !bitcoreConfigPaths_1_1.done; bitcoreConfigPaths_1_1 = bitcoreConfigPaths_1.next()) {
            var path = bitcoreConfigPaths_1_1.value;
            if (!foundConfig) {
                try {
                    var expanded = path[0] === '~' ? path.replace('~', (0, os_1.homedir)()) : path;
                    var bitcoreConfig = require(expanded);
                    foundConfig = bitcoreConfig.bitcoreNode;
                }
                catch (e) {
                    foundConfig = undefined;
                }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (bitcoreConfigPaths_1_1 && !bitcoreConfigPaths_1_1.done && (_a = bitcoreConfigPaths_1.return)) _a.call(bitcoreConfigPaths_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return foundConfig;
}
function setTrustedPeers(config) {
    var e_2, _a, e_3, _b;
    try {
        for (var _c = __values(Object.entries(config)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var _e = __read(_d.value, 2), chain = _e[0], chainObj = _e[1];
            try {
                for (var _f = (e_3 = void 0, __values(Object.keys(chainObj))), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var network = _g.value;
                    var env = process.env;
                    var envString = "TRUSTED_".concat(chain.toUpperCase(), "_").concat(network.toUpperCase(), "_PEER");
                    if (env[envString]) {
                        var peers = config.chains[chain][network].trustedPeers || [];
                        peers.push({
                            host: env[envString],
                            port: env["".concat(envString, "_PORT")]
                        });
                        config.chains[chain][network].trustedPeers = peers;
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return config;
}
var Config = function () {
    var config = {
        maxPoolSize: 50,
        port: 3000,
        dbUrl: process.env.DB_URL || '',
        dbHost: process.env.DB_HOST || '127.0.0.1',
        dbName: process.env.DB_NAME || 'bitcore',
        dbPort: process.env.DB_PORT || '27017',
        dbUser: process.env.DB_USER || '',
        dbPass: process.env.DB_PASS || '',
        numWorkers: (0, os_1.cpus)().length,
        chains: {},
        modules: ['./bitcoin', './bitcoin-cash', './ethereum'],
        services: {
            api: {
                rateLimiter: {
                    disabled: false,
                    whitelist: ['::ffff:127.0.0.1', '::1']
                },
                wallets: {
                    allowCreationBeforeCompleteSync: false,
                    allowUnauthenticatedCalls: false
                }
            },
            event: {
                onlyWalletEvents: false
            },
            p2p: {},
            socket: {
                bwsKeys: []
            },
            storage: {}
        }
    };
    var foundConfig = findConfig();
    var mergeCopyArray = function (objVal, srcVal) { return (objVal instanceof Array ? srcVal : undefined); };
    config = _.mergeWith(config, foundConfig, mergeCopyArray);
    if (!Object.keys(config.chains).length) {
        Object.assign(config.chains, {
            BTC: {
                mainnet: {
                    chainSource: 'p2p',
                    trustedPeers: [{ host: '127.0.0.1', port: 8333 }],
                    rpc: {
                        host: '127.0.0.1',
                        port: 8332,
                        username: 'bitcoin',
                        password: 'bitcoin'
                    }
                }
            }
        });
    }
    config = setTrustedPeers(config);
    return config;
};
exports.default = Config();
//# sourceMappingURL=config.js.map