"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggifyObject = exports.LoggifyFunction = exports.LoggifyClass = exports.SavePerformance = exports.PerformanceTracker = void 0;
var util_1 = __importDefault(require("util"));
var logger_1 = __importDefault(require("../logger"));
var parseArgv_1 = __importDefault(require("../utils/parseArgv"));
exports.PerformanceTracker = {};
var args = (0, parseArgv_1.default)([], [{ arg: 'DEBUG', type: 'bool' }]);
function SavePerformance(logPrefix, startTime, endTime) {
    var totalTime = endTime.getTime() - startTime.getTime();
    if (!exports.PerformanceTracker[logPrefix]) {
        exports.PerformanceTracker[logPrefix] = {
            time: totalTime,
            count: 1,
            avg: totalTime,
            max: totalTime
        };
    }
    else {
        exports.PerformanceTracker[logPrefix].time += totalTime;
        exports.PerformanceTracker[logPrefix].count++;
        exports.PerformanceTracker[logPrefix].avg = exports.PerformanceTracker[logPrefix].time / exports.PerformanceTracker[logPrefix].count;
        exports.PerformanceTracker[logPrefix].max = Math.max(totalTime, exports.PerformanceTracker[logPrefix].max);
    }
}
exports.SavePerformance = SavePerformance;
function LoggifyClass(aClass) {
    if (!args.DEBUG) {
        return aClass;
    }
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var e_1, _a;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spreadArray([], __read(args), false)) || this;
            logger_1.default.debug("Loggifying ".concat(aClass.name, " with args:: ").concat(util_1.default.inspect(args)));
            try {
                for (var _b = __values(Object.getOwnPropertyNames(aClass.prototype)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var prop = _c.value;
                    if (typeof _this[prop] === 'function') {
                        logger_1.default.debug("Loggifying  ".concat(aClass.name, "::").concat(prop));
                        _this[prop] = LoggifyFunction(_this[prop], "".concat(aClass.name, "::").concat(prop), _this);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return _this;
        }
        return class_1;
    }(aClass));
}
exports.LoggifyClass = LoggifyClass;
function LoggifyFunction(fn, logPrefix, bind) {
    if (logPrefix === void 0) { logPrefix = ''; }
    if (!args.DEBUG) {
        return fn;
    }
    var copy = fn;
    if (bind) {
        copy = copy.bind(bind);
    }
    return function () {
        var methodargs = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            methodargs[_i] = arguments[_i];
        }
        var startTime = new Date();
        logger_1.default.debug("".concat(logPrefix, "::called::"));
        var returnVal = copy.apply(void 0, __spreadArray([], __read(methodargs), false));
        if (returnVal && returnVal.then) {
            returnVal
                .catch(function (err) {
                logger_1.default.error("".concat(logPrefix, "::catch::").concat(err));
            })
                .then(function (data) {
                logger_1.default.debug("".concat(logPrefix, "::resolved::"));
                SavePerformance(logPrefix, startTime, new Date());
                return data;
            });
        }
        else {
            SavePerformance(logPrefix, startTime, new Date());
            logger_1.default.debug("".concat(logPrefix, "::returned::"));
        }
        return returnVal;
    };
}
exports.LoggifyFunction = LoggifyFunction;
function LoggifyObject(obj, logPrefix, bind) {
    var e_2, _a;
    if (logPrefix === void 0) { logPrefix = ''; }
    if (!args.DEBUG) {
        return obj;
    }
    try {
        for (var _b = __values(Object.getOwnPropertyNames(obj)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var prop = _c.value;
            if (typeof obj[prop] === 'function') {
                var copy = obj[prop];
                if (bind) {
                    copy = copy.bind(bind);
                }
                logger_1.default.debug("Loggifying  ".concat(logPrefix, "::").concat(prop));
                obj[prop] = LoggifyFunction(obj[prop], "".concat(logPrefix, "::").concat(prop), bind);
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return obj;
}
exports.LoggifyObject = LoggifyObject;
//# sourceMappingURL=Loggify.js.map