"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.timestamp = exports.formatTimestamp = void 0;
var winston = __importStar(require("winston"));
var parseArgv_1 = __importDefault(require("./utils/parseArgv"));
var args = (0, parseArgv_1.default)([], [{ arg: 'DEBUG', type: 'bool' }]);
var logLevel = args.DEBUG ? 'debug' : (process.env.BCN_LOG_LEVEL || 'info');
var logger = winston.createLogger({
    transports: [
        new winston.transports.Console({
            level: logLevel,
        })
    ],
    format: winston.format.combine(winston.format.colorize(), winston.format.prettyPrint(), winston.format.splat(), winston.format.simple(), winston.format.printf(function (info) {
        // fallback in case the above formatters  don't work.
        // eg: logger.log({ some: 'object' })
        if (typeof info.message === 'object') {
            info.message = JSON.stringify(info.message, null, 4);
        }
        return "".concat(info.level, " :: ").concat(new Date().toISOString(), " :: ").concat(info.message);
    }))
});
var timezone = new Date()
    .toLocaleString('en-US', { timeZoneName: 'short' })
    .split(' ')
    .pop();
var formatTimestamp = function (date) {
    return "".concat(date.getFullYear(), "-").concat((date.getMonth() + 1).toString().padStart(2, '0'), "-").concat(date
        .getDate()
        .toString()
        .padStart(2, '0'), " ").concat(date
        .getHours()
        .toString()
        .padStart(2, '0'), ":").concat(date
        .getMinutes()
        .toString()
        .padStart(2, '0'), ":").concat(date
        .getSeconds()
        .toString()
        .padStart(2, '0'), ".").concat(date
        .getMilliseconds()
        .toString()
        .padEnd(3, '0'), " ").concat(timezone);
};
exports.formatTimestamp = formatTimestamp;
var timestamp = function () { return (0, exports.formatTimestamp)(new Date()); };
exports.timestamp = timestamp;
exports.default = logger;
//# sourceMappingURL=logger.js.map