"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseTransaction = void 0;
var storage_1 = require("../services/storage");
var base_1 = require("./base");
var BaseTransaction = /** @class */ (function (_super) {
    __extends(BaseTransaction, _super);
    function BaseTransaction(storage) {
        var _this = _super.call(this, 'transactions', storage) || this;
        _this.allowedPaging = [
            { key: 'blockHash', type: 'string' },
            { key: 'blockHeight', type: 'number' },
            { key: 'blockTimeNormalized', type: 'date' },
            { key: 'txid', type: 'string' }
        ];
        return _this;
    }
    BaseTransaction.prototype.onConnect = function () {
        this.collection.createIndex({ txid: 1 }, { background: true });
        this.collection.createIndex({ chain: 1, network: 1, blockHeight: 1 }, { background: true });
        this.collection.createIndex({ blockHash: 1 }, { background: true });
        this.collection.createIndex({ chain: 1, network: 1, blockTimeNormalized: 1 }, { background: true });
        this.collection.createIndex({ wallets: 1, blockTimeNormalized: 1 }, { background: true, partialFilterExpression: { 'wallets.0': { $exists: true } } });
        this.collection.createIndex({ wallets: 1, blockHeight: 1 }, { background: true, partialFilterExpression: { 'wallets.0': { $exists: true } } });
    };
    BaseTransaction.prototype.getTransactions = function (params) {
        var originalQuery = params.query;
        var _a = storage_1.Storage.getFindOptions(this, params.options), query = _a.query, options = _a.options;
        var finalQuery = Object.assign({}, originalQuery, query);
        return this.collection.find(finalQuery, options).addCursorFlag('noCursorTimeout', true);
    };
    BaseTransaction.prototype.toMempoolSafeUpsert = function (mongoOp, height) {
        if (height >= 0 /* SpentHeightIndicators.minimum */) {
            return mongoOp;
        }
        else {
            var update = mongoOp.updateOne.update;
            return {
                updateOne: {
                    filter: mongoOp.updateOne.filter,
                    update: {
                        $setOnInsert: __assign(__assign({}, (update.$set && update.$set)), (update.$setOnInsert && update.$setOnInsert))
                    },
                    upsert: true,
                    forceServerObjectId: true
                }
            };
        }
    };
    return BaseTransaction;
}(base_1.BaseModel));
exports.BaseTransaction = BaseTransaction;
//# sourceMappingURL=baseTransaction.js.map