"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CacheStorage = exports.CacheModel = void 0;
var middleware_1 = require("../routes/middleware");
var base_1 = require("./base");
var CacheModel = /** @class */ (function (_super) {
    __extends(CacheModel, _super);
    function CacheModel(storage) {
        var _this = _super.call(this, 'cache', storage) || this;
        _this.Times = {
            None: 0,
            Second: 1 * 1000,
            Minute: 60 * 1000,
            Hour: middleware_1.CacheTimes.Minute * 60 * 1000,
            Day: middleware_1.CacheTimes.Hour * 24 * 1000,
            Month: middleware_1.CacheTimes.Day * 30 * 1000,
            Year: middleware_1.CacheTimes.Day * 365 * 1000
        };
        _this.allowedPaging = [];
        return _this;
    }
    CacheModel.prototype.onConnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.createIndex({ key: 1, wallet: 1 }, { background: true, unique: true })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CacheModel.prototype.expire = function (key, wallet) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.updateOne({ key: key, wallet: wallet }, { $set: { expireTime: 0 } })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CacheModel.prototype.setGlobal = function (key, value, cacheTime) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.updateOne({ key: key }, { $set: { value: value, created: Date.now(), expireTime: cacheTime } }, { upsert: true })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CacheModel.prototype.setForWallet = function (wallet, key, value, cacheTime) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.updateOne({ wallet: wallet, key: key }, { $set: { value: value, created: Date.now(), expireTime: cacheTime } }, { upsert: true })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CacheModel.prototype.getGlobal = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var found;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.findOne({ key: key, wallet: undefined })];
                    case 1:
                        found = _a.sent();
                        if (!found) {
                            return [2 /*return*/, null];
                        }
                        if (found.created + found.expireTime >= Date.now()) {
                            // cache hit
                            return [2 /*return*/, found.value];
                        }
                        else {
                            // cache miss
                            this.collection.remove({ _id: found._id });
                            return [2 /*return*/, null];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    CacheModel.prototype.getForWallet = function (wallet, key) {
        return __awaiter(this, void 0, void 0, function () {
            var found;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.findOne({ wallet: wallet, key: key })];
                    case 1:
                        found = _a.sent();
                        if (!found) {
                            return [2 /*return*/, null];
                        }
                        if (found.created + found.expireTime >= Date.now()) {
                            // cache hit
                            return [2 /*return*/, found.value];
                        }
                        else {
                            // cache miss
                            this.collection.remove({ _id: found._id });
                            return [2 /*return*/, null];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    CacheModel.prototype.getGlobalOrRefresh = function (key, onMiss, cacheTime) {
        return __awaiter(this, void 0, void 0, function () {
            var data, fetched;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getGlobal(key)];
                    case 1:
                        data = _a.sent();
                        if (!(data !== null)) return [3 /*break*/, 2];
                        return [2 /*return*/, data];
                    case 2: return [4 /*yield*/, onMiss()];
                    case 3:
                        fetched = _a.sent();
                        return [4 /*yield*/, this.setGlobal(key, fetched, cacheTime)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, fetched];
                }
            });
        });
    };
    CacheModel.prototype.getForWalletOrRefresh = function (wallet, key, onMiss, cacheTime) {
        return __awaiter(this, void 0, void 0, function () {
            var data, fetched;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getForWallet(wallet, key)];
                    case 1:
                        data = _a.sent();
                        if (!(data !== null)) return [3 /*break*/, 2];
                        return [2 /*return*/, data];
                    case 2: return [4 /*yield*/, onMiss()];
                    case 3:
                        fetched = _a.sent();
                        return [4 /*yield*/, this.setForWallet(wallet, key, fetched, cacheTime)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, fetched];
                }
            });
        });
    };
    return CacheModel;
}(base_1.BaseModel));
exports.CacheModel = CacheModel;
exports.CacheStorage = new CacheModel();
//# sourceMappingURL=cache.js.map