"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoinStorage = exports.CoinModel = void 0;
var mongodb_1 = require("mongodb");
var Loggify_1 = require("../decorators/Loggify");
var logger_1 = __importDefault(require("../logger"));
var libs_1 = require("../providers/libs");
var check_1 = require("../utils/check");
var base_1 = require("./base");
var block_1 = require("./block");
var CoinModel = /** @class */ (function (_super) {
    __extends(CoinModel, _super);
    function CoinModel(storage) {
        var _this = _super.call(this, 'coins', storage) || this;
        _this.allowedPaging = [
            { key: 'mintHeight', type: 'number' },
            { key: 'spentHeight', type: 'number' }
        ];
        return _this;
    }
    CoinModel.prototype.onConnect = function () {
        this.collection.createIndex({ mintTxid: 1, mintIndex: 1 }, { background: true });
        this.collection.createIndex({ address: 1, chain: 1, network: 1 }, {
            background: true,
            partialFilterExpression: {
                spentHeight: { $lt: 0 }
            }
        });
        this.collection.createIndex({ address: 1 }, { background: true });
        this.collection.createIndex({ chain: 1, network: 1, mintHeight: 1 }, { background: true });
        this.collection.createIndex({ spentTxid: 1 }, { background: true, sparse: true });
        this.collection.createIndex({ chain: 1, network: 1, spentHeight: 1 }, { background: true });
        this.collection.createIndex({ wallets: 1, spentHeight: 1, value: 1, mintHeight: 1 }, { background: true, partialFilterExpression: { 'wallets.0': { $exists: true } } });
        this.collection.createIndex({ wallets: 1, spentTxid: 1 }, { background: true, partialFilterExpression: { 'wallets.0': { $exists: true } } });
        this.collection.createIndex({ wallets: 1, mintTxid: 1 }, { background: true, partialFilterExpression: { 'wallets.0': { $exists: true } } });
    };
    CoinModel.prototype.getBalance = function (params, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var query, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = params.query;
                        return [4 /*yield*/, this.collection
                                .aggregate([
                                { $match: query },
                                {
                                    $project: {
                                        value: 1,
                                        status: {
                                            $cond: {
                                                if: { $gte: ['$mintHeight', 0 /* SpentHeightIndicators.minimum */] },
                                                then: 'confirmed',
                                                else: 'unconfirmed'
                                            }
                                        },
                                        _id: 0
                                    }
                                },
                                {
                                    $group: {
                                        _id: '$status',
                                        balance: { $sum: '$value' }
                                    }
                                }
                            ], options)
                                .toArray()];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.reduce(function (acc, cur) {
                                acc[cur._id] = cur.balance;
                                acc.balance += cur.balance;
                                return acc;
                            }, { confirmed: 0, unconfirmed: 0, balance: 0 })];
                }
            });
        });
    };
    CoinModel.prototype.getBalanceAtTime = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var query, time, chain, network, _a, block, blockHeight, combinedQuery;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        query = params.query, time = params.time, chain = params.chain, network = params.network;
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .find({
                                $query: {
                                    chain: chain,
                                    network: network,
                                    timeNormalized: { $lte: new Date(time) }
                                }
                            })
                                .limit(1)
                                .sort({ timeNormalized: -1 })
                                .toArray()];
                    case 1:
                        _a = __read.apply(void 0, [_b.sent(), 1]), block = _a[0];
                        blockHeight = block.height;
                        combinedQuery = Object.assign({}, {
                            $or: [{ spentHeight: { $gt: blockHeight } }, { spentHeight: { $lt: 0 /* SpentHeightIndicators.minimum */ } }],
                            mintHeight: { $lte: blockHeight }
                        }, query);
                        return [2 /*return*/, this.getBalance({ query: combinedQuery }, { hint: { wallets: 1, spentHeight: 1, value: 1, mintHeight: 1 } })];
                }
            });
        });
    };
    CoinModel.prototype.resolveAuthhead = function (mintTxid, chain, network) {
        return this.collection
            .aggregate([
            {
                $match: __assign(__assign({ mintTxid: mintTxid.toLowerCase(), mintIndex: 0 }, (typeof chain === 'string' ? { chain: chain } : {})), (typeof network === 'string' ? { network: network } : {}))
            },
            {
                $graphLookup: {
                    from: 'coins',
                    startWith: '$spentTxid',
                    connectFromField: 'spentTxid',
                    connectToField: 'mintTxid',
                    as: 'authheads',
                    maxDepth: 1000000,
                    restrictSearchWithMatch: {
                        mintIndex: 0
                    }
                }
            },
            {
                $project: {
                    chain: '$chain',
                    network: '$network',
                    authbase: '$mintTxid',
                    identityOutputs: {
                        $filter: {
                            input: '$authheads',
                            as: 'authhead',
                            cond: {
                                $and: [
                                    {
                                        $lte: ['$$authhead.spentHeight', -1]
                                    },
                                    {
                                        $eq: ['$$authhead.chain', '$chain']
                                    },
                                    {
                                        $eq: ['$$authhead.network', '$network']
                                    }
                                ]
                            }
                        }
                    }
                }
            }
        ])
            .toArray();
    };
    CoinModel.prototype._apiTransform = function (coin, options) {
        // try to parse coin.address if its 'false' and script exists
        if (coin.address == 'false' && coin.script != undefined && coin.script.toString() != '') {
            try {
                var lib = libs_1.Libs.get(coin.chain).lib;
                var address = lib
                    .Script(coin.script.toString('hex'))
                    .toAddress(coin.network)
                    .toString();
                if (lib.Address.isValid(address, coin.network)) {
                    coin.address = address;
                    // update coin record in db - do it asynchronously as we don't need to wait for result
                    exports.CoinStorage.collection.updateOne({ _id: coin._id }, { $set: { address: coin.address } });
                }
            }
            catch (e) {
                logger_1.default.debug("Could not parse address on \"".concat(coin.chain, ":").concat(coin.network, "\" for coin ").concat(coin.mintTxid, "[").concat(coin.mintIndex, "]"));
            }
        }
        var transform = {
            _id: (0, check_1.valueOrDefault)(coin._id, new mongodb_1.ObjectID()).toHexString(),
            chain: (0, check_1.valueOrDefault)(coin.chain, ''),
            network: (0, check_1.valueOrDefault)(coin.network, ''),
            coinbase: (0, check_1.valueOrDefault)(coin.coinbase, false),
            mintIndex: (0, check_1.valueOrDefault)(coin.mintIndex, -1),
            spentTxid: (0, check_1.valueOrDefault)(coin.spentTxid, ''),
            mintTxid: (0, check_1.valueOrDefault)(coin.mintTxid, ''),
            mintHeight: (0, check_1.valueOrDefault)(coin.mintHeight, -1),
            spentHeight: (0, check_1.valueOrDefault)(coin.spentHeight, -4 /* SpentHeightIndicators.error */),
            address: (0, check_1.valueOrDefault)(coin.address, ''),
            script: (0, check_1.valueOrDefault)(coin.script, Buffer.alloc(0)).toString('hex'),
            value: (0, check_1.valueOrDefault)(coin.value, -1),
            confirmations: (0, check_1.valueOrDefault)(coin.confirmations, -1),
            sequenceNumber: (0, check_1.valueOrDefault)(coin.sequenceNumber, undefined)
        };
        if (options && options.object) {
            return transform;
        }
        return JSON.stringify(transform);
    };
    CoinModel = __decorate([
        Loggify_1.LoggifyClass
    ], CoinModel);
    return CoinModel;
}(base_1.BaseModel));
exports.CoinModel = CoinModel;
exports.CoinStorage = new CoinModel();
//# sourceMappingURL=coin.js.map