"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventStorage = exports.EventModel = void 0;
var base_1 = require("./base");
var EventModel = /** @class */ (function (_super) {
    __extends(EventModel, _super);
    function EventModel(storage) {
        var _this = _super.call(this, 'events', storage) || this;
        _this.allowedPaging = [];
        return _this;
    }
    EventModel.prototype.onConnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collection.createIndex({ type: 1, emitTime: 1 }, { background: true })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.collection.createIndex({ emitTime: 1 }, { background: true, expireAfterSeconds: 60 * 5 })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventModel.prototype.signalBlock = function (block) {
        return this.collection.insertOne({ payload: block, emitTime: new Date(), type: 'block' });
    };
    EventModel.prototype.signalTx = function (tx) {
        return this.collection.insertOne({ payload: tx, emitTime: new Date(), type: 'tx' });
    };
    EventModel.prototype.signalTxs = function (txs) {
        this.collection.insertMany(txs.map(function (tx) { return ({ payload: tx, emitTime: new Date(), type: 'tx' }); }));
    };
    EventModel.prototype.signalAddressCoin = function (payload) {
        return this.collection.insertOne({ payload: payload, emitTime: new Date(), type: 'coin' });
    };
    EventModel.prototype.signalAddressCoins = function (coins) {
        return this.collection.insertMany(coins.map(function (coin) { return ({ payload: coin, emitTime: new Date(), type: 'coin' }); }));
    };
    EventModel.prototype.getBlockTail = function (lastSeen) {
        return this.collection.find({ type: 'block', emitTime: { $gte: lastSeen } }).addCursorFlag('noCursorTimeout', true);
    };
    EventModel.prototype.getTxTail = function (lastSeen) {
        return this.collection.find({ type: 'tx', emitTime: { $gte: lastSeen } }).addCursorFlag('noCursorTimeout', true);
    };
    EventModel.prototype.getCoinTail = function (lastSeen) {
        return this.collection.find({ type: 'coin', emitTime: { $gte: lastSeen } }).addCursorFlag('noCursorTimeout', true);
    };
    return EventModel;
}(base_1.BaseModel));
exports.EventModel = EventModel;
exports.EventStorage = new EventModel();
//# sourceMappingURL=events.js.map