"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RateLimitStorage = exports.RateLimitModel = exports.RateLimitTimes = void 0;
var base_1 = require("./base");
var RateLimitTimes;
(function (RateLimitTimes) {
    RateLimitTimes[RateLimitTimes["None"] = 0] = "None";
    RateLimitTimes[RateLimitTimes["Second"] = 1000] = "Second";
    RateLimitTimes[RateLimitTimes["Minute"] = 60000] = "Minute";
    RateLimitTimes[RateLimitTimes["Hour"] = 3600000] = "Hour";
    RateLimitTimes[RateLimitTimes["Day"] = 86400000] = "Day";
    RateLimitTimes[RateLimitTimes["Month"] = 2592000000] = "Month";
    RateLimitTimes[RateLimitTimes["Year"] = 31536000000] = "Year";
})(RateLimitTimes = exports.RateLimitTimes || (exports.RateLimitTimes = {}));
var RateLimitModel = /** @class */ (function (_super) {
    __extends(RateLimitModel, _super);
    function RateLimitModel(storage) {
        var _this = _super.call(this, 'ratelimits', storage) || this;
        _this.allowedPaging = [];
        return _this;
    }
    RateLimitModel.prototype.onConnect = function () {
        this.collection.createIndex({ identifier: 1, time: 1, method: 1, count: 1 }, { background: true });
        this.collection.createIndex({ expireAt: 1 }, { expireAfterSeconds: 0, background: true });
    };
    RateLimitModel.prototype.incrementAndCheck = function (identifier, method) {
        return Promise.all([
            this.collection.findOneAndUpdate({ identifier: identifier, method: method, period: 'second', time: { $gte: new Date(Date.now() - RateLimitTimes.Second) } }, {
                $setOnInsert: { time: new Date(), expireAt: new Date(Date.now() + 2 * RateLimitTimes.Second) },
                $inc: { count: 1 }
            }, { upsert: true, returnOriginal: false }),
            this.collection.findOneAndUpdate({ identifier: identifier, method: method, period: 'minute', time: { $gte: new Date(Date.now() - RateLimitTimes.Minute) } }, {
                $setOnInsert: { time: new Date(), expireAt: new Date(Date.now() + 2 * RateLimitTimes.Minute) },
                $inc: { count: 1 }
            }, { upsert: true, returnOriginal: false }),
            this.collection.findOneAndUpdate({ identifier: identifier, method: method, period: 'hour', time: { $gte: new Date(Date.now() - RateLimitTimes.Hour) } }, {
                $setOnInsert: { time: new Date(), expireAt: new Date(Date.now() + 2 * RateLimitTimes.Hour) },
                $inc: { count: 1 }
            }, { upsert: true, returnOriginal: false })
        ]);
    };
    return RateLimitModel;
}(base_1.BaseModel));
exports.RateLimitModel = RateLimitModel;
exports.RateLimitStorage = new RateLimitModel();
//# sourceMappingURL=rateLimit.js.map