"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WalletAddressStorage = exports.WalletAddressModel = void 0;
var stream_1 = require("stream");
var partition_1 = require("../utils/partition");
var base_1 = require("./base");
var coin_1 = require("./coin");
var transaction_1 = require("./transaction");
var WalletAddressModel = /** @class */ (function (_super) {
    __extends(WalletAddressModel, _super);
    function WalletAddressModel(storage) {
        var _this = _super.call(this, 'walletaddresses', storage) || this;
        _this.allowedPaging = [];
        return _this;
    }
    WalletAddressModel.prototype.onConnect = function () {
        this.collection.createIndex({ chain: 1, network: 1, address: 1, wallet: 1 }, { background: true, unique: true });
        this.collection.createIndex({ chain: 1, network: 1, wallet: 1, address: 1 }, { background: true, unique: true });
    };
    WalletAddressModel.prototype._apiTransform = function (walletAddress, options) {
        var transform = { address: walletAddress.address };
        if (options && options.object) {
            return transform;
        }
        return JSON.stringify(transform);
    };
    WalletAddressModel.prototype.updateCoins = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, addresses, chain, network, AddressInputStream, FilterExistingAddressesStream, AddNewAddressesStream, UpdateCoinsStream, UpdatedTxidsStream, TxUpdaterStream, MarkProcessedStream, addressInputStream, filterExistingAddressesStream, addNewAddressesStream, updateCoinsStream, updatedTxidsStream, txUpdaterStream, markProcessedStream, handleStreamError;
            return __generator(this, function (_a) {
                wallet = params.wallet, addresses = params.addresses;
                chain = wallet.chain, network = wallet.network;
                AddressInputStream = /** @class */ (function (_super) {
                    __extends(AddressInputStream, _super);
                    function AddressInputStream() {
                        var _this = _super.call(this, { objectMode: true }) || this;
                        _this.addressBatches = (0, partition_1.partition)(addresses, 1000);
                        _this.index = 0;
                        return _this;
                    }
                    AddressInputStream.prototype._read = function () {
                        if (this.index < this.addressBatches.length) {
                            this.push(this.addressBatches[this.index]);
                            this.index++;
                        }
                        else {
                            this.push(null);
                        }
                    };
                    return AddressInputStream;
                }(stream_1.Readable));
                FilterExistingAddressesStream = /** @class */ (function (_super) {
                    __extends(FilterExistingAddressesStream, _super);
                    function FilterExistingAddressesStream() {
                        return _super.call(this, { objectMode: true }) || this;
                    }
                    FilterExistingAddressesStream.prototype._transform = function (addressBatch, _, callback) {
                        return __awaiter(this, void 0, void 0, function () {
                            var exists_1, err_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, exports.WalletAddressStorage.collection
                                                .find({ chain: chain, network: network, wallet: wallet._id, address: { $in: addressBatch } })
                                                .project({ address: 1, processed: 1 })
                                                .toArray()];
                                    case 1:
                                        exists_1 = (_a.sent())
                                            .filter(function (walletAddress) { return walletAddress.processed; })
                                            .map(function (walletAddress) { return walletAddress.address; });
                                        this.push(addressBatch.filter(function (address) {
                                            return !exists_1.includes(address);
                                        }));
                                        callback();
                                        return [3 /*break*/, 3];
                                    case 2:
                                        err_1 = _a.sent();
                                        callback(err_1);
                                        return [3 /*break*/, 3];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        });
                    };
                    return FilterExistingAddressesStream;
                }(stream_1.Transform));
                AddNewAddressesStream = /** @class */ (function (_super) {
                    __extends(AddNewAddressesStream, _super);
                    function AddNewAddressesStream() {
                        return _super.call(this, { objectMode: true }) || this;
                    }
                    AddNewAddressesStream.prototype._transform = function (addressBatch, _, callback) {
                        return __awaiter(this, void 0, void 0, function () {
                            var err_2;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!addressBatch.length) {
                                            return [2 /*return*/, callback()];
                                        }
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, exports.WalletAddressStorage.collection.bulkWrite(addressBatch.map(function (address) {
                                                return {
                                                    insertOne: {
                                                        document: { chain: chain, network: network, wallet: wallet._id, address: address, processed: false }
                                                    }
                                                };
                                            }))];
                                    case 2:
                                        _a.sent(),
                                            { ordered: false };
                                        return [3 /*break*/, 4];
                                    case 3:
                                        err_2 = _a.sent();
                                        // Ignore duplicate keys, they may be half processed
                                        if (err_2.code !== 11000) {
                                            return [2 /*return*/, callback(err_2)];
                                        }
                                        return [3 /*break*/, 4];
                                    case 4:
                                        this.push(addressBatch);
                                        callback();
                                        return [2 /*return*/];
                                }
                            });
                        });
                    };
                    return AddNewAddressesStream;
                }(stream_1.Transform));
                UpdateCoinsStream = /** @class */ (function (_super) {
                    __extends(UpdateCoinsStream, _super);
                    function UpdateCoinsStream() {
                        return _super.call(this, { objectMode: true }) || this;
                    }
                    UpdateCoinsStream.prototype._transform = function (addressBatch, _, callback) {
                        return __awaiter(this, void 0, void 0, function () {
                            var err_3;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!addressBatch.length) {
                                            return [2 /*return*/, callback()];
                                        }
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, coin_1.CoinStorage.collection.bulkWrite(addressBatch.map(function (address) {
                                                return {
                                                    updateMany: {
                                                        filter: { chain: chain, network: network, address: address },
                                                        update: { $addToSet: { wallets: wallet._id } }
                                                    }
                                                };
                                            }), { ordered: false })];
                                    case 2:
                                        _a.sent();
                                        this.push(addressBatch);
                                        callback();
                                        return [3 /*break*/, 4];
                                    case 3:
                                        err_3 = _a.sent();
                                        callback(err_3);
                                        return [3 /*break*/, 4];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        });
                    };
                    return UpdateCoinsStream;
                }(stream_1.Transform));
                UpdatedTxidsStream = /** @class */ (function (_super) {
                    __extends(UpdatedTxidsStream, _super);
                    function UpdatedTxidsStream() {
                        var _this = _super.call(this, { objectMode: true }) || this;
                        _this.txids = {};
                        return _this;
                    }
                    UpdatedTxidsStream.prototype._transform = function (addressBatch, _, callback) {
                        return __awaiter(this, void 0, void 0, function () {
                            var coinStream, errored;
                            var _this = this;
                            return __generator(this, function (_a) {
                                if (!addressBatch.length) {
                                    return [2 /*return*/, callback()];
                                }
                                coinStream = coin_1.CoinStorage.collection
                                    .find({ chain: chain, network: network, address: { $in: addressBatch } })
                                    .project({ mintTxid: 1, spentTxid: 1 });
                                coinStream.on('data', function (coin) {
                                    if (!_this.txids[coin.mintTxid]) {
                                        _this.txids[coin.mintTxid] = true;
                                        _this.push({ txid: coin.mintTxid });
                                    }
                                    if (!_this.txids[coin.spentTxid]) {
                                        _this.txids[coin.spentTxid] = true;
                                        _this.push({ txid: coin.spentTxid });
                                    }
                                });
                                errored = false;
                                coinStream.on('error', function (err) {
                                    errored = true;
                                    coinStream.destroy(err);
                                    callback(err);
                                });
                                coinStream.on('end', function () {
                                    if (errored) {
                                        return;
                                    }
                                    _this.push({ addressBatch: addressBatch });
                                    callback();
                                });
                                return [2 /*return*/];
                            });
                        });
                    };
                    return UpdatedTxidsStream;
                }(stream_1.Transform));
                TxUpdaterStream = /** @class */ (function (_super) {
                    __extends(TxUpdaterStream, _super);
                    function TxUpdaterStream() {
                        return _super.call(this, { objectMode: true }) || this;
                    }
                    TxUpdaterStream.prototype._transform = function (data, _, callback) {
                        return __awaiter(this, void 0, void 0, function () {
                            var txid, addressBatch, err_4;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        txid = data.txid, addressBatch = data.addressBatch;
                                        if (addressBatch) {
                                            this.push(addressBatch);
                                            return [2 /*return*/, callback()];
                                        }
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.updateMany({ chain: chain, network: network, txid: txid }, { $addToSet: { wallets: wallet._id } })];
                                    case 2:
                                        _a.sent();
                                        callback();
                                        return [3 /*break*/, 4];
                                    case 3:
                                        err_4 = _a.sent();
                                        callback(err_4);
                                        return [3 /*break*/, 4];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        });
                    };
                    return TxUpdaterStream;
                }(stream_1.Transform));
                MarkProcessedStream = /** @class */ (function (_super) {
                    __extends(MarkProcessedStream, _super);
                    function MarkProcessedStream() {
                        return _super.call(this, { objectMode: true }) || this;
                    }
                    MarkProcessedStream.prototype._write = function (addressBatch, _, callback) {
                        return __awaiter(this, void 0, void 0, function () {
                            var err_5;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!addressBatch.length) {
                                            return [2 /*return*/, callback()];
                                        }
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, exports.WalletAddressStorage.collection.bulkWrite(addressBatch.map(function (address) {
                                                return {
                                                    updateOne: {
                                                        filter: { chain: chain, network: network, address: address, wallet: wallet._id },
                                                        update: { $set: { processed: true } }
                                                    }
                                                };
                                            }), { ordered: false })];
                                    case 2:
                                        _a.sent();
                                        callback();
                                        return [3 /*break*/, 4];
                                    case 3:
                                        err_5 = _a.sent();
                                        callback(err_5);
                                        return [3 /*break*/, 4];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        });
                    };
                    return MarkProcessedStream;
                }(stream_1.Writable));
                addressInputStream = new AddressInputStream();
                filterExistingAddressesStream = new FilterExistingAddressesStream();
                addNewAddressesStream = new AddNewAddressesStream();
                updateCoinsStream = new UpdateCoinsStream();
                updatedTxidsStream = new UpdatedTxidsStream();
                txUpdaterStream = new TxUpdaterStream();
                markProcessedStream = new MarkProcessedStream();
                handleStreamError = function (stream, reject) {
                    stream.on('error', function (err) {
                        stream.destroy();
                        return reject(err);
                    });
                };
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        markProcessedStream.on('unpipe', function () {
                            return resolve();
                        });
                        handleStreamError(filterExistingAddressesStream, reject);
                        handleStreamError(addNewAddressesStream, reject);
                        handleStreamError(updateCoinsStream, reject);
                        handleStreamError(updatedTxidsStream, reject);
                        handleStreamError(txUpdaterStream, reject);
                        handleStreamError(markProcessedStream, reject);
                        addressInputStream
                            .pipe(filterExistingAddressesStream)
                            .pipe(addNewAddressesStream)
                            .pipe(updateCoinsStream)
                            .pipe(updatedTxidsStream)
                            .pipe(txUpdaterStream)
                            .pipe(markProcessedStream);
                    })];
            });
        });
    };
    return WalletAddressModel;
}(base_1.BaseModel));
exports.WalletAddressModel = WalletAddressModel;
exports.WalletAddressStorage = new WalletAddressModel();
//# sourceMappingURL=walletAddress.js.map