"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EthRoutes = void 0;
var express_1 = require("express");
var logger_1 = __importDefault(require("../../../logger"));
var csp_1 = require("./csp");
var gnosis_1 = require("./gnosis");
exports.EthRoutes = (0, express_1.Router)();
exports.EthRoutes.get('/api/ETH/:network/address/:address/txs/count', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, address, network, nonce, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, address = _a.address, network = _a.network;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, csp_1.ETH.getAccountNonce(network, address)];
            case 2:
                nonce = _b.sent();
                res.json({ nonce: nonce });
                return [3 /*break*/, 4];
            case 3:
                err_1 = _b.sent();
                logger_1.default.error('Nonce Error::%o', err_1);
                res.status(500).send(err_1);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.post('/api/ETH/:network/gas', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, from, to, value, data, gasPrice, network, gasLimit, err_2;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.body, from = _a.from, to = _a.to, value = _a.value, data = _a.data, gasPrice = _a.gasPrice;
                network = req.params.network;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network, from: from, to: to, value: value, data: data, gasPrice: gasPrice })];
            case 2:
                gasLimit = _b.sent();
                res.json(gasLimit);
                return [3 /*break*/, 4];
            case 3:
                err_2 = _b.sent();
                if ((err_2 === null || err_2 === void 0 ? void 0 : err_2.code) != null) { // Preventable error from geth (probably due to insufficient funds or similar)
                    res.status(400).send(err_2.message);
                }
                else {
                    logger_1.default.error('Gas Error::%o', err_2);
                    res.status(500).send(err_2);
                }
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/token/:tokenAddress', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, network, tokenAddress, tokenInfo, err_3;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, network = _a.network, tokenAddress = _a.tokenAddress;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, csp_1.ETH.getERC20TokenInfo(network, tokenAddress)];
            case 2:
                tokenInfo = _b.sent();
                res.json(tokenInfo);
                return [3 /*break*/, 4];
            case 3:
                err_3 = _b.sent();
                logger_1.default.error('Token Info Error::%o', err_3);
                res.status(500).send(err_3);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/token/:tokenAddress/allowance/:ownerAddress/for/:spenderAddress', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, network, tokenAddress, ownerAddress, spenderAddress, allowance, err_4;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, network = _a.network, tokenAddress = _a.tokenAddress, ownerAddress = _a.ownerAddress, spenderAddress = _a.spenderAddress;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, csp_1.ETH.getERC20TokenAllowance(network, tokenAddress, ownerAddress, spenderAddress)];
            case 2:
                allowance = _b.sent();
                res.json(allowance);
                return [3 /*break*/, 4];
            case 3:
                err_4 = _b.sent();
                logger_1.default.error('Token Allowance Error::%o', err_4);
                res.status(500).send(err_4);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/ethmultisig/info/:multisigContractAddress', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, network, multisigContractAddress, multisigInfo, err_5;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, network = _a.network, multisigContractAddress = _a.multisigContractAddress;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, gnosis_1.Gnosis.getMultisigEthInfo(network, multisigContractAddress)];
            case 2:
                multisigInfo = _b.sent();
                res.json(multisigInfo);
                return [3 /*break*/, 4];
            case 3:
                err_5 = _b.sent();
                logger_1.default.error('Multisig Info Error::%o', err_5);
                res.status(500).send(err_5);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/ethmultisig/:sender/instantiation/:txId', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, network, sender, txId, multisigInstantiationInfo, err_6;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, network = _a.network, sender = _a.sender, txId = _a.txId;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, gnosis_1.Gnosis.getMultisigContractInstantiationInfo(network, sender, txId)];
            case 2:
                multisigInstantiationInfo = _b.sent();
                res.json(multisigInstantiationInfo);
                return [3 /*break*/, 4];
            case 3:
                err_6 = _b.sent();
                logger_1.default.error('Multisig Instantiation Error::%o', err_6);
                res.status(500).send(err_6);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/ethmultisig/txps/:multisigContractAddress', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, network, multisigContractAddress, multisigTxpsInfo, err_7;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, network = _a.network, multisigContractAddress = _a.multisigContractAddress;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, gnosis_1.Gnosis.getMultisigTxpsInfo(network, multisigContractAddress)];
            case 2:
                multisigTxpsInfo = _b.sent();
                res.json(multisigTxpsInfo);
                return [3 /*break*/, 4];
            case 3:
                err_7 = _b.sent();
                logger_1.default.error('Multisig Txps Error::%o', err_7);
                res.status(500).send(err_7);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/ethmultisig/transactions/:multisigContractAddress', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, network, multisigContractAddress, chain, err_8;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, network = _a.network, multisigContractAddress = _a.multisigContractAddress;
                chain = 'ETH';
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, gnosis_1.Gnosis.streamGnosisWalletTransactions({
                        chain: chain,
                        network: network,
                        multisigContractAddress: multisigContractAddress,
                        wallet: {},
                        req: req,
                        res: res,
                        args: req.query
                    })];
            case 2: return [2 /*return*/, _b.sent()];
            case 3:
                err_8 = _b.sent();
                logger_1.default.error('Multisig Transactions Error::%o', err_8);
                return [2 /*return*/, res.status(500).send(err_8)];
            case 4: return [2 /*return*/];
        }
    });
}); });
exports.EthRoutes.get('/api/ETH/:network/priorityFee/:percentile', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, percentile, network, priorityFeePercentile, fee, err_9;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, percentile = _a.percentile, network = _a.network;
                priorityFeePercentile = Number(percentile) || 15;
                network = network.toLowerCase();
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, csp_1.ETH.getPriorityFee({ network: network, percentile: priorityFeePercentile })];
            case 2:
                fee = _b.sent();
                if (!fee) {
                    return [2 /*return*/, res.status(404).send('not available right now')];
                }
                return [2 /*return*/, res.json(fee)];
            case 3:
                err_9 = _b.sent();
                logger_1.default.error('Fee Error: %o', err_9.message || err_9);
                return [2 /*return*/, res.status(500).send('Error getting priority fee from RPC')];
            case 4: return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=eth-routes.js.map