"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Gnosis = exports.GnosisApi = void 0;
var stream_1 = require("stream");
var multisig_1 = require("../../../providers/chain-state/evm/abi/multisig");
var multisigTransform_1 = require("../../../providers/chain-state/evm/api/multisigTransform");
var populateEffectsTransform_1 = require("../../../providers/chain-state/evm/api/populateEffectsTransform");
var populateReceiptTransform_1 = require("../../../providers/chain-state/evm/api/populateReceiptTransform");
var transform_1 = require("../../../providers/chain-state/evm/api/transform");
var block_1 = require("../../../providers/chain-state/evm/models/block");
var transaction_1 = require("../../../providers/chain-state/evm/models/transaction");
var config_1 = require("../../../services/config");
var csp_1 = require("./csp");
var GnosisApi = /** @class */ (function () {
    function GnosisApi() {
        this.gnosisFactories = {
            testnet: '0x2C992817e0152A65937527B774c7A99a84603045',
            mainnet: '0x6e95C8E8557AbC08b46F3c347bA06F8dC012763f'
        };
        this.ETH_MULTISIG_TX_PROPOSAL_EXPIRE_TIME = 48 * 3600 * 1000;
    }
    GnosisApi.prototype.multisigFor = function (network, address) {
        return __awaiter(this, void 0, void 0, function () {
            var web3, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, csp_1.ETH.getWeb3(network)];
                    case 1:
                        web3 = (_a.sent()).web3;
                        contract = new web3.eth.Contract(multisig_1.MultisigAbi, address);
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    GnosisApi.prototype.getMultisigContractInstantiationInfo = function (network, sender, txId) {
        return __awaiter(this, void 0, void 0, function () {
            var web3, networkConfig, _a, gnosisFactory, query, found, blockHeight, contract, contractInfo;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, csp_1.ETH.getWeb3(network)];
                    case 1:
                        web3 = (_b.sent()).web3;
                        networkConfig = config_1.Config.chainConfig({ chain: 'ETH', network: network });
                        _a = networkConfig.gnosisFactory, gnosisFactory = _a === void 0 ? this.gnosisFactories[network] : _a;
                        query = { chain: 'ETH', network: network, txid: txId };
                        return [4 /*yield*/, transaction_1.EVMTransactionStorage.collection.findOne(query)];
                    case 2:
                        found = _b.sent();
                        blockHeight = found && found.blockHeight ? found.blockHeight : null;
                        if (!blockHeight || blockHeight < 0)
                            return [2 /*return*/, Promise.resolve([])];
                        return [4 /*yield*/, this.multisigFor(network, gnosisFactory)];
                    case 3:
                        contract = _b.sent();
                        return [4 /*yield*/, contract.getPastEvents('ContractInstantiation', {
                                fromBlock: web3.utils.toHex(blockHeight),
                                toBlock: web3.utils.toHex(blockHeight)
                            })];
                    case 4:
                        contractInfo = _b.sent();
                        return [2 /*return*/, this.convertMultisigContractInstantiationInfo(contractInfo.filter(function (info) { return info.returnValues.sender.toLowerCase() === sender.toLowerCase(); }))];
                }
            });
        });
    };
    GnosisApi.prototype.convertMultisigContractInstantiationInfo = function (contractInstantiationInfo) {
        return contractInstantiationInfo.map(this.convertContractInstantiationInfo);
    };
    GnosisApi.prototype.convertContractInstantiationInfo = function (transfer) {
        var blockHash = transfer.blockHash, blockNumber = transfer.blockNumber, transactionHash = transfer.transactionHash, returnValues = transfer.returnValues, transactionIndex = transfer.transactionIndex;
        return {
            blockHash: blockHash,
            blockNumber: blockNumber,
            transactionHash: transactionHash,
            transactionIndex: transactionIndex,
            hash: transactionHash,
            sender: returnValues['sender'],
            instantiation: returnValues['instantiation']
        };
    };
    GnosisApi.prototype.getMultisigTxpsInfo = function (network, multisigContractAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, time, _a, block, blockHeight, _b, confirmationInfo, revocationInfo, executionInfo, executionFailure, executionTransactionIdArray, contractTransactionsInfo, multisigTxpsInfo;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.multisigFor(network, multisigContractAddress)];
                    case 1:
                        contract = _c.sent();
                        time = Math.floor(Date.now()) - this.ETH_MULTISIG_TX_PROPOSAL_EXPIRE_TIME;
                        return [4 /*yield*/, block_1.EVMBlockStorage.collection
                                .find({
                                chain: 'ETH',
                                network: network,
                                timeNormalized: { $gte: new Date(time) }
                            })
                                .limit(1)
                                .toArray()];
                    case 2:
                        _a = __read.apply(void 0, [_c.sent(), 1]), block = _a[0];
                        blockHeight = block.height;
                        return [4 /*yield*/, Promise.all([
                                contract.getPastEvents('Confirmation', {
                                    fromBlock: blockHeight,
                                    toBlock: 'latest'
                                }),
                                contract.getPastEvents('Revocation', {
                                    fromBlock: blockHeight,
                                    toBlock: 'latest'
                                }),
                                contract.getPastEvents('Execution', {
                                    fromBlock: blockHeight,
                                    toBlock: 'latest'
                                }),
                                contract.getPastEvents('ExecutionFailure', {
                                    fromBlock: blockHeight,
                                    toBlock: 'latest'
                                })
                            ])];
                    case 3:
                        _b = __read.apply(void 0, [_c.sent(), 4]), confirmationInfo = _b[0], revocationInfo = _b[1], executionInfo = _b[2], executionFailure = _b[3];
                        executionTransactionIdArray = executionInfo.map(function (i) { return i.returnValues.transactionId; });
                        contractTransactionsInfo = __spreadArray(__spreadArray(__spreadArray([], __read(confirmationInfo), false), __read(revocationInfo), false), __read(executionFailure), false);
                        multisigTxpsInfo = contractTransactionsInfo.filter(function (i) { return !executionTransactionIdArray.includes(i.returnValues.transactionId); });
                        return [2 /*return*/, this.convertMultisigTxpsInfo(multisigTxpsInfo)];
                }
            });
        });
    };
    GnosisApi.prototype.convertMultisigTxpsInfo = function (multisigTxpsInfo) {
        return multisigTxpsInfo.map(this.convertTxpsInfo);
    };
    GnosisApi.prototype.convertTxpsInfo = function (transfer) {
        var blockHash = transfer.blockHash, blockNumber = transfer.blockNumber, transactionHash = transfer.transactionHash, returnValues = transfer.returnValues, transactionIndex = transfer.transactionIndex, event = transfer.event;
        return {
            blockHash: blockHash,
            blockNumber: blockNumber,
            transactionHash: transactionHash,
            transactionIndex: transactionIndex,
            hash: transactionHash,
            sender: returnValues['sender'],
            transactionId: returnValues['transactionId'],
            event: event
        };
    };
    GnosisApi.prototype.getMultisigEthInfo = function (network, multisigContractAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, owners, required;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.multisigFor(network, multisigContractAddress)];
                    case 1:
                        contract = _a.sent();
                        return [4 /*yield*/, contract.methods.getOwners().call()];
                    case 2:
                        owners = _a.sent();
                        return [4 /*yield*/, contract.methods.required().call()];
                    case 3:
                        required = _a.sent();
                        return [2 /*return*/, {
                                owners: owners,
                                required: required
                            }];
                }
            });
        });
    };
    GnosisApi.prototype.streamGnosisWalletTransactions = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var multisigContractAddress, res, args, transactionQuery, query, transactionStream, ethTransactionTransform, populateReceipt, populateEffects, ethMultisigTransform;
            return __generator(this, function (_a) {
                multisigContractAddress = params.multisigContractAddress, res = params.res, args = params.args;
                transactionQuery = csp_1.ETH.getWalletTransactionQuery(params);
                delete transactionQuery.wallets;
                delete transactionQuery['wallets.0'];
                if (args.tokenAddress) {
                    query = {
                        $or: [
                            __assign(__assign({}, transactionQuery), { to: args.tokenAddress, 'abiType.params.0.value': multisigContractAddress.toLowerCase() }),
                            __assign(__assign({}, transactionQuery), { 'internal.action.to': args.tokenAddress.toLowerCase(), 'internal.action.from': multisigContractAddress.toLowerCase() }),
                            __assign(__assign({}, transactionQuery), { 'effects.contractAddress': args.tokenAddress, 'effects.from': multisigContractAddress })
                        ]
                    };
                }
                else {
                    query = {
                        $or: [
                            __assign(__assign({}, transactionQuery), { to: multisigContractAddress }),
                            __assign(__assign({}, transactionQuery), { 'internal.action.to': multisigContractAddress.toLowerCase() }),
                            __assign(__assign({}, transactionQuery), { 'effects.to': multisigContractAddress })
                        ]
                    };
                }
                transactionStream = new stream_1.Readable({ objectMode: true });
                ethTransactionTransform = new transform_1.EVMListTransactionsStream([multisigContractAddress, args.tokenAddress]);
                populateReceipt = new populateReceiptTransform_1.PopulateReceiptTransform();
                populateEffects = new populateEffectsTransform_1.PopulateEffectsTransform();
                transactionStream = transaction_1.EVMTransactionStorage.collection
                    .find(query)
                    .sort({ blockTimeNormalized: 1 })
                    .addCursorFlag('noCursorTimeout', true);
                transactionStream = transactionStream.pipe(populateEffects); // For old db entires
                if (multisigContractAddress) {
                    ethMultisigTransform = new multisigTransform_1.MultisigRelatedFilterTransform(multisigContractAddress, args.tokenAddress);
                    transactionStream = transactionStream.pipe(ethMultisigTransform);
                }
                transactionStream
                    .pipe(populateReceipt)
                    .pipe(ethTransactionTransform)
                    .pipe(res);
                return [2 /*return*/];
            });
        });
    };
    return GnosisApi;
}());
exports.GnosisApi = GnosisApi;
exports.Gnosis = new GnosisApi();
//# sourceMappingURL=gnosis.js.map