"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.LitecoinP2PWorker = void 0;
var events_1 = require("events");
var block_1 = require("../../models/block");
var libs_1 = require("../../providers/libs");
var p2p_1 = require("../bitcoin/p2p");
var LitecoinP2PWorker = /** @class */ (function (_super) {
    __extends(LitecoinP2PWorker, _super);
    function LitecoinP2PWorker(_a) {
        var _b;
        var chain = _a.chain, network = _a.network, chainConfig = _a.chainConfig, _c = _a.blockModel, blockModel = _c === void 0 ? block_1.BitcoinBlockStorage : _c;
        var _this = _super.call(this, { chain: chain, network: network, chainConfig: chainConfig, blockModel: blockModel }) || this;
        _this.blockModel = blockModel;
        _this.chain = chain;
        _this.network = network;
        _this.bitcoreLib = libs_1.Libs.get(_this.chain).lib;
        _this.bitcoreP2p = libs_1.Libs.get(_this.chain).p2p;
        _this.chainConfig = chainConfig;
        _this.events = new events_1.EventEmitter();
        _this.isSyncing = false;
        _this.initialSyncComplete = false;
        _this.invCache = {};
        _this.invCacheLimits = (_b = {},
            _b[_this.bitcoreP2p.Inventory.TYPE.BLOCK] = 100,
            _b[_this.bitcoreP2p.Inventory.TYPE.TX] = 100000,
            _b);
        if (_this.network === 'regtest') {
            _this.bitcoreLib.Networks.enableRegtest();
        }
        _this.messages = new _this.bitcoreP2p.Messages({
            // As of Litcoin Core v0.18.1, min protocolVersion is 70002
            // As of bitcore v8.x, max protocolVersion is 70011 before seeing connection errors
            protocolVersion: 70011,
            network: _this.bitcoreLib.Networks.get(_this.network),
            Block: _this.bitcoreLib.Block,
            Transaction: _this.bitcoreLib.Transaction,
            BlockHeader: _this.bitcoreLib.BlockHeader
        });
        _this.pool = new _this.bitcoreP2p.Pool({
            addrs: _this.chainConfig.trustedPeers.map(function (peer) {
                return {
                    ip: {
                        v4: peer.host
                    },
                    port: peer.port
                };
            }),
            dnsSeed: false,
            listenAddr: false,
            network: _this.network,
            messages: _this.messages
        });
        return _this;
    }
    return LitecoinP2PWorker;
}(p2p_1.BitcoinP2PWorker));
exports.LitecoinP2PWorker = LitecoinP2PWorker;
//# sourceMappingURL=p2p.js.map