"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RippleEventAdapter = void 0;
var logger_1 = __importDefault(require("../../../logger"));
var RippleEventAdapter = /** @class */ (function () {
    function RippleEventAdapter(services) {
        this.services = services;
        this.stopping = false;
        this.clients = [];
    }
    RippleEventAdapter.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.stopping = false;
                console.log('Starting websocket adapter for Ripple');
                this.services.Event.events.on('stop', function () {
                    _this.stop();
                });
                this.services.Event.events.on('start', function () { return __awaiter(_this, void 0, void 0, function () {
                    var networks, chain, csp, _loop_1, networks_1, networks_1_1, network, e_1_1;
                    var e_1, _a;
                    var _this = this;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                networks = this.services.Config.chainNetworks()
                                    .filter(function (c) { return c.chain === 'XRP'; })
                                    .map(function (c) { return c.network; });
                                chain = 'XRP';
                                csp = this.services.CSP.get({ chain: chain });
                                _loop_1 = function (network) {
                                    var client_1, e_2;
                                    return __generator(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                _c.trys.push([0, 3, , 4]);
                                                return [4 /*yield*/, csp.getClient(network)];
                                            case 1:
                                                client_1 = _c.sent();
                                                client_1.rpc.on('ledgerClosed', function (ledger) { return __awaiter(_this, void 0, void 0, function () {
                                                    return __generator(this, function (_a) {
                                                        if (this.stopping) {
                                                            return [2 /*return*/];
                                                        }
                                                        this.services.Event.blockEvent.emit('block', __assign({ chain: chain, network: network }, ledger));
                                                        return [2 /*return*/];
                                                    });
                                                }); });
                                                client_1.rpc.on('disconnected', function () {
                                                    if (!_this.stopping) {
                                                        client_1.rpc.connect();
                                                    }
                                                });
                                                client_1.rpc.on('transaction', function (tx) { return __awaiter(_this, void 0, void 0, function () {
                                                    var address, transformedTx, transformedCoins, _a, transaction, coins, coins_1, coins_1_1, coin;
                                                    var e_3, _b;
                                                    return __generator(this, function (_c) {
                                                        switch (_c.label) {
                                                            case 0:
                                                                if (this.stopping) {
                                                                    return [2 /*return*/];
                                                                }
                                                                address = tx.transaction.Account;
                                                                transformedTx = __assign(__assign({}, csp.transform(tx, network)), { wallets: new Array() });
                                                                if (!('chain' in transformedTx)) return [3 /*break*/, 2];
                                                                transformedCoins = csp.transformToCoins(tx, network);
                                                                return [4 /*yield*/, csp.tag(chain, network, transformedTx, transformedCoins)];
                                                            case 1:
                                                                _a = _c.sent(), transaction = _a.transaction, coins = _a.coins;
                                                                this.services.Event.txEvent.emit('tx', __assign({}, transaction));
                                                                if (coins && coins.length) {
                                                                    try {
                                                                        for (coins_1 = __values(coins), coins_1_1 = coins_1.next(); !coins_1_1.done; coins_1_1 = coins_1.next()) {
                                                                            coin = coins_1_1.value;
                                                                            this.services.Event.addressCoinEvent.emit('coin', { address: address, coin: coin });
                                                                        }
                                                                    }
                                                                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                                                                    finally {
                                                                        try {
                                                                            if (coins_1_1 && !coins_1_1.done && (_b = coins_1.return)) _b.call(coins_1);
                                                                        }
                                                                        finally { if (e_3) throw e_3.error; }
                                                                    }
                                                                }
                                                                _c.label = 2;
                                                            case 2: return [2 /*return*/];
                                                        }
                                                    });
                                                }); });
                                                return [4 /*yield*/, client_1.asyncRequest('subscribe', { streams: ['ledger', 'transactions_proposed'] })];
                                            case 2:
                                                _c.sent();
                                                return [3 /*break*/, 4];
                                            case 3:
                                                e_2 = _c.sent();
                                                logger_1.default.error('Error connecting to XRP: %o', e_2);
                                                return [3 /*break*/, 4];
                                            case 4: return [2 /*return*/];
                                        }
                                    });
                                };
                                _b.label = 1;
                            case 1:
                                _b.trys.push([1, 6, 7, 8]);
                                networks_1 = __values(networks), networks_1_1 = networks_1.next();
                                _b.label = 2;
                            case 2:
                                if (!!networks_1_1.done) return [3 /*break*/, 5];
                                network = networks_1_1.value;
                                return [5 /*yield**/, _loop_1(network)];
                            case 3:
                                _b.sent();
                                _b.label = 4;
                            case 4:
                                networks_1_1 = networks_1.next();
                                return [3 /*break*/, 2];
                            case 5: return [3 /*break*/, 8];
                            case 6:
                                e_1_1 = _b.sent();
                                e_1 = { error: e_1_1 };
                                return [3 /*break*/, 8];
                            case 7:
                                try {
                                    if (networks_1_1 && !networks_1_1.done && (_a = networks_1.return)) _a.call(networks_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                                return [7 /*endfinally*/];
                            case 8: return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
            });
        });
    };
    RippleEventAdapter.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, client, e_4_1;
            var e_4, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        this.stopping = true;
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        _a = __values(this.clients), _b = _a.next();
                        _d.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 5];
                        client = _b.value;
                        client.rpc.removeAllListeners();
                        return [4 /*yield*/, client.asyncRequest('unsubscribe', { streams: ['ledger', 'transactions_proposed'] })];
                    case 3:
                        _d.sent();
                        client.rpc.disconnect();
                        _d.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_4_1 = _d.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_4) throw e_4.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    return RippleEventAdapter;
}());
exports.RippleEventAdapter = RippleEventAdapter;
//# sourceMappingURL=event-adapter.js.map