"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RippleWalletTransactions = void 0;
var stream_1 = require("stream");
var walletAddress_1 = require("../../../models/walletAddress");
var RippleWalletTransactions = /** @class */ (function (_super) {
    __extends(RippleWalletTransactions, _super);
    function RippleWalletTransactions(wallet, csp) {
        var _this = _super.call(this, { objectMode: true }) || this;
        _this.wallet = wallet;
        _this.csp = csp;
        return _this;
    }
    RippleWalletTransactions.prototype.getAddresses = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, chain, network, _id, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.wallet, chain = _a.chain, network = _a.network, _id = _a._id;
                        if (!!this.walletAddresses) return [3 /*break*/, 2];
                        _b = this;
                        return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection.find({ chain: chain, network: network, wallet: _id }).toArray()];
                    case 1:
                        _b.walletAddresses = _c.sent();
                        _c.label = 2;
                    case 2: return [2 /*return*/, this.walletAddresses];
                }
            });
        });
    };
    RippleWalletTransactions.prototype._transform = function (tx, _, done) {
        return __awaiter(this, void 0, void 0, function () {
            var network, transaction, changes, changed, relevantAddresses, sending, receiving, relevantAddresses_1, relevantAddresses_1_1, address, _a, _b, output, _c, _d, output;
            var e_1, _e, e_2, _f, e_3, _g;
            return __generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        network = this.wallet.network;
                        transaction = this.csp.transform(tx, network);
                        changes = tx.outcome.balanceChanges;
                        changed = Object.keys(changes);
                        return [4 /*yield*/, this.getAddresses()];
                    case 1:
                        relevantAddresses = (_h.sent()).filter(function (w) { return changed.includes(w.address); }).map(function (w) { return w.address; });
                        sending = false;
                        receiving = false;
                        try {
                            for (relevantAddresses_1 = __values(relevantAddresses), relevantAddresses_1_1 = relevantAddresses_1.next(); !relevantAddresses_1_1.done; relevantAddresses_1_1 = relevantAddresses_1.next()) {
                                address = relevantAddresses_1_1.value;
                                try {
                                    for (_a = (e_2 = void 0, __values(changes[address])), _b = _a.next(); !_b.done; _b = _a.next()) {
                                        output = _b.value;
                                        if (Number(output.value) > 0) {
                                            receiving = true;
                                        }
                                        if (Number(output.value) < 0) {
                                            sending = true;
                                        }
                                    }
                                }
                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                finally {
                                    try {
                                        if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
                                    }
                                    finally { if (e_2) throw e_2.error; }
                                }
                                try {
                                    for (_c = (e_3 = void 0, __values(changes[address])), _d = _c.next(); !_d.done; _d = _c.next()) {
                                        output = _d.value;
                                        if (sending) {
                                            if (!receiving) {
                                                this.push(JSON.stringify({
                                                    id: tx.hash,
                                                    txid: tx.hash,
                                                    fee: transaction.fee * 1e6,
                                                    size: 0,
                                                    category: 'send',
                                                    satoshis: -1 * Number(output.value) * 1e6,
                                                    height: transaction.blockHeight,
                                                    address: address,
                                                    outputIndex: changed.indexOf(address),
                                                    blockTime: transaction.blockTimeNormalized
                                                }) + '\n');
                                            }
                                            else {
                                                this.push(JSON.stringify({
                                                    id: tx.hash,
                                                    txid: tx.hash,
                                                    fee: transaction.fee * 1e6,
                                                    size: 0,
                                                    category: 'move',
                                                    satoshis: -1 * Number(output.value) * 1e6,
                                                    height: transaction.blockHeight,
                                                    address: address,
                                                    outputIndex: changed.indexOf(address),
                                                    blockTime: transaction.blockTimeNormalized
                                                }) + '\n');
                                            }
                                            if (transaction.fee > 0) {
                                                this.push(JSON.stringify({
                                                    id: tx.hash,
                                                    txid: tx.hash,
                                                    category: 'fee',
                                                    satoshis: -1 * Number(transaction.fee) * 1e6,
                                                    height: transaction.blockHeight,
                                                    blockTime: transaction.blockTimeNormalized
                                                }) + '\n');
                                            }
                                            return [2 /*return*/, done()];
                                        }
                                        else {
                                            if (receiving) {
                                                this.push(JSON.stringify({
                                                    id: tx.hash,
                                                    txid: tx.hash,
                                                    fee: transaction.fee * 1e6,
                                                    size: 0,
                                                    category: 'receive',
                                                    satoshis: Number(output.value) * 1e6,
                                                    height: transaction.blockHeight,
                                                    address: address,
                                                    outputIndex: changed.indexOf(address),
                                                    blockTime: transaction.blockTimeNormalized
                                                }) + '\n');
                                            }
                                        }
                                    }
                                }
                                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                                finally {
                                    try {
                                        if (_d && !_d.done && (_g = _c.return)) _g.call(_c);
                                    }
                                    finally { if (e_3) throw e_3.error; }
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (relevantAddresses_1_1 && !relevantAddresses_1_1.done && (_e = relevantAddresses_1.return)) _e.call(relevantAddresses_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        done();
                        return [2 /*return*/];
                }
            });
        });
    };
    return RippleWalletTransactions;
}(stream_1.Transform));
exports.RippleWalletTransactions = RippleWalletTransactions;
//# sourceMappingURL=transform.js.map