"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XrpBlockStorage = exports.XrpBlockModel = void 0;
var Loggify_1 = require("../../../decorators/Loggify");
var logger_1 = __importDefault(require("../../../logger"));
var baseBlock_1 = require("../../../models/baseBlock");
var events_1 = require("../../../models/events");
var transaction_1 = require("./transaction");
var XrpBlockModel = /** @class */ (function (_super) {
    __extends(XrpBlockModel, _super);
    function XrpBlockModel(storage) {
        return _super.call(this, storage) || this;
    }
    XrpBlockModel.prototype.onConnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                _super.prototype.onConnect.call(this);
                return [2 /*return*/];
            });
        });
    };
    XrpBlockModel.prototype.addBlock = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var block, chain, network, reorg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        block = params.block, chain = params.chain, network = params.network;
                        return [4 /*yield*/, this.handleReorg({ block: block, chain: chain, network: network })];
                    case 1:
                        reorg = _a.sent();
                        if (reorg) {
                            return [2 /*return*/, Promise.reject('reorg')];
                        }
                        return [2 /*return*/, this.processBlock(params)];
                }
            });
        });
    };
    XrpBlockModel.prototype.processBlock = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, transactions, parentChain, forkHeight, initialSyncComplete, coins, blockOp, convertedBlock, height, timeNormalized, time, previousBlock;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, transactions = params.transactions, parentChain = params.parentChain, forkHeight = params.forkHeight, initialSyncComplete = params.initialSyncComplete, coins = params.coins;
                        return [4 /*yield*/, this.getBlockOp(params)];
                    case 1:
                        blockOp = _a.sent();
                        convertedBlock = blockOp.updateOne.update.$set;
                        height = convertedBlock.height, timeNormalized = convertedBlock.timeNormalized, time = convertedBlock.time;
                        return [4 /*yield*/, this.collection.findOne({ hash: convertedBlock.previousBlockHash, chain: chain, network: network })];
                    case 2:
                        previousBlock = _a.sent();
                        return [4 /*yield*/, this.collection.bulkWrite([blockOp])];
                    case 3:
                        _a.sent();
                        if (!previousBlock) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.collection.updateOne({ chain: chain, network: network, hash: previousBlock.hash }, { $set: { nextBlockHash: convertedBlock.hash } })];
                    case 4:
                        _a.sent();
                        logger_1.default.debug('Updating previous block.nextBlockHash %o', convertedBlock.hash);
                        _a.label = 5;
                    case 5: return [4 /*yield*/, transaction_1.XrpTransactionStorage.batchImport({
                            txs: transactions,
                            coins: coins,
                            blockHash: convertedBlock.hash,
                            blockTime: new Date(time),
                            blockTimeNormalized: new Date(timeNormalized),
                            height: height,
                            chain: chain,
                            network: network,
                            parentChain: parentChain,
                            forkHeight: forkHeight,
                            initialSyncComplete: initialSyncComplete
                        })];
                    case 6:
                        _a.sent();
                        if (initialSyncComplete) {
                            events_1.EventStorage.signalBlock(convertedBlock);
                        }
                        return [4 /*yield*/, this.collection.updateOne({ hash: convertedBlock.hash, chain: chain, network: network }, { $set: { processed: true } })];
                    case 7:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    XrpBlockModel.prototype.getBlockOp = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var block, chain, network, blockTime, prevHash, previousBlock, timeNormalized, height;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        block = params.block, chain = params.chain, network = params.network;
                        blockTime = block.time;
                        prevHash = block.previousBlockHash;
                        return [4 /*yield*/, this.collection.findOne({ hash: prevHash, chain: chain, network: network })];
                    case 1:
                        previousBlock = _a.sent();
                        timeNormalized = (function () {
                            var prevTime = previousBlock ? previousBlock.timeNormalized : null;
                            if (prevTime && blockTime.getTime() <= prevTime.getTime()) {
                                return new Date(prevTime.getTime() + 1);
                            }
                            else {
                                return blockTime;
                            }
                        })();
                        height = block.height;
                        logger_1.default.debug('Setting blockheight: %o', height);
                        return [2 /*return*/, {
                                updateOne: {
                                    filter: {
                                        hash: block.hash,
                                        chain: chain,
                                        network: network
                                    },
                                    update: {
                                        $set: __assign(__assign({}, block), { timeNormalized: timeNormalized })
                                    },
                                    upsert: true
                                }
                            }];
                }
            });
        });
    };
    XrpBlockModel.prototype.handleReorg = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var block, chain, network, prevHash, localTip, prevBlock, reorgOps;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        block = params.block, chain = params.chain, network = params.network;
                        prevHash = block.previousBlockHash;
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 1:
                        localTip = _a.sent();
                        if (block != null && localTip != null && (localTip.hash === prevHash || localTip.hash === block.hash)) {
                            return [2 /*return*/, false];
                        }
                        if (!localTip || localTip.height === 0) {
                            return [2 /*return*/, false];
                        }
                        if (!block) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.collection.findOne({ chain: chain, network: network, hash: prevHash })];
                    case 2:
                        prevBlock = _a.sent();
                        if (prevBlock) {
                            localTip = prevBlock;
                        }
                        else {
                            logger_1.default.error("Previous block isn't in the DB need to roll back until we have a block in common");
                        }
                        logger_1.default.info("Resetting tip to ".concat(localTip.height - 1, " %o"), { chain: chain, network: network });
                        _a.label = 3;
                    case 3:
                        reorgOps = [
                            this.collection.deleteMany({ chain: chain, network: network, height: { $gte: localTip.height } }),
                            transaction_1.XrpTransactionStorage.collection.deleteMany({ chain: chain, network: network, blockHeight: { $gte: localTip.height } })
                        ];
                        return [4 /*yield*/, Promise.all(reorgOps)];
                    case 4:
                        _a.sent();
                        logger_1.default.debug('Removed data from above blockHeight: %o', localTip.height);
                        return [2 /*return*/, localTip.hash !== prevHash];
                }
            });
        });
    };
    XrpBlockModel.prototype._apiTransform = function (block, options) {
        var transform = {
            _id: block._id,
            chain: block.chain,
            network: block.network,
            hash: block.hash,
            height: block.height,
            size: block.size,
            time: block.time,
            timeNormalized: block.timeNormalized,
            previousBlockHash: block.previousBlockHash,
            nextBlockHash: block.nextBlockHash,
            reward: block.reward,
            transactionCount: block.transactionCount
        };
        if (options && options.object) {
            return transform;
        }
        return JSON.stringify(transform);
    };
    XrpBlockModel = __decorate([
        Loggify_1.LoggifyClass
    ], XrpBlockModel);
    return XrpBlockModel;
}(baseBlock_1.BaseBlock));
exports.XrpBlockModel = XrpBlockModel;
exports.XrpBlockStorage = new XrpBlockModel();
//# sourceMappingURL=block.js.map