"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XrpTransactionStorage = exports.XrpTransactionModel = void 0;
var Loggify_1 = require("../../../decorators/Loggify");
var logger_1 = __importDefault(require("../../../logger"));
var baseTransaction_1 = require("../../../models/baseTransaction");
var cache_1 = require("../../../models/cache");
var coin_1 = require("../../../models/coin");
var events_1 = require("../../../models/events");
var config_1 = require("../../../services/config");
var storage_1 = require("../../../services/storage");
var check_1 = require("../../../utils/check");
var partition_1 = require("../../../utils/partition");
var XrpTransactionModel = /** @class */ (function (_super) {
    __extends(XrpTransactionModel, _super);
    function XrpTransactionModel(storage) {
        if (storage === void 0) { storage = storage_1.Storage; }
        return _super.call(this, storage) || this;
    }
    XrpTransactionModel.prototype.onConnect = function () {
        _super.prototype.onConnect.call(this);
        this.collection.createIndex({ chain: 1, network: 1, from: 1, nonce: 1 }, { background: true, sparse: true });
    };
    XrpTransactionModel.prototype.batchImport = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var txOps, coinOps, batchSize, txOps_1, txOps_1_1, op, filter, tx, e_1_1, coinOps_1, coinOps_1_1, coinOp, coin, e_2_1;
            var e_1, _a, e_2, _b;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.addTransactions(__assign({}, params))];
                    case 1:
                        txOps = _c.sent();
                        return [4 /*yield*/, this.addCoins(__assign({}, params))];
                    case 2:
                        coinOps = (_c.sent());
                        batchSize = config_1.Config.get().maxPoolSize;
                        logger_1.default.debug('Writing Transactions: %o', txOps.length);
                        return [4 /*yield*/, Promise.all((0, partition_1.partition)(txOps, txOps.length / batchSize).map(function (txBatch) {
                                return _this.collection.bulkWrite(txBatch.map(function (op) { return _this.toMempoolSafeUpsert(op, 0 /* SpentHeightIndicators.minimum */); }), {
                                    ordered: false
                                });
                            }))];
                    case 3:
                        _c.sent();
                        return [4 /*yield*/, Promise.all((0, partition_1.partition)(coinOps, coinOps.length / batchSize).map(function (coinBatch) {
                                return coin_1.CoinStorage.collection.bulkWrite(coinBatch.map(function (op) { return _this.toMempoolSafeUpsert(op, 0 /* SpentHeightIndicators.minimum */); }), { ordered: false });
                            }))];
                    case 4:
                        _c.sent();
                        if (!params.initialSyncComplete) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.expireBalanceCache(coinOps)];
                    case 5:
                        _c.sent();
                        _c.label = 6;
                    case 6:
                        if (!(params.height != undefined && params.height < 0 /* SpentHeightIndicators.minimum */)) return [3 /*break*/, 21];
                        _c.label = 7;
                    case 7:
                        _c.trys.push([7, 12, 13, 14]);
                        txOps_1 = __values(txOps), txOps_1_1 = txOps_1.next();
                        _c.label = 8;
                    case 8:
                        if (!!txOps_1_1.done) return [3 /*break*/, 11];
                        op = txOps_1_1.value;
                        filter = op.updateOne.filter;
                        tx = __assign(__assign({}, op.updateOne.update.$set), filter);
                        return [4 /*yield*/, events_1.EventStorage.signalTx(tx)];
                    case 9:
                        _c.sent();
                        _c.label = 10;
                    case 10:
                        txOps_1_1 = txOps_1.next();
                        return [3 /*break*/, 8];
                    case 11: return [3 /*break*/, 14];
                    case 12:
                        e_1_1 = _c.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 14];
                    case 13:
                        try {
                            if (txOps_1_1 && !txOps_1_1.done && (_a = txOps_1.return)) _a.call(txOps_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 14:
                        _c.trys.push([14, 19, 20, 21]);
                        coinOps_1 = __values(coinOps), coinOps_1_1 = coinOps_1.next();
                        _c.label = 15;
                    case 15:
                        if (!!coinOps_1_1.done) return [3 /*break*/, 18];
                        coinOp = coinOps_1_1.value;
                        coin = __assign(__assign({}, coinOp.updateOne.filter), coinOp.updateOne.update.$set);
                        return [4 /*yield*/, events_1.EventStorage.signalAddressCoin({
                                address: coin.address,
                                coin: {
                                    value: coin.value,
                                    address: coin.address,
                                    chain: params.chain,
                                    network: params.network,
                                    mintTxid: coin.mintTxid
                                }
                            })];
                    case 16:
                        _c.sent();
                        _c.label = 17;
                    case 17:
                        coinOps_1_1 = coinOps_1.next();
                        return [3 /*break*/, 15];
                    case 18: return [3 /*break*/, 21];
                    case 19:
                        e_2_1 = _c.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 21];
                    case 20:
                        try {
                            if (coinOps_1_1 && !coinOps_1_1.done && (_b = coinOps_1.return)) _b.call(coinOps_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 21: return [2 /*return*/];
                }
            });
        });
    };
    XrpTransactionModel.prototype.expireBalanceCache = function (coinOps) {
        return __awaiter(this, void 0, void 0, function () {
            var batch, coinOps_2, coinOps_2_1, coinOp, coin, address, chain, network, batch_1, batch_1_1, payload, address, chain, network, lowerAddress, cacheKey, e_3_1;
            var e_4, _a, e_3, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        batch = new Array();
                        try {
                            for (coinOps_2 = __values(coinOps), coinOps_2_1 = coinOps_2.next(); !coinOps_2_1.done; coinOps_2_1 = coinOps_2.next()) {
                                coinOp = coinOps_2_1.value;
                                coin = __assign(__assign({}, coinOp.updateOne.filter), coinOp.updateOne.update.$set);
                                address = coin.address, chain = coin.chain, network = coin.network;
                                batch.push({ address: address, chain: chain, network: network });
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (coinOps_2_1 && !coinOps_2_1.done && (_a = coinOps_2.return)) _a.call(coinOps_2);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 6, 7, 8]);
                        batch_1 = __values(batch), batch_1_1 = batch_1.next();
                        _c.label = 2;
                    case 2:
                        if (!!batch_1_1.done) return [3 /*break*/, 5];
                        payload = batch_1_1.value;
                        address = payload.address, chain = payload.chain, network = payload.network;
                        lowerAddress = address.toLowerCase();
                        cacheKey = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(lowerAddress);
                        return [4 /*yield*/, cache_1.CacheStorage.expire(cacheKey)];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4:
                        batch_1_1 = batch_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_3_1 = _c.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (batch_1_1 && !batch_1_1.done && (_b = batch_1.return)) _b.call(batch_1);
                        }
                        finally { if (e_3) throw e_3.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    XrpTransactionModel.prototype.addTransactions = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var blockTimeNormalized, chain, height, network, parentChain, forkHeight, parentTxs;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        blockTimeNormalized = params.blockTimeNormalized, chain = params.chain, height = params.height, network = params.network, parentChain = params.parentChain, forkHeight = params.forkHeight;
                        if (!(parentChain && forkHeight && height != undefined && height < forkHeight)) return [3 /*break*/, 2];
                        return [4 /*yield*/, exports.XrpTransactionStorage.collection
                                .find({ blockHeight: height, chain: parentChain, network: network })
                                .toArray()];
                    case 1:
                        parentTxs = _a.sent();
                        return [2 /*return*/, parentTxs.map(function (parentTx) {
                                return {
                                    updateOne: {
                                        filter: { txid: parentTx.txid, chain: chain, network: network },
                                        update: {
                                            $set: __assign(__assign({}, parentTx), { wallets: new Array() })
                                        },
                                        upsert: true,
                                        forceServerObjectId: true
                                    }
                                };
                            })];
                    case 2: return [2 /*return*/, Promise.all(params.txs.map(function (tx) { return __awaiter(_this, void 0, void 0, function () {
                            var txid, wallets;
                            return __generator(this, function (_a) {
                                txid = tx.txid, wallets = tx.wallets;
                                return [2 /*return*/, {
                                        updateOne: {
                                            filter: { txid: txid, chain: chain, network: network },
                                            update: {
                                                $set: __assign(__assign({}, tx), { blockTimeNormalized: tx.blockTimeNormalized || blockTimeNormalized, wallets: wallets })
                                            },
                                            upsert: true,
                                            forceServerObjectId: true
                                        }
                                    }];
                            });
                        }); }))];
                }
            });
        });
    };
    XrpTransactionModel.prototype.addCoins = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, height, network, parentChain, forkHeight, parentChainCoins;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, height = params.height, network = params.network, parentChain = params.parentChain, forkHeight = params.forkHeight;
                        if (!(parentChain && forkHeight && height != undefined && height < forkHeight)) return [3 /*break*/, 2];
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({ blockHeight: height, chain: parentChain, network: network })
                                .toArray()];
                    case 1:
                        parentChainCoins = _a.sent();
                        return [2 /*return*/, parentChainCoins.map(function (coin) {
                                var mintTxid = coin.mintTxid;
                                return {
                                    updateOne: {
                                        filter: {
                                            mintTxid: mintTxid,
                                            mintIndex: coin.mintIndex,
                                            chain: chain,
                                            network: network
                                        },
                                        update: {
                                            $set: __assign(__assign({}, coin), { wallets: [] })
                                        },
                                        upsert: true,
                                        forceServerObjectId: true
                                    }
                                };
                            })];
                    case 2: return [2 /*return*/, params.coins.map(function (coin) {
                            var mintTxid = coin.mintTxid, wallets = coin.wallets, address = coin.address;
                            return {
                                updateOne: {
                                    filter: {
                                        mintTxid: mintTxid,
                                        mintIndex: coin.mintIndex,
                                        chain: chain,
                                        network: network
                                    },
                                    update: {
                                        $set: {
                                            chain: chain,
                                            network: network,
                                            address: address,
                                            mintHeight: coin.mintHeight || height,
                                            coinbase: coin.coinbase,
                                            value: coin.value
                                        },
                                        $setOnInsert: {
                                            wallets: wallets
                                        }
                                    },
                                    upsert: true,
                                    forceServerObjectId: true
                                }
                            };
                        })];
                }
            });
        });
    };
    XrpTransactionModel.prototype.getTransactions = function (params) {
        var originalQuery = params.query;
        var _a = storage_1.Storage.getFindOptions(this, params.options), query = _a.query, options = _a.options;
        var finalQuery = Object.assign({}, originalQuery, query);
        return this.collection.find(finalQuery, options).addCursorFlag('noCursorTimeout', true);
    };
    XrpTransactionModel.prototype._apiTransform = function (tx, options) {
        var transaction = {
            txid: tx.txid || '',
            network: tx.network || '',
            chain: tx.chain || '',
            blockHeight: (0, check_1.valueOrDefault)(tx.blockHeight, -1),
            blockHash: tx.blockHash || '',
            blockTime: tx.blockTime ? tx.blockTime.toISOString() : '',
            blockTimeNormalized: tx.blockTimeNormalized ? tx.blockTimeNormalized.toISOString() : '',
            fee: (0, check_1.valueOrDefault)(tx.fee, -1),
            value: (0, check_1.valueOrDefault)(tx.value, -1),
            from: tx.from || '',
            nonce: (0, check_1.valueOrDefault)(tx.nonce, -1),
            to: (0, check_1.valueOrDefault)(tx.to, ''),
            currency: (0, check_1.valueOrDefault)(tx.currency, 'XRP'),
            invoiceID: (0, check_1.valueOrDefault)(tx.invoiceID, '')
        };
        if (options && options.object) {
            return transaction;
        }
        return JSON.stringify(transaction);
    };
    XrpTransactionModel = __decorate([
        Loggify_1.LoggifyClass
    ], XrpTransactionModel);
    return XrpTransactionModel;
}(baseTransaction_1.BaseTransaction));
exports.XrpTransactionModel = XrpTransactionModel;
exports.XrpTransactionStorage = new XrpTransactionModel();
//# sourceMappingURL=transaction.js.map