"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultisigRelatedFilterTransform = void 0;
var stream_1 = require("stream");
var MultisigRelatedFilterTransform = /** @class */ (function (_super) {
    __extends(MultisigRelatedFilterTransform, _super);
    function MultisigRelatedFilterTransform(multisigContractAddress, tokenAddress) {
        var _this = _super.call(this, { objectMode: true }) || this;
        _this.multisigContractAddress = multisigContractAddress;
        _this.tokenAddress = tokenAddress;
        return _this;
    }
    MultisigRelatedFilterTransform.prototype._transform = function (tx, _, done) {
        return __awaiter(this, void 0, void 0, function () {
            var hasEffects, walletRelatedInternalTxs, walletRelatedInternalTxs_1, walletRelatedInternalTxs_1_1, internalTx, _tx;
            var e_1, _a;
            var _this = this;
            return __generator(this, function (_b) {
                hasEffects = false;
                if (tx.effects && tx.effects.length) {
                    walletRelatedInternalTxs = tx.effects.filter(function (internalTx) {
                        if (_this.tokenAddress) {
                            return [internalTx.to, internalTx.from].includes(_this.multisigContractAddress) && internalTx.contractAddress && internalTx.contractAddress.toLowerCase() == _this.tokenAddress.toLowerCase();
                        }
                        else {
                            // contractAddress is undefined on native asset transfers
                            return [internalTx.to, internalTx.from].includes(_this.multisigContractAddress) && !internalTx.contractAddress;
                        }
                    });
                    try {
                        // Create a tx object for each internal transfer
                        for (walletRelatedInternalTxs_1 = __values(walletRelatedInternalTxs), walletRelatedInternalTxs_1_1 = walletRelatedInternalTxs_1.next(); !walletRelatedInternalTxs_1_1.done; walletRelatedInternalTxs_1_1 = walletRelatedInternalTxs_1.next()) {
                            internalTx = walletRelatedInternalTxs_1_1.value;
                            _tx = Object.assign({}, tx);
                            _tx.value = Number(internalTx.amount);
                            _tx.to = internalTx.to;
                            _tx.from = internalTx.from;
                            this.push(_tx);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (walletRelatedInternalTxs_1_1 && !walletRelatedInternalTxs_1_1.done && (_a = walletRelatedInternalTxs_1.return)) _a.call(walletRelatedInternalTxs_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    // If we didn't find any internal transfers, original tx may be inconsequential
                    hasEffects = !!walletRelatedInternalTxs.length;
                }
                if (!hasEffects && tx.to !== this.multisigContractAddress) {
                    // If no effects and tx isn't to multisig, we don't care about original tx, return done()
                    return [2 /*return*/, done()];
                }
                this.push(tx);
                return [2 /*return*/, done()];
            });
        });
    };
    return MultisigRelatedFilterTransform;
}(stream_1.Transform));
exports.MultisigRelatedFilterTransform = MultisigRelatedFilterTransform;
//# sourceMappingURL=multisigTransform.js.map