"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EVMVerificationPeer = void 0;
var logger_1 = __importDefault(require("../../../../logger"));
var block_1 = require("../models/block");
var p2p_1 = require("./p2p");
var EVMVerificationPeer = /** @class */ (function (_super) {
    __extends(EVMVerificationPeer, _super);
    function EVMVerificationPeer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.prevBlockNum = 0;
        _this.prevHash = '';
        _this.nextBlockHash = '';
        _this.deepScan = false;
        return _this;
    }
    EVMVerificationPeer.prototype.enableDeepScan = function () {
        this.deepScan = true;
    };
    EVMVerificationPeer.prototype.disableDeepScan = function () {
        this.deepScan = false;
    };
    EVMVerificationPeer.prototype.setupListeners = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.web3.eth.subscribe('pendingTransactions')];
                    case 1:
                        _a.txSubscription = _c.sent();
                        this.txSubscription.subscribe(function (_err, tx) {
                            _this.events.emit('transaction', tx);
                        });
                        _b = this;
                        return [4 /*yield*/, this.web3.eth.subscribe('newBlockHeaders')];
                    case 2:
                        _b.blockSubscription = _c.sent();
                        this.blockSubscription.subscribe(function (_err, block) {
                            _this.events.emit('block', block);
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    EVMVerificationPeer.prototype.resync = function (start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, chain, network, currentHeight, lastLog, block, _b, convertedBlock, convertedTxs, nextBlock;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this, chain = _a.chain, network = _a.network;
                        currentHeight = Math.max(1, start);
                        _c.label = 1;
                    case 1:
                        if (!(currentHeight <= end)) return [3 /*break*/, 6];
                        lastLog = Date.now();
                        return [4 /*yield*/, this.getBlock(currentHeight)];
                    case 2:
                        block = _c.sent();
                        return [4 /*yield*/, this.convertBlock(block)];
                    case 3:
                        _b = _c.sent(), convertedBlock = _b.convertedBlock, convertedTxs = _b.convertedTxs;
                        return [4 /*yield*/, block_1.EVMBlockStorage.collection.findOne({ chain: chain, network: network, previousBlockHash: block.hash })];
                    case 4:
                        nextBlock = _c.sent();
                        if (nextBlock) {
                            convertedBlock.nextBlockHash = nextBlock.hash;
                        }
                        return [4 /*yield*/, this.blockModel.processBlock({
                                chain: this.chain,
                                network: this.network,
                                forkHeight: this.chainConfig.forkHeight,
                                parentChain: this.chainConfig.parentChain,
                                initialSyncComplete: this.initialSyncComplete,
                                block: convertedBlock,
                                transactions: convertedTxs
                            })];
                    case 5:
                        _c.sent();
                        currentHeight++;
                        if (Date.now() - lastLog > 100) {
                            logger_1.default.info('Re-Sync: %o', {
                                chain: chain,
                                network: network,
                                height: currentHeight
                            });
                            lastLog = Date.now();
                        }
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    EVMVerificationPeer.prototype.getBlockForNumber = function (blockNum) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getBlock(blockNum)];
            });
        });
    };
    EVMVerificationPeer.prototype.validateDataForBlock = function (blockNum, tipHeight, log) {
        if (log === void 0) { log = false; }
        return __awaiter(this, void 0, void 0, function () {
            var success, _a, chain, network, atTipOfChain, errors, _b, block, blockTxs, error, blockTxids, firstHash, _c, mempoolTxs, blocksForHash, blocksForHeight, seenTxs, linearProgress, prevHashMismatch, nextHashMismatch, missingLinearData, missingNextBlockHash, missingPrevBlockHash, missingData, error, mempoolTxs_1, mempoolTxs_1_1, tx, error, blockTxs_1, blockTxs_1_1, tx, error, error, error, error, hashFromTx, error;
            var e_1, _d, e_2, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        success = true;
                        _a = this, chain = _a.chain, network = _a.network;
                        atTipOfChain = blockNum === tipHeight;
                        errors = new Array();
                        return [4 /*yield*/, Promise.all([
                                this.blockModel.collection.findOne({
                                    chain: chain,
                                    network: network,
                                    height: blockNum,
                                    processed: true
                                }),
                                this.txModel.collection.find({ chain: chain, network: network, blockHeight: blockNum }).toArray()
                            ])];
                    case 1:
                        _b = __read.apply(void 0, [_f.sent(), 2]), block = _b[0], blockTxs = _b[1];
                        if (!block) {
                            success = false;
                            error = {
                                model: 'block',
                                err: true,
                                type: 'MISSING_BLOCK',
                                payload: { blockNum: blockNum }
                            };
                            errors.push(error);
                            if (log) {
                                console.log(JSON.stringify(error));
                            }
                            return [2 /*return*/, { success: success, errors: errors }];
                        }
                        blockTxids = blockTxs.map(function (t) { return t.txid; });
                        firstHash = blockTxs[0] ? blockTxs[0].blockHash : block.hash;
                        return [4 /*yield*/, Promise.all([
                                this.txModel.collection.find({ chain: chain, network: network, blockHeight: -1, txid: { $in: blockTxids } }).toArray(),
                                this.blockModel.collection.countDocuments({ chain: chain, network: network, hash: firstHash }),
                                this.blockModel.collection.countDocuments({
                                    chain: chain,
                                    network: network,
                                    height: blockNum,
                                    processed: true
                                })
                            ])];
                    case 2:
                        _c = __read.apply(void 0, [_f.sent(), 3]), mempoolTxs = _c[0], blocksForHash = _c[1], blocksForHeight = _c[2];
                        seenTxs = {};
                        linearProgress = this.prevBlockNum && this.prevBlockNum == blockNum - 1;
                        prevHashMismatch = this.prevHash && block.previousBlockHash != this.prevHash;
                        nextHashMismatch = this.nextBlockHash && block.hash != this.nextBlockHash;
                        this.prevHash = block.hash;
                        this.nextBlockHash = block.nextBlockHash;
                        this.prevBlockNum = blockNum;
                        missingLinearData = linearProgress && (prevHashMismatch || nextHashMismatch);
                        missingNextBlockHash = !atTipOfChain && !block.nextBlockHash;
                        missingPrevBlockHash = !block.previousBlockHash;
                        missingData = missingNextBlockHash || missingPrevBlockHash || missingLinearData;
                        if (!block || block.transactionCount != blockTxs.length || missingData) {
                            success = false;
                            error = {
                                model: 'block',
                                err: true,
                                type: 'CORRUPTED_BLOCK',
                                payload: { blockNum: blockNum, txCount: block.transactionCount, foundTxs: blockTxs.length }
                            };
                            errors.push(error);
                            if (log) {
                                console.log(JSON.stringify(error));
                            }
                        }
                        try {
                            for (mempoolTxs_1 = __values(mempoolTxs), mempoolTxs_1_1 = mempoolTxs_1.next(); !mempoolTxs_1_1.done; mempoolTxs_1_1 = mempoolTxs_1.next()) {
                                tx = mempoolTxs_1_1.value;
                                success = false;
                                error = { model: 'transaction', err: true, type: 'DUPE_TRANSACTION', payload: { tx: tx, blockNum: blockNum } };
                                errors.push(error);
                                if (log) {
                                    console.log(JSON.stringify(error));
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (mempoolTxs_1_1 && !mempoolTxs_1_1.done && (_d = mempoolTxs_1.return)) _d.call(mempoolTxs_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        try {
                            for (blockTxs_1 = __values(blockTxs), blockTxs_1_1 = blockTxs_1.next(); !blockTxs_1_1.done; blockTxs_1_1 = blockTxs_1.next()) {
                                tx = blockTxs_1_1.value;
                                if (tx.fee < 0) {
                                    success = false;
                                    error = { model: 'transaction', err: true, type: 'NEG_FEE', payload: { tx: tx, blockNum: blockNum } };
                                    errors.push(error);
                                    if (log) {
                                        console.log(JSON.stringify(error));
                                    }
                                }
                                if (seenTxs[tx.txid]) {
                                    success = false;
                                    error = { model: 'transaction', err: true, type: 'DUPE_TRANSACTION', payload: { tx: tx, blockNum: blockNum } };
                                    errors.push(error);
                                    if (log) {
                                        console.log(JSON.stringify(error));
                                    }
                                }
                                else {
                                    seenTxs[tx.txid] = tx;
                                }
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (blockTxs_1_1 && !blockTxs_1_1.done && (_e = blockTxs_1.return)) _e.call(blockTxs_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        if (blocksForHeight === 0) {
                            success = false;
                            error = {
                                model: 'block',
                                err: true,
                                type: 'MISSING_BLOCK',
                                payload: { blockNum: blockNum }
                            };
                            errors.push(error);
                            if (log) {
                                console.log(JSON.stringify(error));
                            }
                        }
                        if (blocksForHeight > 1) {
                            success = false;
                            error = {
                                model: 'block',
                                err: true,
                                type: 'DUPE_BLOCKHEIGHT',
                                payload: { blockNum: blockNum, blocksForHeight: blocksForHeight }
                            };
                            errors.push(error);
                            if (log) {
                                console.log(JSON.stringify(error));
                            }
                        }
                        // blocks with same hash
                        if (blockTxs.length > 0) {
                            hashFromTx = blockTxs[0].blockHash;
                            if (blocksForHash > 1) {
                                success = false;
                                error = { model: 'block', err: true, type: 'DUPE_BLOCKHASH', payload: { hash: hashFromTx, blockNum: blockNum } };
                                errors.push(error);
                                if (log) {
                                    console.log(JSON.stringify(error));
                                }
                            }
                        }
                        return [2 /*return*/, { success: success, errors: errors }];
                }
            });
        });
    };
    return EVMVerificationPeer;
}(p2p_1.EVMP2pWorker));
exports.EVMVerificationPeer = EVMVerificationPeer;
//# sourceMappingURL=EVMVerificationPeer.js.map