"use strict";
/**
 * !Important!
 * Erigon support is not actively maintained by BitPay. If there
 *  are issues with connecting to Erigon that need fixing, please
 *  open a PR.
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErigonRPC = void 0;
var abi_decoder_1 = __importDefault(require("abi-decoder"));
var Loggify_1 = require("../../../../../decorators/Loggify");
var erc20_1 = require("../../abi/erc20");
var erc721_1 = require("../../abi/erc721");
var transaction_1 = require("../../models/transaction");
abi_decoder_1.default.addABI(erc20_1.ERC20Abi);
abi_decoder_1.default.addABI(erc721_1.ERC721Abi);
if (Symbol['asyncIterator'] === undefined)
    Symbol['asyncIterator'] = Symbol.for('asyncIterator');
var ErigonRPC = /** @class */ (function () {
    function ErigonRPC(web3) {
        this.web3 = web3;
    }
    ErigonRPC.prototype.getBlock = function (blockNumber) {
        return this.web3.eth.getBlock(blockNumber, true);
    };
    ErigonRPC.prototype.traceBlock = function (blockNumber) {
        return __awaiter(this, void 0, void 0, function () {
            var txs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.send({
                            method: 'trace_block',
                            params: [this.web3.utils.toHex(blockNumber)],
                            jsonrpc: '2.0',
                            id: Date.now() + Math.round(Math.random() * 1000)
                        })];
                    case 1:
                        txs = _a.sent();
                        return [2 /*return*/, txs];
                }
            });
        });
    };
    ErigonRPC.prototype.getTransactionsFromBlock = function (blockNumber) {
        return __awaiter(this, void 0, void 0, function () {
            var txs;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.traceBlock(blockNumber)];
                    case 1:
                        txs = (_a.sent()) || [];
                        return [2 /*return*/, txs.map(function (tx) { return _this.transactionFromErigonTrace(tx); })];
                }
            });
        });
    };
    ErigonRPC.prototype.send = function (data) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var provider = _this.web3.eth.currentProvider; // Import type HttpProvider web3-core
            provider.send(data, function (err, data) {
                if (err)
                    return reject(err);
                resolve(data.result);
            });
        });
    };
    ErigonRPC.prototype.transactionFromErigonTrace = function (tx) {
        var abiType = transaction_1.EVMTransactionStorage.abiDecode(tx.action.input);
        var convertedTx = __assign({}, tx);
        if (abiType) {
            convertedTx.abiType = abiType;
        }
        return convertedTx;
    };
    ErigonRPC.prototype.reconcileTraces = function (block, transactions, traceTxs) {
        var e_1, _a;
        var gasSum = transactions.reduce(function (sum, e) { return sum + e.fee; }, 0);
        var _loop_1 = function (tx) {
            if (tx.type === 'reward') {
                if (tx.action.rewardType && tx.action.rewardType === 'block') {
                    var totalReward = Number.parseInt(tx.action.value, 16) + gasSum;
                    block.reward = totalReward;
                }
                if (tx.action.rewardType && tx.action.rewardType === 'uncle') {
                    var uncles = block.uncleReward || [];
                    var uncleValue = Number.parseInt(tx.action.value, 16);
                    uncles.push(uncleValue);
                    block.uncleReward = uncles;
                }
            }
            if (tx && tx.action) {
                var foundIndex = transactions.findIndex(function (t) {
                    return t.txid === tx.transactionHash &&
                        t.from !== tx.action.from &&
                        t.to.toLowerCase() !== (tx.action.to || '').toLowerCase();
                });
                if (foundIndex > -1) {
                    transactions[foundIndex].internal.push(tx);
                }
                if (tx.error) {
                    var errorIndex = transactions.findIndex(function (t) { return t.txid === tx.transactionHash; });
                    if (errorIndex && errorIndex > -1) {
                        transactions[errorIndex].error = tx.error;
                    }
                }
            }
        };
        try {
            for (var traceTxs_1 = __values(traceTxs), traceTxs_1_1 = traceTxs_1.next(); !traceTxs_1_1.done; traceTxs_1_1 = traceTxs_1.next()) {
                var tx = traceTxs_1_1.value;
                _loop_1(tx);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (traceTxs_1_1 && !traceTxs_1_1.done && (_a = traceTxs_1.return)) _a.call(traceTxs_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    ErigonRPC = __decorate([
        Loggify_1.LoggifyClass
    ], ErigonRPC);
    return ErigonRPC;
}());
exports.ErigonRPC = ErigonRPC;
//# sourceMappingURL=erigonRpc.js.map