"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GethRPC = void 0;
var logger_1 = __importDefault(require("../../../../../logger"));
var transaction_1 = require("../../models/transaction");
var GethRPC = /** @class */ (function () {
    function GethRPC(web3) {
        this.web3 = web3;
    }
    GethRPC.prototype.getBlock = function (blockNumber) {
        return this.web3.eth.getBlock(blockNumber, true);
    };
    GethRPC.prototype.traceBlock = function (blockNumber) {
        return __awaiter(this, void 0, void 0, function () {
            var result, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = [];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.send({
                                method: 'debug_traceBlockByNumber',
                                params: [this.web3.utils.toHex(blockNumber), { tracer: 'callTracer' }],
                                jsonrpc: '2.0',
                                id: Date.now() + Math.round(Math.random() * 1000)
                            })];
                    case 2:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        logger_1.default.debug('%o', e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, result];
                }
            });
        });
    };
    GethRPC.prototype.getTransactionsFromBlock = function (blockNumber) {
        return __awaiter(this, void 0, void 0, function () {
            var tracedTxs, txs;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.traceBlock(blockNumber)];
                    case 1:
                        tracedTxs = _a.sent();
                        txs = tracedTxs && tracedTxs.length > 0 ? tracedTxs.filter(function (tx) { return tx.result; }) : [];
                        return [2 /*return*/, txs.map(function (tx) { return _this.transactionFromGethTrace(tx); })];
                }
            });
        });
    };
    GethRPC.prototype.send = function (data) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var provider = _this.web3.eth.currentProvider;
            provider.send(data, function (err, data) {
                if (err || data.error)
                    return reject(err || data.error);
                resolve(data.result);
            });
        });
    };
    GethRPC.prototype.transactionFromGethTrace = function (tx) {
        var e_2, _a;
        var convertedTx = tx.result;
        convertedTx.abiType = transaction_1.EVMTransactionStorage.abiDecode(tx.result.input);
        try {
            for (var _b = __values(convertedTx.calls || []), _c = _b.next(); !_c.done; _c = _b.next()) {
                var call = _c.value;
                call.abiType = transaction_1.EVMTransactionStorage.abiDecode(tx.result.input);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return convertedTx;
    };
    GethRPC.prototype.reconcileTraces = function (block, transactions, traces) {
        var _this = this;
        // TODO calculate total block reward including fees
        block;
        for (var i in traces) {
            if (traces[i].calls) {
                var tx = transactions[i];
                tx.calls = traces[i].calls.flatMap(function (call, idx) { return _this.flattenTraceCalls(call, idx.toString()); });
            }
        }
        return transactions;
    };
    GethRPC.prototype.flattenTraceCalls = function (trace, depth) {
        var e_3, _a;
        var _this = this;
        var retval = [];
        var calls = trace.calls;
        delete trace.calls;
        trace.abiType = trace.input ? transaction_1.EVMTransactionStorage.abiDecode(trace.input) : undefined;
        if (trace.abiType) {
            try {
                for (var _b = __values(trace.abiType.params), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var param = _c.value;
                    param.value = typeof param.value === 'string' ? param.value : JSON.stringify(param.value);
                    if (param.value && param.value.length > 100) {
                        // Need to truncate this so it doesn't blow up the index.
                        param.value = param.value.substring(0, 100) + '...';
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        trace.depth = depth;
        retval.push(trace);
        if (calls) {
            retval.push.apply(retval, __spreadArray([], __read(calls.flatMap(function (call, idx) { return _this.flattenTraceCalls(call, depth + '_' + idx); })), false));
        }
        return retval;
    };
    return GethRPC;
}());
exports.GethRPC = GethRPC;
//# sourceMappingURL=gethRpc.js.map