"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyncWorker = void 0;
var crypto_rpc_1 = require("crypto-rpc");
var worker = __importStar(require("worker_threads"));
var logger_1 = __importDefault(require("../../../../logger"));
var config_1 = require("../../../../services/config");
var storage_1 = require("../../../../services/storage");
var check_1 = require("../../../../utils/check");
var wait_1 = require("../../../../utils/wait");
var block_1 = require("../models/block");
var transaction_1 = require("../models/transaction");
var rpcs_1 = require("./rpcs");
var SyncWorker = /** @class */ (function () {
    function SyncWorker() {
        this.chain = worker.workerData.chain;
        this.network = worker.workerData.network;
        this.parentPort = worker.parentPort;
        this.stopping = false;
        this.isWorking = false;
        this.chainConfig = config_1.Config.get().chains[this.chain][this.network];
    }
    SyncWorker.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.connect()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, storage_1.Storage.start()];
                    case 2:
                        _a.sent();
                        this.parentPort.on('message', this.messageHandler.bind(this));
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncWorker.prototype.stop = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        this.stopping = true;
                        logger_1.default.info('Stopping syncing thread ' + worker.threadId);
                        _c.label = 1;
                    case 1:
                        if (!this.isWorking) return [3 /*break*/, 3];
                        return [4 /*yield*/, (0, wait_1.wait)(1000)];
                    case 2:
                        _c.sent();
                        return [3 /*break*/, 1];
                    case 3: return [4 /*yield*/, storage_1.Storage.stop()];
                    case 4:
                        _c.sent();
                        return [4 /*yield*/, ((_b = (_a = this.web3) === null || _a === void 0 ? void 0 : _a.currentProvider) === null || _b === void 0 ? void 0 : _b.disconnect())];
                    case 5:
                        _c.sent();
                        process.exit(0);
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncWorker.prototype.messageHandler = function (msg) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (msg.message) {
                    case 'shutdown':
                        this.stop();
                        return [2 /*return*/];
                    default:
                        this.syncBlock(msg);
                        return [2 /*return*/];
                }
                return [2 /*return*/];
            });
        });
    };
    SyncWorker.prototype.syncBlock = function (_a) {
        var blockNum = _a.blockNum;
        return __awaiter(this, void 0, void 0, function () {
            var block, _b, convertedBlock, convertedTxs, err_1, error;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 4, 7, 8]);
                        if (this.stopping) {
                            return [2 /*return*/];
                        }
                        this.isWorking = true;
                        return [4 /*yield*/, this.rpc.getBlock(blockNum)];
                    case 1:
                        block = _c.sent();
                        if (!block) {
                            worker.parentPort.postMessage({ message: 'sync', notFound: true, blockNum: blockNum, threadId: worker.threadId });
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.convertBlock(block)];
                    case 2:
                        _b = _c.sent(), convertedBlock = _b.convertedBlock, convertedTxs = _b.convertedTxs;
                        return [4 /*yield*/, this.processBlock(convertedBlock, convertedTxs)];
                    case 3:
                        _c.sent();
                        worker.parentPort.postMessage({
                            message: 'sync',
                            notFound: !block,
                            blockNum: block.number,
                            threadId: worker.threadId
                        });
                        return [3 /*break*/, 8];
                    case 4:
                        err_1 = _c.sent();
                        logger_1.default.debug("Syncing thread ".concat(worker.threadId, " error: ").concat(err_1.stack));
                        error = err_1.message;
                        if (error === 'Invalid JSON RPC response: ""') {
                            error = null;
                        }
                        if (!error.includes('connect')) return [3 /*break*/, 6];
                        error = null;
                        logger_1.default.info("Syncing thread ".concat(worker.threadId, " lost connection to the node. Reconnecting."));
                        return [4 /*yield*/, this.connect()];
                    case 5:
                        _c.sent();
                        _c.label = 6;
                    case 6:
                        worker.parentPort.postMessage({ message: 'sync', notFound: true, blockNum: blockNum, threadId: worker.threadId, error: error });
                        return [3 /*break*/, 8];
                    case 7:
                        this.isWorking = false;
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    SyncWorker.prototype.getClient = function () {
        return __awaiter(this, void 0, void 0, function () {
            var nodeVersion, client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.web3.eth.getNodeInfo()];
                    case 1:
                        nodeVersion = _a.sent();
                        client = nodeVersion.split('/')[0].toLowerCase();
                        if (client !== 'erigon' && client !== 'geth') {
                            // assume it's a geth fork, or at least more like geth.
                            // this is helpful when using a dev solution like ganache.
                            return [2 /*return*/, 'geth'];
                        }
                        return [2 /*return*/, client];
                }
            });
        });
    };
    SyncWorker.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var providerIdx, providerConfig, rpcConfig, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        providerIdx = worker.threadId % (this.chainConfig.providers || []).length;
                        providerConfig = this.chainConfig.provider || this.chainConfig.providers[providerIdx];
                        rpcConfig = __assign(__assign({}, providerConfig), { chain: this.chain, currencyConfig: {} });
                        this.web3 = new crypto_rpc_1.CryptoRpc(rpcConfig).get(this.chain).web3;
                        _a = this;
                        return [4 /*yield*/, this.getClient()];
                    case 1:
                        _a.client = _b.sent();
                        this.rpc = new rpcs_1.Rpcs[this.client](this.web3);
                        return [2 /*return*/, { web3: this.web3, rpc: this.rpc }];
                }
            });
        });
    };
    SyncWorker.prototype.processBlock = function (block, transactions) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, block_1.EVMBlockStorage.addBlock({
                            chain: this.chain,
                            network: this.network,
                            forkHeight: this.chainConfig.forkHeight,
                            parentChain: this.chainConfig.parentChain,
                            initialSyncComplete: false,
                            block: block,
                            transactions: transactions
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncWorker.prototype.getBlockReward = function (block) {
        block;
        return 0;
    };
    SyncWorker.prototype.convertBlock = function (block) {
        return __awaiter(this, void 0, void 0, function () {
            var blockTime, hash, height, reward, convertedBlock, transactions, convertedTxs, traceTxs;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        blockTime = Number(block.timestamp) * 1000;
                        hash = block.hash;
                        height = block.number;
                        reward = this.getBlockReward(block);
                        convertedBlock = {
                            chain: this.chain,
                            network: this.network,
                            height: height,
                            hash: hash,
                            coinbase: Buffer.from(block.miner),
                            merkleRoot: Buffer.from(block.transactionsRoot),
                            time: new Date(blockTime),
                            timeNormalized: new Date(blockTime),
                            nonce: Buffer.from(block.extraData),
                            previousBlockHash: block.parentHash,
                            difficulty: block.difficulty,
                            totalDifficulty: block.totalDifficulty,
                            nextBlockHash: '',
                            transactionCount: block.transactions.length,
                            size: block.size,
                            reward: reward,
                            logsBloom: Buffer.from(block.logsBloom),
                            sha3Uncles: Buffer.from(block.sha3Uncles),
                            receiptsRoot: Buffer.from(block.receiptsRoot),
                            processed: false,
                            gasLimit: block.gasLimit,
                            gasUsed: block.gasUsed,
                            stateRoot: Buffer.from(block.stateRoot)
                        };
                        transactions = block.transactions;
                        convertedTxs = transactions.map(function (t) { return _this.convertTx(t, convertedBlock); });
                        return [4 /*yield*/, this.rpc.getTransactionsFromBlock(convertedBlock.height)];
                    case 1:
                        traceTxs = _a.sent();
                        transaction_1.EVMTransactionStorage.addEffectsToTxs(convertedTxs);
                        this.rpc.reconcileTraces(convertedBlock, convertedTxs, traceTxs);
                        return [2 /*return*/, { convertedBlock: convertedBlock, convertedTxs: convertedTxs }];
                }
            });
        });
    };
    SyncWorker.prototype.convertTx = function (tx, block) {
        var txid = tx.hash || '';
        var to = tx.to || '';
        var from = tx.from || '';
        var value = Number(tx.value);
        var fee = Number(tx.gas) * Number(tx.gasPrice);
        var abiType = transaction_1.EVMTransactionStorage.abiDecode(tx.input);
        var nonce = tx.nonce || 0;
        var convertedTx = {
            chain: this.chain,
            network: this.network,
            blockHeight: (0, check_1.valueOrDefault)(tx.blockNumber, -1),
            blockHash: (0, check_1.valueOrDefault)(tx.blockHash, undefined),
            data: Buffer.from(tx.input || '0x'),
            txid: txid,
            blockTime: new Date(),
            blockTimeNormalized: new Date(),
            fee: fee,
            transactionIndex: tx.transactionIndex || 0,
            value: value,
            wallets: [],
            to: to,
            from: from,
            gasLimit: Number(tx.gas),
            gasPrice: Number(tx.gasPrice),
            nonce: nonce,
            internal: [],
            calls: []
        };
        if (abiType) {
            convertedTx.abiType = abiType;
        }
        if (block) {
            var blockHash = block.hash, blockTime = block.time, blockTimeNormalized = block.timeNormalized, height = block.height;
            return __assign(__assign({}, convertedTx), { blockHeight: height, blockHash: blockHash, blockTime: blockTime, blockTimeNormalized: blockTimeNormalized });
        }
        return convertedTx;
    };
    return SyncWorker;
}());
exports.SyncWorker = SyncWorker;
worker.parentPort.once('message', function (msg) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (msg.message !== 'start') {
                        throw new Error('Unknown startup message');
                    }
                    return [4 /*yield*/, new SyncWorker().start()];
                case 1:
                    _a.sent();
                    return [2 /*return*/, worker.parentPort.postMessage({ message: 'ready' })];
            }
        });
    });
});
//# sourceMappingURL=syncWorker.js.map