"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChainStateProvider = void 0;
var services = {};
var ChainStateProxy = /** @class */ (function () {
    function ChainStateProxy() {
    }
    ChainStateProxy.prototype.get = function (_a) {
        var chain = _a.chain;
        if (services[chain] == undefined) {
            throw new Error("Chain ".concat(chain, " doesn't have a ChainStateProvider registered"));
        }
        return services[chain];
    };
    ChainStateProxy.prototype.streamAddressUtxos = function (params) {
        return this.get(params).streamAddressUtxos(params);
    };
    ChainStateProxy.prototype.streamAddressTransactions = function (params) {
        return this.get(params).streamAddressTransactions(params);
    };
    ChainStateProxy.prototype.getBalanceForAddress = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getBalanceForAddress(params)];
            });
        });
    };
    ChainStateProxy.prototype.getBlock = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getBlock(params)];
            });
        });
    };
    ChainStateProxy.prototype.getBlockBeforeTime = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getBlockBeforeTime(params)];
            });
        });
    };
    ChainStateProxy.prototype.streamBlocks = function (params) {
        return this.get(params).streamBlocks(params);
    };
    ChainStateProxy.prototype.streamTransactions = function (params) {
        return this.get(params).streamTransactions(params);
    };
    ChainStateProxy.prototype.getAuthhead = function (params) {
        return this.get(params).getAuthhead(params);
    };
    ChainStateProxy.prototype.getDailyTransactions = function (params) {
        return this.get(params).getDailyTransactions(params);
    };
    ChainStateProxy.prototype.getTransaction = function (params) {
        return this.get(params).getTransaction(params);
    };
    ChainStateProxy.prototype.createWallet = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).createWallet(params)];
            });
        });
    };
    ChainStateProxy.prototype.getWallet = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getWallet(params)];
            });
        });
    };
    ChainStateProxy.prototype.streamWalletAddresses = function (params) {
        return this.get(params).streamWalletAddresses(params);
    };
    ChainStateProxy.prototype.walletCheck = function (params) {
        return this.get(params).walletCheck(params);
    };
    ChainStateProxy.prototype.updateWallet = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).updateWallet(params)];
            });
        });
    };
    ChainStateProxy.prototype.streamWalletTransactions = function (params) {
        return this.get(params).streamWalletTransactions(params);
    };
    ChainStateProxy.prototype.getWalletBalance = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getWalletBalance(params)];
            });
        });
    };
    ChainStateProxy.prototype.getWalletBalanceAtTime = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getWalletBalanceAtTime(params)];
            });
        });
    };
    ChainStateProxy.prototype.getFee = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getFee(params)];
            });
        });
    };
    ChainStateProxy.prototype.getPriorityFee = function (params) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                return [2 /*return*/, (_b = (_a = this.get(params)).getPriorityFee) === null || _b === void 0 ? void 0 : _b.call(_a, params)];
            });
        });
    };
    ChainStateProxy.prototype.streamWalletUtxos = function (params) {
        return this.get(params).streamWalletUtxos(params);
    };
    ChainStateProxy.prototype.broadcastTransaction = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).broadcastTransaction(params)];
            });
        });
    };
    ChainStateProxy.prototype.registerService = function (currency, service) {
        services[currency] = service;
    };
    ChainStateProxy.prototype.getCoinsForTx = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getCoinsForTx(params)];
            });
        });
    };
    ChainStateProxy.prototype.getLocalTip = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getLocalTip(params)];
            });
        });
    };
    ChainStateProxy.prototype.getLocatorHashes = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.get(params).getLocatorHashes(params)];
            });
        });
    };
    ChainStateProxy.prototype.streamMissingWalletAddresses = function (params) {
        return this.get(params).streamMissingWalletAddresses(params);
    };
    ChainStateProxy.prototype.isValid = function (params) {
        return this.get(params).isValid(params);
    };
    return ChainStateProxy;
}());
exports.ChainStateProvider = new ChainStateProxy();
//# sourceMappingURL=index.js.map