"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalStateProvider = void 0;
var through2_1 = __importDefault(require("through2"));
var crypto_wallet_core_1 = require("crypto-wallet-core");
var Loggify_1 = require("../../../decorators/Loggify");
var block_1 = require("../../../models/block");
var cache_1 = require("../../../models/cache");
var coin_1 = require("../../../models/coin");
var state_1 = require("../../../models/state");
var transaction_1 = require("../../../models/transaction");
var wallet_1 = require("../../../models/wallet");
var walletAddress_1 = require("../../../models/walletAddress");
var rpc_1 = require("../../../rpc");
var config_1 = require("../../../services/config");
var storage_1 = require("../../../services/storage");
var stringifyJsonStream_1 = require("../../../utils/stringifyJsonStream");
var transforms_1 = require("./transforms");
var InternalStateProvider = /** @class */ (function () {
    function InternalStateProvider(chain, WalletStreamTransform) {
        if (WalletStreamTransform === void 0) { WalletStreamTransform = transforms_1.ListTransactionsStream; }
        this.WalletStreamTransform = WalletStreamTransform;
        this.chain = chain;
        this.chain = this.chain.toUpperCase();
    }
    InternalStateProvider.prototype.getRPC = function (chain, network) {
        var RPC_PEER = config_1.Config.chainConfig({ chain: chain, network: network }).rpc;
        if (!RPC_PEER) {
            throw new Error("RPC not configured for ".concat(chain, " ").concat(network));
        }
        var username = RPC_PEER.username, password = RPC_PEER.password, host = RPC_PEER.host, port = RPC_PEER.port;
        return new rpc_1.RPC(username, password, host, port);
    };
    InternalStateProvider.prototype.getAddressQuery = function (params) {
        var chain = params.chain, network = params.network, address = params.address, args = params.args;
        if (typeof address !== 'string' || !chain || !network) {
            throw new Error('Missing required param');
        }
        var query = { chain: chain, network: network.toLowerCase(), address: address };
        if (args.unspent) {
            query.spentHeight = { $lt: 0 /* SpentHeightIndicators.minimum */ };
        }
        if (args.excludeConflicting) {
            query.mintHeight = { $gt: -3 /* SpentHeightIndicators.conflicting */ };
        }
        return query;
    };
    InternalStateProvider.prototype.streamAddressUtxos = function (params) {
        var req = params.req, res = params.res, args = params.args;
        var limit = args.limit, since = args.since;
        var query = this.getAddressQuery(params);
        storage_1.Storage.apiStreamingFind(coin_1.CoinStorage, query, { limit: limit, since: since, paging: '_id' }, req, res);
    };
    InternalStateProvider.prototype.streamAddressTransactions = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var req, res, args, limit, since, query;
            return __generator(this, function (_a) {
                req = params.req, res = params.res, args = params.args;
                limit = args.limit, since = args.since;
                query = this.getAddressQuery(params);
                storage_1.Storage.apiStreamingFind(coin_1.CoinStorage, query, { limit: limit, since: since, paging: '_id' }, req, res);
                return [2 /*return*/];
            });
        });
    };
    InternalStateProvider.prototype.getBalanceForAddress = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, address, query, balance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, address = params.address;
                        query = {
                            chain: chain,
                            network: network,
                            address: address,
                            spentHeight: { $lt: 0 /* SpentHeightIndicators.minimum */ },
                            mintHeight: { $gt: -3 /* SpentHeightIndicators.conflicting */ }
                        };
                        return [4 /*yield*/, coin_1.CoinStorage.getBalance({ query: query })];
                    case 1:
                        balance = _a.sent();
                        return [2 /*return*/, balance];
                }
            });
        });
    };
    InternalStateProvider.prototype.streamBlocks = function (params) {
        var req = params.req, res = params.res;
        var _a = this.getBlocksQuery(params), query = _a.query, options = _a.options;
        storage_1.Storage.apiStreamingFind(block_1.BitcoinBlockStorage, query, options, req, res);
    };
    InternalStateProvider.prototype.getBlocks = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, query, options, cursor, blocks, tip, tipHeight, blockTransform;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.getBlocksQuery(params), query = _a.query, options = _a.options;
                        cursor = block_1.BitcoinBlockStorage.collection.find(query, options).addCursorFlag('noCursorTimeout', true);
                        if (options.sort) {
                            cursor = cursor.sort(options.sort);
                        }
                        return [4 /*yield*/, cursor.toArray()];
                    case 1:
                        blocks = _b.sent();
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 2:
                        tip = _b.sent();
                        tipHeight = tip ? tip.height : 0;
                        blockTransform = function (b) {
                            var confirmations = 0;
                            if (b.height && b.height >= 0) {
                                confirmations = tipHeight - b.height + 1;
                            }
                            var convertedBlock = block_1.BitcoinBlockStorage._apiTransform(b, { object: true });
                            return __assign(__assign({}, convertedBlock), { confirmations: confirmations });
                        };
                        return [2 /*return*/, blocks.map(blockTransform)];
                }
            });
        });
    };
    InternalStateProvider.prototype.getBlocksQuery = function (params) {
        var chain = params.chain, network = params.network, sinceBlock = params.sinceBlock, blockId = params.blockId, _a = params.args, args = _a === void 0 ? {} : _a;
        var startDate = args.startDate, endDate = args.endDate, date = args.date, since = args.since, direction = args.direction, paging = args.paging;
        var _b = args.limit, limit = _b === void 0 ? 10 : _b, _c = args.sort, sort = _c === void 0 ? { height: -1 } : _c;
        var options = { limit: limit, sort: sort, since: since, direction: direction, paging: paging };
        if (!chain || !network) {
            throw new Error('Missing required param');
        }
        var query = {
            chain: chain,
            network: network.toLowerCase(),
            processed: true
        };
        if (blockId) {
            if (blockId.length >= 64) {
                query.hash = blockId;
            }
            else {
                var height = parseInt(blockId, 10);
                if (Number.isNaN(height) || height.toString(10) !== blockId) {
                    throw new Error('invalid block id provided');
                }
                query.height = height;
            }
        }
        if (sinceBlock) {
            var height = Number(sinceBlock);
            if (Number.isNaN(height) || height.toString(10) !== sinceBlock) {
                throw new Error('invalid block id provided');
            }
            query.height = { $gt: height };
        }
        if (startDate) {
            query.time = { $gt: new Date(startDate) };
        }
        if (endDate) {
            Object.assign(query.time, __assign(__assign({}, query.time), { $lt: new Date(endDate) }));
        }
        if (date) {
            var firstDate = new Date(date);
            var nextDate = new Date(date);
            nextDate.setDate(nextDate.getDate() + 1);
            query.time = { $gt: firstDate, $lt: nextDate };
        }
        return { query: query, options: options };
    };
    InternalStateProvider.prototype.getBlock = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var blocks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getBlocks(params)];
                    case 1:
                        blocks = _a.sent();
                        return [2 /*return*/, blocks[0]];
                }
            });
        });
    };
    InternalStateProvider.prototype.getBlockBeforeTime = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, time, date, _a, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        chain = params.chain, network = params.network, time = params.time;
                        date = new Date(time || Date.now());
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .find({
                                chain: chain,
                                network: network,
                                timeNormalized: { $lte: date }
                            })
                                .limit(1)
                                .sort({ timeNormalized: -1 })
                                .toArray()];
                    case 1:
                        _a = __read.apply(void 0, [_b.sent(), 1]), block = _a[0];
                        return [2 /*return*/, block];
                }
            });
        });
    };
    InternalStateProvider.prototype.streamTransactions = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, req, res, args, blockHash, blockHeight, query, tip, tipHeight;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, req = params.req, res = params.res, args = params.args;
                        blockHash = args.blockHash, blockHeight = args.blockHeight;
                        if (!chain || !network) {
                            throw new Error('Missing chain or network');
                        }
                        query = {
                            chain: chain,
                            network: network.toLowerCase()
                        };
                        if (blockHeight !== undefined) {
                            query.blockHeight = Number(blockHeight);
                        }
                        if (blockHash !== undefined) {
                            query.blockHash = blockHash;
                        }
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 1:
                        tip = _a.sent();
                        tipHeight = tip ? tip.height : 0;
                        return [2 /*return*/, storage_1.Storage.apiStreamingFind(transaction_1.TransactionStorage, query, args, req, res, function (t) {
                                var confirmations = 0;
                                if (t.blockHeight !== undefined && t.blockHeight >= 0) {
                                    confirmations = tipHeight - t.blockHeight + 1;
                                }
                                var convertedTx = transaction_1.TransactionStorage._apiTransform(t, { object: true });
                                return JSON.stringify(__assign(__assign({}, convertedTx), { confirmations: confirmations }));
                            })];
                }
            });
        });
    };
    InternalStateProvider.prototype.getTransaction = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, txId, query, tip, tipHeight, found, confirmations, convertedTx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, txId = params.txId;
                        if (typeof txId !== 'string' || !chain || !network) {
                            throw new Error('Missing required param');
                        }
                        network = network.toLowerCase();
                        query = { chain: chain, network: network, txid: txId };
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 1:
                        tip = _a.sent();
                        tipHeight = tip ? tip.height : 0;
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.findOne(query)];
                    case 2:
                        found = _a.sent();
                        if (found) {
                            confirmations = 0;
                            if (found.blockHeight && found.blockHeight >= 0) {
                                confirmations = tipHeight - found.blockHeight + 1;
                            }
                            convertedTx = transaction_1.TransactionStorage._apiTransform(found, { object: true });
                            return [2 /*return*/, __assign(__assign({}, convertedTx), { confirmations: confirmations })];
                        }
                        else {
                            return [2 /*return*/, undefined];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    InternalStateProvider.prototype.getAuthhead = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, txId, found, transformedCoins;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, txId = params.txId;
                        if (typeof txId !== 'string') {
                            throw new Error('Missing required param');
                        }
                        return [4 /*yield*/, coin_1.CoinStorage.resolveAuthhead(txId, chain, network)];
                    case 1:
                        found = (_a.sent())[0];
                        if (found) {
                            transformedCoins = found.identityOutputs.map(function (output) {
                                return coin_1.CoinStorage._apiTransform(output, { object: true });
                            });
                            return [2 /*return*/, {
                                    chain: found.chain,
                                    network: found.network,
                                    authbase: found.authbase,
                                    identityOutputs: transformedCoins
                                }];
                        }
                        else {
                            return [2 /*return*/, undefined];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    InternalStateProvider.prototype.createWallet = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, name, pubKey, path, singleAddress, state, initialSyncComplete, walletConfig, canCreate, wallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, name = params.name, pubKey = params.pubKey, path = params.path, singleAddress = params.singleAddress;
                        if (typeof name !== 'string' || !network) {
                            throw new Error('Missing required param');
                        }
                        return [4 /*yield*/, state_1.StateStorage.collection.findOne({})];
                    case 1:
                        state = _a.sent();
                        initialSyncComplete = state && state.initialSyncComplete && state.initialSyncComplete.includes("".concat(chain, ":").concat(network));
                        walletConfig = config_1.Config.for('api').wallets;
                        canCreate = walletConfig && walletConfig.allowCreationBeforeCompleteSync;
                        if (!initialSyncComplete && !canCreate) {
                            throw new Error('Wallet creation not permitted before intitial sync is complete');
                        }
                        wallet = {
                            chain: chain,
                            network: network,
                            name: name,
                            pubKey: pubKey,
                            path: path,
                            singleAddress: singleAddress
                        };
                        return [4 /*yield*/, wallet_1.WalletStorage.collection.insertOne(wallet)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, wallet];
                }
            });
        });
    };
    InternalStateProvider.prototype.getWallet = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var pubKey;
            return __generator(this, function (_a) {
                pubKey = params.pubKey;
                return [2 /*return*/, wallet_1.WalletStorage.collection.findOne({ pubKey: pubKey })];
            });
        });
    };
    InternalStateProvider.prototype.streamWalletAddresses = function (params) {
        var walletId = params.walletId, req = params.req, res = params.res;
        var query = { wallet: walletId };
        storage_1.Storage.apiStreamingFind(walletAddress_1.WalletAddressStorage, query, {}, req, res);
    };
    InternalStateProvider.prototype.walletCheck = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, wallet;
            return __generator(this, function (_a) {
                chain = params.chain, network = params.network, wallet = params.wallet;
                return [2 /*return*/, new Promise(function (resolve) {
                        var addressStream = walletAddress_1.WalletAddressStorage.collection.find({ chain: chain, network: network, wallet: wallet }).project({ address: 1 });
                        var sum = 0;
                        var lastAddress;
                        addressStream.on('data', function (walletAddress) {
                            if (walletAddress.address) {
                                lastAddress = walletAddress.address;
                                var addressSum = Buffer.from(walletAddress.address).reduce(function (tot, cur) { return (tot + cur) % Number.MAX_SAFE_INTEGER; });
                                sum = (sum + addressSum) % Number.MAX_SAFE_INTEGER;
                            }
                        });
                        addressStream.on('end', function () {
                            resolve({ lastAddress: lastAddress, sum: sum });
                        });
                    })];
            });
        });
    };
    InternalStateProvider.prototype.streamMissingWalletAddresses = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, pubKey, res, wallet, walletId, query, cursor, seen, stringifyWallets, allMissingAddresses, totalMissingValue, missingStream;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, pubKey = params.pubKey, res = params.res;
                        return [4 /*yield*/, wallet_1.WalletStorage.collection.findOne({ pubKey: pubKey })];
                    case 1:
                        wallet = _a.sent();
                        walletId = wallet._id;
                        query = { chain: chain, network: network, wallets: walletId, spentHeight: { $gte: 0 /* SpentHeightIndicators.minimum */ } };
                        cursor = coin_1.CoinStorage.collection.find(query).addCursorFlag('noCursorTimeout', true);
                        seen = {};
                        stringifyWallets = function (wallets) { return wallets.map(function (w) { return w.toHexString(); }); };
                        allMissingAddresses = new Array();
                        totalMissingValue = 0;
                        missingStream = cursor.pipe((0, through2_1.default)({ objectMode: true }, function (spentCoin, _, done) { return __awaiter(_this, void 0, void 0, function () {
                            var spends, missing;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!!seen[spentCoin.spentTxid]) return [3 /*break*/, 2];
                                        seen[spentCoin.spentTxid] = true;
                                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                                .find({ chain: chain, network: network, spentTxid: spentCoin.spentTxid })
                                                .addCursorFlag('noCursorTimeout', true)
                                                .toArray()];
                                    case 1:
                                        spends = _a.sent();
                                        missing = spends
                                            .filter(function (coin) { return !stringifyWallets(coin.wallets).includes(walletId.toHexString()); })
                                            .map(function (coin) {
                                            var _id = coin._id, wallets = coin.wallets, address = coin.address, value = coin.value;
                                            totalMissingValue += value;
                                            allMissingAddresses.push(address);
                                            return { _id: _id, wallets: wallets, address: address, value: value, expected: walletId.toHexString() };
                                        });
                                        if (missing.length > 0) {
                                            return [2 /*return*/, done(undefined, { txid: spentCoin.spentTxid, missing: missing })];
                                        }
                                        _a.label = 2;
                                    case 2: return [2 /*return*/, done()];
                                }
                            });
                        }); }, function (done) {
                            this.push({ allMissingAddresses: allMissingAddresses, totalMissingValue: totalMissingValue });
                            done();
                        }));
                        missingStream.pipe(new stringifyJsonStream_1.StringifyJsonStream()).pipe(res);
                        return [2 /*return*/];
                }
            });
        });
    };
    InternalStateProvider.prototype.updateWallet = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, addresses;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        wallet = params.wallet, addresses = params.addresses;
                        return [4 /*yield*/, walletAddress_1.WalletAddressStorage.updateCoins({ wallet: wallet, addresses: addresses })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    InternalStateProvider.prototype.streamWalletTransactions = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, wallet, res, args, query, blockRangeQuery, startDate, endDate, transactionStream, listTransactionsStream;
            return __generator(this, function (_a) {
                chain = params.chain, network = params.network, wallet = params.wallet, res = params.res, args = params.args;
                query = {
                    chain: chain,
                    network: network,
                    wallets: wallet._id,
                    'wallets.0': { $exists: true }
                };
                if (args) {
                    if (args.startBlock || args.endBlock) {
                        query.$or = [];
                        if (args.includeMempool) {
                            query.$or.push({ blockHeight: -1 /* SpentHeightIndicators.pending */ });
                        }
                        blockRangeQuery = {};
                        if (args.startBlock) {
                            blockRangeQuery.$gte = Number(args.startBlock);
                        }
                        if (args.endBlock) {
                            blockRangeQuery.$lte = Number(args.endBlock);
                        }
                        query.$or.push({ blockHeight: blockRangeQuery });
                    }
                    else {
                        if (args.startDate) {
                            startDate = new Date(args.startDate);
                            if (startDate.getTime()) {
                                query.blockTimeNormalized = { $gte: new Date(args.startDate) };
                            }
                        }
                        if (args.endDate) {
                            endDate = new Date(args.endDate);
                            if (endDate.getTime()) {
                                query.blockTimeNormalized = query.blockTimeNormalized || {};
                                query.blockTimeNormalized.$lt = new Date(args.endDate);
                            }
                        }
                    }
                }
                transactionStream = transaction_1.TransactionStorage.collection
                    .find(query)
                    .sort({ blockTimeNormalized: 1 })
                    .addCursorFlag('noCursorTimeout', true);
                listTransactionsStream = new this.WalletStreamTransform(wallet);
                transactionStream.pipe(listTransactionsStream).pipe(res);
                return [2 /*return*/];
            });
        });
    };
    InternalStateProvider.prototype.getWalletBalance = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                query = {
                    wallets: params.wallet._id,
                    'wallets.0': { $exists: true },
                    spentHeight: { $lt: 0 /* SpentHeightIndicators.minimum */ },
                    mintHeight: { $gt: -3 /* SpentHeightIndicators.conflicting */ }
                };
                return [2 /*return*/, coin_1.CoinStorage.getBalance({ query: query })];
            });
        });
    };
    InternalStateProvider.prototype.getWalletBalanceAtTime = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, time, query;
            return __generator(this, function (_a) {
                chain = params.chain, network = params.network, time = params.time;
                query = { wallets: params.wallet._id, 'wallets.0': { $exists: true } };
                return [2 /*return*/, coin_1.CoinStorage.getBalanceAtTime({ query: query, time: time, chain: chain, network: network })];
            });
        });
    };
    InternalStateProvider.prototype.streamWalletUtxos = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, limit, _a, args, req, res, query, tip, tipHeight, utxoTransform;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        wallet = params.wallet, limit = params.limit, _a = params.args, args = _a === void 0 ? {} : _a, req = params.req, res = params.res;
                        query = {
                            wallets: wallet._id,
                            'wallets.0': { $exists: true },
                            mintHeight: { $gt: -3 /* SpentHeightIndicators.conflicting */ }
                        };
                        if (args.includeSpent !== 'true') {
                            query.spentHeight = { $lt: -1 /* SpentHeightIndicators.pending */ };
                        }
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 1:
                        tip = _b.sent();
                        tipHeight = tip ? tip.height : 0;
                        utxoTransform = function (c) {
                            var confirmations = 0;
                            if (c.mintHeight && c.mintHeight >= 0) {
                                confirmations = tipHeight - c.mintHeight + 1;
                            }
                            c.confirmations = confirmations;
                            return coin_1.CoinStorage._apiTransform(c);
                        };
                        storage_1.Storage.apiStreamingFind(coin_1.CoinStorage, query, { limit: limit }, req, res, utxoTransform);
                        return [2 /*return*/];
                }
            });
        });
    };
    InternalStateProvider.prototype.getFee = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, target, mode, cacheKey;
            var _this = this;
            return __generator(this, function (_a) {
                chain = params.chain, network = params.network, target = params.target, mode = params.mode;
                cacheKey = "getFee-".concat(chain, "-").concat(network, "-").concat(target).concat(mode ? '-' + mode.toLowerCase() : '');
                return [2 /*return*/, cache_1.CacheStorage.getGlobalOrRefresh(cacheKey, function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/, this.getRPC(chain, network).getEstimateSmartFee(Number(target), mode)];
                        });
                    }); }, 5 * cache_1.CacheStorage.Times.Minute)];
            });
        });
    };
    InternalStateProvider.prototype.broadcastTransaction = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, rawTx, txids, rawTxs, rawTxs_1, rawTxs_1_1, tx, txid, e_1_1;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        chain = params.chain, network = params.network, rawTx = params.rawTx;
                        txids = new Array();
                        rawTxs = typeof rawTx === 'string' ? [rawTx] : rawTx;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, 7, 8]);
                        rawTxs_1 = __values(rawTxs), rawTxs_1_1 = rawTxs_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!rawTxs_1_1.done) return [3 /*break*/, 5];
                        tx = rawTxs_1_1.value;
                        return [4 /*yield*/, this.getRPC(chain, network).sendTransaction(tx)];
                    case 3:
                        txid = _b.sent();
                        txids.push(txid);
                        _b.label = 4;
                    case 4:
                        rawTxs_1_1 = rawTxs_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (rawTxs_1_1 && !rawTxs_1_1.done && (_a = rawTxs_1.return)) _a.call(rawTxs_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/, txids.length === 1 ? txids[0] : txids];
                }
            });
        });
    };
    InternalStateProvider.prototype.getCoinsForTx = function (_a) {
        var chain = _a.chain, network = _a.network, txid = _a.txid;
        return __awaiter(this, void 0, void 0, function () {
            var tx, inputs, outputs;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({ txid: txid })];
                    case 1:
                        tx = _b.sent();
                        if (tx === 0) {
                            throw new Error("No such transaction ".concat(txid));
                        }
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({
                                chain: chain,
                                network: network,
                                spentTxid: txid
                            })
                                .addCursorFlag('noCursorTimeout', true)
                                .toArray()];
                    case 2:
                        inputs = _b.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({
                                chain: chain,
                                network: network,
                                mintTxid: txid
                            })
                                .addCursorFlag('noCursorTimeout', true)
                                .toArray()];
                    case 3:
                        outputs = _b.sent();
                        return [2 /*return*/, {
                                inputs: inputs.map(function (input) { return coin_1.CoinStorage._apiTransform(input, { object: true }); }),
                                outputs: outputs.map(function (output) { return coin_1.CoinStorage._apiTransform(output, { object: true }); })
                            }];
                }
            });
        });
    };
    InternalStateProvider.prototype.getDailyTransactions = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, startDate, endDate, formatDate, todayTruncatedUTC, oneMonth, isValidDate, start, end, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, startDate = params.startDate, endDate = params.endDate;
                        formatDate = function (d) { return new Date(d.toISOString().split('T')[0]); };
                        todayTruncatedUTC = formatDate(new Date());
                        oneMonth = new Date(todayTruncatedUTC);
                        oneMonth.setDate(todayTruncatedUTC.getDate() - 30);
                        oneMonth = formatDate(oneMonth);
                        isValidDate = function (d) {
                            return new Date(d).toString() !== 'Invalid Date';
                        };
                        start = startDate && isValidDate(startDate) ? new Date(startDate) : oneMonth;
                        end = endDate && isValidDate(endDate) ? formatDate(new Date(endDate)) : todayTruncatedUTC;
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .aggregate([
                                {
                                    $match: {
                                        chain: chain,
                                        network: network,
                                        timeNormalized: {
                                            $gte: start,
                                            $lt: end
                                        }
                                    }
                                },
                                {
                                    $group: {
                                        _id: {
                                            $dateToString: {
                                                format: '%Y-%m-%d',
                                                date: '$timeNormalized'
                                            }
                                        },
                                        transactionCount: {
                                            $sum: '$transactionCount'
                                        }
                                    }
                                },
                                {
                                    $project: {
                                        _id: 0,
                                        date: '$_id',
                                        transactionCount: '$transactionCount'
                                    }
                                },
                                {
                                    $sort: {
                                        date: 1
                                    }
                                }
                            ])
                                .toArray()];
                    case 1:
                        results = _a.sent();
                        return [2 /*return*/, {
                                chain: chain,
                                network: network,
                                results: results
                            }];
                }
            });
        });
    };
    InternalStateProvider.prototype.getLocalTip = function (_a) {
        var chain = _a.chain, network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                return [2 /*return*/, block_1.BitcoinBlockStorage.getLocalTip({ chain: chain, network: network })];
            });
        });
    };
    /**
     * Get a series of hashes that come before a given height, or the 30 most recent hashes
     *
     * @returns Array<string>
     */
    InternalStateProvider.prototype.getLocatorHashes = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, startHeight, endHeight, query, locatorBlocks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = params.chain, network = params.network, startHeight = params.startHeight, endHeight = params.endHeight;
                        query = startHeight && endHeight
                            ? {
                                processed: true,
                                chain: chain,
                                network: network,
                                height: { $gt: startHeight, $lt: endHeight }
                            }
                            : {
                                processed: true,
                                chain: chain,
                                network: network
                            };
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .find(query, { sort: { height: -1 }, limit: 30 })
                                .addCursorFlag('noCursorTimeout', true)
                                .toArray()];
                    case 1:
                        locatorBlocks = _a.sent();
                        if (locatorBlocks.length < 2) {
                            return [2 /*return*/, [Array(65).join('0')]];
                        }
                        return [2 /*return*/, locatorBlocks.map(function (block) { return block.hash; })];
                }
            });
        });
    };
    InternalStateProvider.prototype.isValid = function (params) {
        var input = params.input;
        if (this.isValidBlockOrTx(input)) {
            return { isValid: true, type: 'blockOrTx' };
        }
        else if (this.isValidAddress(params)) {
            return { isValid: true, type: 'addr' };
        }
        else if (this.isValidBlockIndex(input)) {
            return { isValid: true, type: 'blockOrTx' };
        }
        else {
            return { isValid: false, type: 'invalid' };
        }
    };
    InternalStateProvider.prototype.isValidBlockOrTx = function (inputValue) {
        var regexp = /^[0-9a-fA-F]{64}$/;
        if (regexp.test(inputValue)) {
            return true;
        }
        else {
            return false;
        }
    };
    InternalStateProvider.prototype.isValidAddress = function (params) {
        var chain = params.chain, network = params.network, input = params.input;
        var addr = this.extractAddress(input);
        return !!crypto_wallet_core_1.Validation.validateAddress(chain, network, addr);
    };
    InternalStateProvider.prototype.isValidBlockIndex = function (inputValue) {
        return isFinite(inputValue);
    };
    InternalStateProvider.prototype.extractAddress = function (address) {
        var extractedAddress = address.replace(/^(bitcoincash:|bchtest:|bitcoin:)/i, '').replace(/\?.*/, '');
        return extractedAddress || address;
    };
    InternalStateProvider.prototype.getWalletAddresses = function (walletId) {
        return __awaiter(this, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                query = { chain: this.chain, wallet: walletId };
                return [2 /*return*/, walletAddress_1.WalletAddressStorage.collection
                        .find(query)
                        .addCursorFlag('noCursorTimeout', true)
                        .toArray()];
            });
        });
    };
    InternalStateProvider = __decorate([
        Loggify_1.LoggifyClass
    ], InternalStateProvider);
    return InternalStateProvider;
}());
exports.InternalStateProvider = InternalStateProvider;
//# sourceMappingURL=internal.js.map