"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListTransactionsStream = void 0;
var stream_1 = require("stream");
var coin_1 = require("../../../models/coin");
var ListTransactionsStream = /** @class */ (function (_super) {
    __extends(ListTransactionsStream, _super);
    function ListTransactionsStream(wallet) {
        var _this = _super.call(this, { objectMode: true }) || this;
        _this.wallet = wallet;
        return _this;
    }
    ListTransactionsStream.prototype._transform = function (transaction, _, done) {
        return __awaiter(this, void 0, void 0, function () {
            var sending, wallet, outputs, outputs;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, coin_1.CoinStorage.collection.countDocuments({
                            wallets: this.wallet._id,
                            'wallets.0': { $exists: true },
                            spentTxid: transaction.txid
                        })];
                    case 1:
                        sending = !!(_a.sent());
                        wallet = this.wallet._id.toString();
                        if (!sending) return [3 /*break*/, 3];
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({
                                chain: transaction.chain,
                                network: transaction.network,
                                mintTxid: transaction.txid
                            }, { batchSize: 10000 })
                                .project({ address: 1, wallets: 1, value: 1, mintIndex: 1 })
                                .addCursorFlag('noCursorTimeout', true)
                                .toArray()];
                    case 2:
                        outputs = _a.sent();
                        outputs.forEach(function (output) {
                            var sendingToOurself = output.wallets.some(function (outputWallet) {
                                return outputWallet.equals(wallet);
                            });
                            if (!sendingToOurself) {
                                _this.push(JSON.stringify({
                                    id: transaction._id,
                                    txid: transaction.txid,
                                    fee: transaction.fee,
                                    size: transaction.size,
                                    category: 'send',
                                    satoshis: -output.value,
                                    height: transaction.blockHeight,
                                    address: output.address,
                                    outputIndex: output.mintIndex,
                                    blockTime: transaction.blockTimeNormalized
                                }) + '\n');
                            }
                            else {
                                _this.push(JSON.stringify({
                                    id: transaction._id,
                                    txid: transaction.txid,
                                    fee: transaction.fee,
                                    size: transaction.size,
                                    category: 'move',
                                    satoshis: -output.value,
                                    height: transaction.blockHeight,
                                    address: output.address,
                                    outputIndex: output.mintIndex,
                                    blockTime: transaction.blockTimeNormalized
                                }) + '\n');
                            }
                        });
                        if (transaction.fee > 0) {
                            this.push(JSON.stringify({
                                id: transaction._id,
                                txid: transaction.txid,
                                category: 'fee',
                                satoshis: -transaction.fee,
                                height: transaction.blockHeight,
                                blockTime: transaction.blockTimeNormalized
                            }) + '\n');
                        }
                        return [2 /*return*/, done()];
                    case 3: return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({
                            wallets: this.wallet._id,
                            'wallets.0': { $exists: true },
                            mintTxid: transaction.txid
                        })
                            .project({ address: 1, wallets: 1, value: 1, mintIndex: 1 })
                            .addCursorFlag('noCursorTimeout', true)
                            .toArray()];
                    case 4:
                        outputs = _a.sent();
                        outputs.forEach(function (output) {
                            var weReceived = output.wallets.some(function (outputWallet) {
                                return outputWallet.equals(wallet);
                            });
                            if (weReceived) {
                                _this.push(JSON.stringify({
                                    id: transaction._id,
                                    txid: transaction.txid,
                                    fee: transaction.fee,
                                    size: transaction.size,
                                    category: 'receive',
                                    satoshis: output.value,
                                    height: transaction.blockHeight,
                                    address: output.address,
                                    outputIndex: output.mintIndex,
                                    blockTime: transaction.blockTimeNormalized
                                }) + '\n');
                            }
                        });
                        _a.label = 5;
                    case 5:
                        done();
                        return [2 /*return*/];
                }
            });
        });
    };
    return ListTransactionsStream;
}(stream_1.Transform));
exports.ListTransactionsStream = ListTransactionsStream;
//# sourceMappingURL=transforms.js.map