"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var coin_1 = require("../../models/coin");
var transaction_1 = require("../../models/transaction");
var chain_state_1 = require("../../providers/chain-state");
var middleware_1 = require("../middleware");
var router = require('express').Router({ mergeParams: true });
router.get('/', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, chain, network, _b, sinceBlock, date, limit, since, direction, paging, payload;
        return __generator(this, function (_c) {
            _a = req.params, chain = _a.chain, network = _a.network;
            _b = req.query, sinceBlock = _b.sinceBlock, date = _b.date, limit = _b.limit, since = _b.since, direction = _b.direction, paging = _b.paging;
            if (limit) {
                limit = parseInt(limit);
            }
            try {
                payload = {
                    chain: chain,
                    network: network,
                    sinceBlock: sinceBlock,
                    args: { date: date, limit: limit, since: since, direction: direction, paging: paging },
                    req: req,
                    res: res
                };
                return [2 /*return*/, chain_state_1.ChainStateProvider.streamBlocks(payload)];
            }
            catch (err) {
                return [2 /*return*/, res.status(500).send(err)];
            }
            return [2 /*return*/];
        });
    });
});
router.get('/tip', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, chain, network, tip, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = req.params, chain = _a.chain, network = _a.network;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.getLocalTip({ chain: chain, network: network })];
                case 2:
                    tip = _b.sent();
                    return [2 /*return*/, res.json(tip)];
                case 3:
                    err_1 = _b.sent();
                    console.error(err_1);
                    return [2 /*return*/, res.status(500).send(err_1)];
                case 4: return [2 /*return*/];
            }
        });
    });
});
router.get('/:blockId', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, blockId, chain, network, block, tip, err_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = req.params, blockId = _a.blockId, chain = _a.chain, network = _a.network;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.getBlock({ chain: chain, network: network, blockId: blockId })];
                case 2:
                    block = _b.sent();
                    if (!block) {
                        return [2 /*return*/, res.status(404).send('block not found')];
                    }
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.getLocalTip({ chain: chain, network: network })];
                case 3:
                    tip = _b.sent();
                    if (block && tip && tip.height - block.height > middleware_1.Confirmations.Deep) {
                        (0, middleware_1.SetCache)(res, middleware_1.CacheTimes.Month);
                    }
                    return [2 /*return*/, res.json(block)];
                case 4:
                    err_2 = _b.sent();
                    return [2 /*return*/, res.status(500).send(err_2)];
                case 5: return [2 /*return*/];
            }
        });
    });
});
// return all { txids, inputs, ouputs} for a blockHash paginated at max 500 per page, to limit reqs and overload
router.get('/:blockHash/coins/:limit/:pgnum', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, chain, network, blockHash, limit, pgnum, pageNumber, maxLimit, skips, numOfTxs, txs, _b, txidIndexes_1, txids, inputs, outputs, prevPageNum, nxtPageNum, previous, next, sanitize, err_3;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = req.params, chain = _a.chain, network = _a.network, blockHash = _a.blockHash, limit = _a.limit, pgnum = _a.pgnum;
                    try {
                        pageNumber = parseInt(pgnum, 10);
                        maxLimit = parseInt(limit, 10);
                        if (maxLimit) {
                            if (maxLimit > 500)
                                maxLimit = 500;
                        }
                    }
                    catch (err) {
                        console.log(err);
                    }
                    skips = maxLimit * (pageNumber - 1);
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, blockHash: blockHash }).count()];
                case 1:
                    numOfTxs = _c.sent();
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 9, , 10]);
                    if (!(numOfTxs < maxLimit)) return [3 /*break*/, 4];
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, blockHash: blockHash }).toArray()];
                case 3:
                    _b = _c.sent();
                    return [3 /*break*/, 6];
                case 4: return [4 /*yield*/, transaction_1.TransactionStorage.collection
                        .find({ chain: chain, network: network, blockHash: blockHash })
                        .skip(skips)
                        .limit(maxLimit)
                        .toArray()];
                case 5:
                    _b = _c.sent();
                    _c.label = 6;
                case 6:
                    txs = _b;
                    if (!txs) {
                        return [2 /*return*/, res.status(422).send('No txs for page')];
                    }
                    txidIndexes_1 = {};
                    txids = txs.map(function (tx, index) {
                        txidIndexes_1[index] = tx.txid;
                        return tx.txid;
                    });
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, spentTxid: { $in: txids } })
                            .addCursorFlag('noCursorTimeout', true)
                            .toArray()];
                case 7:
                    inputs = _c.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: txids } })
                            .addCursorFlag('noCursorTimeout', true)
                            .toArray()];
                case 8:
                    outputs = _c.sent();
                    prevPageNum = void 0;
                    nxtPageNum = void 0;
                    previous = '';
                    next = '';
                    if (pageNumber !== 1) {
                        prevPageNum = parseInt(pageNumber) - 1;
                        previous = "/block/".concat(blockHash, "/coins/").concat(maxLimit, "/").concat(prevPageNum);
                    }
                    if (numOfTxs - maxLimit * pageNumber > 0) {
                        nxtPageNum = pageNumber + 1;
                        next = "/block/".concat(blockHash, "/coins/").concat(maxLimit, "/").concat(nxtPageNum);
                    }
                    sanitize = function (coins) { return coins.map(function (c) { return coin_1.CoinStorage._apiTransform(c, { object: true }); }); };
                    return [2 /*return*/, res.json({ txids: txids, inputs: sanitize(inputs), outputs: sanitize(outputs), previous: previous, next: next })];
                case 9:
                    err_3 = _c.sent();
                    return [2 /*return*/, res.status(500).send(err_3)];
                case 10: return [2 /*return*/];
            }
        });
    });
});
router.get('/before-time/:time', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, time, chain, network, block, tip, err_4;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = req.params, time = _a.time, chain = _a.chain, network = _a.network;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.getBlockBeforeTime({ chain: chain, network: network, time: time })];
                case 2:
                    block = _b.sent();
                    if (!block) {
                        return [2 /*return*/, res.status(404).send('block not found')];
                    }
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.getLocalTip({ chain: chain, network: network })];
                case 3:
                    tip = _b.sent();
                    if (block && tip && tip.height - block.height > middleware_1.Confirmations.Deep) {
                        (0, middleware_1.SetCache)(res, middleware_1.CacheTimes.Month);
                    }
                    return [2 /*return*/, res.json(block)];
                case 4:
                    err_4 = _b.sent();
                    return [2 /*return*/, res.status(500).send(err_4)];
                case 5: return [2 /*return*/];
            }
        });
    });
});
module.exports = {
    router: router,
    path: '/block'
};
//# sourceMappingURL=block.js.map