"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = __importDefault(require("../../config"));
var logger_1 = __importDefault(require("../../logger"));
var chain_state_1 = require("../../providers/chain-state");
var middleware_1 = require("../middleware");
var middleware_2 = require("../middleware");
var router = require('express').Router({ mergeParams: true });
var feeCache = {};
var feeModes = {
    BTC: ['CONSERVATIVE', 'ECONOMICAL'],
    LTC: ['CONSERVATIVE', 'ECONOMICAL']
};
router.get('/:target', (0, middleware_2.CacheMiddleware)(middleware_1.CacheTimes.Second), function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, target, chain, network, _b, mode, txType, targetNum, feeCacheKey, cachedFee, fee, err_1;
    var _c, _d, _e;
    return __generator(this, function (_f) {
        switch (_f.label) {
            case 0:
                _a = req.params, target = _a.target, chain = _a.chain, network = _a.network;
                _b = req.query, mode = _b.mode, txType = _b.txType;
                if (!chain || !network) {
                    return [2 /*return*/, res.status(400).send('Missing required param')];
                }
                chain = chain.toUpperCase();
                network = network.toLowerCase();
                mode = mode === null || mode === void 0 ? void 0 : mode.toUpperCase();
                targetNum = Number(target);
                if (targetNum < 0 || targetNum > 100) {
                    return [2 /*return*/, res.status(400).send('invalid target specified')];
                }
                if (!mode) {
                    mode = (_d = (_c = config_1.default.chains[chain]) === null || _c === void 0 ? void 0 : _c[network]) === null || _d === void 0 ? void 0 : _d.defaultFeeMode;
                }
                else if (!feeModes[chain]) {
                    mode = undefined;
                }
                else if (!((_e = feeModes[chain]) === null || _e === void 0 ? void 0 : _e.includes(mode))) {
                    return [2 /*return*/, res.status(400).send('invalid mode specified')];
                }
                if (txType && txType.toString() != '2') {
                    return [2 /*return*/, res.status(400).send('invalid txType specified')];
                }
                feeCacheKey = "".concat(chain, ":").concat(network, ":").concat(target);
                feeCacheKey += "".concat(mode ? ':' + mode : '');
                feeCacheKey += "".concat(txType ? ':type' + txType : '');
                cachedFee = feeCache[feeCacheKey];
                if (cachedFee && cachedFee.date > Date.now() - 10 * 1000) {
                    return [2 /*return*/, res.json(cachedFee.fee)];
                }
                _f.label = 1;
            case 1:
                _f.trys.push([1, 3, , 4]);
                return [4 /*yield*/, chain_state_1.ChainStateProvider.getFee({ chain: chain, network: network, target: targetNum, mode: mode, txType: txType })];
            case 2:
                fee = _f.sent();
                if (!fee) {
                    return [2 /*return*/, res.status(404).send('not available right now')];
                }
                // As of v0.21.2.2, Litecoin Core has a bug where it returns a fee rate of 0.00000999 which is below the min relay fee (0.00001).
                // TODO: remove this if statement once https://github.com/litecoin-project/litecoin/issues/908 is fixed.
                if (chain === 'LTC' && fee.feerate && fee.feerate < 0.00001) {
                    fee.feerate = 0.00001;
                }
                feeCache[feeCacheKey] = { fee: fee, date: Date.now() };
                return [2 /*return*/, res.json(fee)];
            case 3:
                err_1 = _f.sent();
                logger_1.default.error('Fee Error: %o', err_1.message || err_1);
                return [2 /*return*/, res.status(500).send('Error getting fee from RPC')];
            case 4: return [2 /*return*/];
        }
    });
}); });
module.exports = {
    router: router,
    path: '/fee'
};
//# sourceMappingURL=fee.js.map