"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = require("express");
var logger_1 = __importDefault(require("../../logger"));
var chain_state_1 = require("../../providers/chain-state");
var middleware_1 = require("../middleware");
var middleware_2 = require("../middleware");
var router = (0, express_1.Router)({ mergeParams: true });
router.get('/', function (req, res) {
    var _a = req.params, chain = _a.chain, network = _a.network;
    var _b = req.query, blockHeight = _b.blockHeight, blockHash = _b.blockHash, limit = _b.limit, since = _b.since, direction = _b.direction, paging = _b.paging;
    if (!chain || !network) {
        return res.status(400).send('Missing required param');
    }
    if (!blockHash && !blockHeight) {
        return res.status(400).send('Must provide blockHash or blockHeight');
    }
    chain = chain.toUpperCase();
    network = network.toLowerCase();
    var payload = {
        chain: chain,
        network: network,
        req: req,
        res: res,
        args: { limit: limit, since: since, direction: direction, paging: paging }
    };
    if (blockHeight !== undefined) {
        payload.args.blockHeight = parseInt(blockHeight);
    }
    if (blockHash !== undefined) {
        payload.args.blockHash = blockHash;
    }
    return chain_state_1.ChainStateProvider.streamTransactions(payload);
});
router.get('/:txId', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, txId, tx, tip, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, chain = _a.chain, network = _a.network, txId = _a.txId;
                if (typeof txId !== 'string' || !chain || !network) {
                    return [2 /*return*/, res.status(400).send('Missing required param')];
                }
                txId = txId
                    .replace(/&/g, '&amp;')
                    .replace(/</g, '&lt;')
                    .replace(/>/g, '&gt;')
                    .replace(/"/g, '&quot;');
                chain = chain.toUpperCase();
                network = network.toLowerCase();
                _b.label = 1;
            case 1:
                _b.trys.push([1, 6, , 7]);
                return [4 /*yield*/, chain_state_1.ChainStateProvider.getTransaction({ chain: chain, network: network, txId: txId })];
            case 2:
                tx = _b.sent();
                if (!!tx) return [3 /*break*/, 3];
                return [2 /*return*/, res.status(404).send("The requested txid ".concat(txId, " could not be found."))];
            case 3: return [4 /*yield*/, chain_state_1.ChainStateProvider.getLocalTip({ chain: chain, network: network })];
            case 4:
                tip = _b.sent();
                if (tx && tip && tx.blockHeight > 0 && tip.height - tx.blockHeight > 100) {
                    (0, middleware_1.SetCache)(res, middleware_2.CacheTimes.Month);
                }
                return [2 /*return*/, res.send(tx)];
            case 5: return [3 /*break*/, 7];
            case 6:
                err_1 = _b.sent();
                return [2 /*return*/, res.status(500).send(err_1)];
            case 7: return [2 /*return*/];
        }
    });
}); });
// Get transaction with input and outputs, assigned to key coins
router.get('/:txId/populated', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, txId, txid, tx, coins, tip, err_2;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = req.params, chain = _a.chain, network = _a.network, txId = _a.txId;
                txid = txId;
                if (typeof txid !== 'string' || !chain || !network) {
                    return [2 /*return*/, res.status(400).send('Missing required param')];
                }
                _c.label = 1;
            case 1:
                _c.trys.push([1, 3, , 4]);
                tx = void 0;
                coins = void 0;
                tip = void 0;
                return [4 /*yield*/, Promise.all([
                        chain_state_1.ChainStateProvider.getTransaction({ chain: chain, network: network, txId: txId }),
                        chain_state_1.ChainStateProvider.getCoinsForTx({ chain: chain, network: network, txid: txid }),
                        chain_state_1.ChainStateProvider.getLocalTip({ chain: chain, network: network })
                    ])];
            case 2:
                _b = __read.apply(void 0, [_c.sent(), 3]), tx = _b[0], coins = _b[1], tip = _b[2];
                if (!tx) {
                    return [2 /*return*/, res.status(404).send("The requested txid ".concat(txid, " could not be found."))];
                }
                else {
                    if (tx && tip && tx.blockHeight > 0 && tip.height - tx.blockHeight > 100) {
                        (0, middleware_1.SetCache)(res, middleware_2.CacheTimes.Month);
                    }
                    if (!coins) {
                        res.status(404).send("The requested coins for txid ".concat(txid, " could not be found."));
                    }
                    tx.coins = coins;
                    return [2 /*return*/, res.send(tx)];
                }
                return [3 /*break*/, 4];
            case 3:
                err_2 = _c.sent();
                return [2 /*return*/, res.status(500).send(err_2)];
            case 4: return [2 /*return*/];
        }
    });
}); });
router.get('/:txId/authhead', function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, txId, authhead, err_3;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, chain = _a.chain, network = _a.network, txId = _a.txId;
                if (typeof txId !== 'string' || !chain || !network) {
                    return [2 /*return*/, res.status(400).send('Missing required param')];
                }
                chain = chain.toUpperCase();
                network = network.toLowerCase();
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, chain_state_1.ChainStateProvider.getAuthhead({ chain: chain, network: network, txId: txId })];
            case 2:
                authhead = _b.sent();
                if (!authhead) {
                    return [2 /*return*/, res.status(404).send("Authhead for txid ".concat(txId, " could not be found."))];
                }
                else {
                    return [2 /*return*/, res.send(authhead)];
                }
                return [3 /*break*/, 4];
            case 3:
                err_3 = _b.sent();
                return [2 /*return*/, res.status(500).send(err_3)];
            case 4: return [2 /*return*/];
        }
    });
}); });
router.get('/:txid/coins', function (req, res, next) {
    var _a = req.params, chain = _a.chain, network = _a.network, txid = _a.txid;
    if (typeof txid !== 'string' || typeof chain !== 'string' || typeof network !== 'string') {
        res.status(400).send('Missing required param');
    }
    else {
        chain = chain.toUpperCase();
        network = network.toLowerCase();
        chain_state_1.ChainStateProvider.getCoinsForTx({ chain: chain, network: network, txid: txid })
            .then(function (coins) {
            res.setHeader('Content-Type', 'application/json');
            return res.status(200).send(JSON.stringify(coins));
        })
            .catch(next);
    }
});
router.post('/send', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, chain, network, rawTx, txid, err_4;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = req.params, chain = _a.chain, network = _a.network;
                    rawTx = req.body.rawTx;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    if (typeof rawTx !== 'string' && !Array.isArray(rawTx)) {
                        return [2 /*return*/, res.status(400).send('Invalid rawTx')];
                    }
                    if (Array.isArray(rawTx) && !rawTx.every(function (tx) { return typeof tx === 'string'; })) {
                        return [2 /*return*/, res.status(400).send('Invalid array of rawTx')];
                    }
                    chain = chain.toUpperCase();
                    network = network.toLowerCase();
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.broadcastTransaction({
                            chain: chain,
                            network: network,
                            rawTx: rawTx
                        })];
                case 2:
                    txid = _b.sent();
                    return [2 /*return*/, res.send({ txid: txid })];
                case 3:
                    err_4 = _b.sent();
                    logger_1.default.error('Broadcast error: %o %o %o %o', chain, network, rawTx, err_4);
                    return [2 /*return*/, res.status(500).send(err_4.message)];
                case 4: return [2 /*return*/];
            }
        });
    });
});
module.exports = {
    router: router,
    path: '/tx'
};
//# sourceMappingURL=tx.js.map