"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var crypto_wallet_core_1 = require("crypto-wallet-core");
var express_1 = require("express");
var chain_state_1 = require("../../providers/chain-state");
var auth_1 = require("../../utils/auth");
var router = (0, express_1.Router)({ mergeParams: true });
function isTooLong(field, maxLength) {
    if (maxLength === void 0) { maxLength = 255; }
    return field && field.toString().length >= maxLength;
}
// create wallet
router.post('/', function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, chain, network, _b, name, pubKey, path, singleAddress, existingWallet, result, err_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 3, , 4]);
                    _a = req.params, chain = _a.chain, network = _a.network;
                    _b = req.body, name = _b.name, pubKey = _b.pubKey, path = _b.path, singleAddress = _b.singleAddress;
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.getWallet({
                            chain: chain,
                            network: network,
                            pubKey: pubKey
                        })];
                case 1:
                    existingWallet = _c.sent();
                    if (existingWallet) {
                        return [2 /*return*/, res.status(200).send('Wallet already exists')];
                    }
                    if (isTooLong(name) || isTooLong(pubKey) || isTooLong(path) || isTooLong(singleAddress)) {
                        return [2 /*return*/, res.status(413).send('String length exceeds limit')];
                    }
                    return [4 /*yield*/, chain_state_1.ChainStateProvider.createWallet({
                            chain: chain,
                            network: network,
                            singleAddress: singleAddress,
                            name: name,
                            pubKey: pubKey,
                            path: path
                        })];
                case 2:
                    result = _c.sent();
                    return [2 /*return*/, res.send(result)];
                case 3:
                    err_1 = _c.sent();
                    return [2 /*return*/, res.status(500).send(err_1)];
                case 4: return [2 /*return*/];
            }
        });
    });
});
router.get('/:pubKey/addresses/missing', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, pubKey, payload, err_2;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                _a = req.params, chain = _a.chain, network = _a.network, pubKey = _a.pubKey;
                payload = {
                    chain: chain,
                    network: network,
                    pubKey: pubKey,
                    stream: res
                };
                return [4 /*yield*/, chain_state_1.ChainStateProvider.streamMissingWalletAddresses(payload)];
            case 1: return [2 /*return*/, _b.sent()];
            case 2:
                err_2 = _b.sent();
                return [2 /*return*/, res.status(500).send(err_2)];
            case 3: return [2 /*return*/];
        }
    });
}); });
router.get('/:pubKey/addresses', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var wallet, _a, chain, network, limit, payload, err_3;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                wallet = req.wallet;
                _a = req.params, chain = _a.chain, network = _a.network;
                limit = req.query.limit;
                payload = {
                    chain: chain,
                    network: network,
                    walletId: wallet._id,
                    limit: limit,
                    req: req,
                    res: res
                };
                return [4 /*yield*/, chain_state_1.ChainStateProvider.streamWalletAddresses(payload)];
            case 1: return [2 /*return*/, _b.sent()];
            case 2:
                err_3 = _b.sent();
                return [2 /*return*/, res.status(500).send(err_3)];
            case 3: return [2 /*return*/];
        }
    });
}); });
router.get('/:pubKey/check', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, wallet, result, err_4;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                _a = req.params, chain = _a.chain, network = _a.network;
                wallet = req.wallet._id;
                return [4 /*yield*/, chain_state_1.ChainStateProvider.walletCheck({
                        chain: chain,
                        network: network,
                        wallet: wallet
                    })];
            case 1:
                result = _b.sent();
                return [2 /*return*/, res.send(result)];
            case 2:
                err_4 = _b.sent();
                return [2 /*return*/, res.status(500).json(err_4)];
            case 3: return [2 /*return*/];
        }
    });
}); });
// update wallet
router.post('/:pubKey', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var keepAlive, _a, chain, network, addressLines, addresses, addresses_1, addresses_1_1, address, err_5;
    var e_1, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _c.trys.push([0, 2, , 3]);
                _a = req.params, chain = _a.chain, network = _a.network;
                addressLines = req.body.filter(function (line) { return !!line.address; });
                addresses = addressLines.map(function (_a) {
                    var address = _a.address;
                    return address;
                });
                try {
                    for (addresses_1 = __values(addresses), addresses_1_1 = addresses_1.next(); !addresses_1_1.done; addresses_1_1 = addresses_1.next()) {
                        address = addresses_1_1.value;
                        if (isTooLong(address) || !crypto_wallet_core_1.Validation.validateAddress(chain, network, address)) {
                            return [2 /*return*/, res.status(413).send('Invalid address')];
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (addresses_1_1 && !addresses_1_1.done && (_b = addresses_1.return)) _b.call(addresses_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                res.status(200);
                keepAlive = setInterval(function () {
                    res.write('\n');
                }, 1000);
                return [4 /*yield*/, chain_state_1.ChainStateProvider.updateWallet({
                        chain: chain,
                        network: network,
                        wallet: req.wallet,
                        addresses: addresses
                    })];
            case 1:
                _c.sent();
                clearInterval(keepAlive);
                return [2 /*return*/, res.end()];
            case 2:
                err_5 = _c.sent();
                clearInterval(keepAlive);
                return [2 /*return*/, res.status(500).send(err_5)];
            case 3: return [2 /*return*/];
        }
    });
}); });
router.get('/:pubKey/transactions', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, err_6;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                _a = req.params, chain = _a.chain, network = _a.network;
                return [4 /*yield*/, chain_state_1.ChainStateProvider.streamWalletTransactions({
                        chain: chain,
                        network: network,
                        wallet: req.wallet,
                        req: req,
                        res: res,
                        args: req.query
                    })];
            case 1: return [2 /*return*/, _b.sent()];
            case 2:
                err_6 = _b.sent();
                return [2 /*return*/, res.status(500).send(err_6)];
            case 3: return [2 /*return*/];
        }
    });
}); });
router.get('/:pubKey/balance', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, result, err_7;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, chain = _a.chain, network = _a.network;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, chain_state_1.ChainStateProvider.getWalletBalance({
                        chain: chain,
                        network: network,
                        wallet: req.wallet,
                        args: req.query
                    })];
            case 2:
                result = _b.sent();
                return [2 /*return*/, res.send(result || { confirmed: 0, unconfirmed: 0, balance: 0 })];
            case 3:
                err_7 = _b.sent();
                return [2 /*return*/, res.status(500).json(err_7)];
            case 4: return [2 /*return*/];
        }
    });
}); });
router.get('/:pubKey/balance/:time', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, time, result, err_8;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = req.params, chain = _a.chain, network = _a.network, time = _a.time;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, chain_state_1.ChainStateProvider.getWalletBalanceAtTime({
                        chain: chain,
                        network: network,
                        wallet: req.wallet,
                        time: time,
                        args: req.query
                    })];
            case 2:
                result = _b.sent();
                return [2 /*return*/, res.send(result || { confirmed: 0, unconfirmed: 0, balance: 0 })];
            case 3:
                err_8 = _b.sent();
                return [2 /*return*/, res.status(500).json(err_8)];
            case 4: return [2 /*return*/];
        }
    });
}); });
router.get('/:pubKey/utxos', auth_1.Auth.authenticateMiddleware, function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, limit;
    return __generator(this, function (_b) {
        _a = req.params, chain = _a.chain, network = _a.network;
        limit = req.query.limit;
        try {
            return [2 /*return*/, chain_state_1.ChainStateProvider.streamWalletUtxos({
                    chain: chain,
                    network: network,
                    wallet: req.wallet,
                    limit: limit,
                    req: req,
                    res: res,
                    args: req.query
                })];
        }
        catch (err) {
            return [2 /*return*/, res.status(500).send(err)];
        }
        return [2 /*return*/];
    });
}); });
router.get('/:pubKey', auth_1.Auth.authenticateMiddleware, function (req, res) {
    return __awaiter(this, void 0, void 0, function () {
        var wallet;
        return __generator(this, function (_a) {
            try {
                wallet = req.wallet;
                return [2 /*return*/, res.send(wallet)];
            }
            catch (err) {
                return [2 /*return*/, res.status(500).send(err)];
            }
            return [2 /*return*/];
        });
    });
});
module.exports = {
    router: router,
    path: '/wallet'
};
//# sourceMappingURL=wallet.js.map