"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var e_1, _a, e_2, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
var cors_1 = __importDefault(require("cors"));
var express_1 = __importDefault(require("express"));
var config_1 = __importDefault(require("../config"));
var config_2 = require("../services/config");
var middleware_1 = require("./middleware");
var web3_1 = require("./web3");
var app = (0, express_1.default)();
var bodyParser = require('body-parser');
app.use(bodyParser.json({
    limit: 100000000
}));
app.use(bodyParser.raw({
    limit: 100000000
}));
var chains = config_2.Config.chains();
var networks = {};
try {
    for (var chains_1 = __values(chains), chains_1_1 = chains_1.next(); !chains_1_1.done; chains_1_1 = chains_1.next()) {
        var chain = chains_1_1.value;
        try {
            for (var _d = (e_2 = void 0, __values(Object.keys(config_1.default.chains[chain]))), _e = _d.next(); !_e.done; _e = _d.next()) {
                var network = _e.value;
                networks[chain] = networks[chain] || {};
                Object.assign(networks[chain], (_c = {},
                    _c[network] = true,
                    _c));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
            }
            finally { if (e_2) throw e_2.error; }
        }
    }
}
catch (e_1_1) { e_1 = { error: e_1_1 }; }
finally {
    try {
        if (chains_1_1 && !chains_1_1.done && (_a = chains_1.return)) _a.call(chains_1);
    }
    finally { if (e_1) throw e_1.error; }
}
function bootstrap(path) {
    var fs = require('fs');
    var router = express_1.default.Router({
        mergeParams: true
    });
    var folder = path ? path + '/' : '';
    fs.readdirSync(__dirname + '/' + path).forEach(function (file) {
        if (file.match(/\.js$/) !== null && file !== 'index.js') {
            var route = require('./' + folder + file);
            router.use(route.path, route.router);
        }
    });
    return router;
}
function getRouterFromFile(path) {
    var router = express_1.default.Router({
        mergeParams: true
    });
    var route = require('./' + path);
    router.use(route.path, route.router);
    return router;
}
app.use((0, cors_1.default)());
app.use((0, middleware_1.LogMiddleware)());
app.use((0, middleware_1.CacheMiddleware)(middleware_1.CacheTimes.Second, middleware_1.CacheTimes.Second));
app.use((0, middleware_1.RateLimiter)('GLOBAL', 10, 200, 4000));
app.use('/api', getRouterFromFile('status'));
app.use('/api/:chain/:network', function (req, resp, next) {
    var _a = req.params, chain = _a.chain, network = _a.network;
    var hasChain = chains.includes(chain);
    var chainNetworks = networks[chain] || null;
    var hasChainNetworks = chainNetworks != null;
    var hasNetworkForChain = hasChainNetworks ? chainNetworks[network] : false;
    if (chain && !hasChain) {
        return resp.status(500).send("This node is not configured for the chain ".concat(chain));
    }
    if (network && (!hasChainNetworks || !hasNetworkForChain)) {
        return resp.status(500).send("This node is not configured for the network ".concat(network, " on chain ").concat(chain));
    }
    return next();
});
app.use('/api/:chain/:network', bootstrap('api'));
app.use('/web3/:chain/:network', web3_1.Web3Proxy);
exports.default = app;
//# sourceMappingURL=index.js.map