"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RateLimiter = exports.CacheMiddleware = exports.SetCache = exports.CacheTimes = exports.Confirmations = exports.LogMiddleware = void 0;
var logger_1 = __importDefault(require("../logger"));
var rateLimit_1 = require("../models/rateLimit");
var config_1 = require("../services/config");
function LogObj(logOut) {
    logger_1.default.info("".concat(logOut.time, " | ").concat(logOut.ip, " | ").concat(logOut.phase, " | ").concat(logOut.took, " | ").concat(logOut.method, " | ").concat(logOut.status, " | ").concat(logOut.url, " | ").concat(logOut.openConnections, " open"));
}
var openConnections = 0;
function LogPhase(req, res, phase) {
    var ip = req.header('CF-Connecting-IP') || req.socket.remoteAddress || req.hostname;
    var logOut = {
        time: req.startTime ? req.startTime.toTimeString() : new Date().toTimeString(),
        ip: ip.padStart(22, ' '),
        phase: phase.padStart(8, ' '),
        method: req.method.padStart(6, ' '),
        status: '...'.padStart(5, ' '),
        url: "".concat(req.baseUrl).concat(req.url),
        took: '...'.padStart(10, ' '),
        openConnections: openConnections.toString().padStart(6, ' ')
    };
    if (req.startTime && ['END', 'CLOSED'].includes(phase)) {
        var endTime = new Date();
        var startTime = req.startTime ? req.startTime : endTime;
        var totalTime = endTime.getTime() - startTime.getTime();
        var totalTimeMsg = "".concat(totalTime, " ms").padStart(10, ' ');
        logOut.took = totalTimeMsg.padStart(10, ' ');
        logOut.status = res.statusCode.toString().padStart(5, ' ');
    }
    LogObj(logOut);
}
function LogMiddleware() {
    return function (req, res, next) {
        req.startTime = new Date();
        openConnections++;
        LogPhase(req, res, 'START');
        res.on('finish', function () {
            LogPhase(req, res, 'END');
        });
        res.on('close', function () {
            openConnections--;
            LogPhase(req, res, 'CLOSED');
        });
        next();
    };
}
exports.LogMiddleware = LogMiddleware;
var Confirmations;
(function (Confirmations) {
    Confirmations[Confirmations["None"] = 0] = "None";
    Confirmations[Confirmations["Shallow"] = 1] = "Shallow";
    Confirmations[Confirmations["Deep"] = 100] = "Deep";
})(Confirmations = exports.Confirmations || (exports.Confirmations = {}));
var CacheTimes;
(function (CacheTimes) {
    CacheTimes[CacheTimes["None"] = 0] = "None";
    CacheTimes[CacheTimes["Second"] = 1] = "Second";
    CacheTimes[CacheTimes["Minute"] = 60] = "Minute";
    CacheTimes[CacheTimes["Hour"] = 3600] = "Hour";
    CacheTimes[CacheTimes["Day"] = 86400] = "Day";
    CacheTimes[CacheTimes["Month"] = 2592000] = "Month";
    CacheTimes[CacheTimes["Year"] = 31536000] = "Year";
})(CacheTimes = exports.CacheTimes || (exports.CacheTimes = {}));
function SetCache(res, serverSeconds, browserSeconds) {
    if (browserSeconds === void 0) { browserSeconds = 0; }
    res.setHeader('Cache-Control', "s-maxage=".concat(serverSeconds, ", max-age=").concat(browserSeconds));
}
exports.SetCache = SetCache;
function CacheMiddleware(serverSeconds, browserSeconds) {
    if (serverSeconds === void 0) { serverSeconds = CacheTimes.Second; }
    if (browserSeconds === void 0) { browserSeconds = CacheTimes.None; }
    return function (_, res, next) {
        SetCache(res, serverSeconds, browserSeconds);
        next();
    };
}
exports.CacheMiddleware = CacheMiddleware;
function isWhiteListed(whitelist, ip) {
    if (whitelist === void 0) { whitelist = []; }
    return whitelist.some(function (listItem) { return ip.startsWith(listItem); });
}
function RateLimiter(method, perSecond, perMinute, perHour) {
    var _this = this;
    return function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var identifier, rateLimiter, whitelist, isDisabled, _a, perSecondResult, perMinuteResult, perHourResult, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    identifier = req.header('CF-Connecting-IP') || req.socket.remoteAddress || '';
                    rateLimiter = config_1.Config.for('api').rateLimiter;
                    whitelist = rateLimiter && rateLimiter.whitelist;
                    isDisabled = rateLimiter && rateLimiter.disabled;
                    if (isDisabled || isWhiteListed(whitelist, identifier)) {
                        return [2 /*return*/, next()];
                    }
                    return [4 /*yield*/, rateLimit_1.RateLimitStorage.incrementAndCheck(identifier, method)];
                case 1:
                    _a = __read.apply(void 0, [_b.sent(), 3]), perSecondResult = _a[0], perMinuteResult = _a[1], perHourResult = _a[2];
                    if (perSecondResult.value.count > perSecond ||
                        perMinuteResult.value.count > perMinute ||
                        perHourResult.value.count > perHour) {
                        return [2 /*return*/, res.status(429).send('Rate Limited')];
                    }
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _b.sent();
                    logger_1.default.error('Rate Limiter failed');
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/, next()];
            }
        });
    }); };
}
exports.RateLimiter = RateLimiter;
//# sourceMappingURL=middleware.js.map