"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Web3Proxy = void 0;
var request_1 = __importDefault(require("request"));
var config_1 = require("../../services/config");
function Web3Proxy(req, res) {
    var _a = req.params, chain = _a.chain, network = _a.network;
    var chainConfig = config_1.Config.chainConfig({ chain: chain, network: network });
    var provider = chainConfig.provider || (chainConfig.providers && chainConfig.providers[0]);
    if (provider && chainConfig.publicWeb3) {
        var host = provider.host, port = provider.port;
        var url = "http://".concat(host, ":").concat(port);
        var requestStream = void 0;
        if (req.body.jsonrpc) {
            var options = {
                uri: url,
                headers: { 'content-type': 'application/x-www-form-urlencoded' },
                method: req.method,
                body: JSON.stringify(req.body),
                json: true
            };
            requestStream = (0, request_1.default)(options);
        }
        else {
            requestStream = req.pipe((0, request_1.default)(url));
        }
        requestStream
            .on('error', function () {
            res.status(500).send('An Error Has Occurred');
        })
            .pipe(res);
    }
    else {
        res.status(500).send("This node is not configured with a web3 connection for ".concat(chain, " ").concat(network, " "));
    }
}
exports.Web3Proxy = Web3Proxy;
//# sourceMappingURL=index.js.map