"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncRPC = exports.RPC = void 0;
var request = require("request");
var Loggify_1 = require("./decorators/Loggify");
var RPC = /** @class */ (function () {
    function RPC(username, password, host, port) {
        this.username = username;
        this.password = password;
        this.host = host;
        this.port = port;
    }
    RPC.prototype.callMethod = function (method, params, callback, walletName) {
        request({
            method: 'POST',
            url: "http://".concat(this.username, ":").concat(this.password, "@").concat(this.host, ":").concat(this.port).concat(walletName ? '/wallet/' + walletName : ''),
            body: {
                jsonrpc: '1.0',
                id: Date.now(),
                method: method,
                params: params
            },
            json: true
        }, function (err, res) {
            if (err) {
                return callback(err);
            }
            else if (res) {
                if (res.body) {
                    if (res.body.error) {
                        return callback(res.body.error);
                    }
                    else if (res.body.result) {
                        return callback(null, res.body && res.body.result);
                    }
                    else {
                        return callback({ msg: 'No error or body found', body: res.body });
                    }
                }
            }
            else {
                return callback('No response or error returned by rpc call');
            }
        });
    };
    RPC.prototype.asyncCall = function (method, params, walletName) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.callMethod(method, params, function (err, data) {
                            if (err) {
                                return reject(err);
                            }
                            return resolve(data);
                        }, walletName);
                    })];
            });
        });
    };
    RPC.prototype.getChainTip = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tips;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.asyncCall('getchaintips', [])];
                    case 1:
                        tips = _a.sent();
                        return [2 /*return*/, tips[0]];
                }
            });
        });
    };
    RPC.prototype.getBestBlockHash = function () {
        return this.asyncCall('getbestblockhash', []);
    };
    RPC.prototype.getBlockHeight = function () {
        return this.asyncCall('getblockcount', []);
    };
    RPC.prototype.getBlock = function (hash, verbose) {
        return this.asyncCall('getblock', [hash, verbose]);
    };
    RPC.prototype.getBlockHash = function (height) {
        return this.asyncCall('getblockhash', [height]);
    };
    RPC.prototype.getBlockByHeight = function (height) {
        return __awaiter(this, void 0, void 0, function () {
            var hash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getBlockHash(height)];
                    case 1:
                        hash = _a.sent();
                        return [2 /*return*/, this.getBlock(hash, false)];
                }
            });
        });
    };
    RPC.prototype.getTransaction = function (txid) {
        return this.asyncCall('getrawtransaction', [txid, true]);
    };
    RPC.prototype.sendTransaction = function (rawTx) {
        var txs = typeof rawTx === 'string' ? [rawTx] : rawTx;
        return this.asyncCall('sendrawtransaction', txs);
    };
    RPC.prototype.decodeScript = function (hex) {
        return this.asyncCall('decodescript', [hex]);
    };
    RPC.prototype.getWalletAddresses = function (account) {
        return this.asyncCall('getaddressesbyaccount', [account]);
    };
    RPC.prototype.getEstimateSmartFee = function (target, mode) {
        return __awaiter(this, void 0, void 0, function () {
            var args;
            return __generator(this, function (_a) {
                args = [target];
                if (mode) {
                    args.push(mode);
                }
                return [2 /*return*/, this.asyncCall('estimatesmartfee', args)];
            });
        });
    };
    RPC.prototype.getEstimateFee = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.asyncCall('estimatefee', [])];
            });
        });
    };
    RPC = __decorate([
        Loggify_1.LoggifyClass
    ], RPC);
    return RPC;
}());
exports.RPC = RPC;
var AsyncRPC = /** @class */ (function () {
    function AsyncRPC(username, password, host, port) {
        this.rpc = new RPC(username, password, host, port);
        this.walletName = process.env.LOADED_MOCHA_OPTS === 'true' ? 'MOCHA_BITCORE_WALLET' : undefined;
    }
    AsyncRPC.prototype.call = function (method, params, walletName) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.rpc.callMethod(method, params, function (err, data) {
                            if (err) {
                                return reject(err);
                            }
                            return resolve(data);
                        }, walletName);
                    })];
            });
        });
    };
    AsyncRPC.prototype.setWallet = function (walletName) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.walletName && !walletName) {
                            throw new Error('No wallet name specified');
                        }
                        if (this.walletName == walletName) {
                            return [2 /*return*/];
                        }
                        walletName = walletName || this.walletName;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.call('createwallet', [walletName])];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        if (!err_1.message.includes('already exists')) {
                            throw err_1;
                        }
                        return [3 /*break*/, 4];
                    case 4:
                        this.walletName = walletName;
                        return [2 /*return*/];
                }
            });
        });
    };
    AsyncRPC.prototype.block = function (hash) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.call('getblock', [hash, 1])];
                    case 1: return [2 /*return*/, (_a.sent())];
                }
            });
        });
    };
    AsyncRPC.prototype.verbose_block = function (hash) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.call('getblock', [hash, 2])];
                    case 1: return [2 /*return*/, (_a.sent())];
                }
            });
        });
    };
    AsyncRPC.prototype.getnewaddress = function (account) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setWallet()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.call('getnewaddress', [account], this.walletName)];
                    case 2: return [2 /*return*/, (_a.sent())];
                }
            });
        });
    };
    AsyncRPC.prototype.signrawtx = function (txs) {
        return __awaiter(this, void 0, void 0, function () {
            var ret, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setWallet()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 6]);
                        return [4 /*yield*/, this.call('signrawtransactionwithwallet', [txs], this.walletName)];
                    case 3:
                        ret = _a.sent();
                        return [2 /*return*/, ret];
                    case 4:
                        e_1 = _a.sent();
                        if (!e_1.code || e_1.code != -32601)
                            return [2 /*return*/, Promise.reject(e_1)];
                        return [4 /*yield*/, this.call('signrawtransaction', [txs])];
                    case 5: return [2 /*return*/, _a.sent()];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    AsyncRPC.prototype.transaction = function (txid, block) {
        return __awaiter(this, void 0, void 0, function () {
            var args;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        args = [txid, true];
                        if (block) {
                            args.push(block);
                        }
                        return [4 /*yield*/, this.call('getrawtransaction', args)];
                    case 1: return [2 /*return*/, (_a.sent())];
                }
            });
        });
    };
    AsyncRPC.prototype.sendtoaddress = function (address, value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setWallet()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this.call('sendtoaddress', [address, value], this.walletName)];
                }
            });
        });
    };
    AsyncRPC = __decorate([
        Loggify_1.LoggifyClass
    ], AsyncRPC);
    return AsyncRPC;
}());
exports.AsyncRPC = AsyncRPC;
//# sourceMappingURL=rpc.js.map