"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = exports.ConfigService = void 0;
var config_1 = __importDefault(require("../config"));
var check_1 = require("../utils/check");
var ConfigService = /** @class */ (function () {
    function ConfigService(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b._config, _config = _c === void 0 ? config_1.default : _c;
        this._config = _config;
    }
    ConfigService.prototype.get = function () {
        return this._config;
    };
    ConfigService.prototype.updateConfig = function (partialConfig) {
        var newConfig = Object.assign({}, this.get(), partialConfig);
        this._config = newConfig;
    };
    ConfigService.prototype.chains = function () {
        return Object.keys(this.get().chains);
    };
    ConfigService.prototype.networksFor = function (chain) {
        return Object.keys(this.get().chains[chain]);
    };
    ConfigService.prototype.chainNetworks = function () {
        var e_1, _a, e_2, _b;
        var chainNetworks = new Array();
        try {
            for (var _c = __values(this.chains()), _d = _c.next(); !_d.done; _d = _c.next()) {
                var chain = _d.value;
                try {
                    for (var _e = (e_2 = void 0, __values(this.networksFor(chain))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var network = _f.value;
                        chainNetworks.push({ chain: chain, network: network });
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return chainNetworks;
    };
    ConfigService.prototype.chainConfig = function (_a) {
        var chain = _a.chain, network = _a.network;
        return this.get().chains[chain][network];
    };
    ConfigService.prototype.for = function (service) {
        return this.get().services[service] || {};
    };
    ConfigService.prototype.isDisabled = function (service) {
        var serviceConfig = this.for(service);
        var isDefined = function (x) { return x !== undefined; };
        var disabled = isDefined(serviceConfig) ? (0, check_1.valueOrDefault)(serviceConfig.disabled, false) : false;
        return disabled;
    };
    return ConfigService;
}());
exports.ConfigService = ConfigService;
exports.Config = new ConfigService();
//# sourceMappingURL=config.js.map