"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Event = exports.EventService = void 0;
var events_1 = require("events");
var Loggify_1 = require("../decorators/Loggify");
var logger_1 = __importDefault(require("../logger"));
var events_2 = require("../models/events");
var config_1 = require("./config");
var storage_1 = require("./storage");
var EventService = /** @class */ (function () {
    function EventService(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.storageService, storageService = _c === void 0 ? storage_1.Storage : _c, _d = _b.eventModel, eventModel = _d === void 0 ? events_2.EventStorage : _d, _e = _b.configService, configService = _e === void 0 ? config_1.Config : _e;
        this.txEvent = new events_1.EventEmitter();
        this.blockEvent = new events_1.EventEmitter();
        this.addressCoinEvent = new events_1.EventEmitter();
        this.events = new events_1.EventEmitter();
        this.stopped = false;
        this.storageService = storageService;
        this.configService = configService;
        this.eventModel = eventModel;
        this.signalTx = this.signalTx.bind(this);
        this.signalBlock = this.signalBlock.bind(this);
        this.signalAddressCoin = this.signalAddressCoin.bind(this);
    }
    EventService.prototype.start = function () {
        var _this = this;
        if (this.configService.isDisabled('event')) {
            logger_1.default.info('Disabled Event Service');
            return;
        }
        logger_1.default.info('Starting Event Service');
        this.stopped = false;
        this.events.emit('start');
        if (this.storageService.connected) {
            this.wireup();
        }
        else {
            this.storageService.connection.on('CONNECTED', function () {
                _this.wireup();
            });
        }
    };
    EventService.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                logger_1.default.info('Stopping Event Service');
                this.stopped = true;
                this.events.emit('stop');
                return [2 /*return*/];
            });
        });
    };
    EventService.prototype.wireup = function () {
        return __awaiter(this, void 0, void 0, function () {
            var lastBlockUpdate, lastTxUpdate, lastAddressTxUpdate, retryTxCursor, retryBlockCursor, retryAddressTxCursor;
            var _this = this;
            return __generator(this, function (_a) {
                lastBlockUpdate = new Date();
                lastTxUpdate = new Date();
                lastAddressTxUpdate = new Date();
                retryTxCursor = function () { return __awaiter(_this, void 0, void 0, function () {
                    var txCursor, _a, txEvent, tx;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                txCursor = this.eventModel.getTxTail(lastTxUpdate);
                                _b.label = 1;
                            case 1:
                                _a = !this.stopped;
                                if (!_a) return [3 /*break*/, 3];
                                return [4 /*yield*/, txCursor.hasNext()];
                            case 2:
                                _a = (_b.sent());
                                _b.label = 3;
                            case 3:
                                if (!_a) return [3 /*break*/, 5];
                                return [4 /*yield*/, txCursor.next()];
                            case 4:
                                txEvent = _b.sent();
                                if (txEvent) {
                                    tx = txEvent.payload;
                                    this.txEvent.emit('tx', tx);
                                    lastTxUpdate = new Date();
                                }
                                return [3 /*break*/, 1];
                            case 5:
                                if (!this.stopped) {
                                    setTimeout(retryTxCursor, 100);
                                }
                                return [2 /*return*/];
                        }
                    });
                }); };
                retryTxCursor();
                retryBlockCursor = function () { return __awaiter(_this, void 0, void 0, function () {
                    var blockCursor, _a, blockEvent, block;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                blockCursor = this.eventModel.getBlockTail(lastBlockUpdate);
                                _b.label = 1;
                            case 1:
                                _a = !this.stopped;
                                if (!_a) return [3 /*break*/, 3];
                                return [4 /*yield*/, blockCursor.hasNext()];
                            case 2:
                                _a = (_b.sent());
                                _b.label = 3;
                            case 3:
                                if (!_a) return [3 /*break*/, 5];
                                return [4 /*yield*/, blockCursor.next()];
                            case 4:
                                blockEvent = _b.sent();
                                if (blockEvent) {
                                    block = blockEvent.payload;
                                    this.blockEvent.emit('block', block);
                                    lastBlockUpdate = new Date();
                                }
                                return [3 /*break*/, 1];
                            case 5:
                                if (!this.stopped) {
                                    setTimeout(retryBlockCursor, 100);
                                }
                                return [2 /*return*/];
                        }
                    });
                }); };
                retryBlockCursor();
                retryAddressTxCursor = function () { return __awaiter(_this, void 0, void 0, function () {
                    var addressTxCursor, _a, addressTx, addressCoin;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                addressTxCursor = this.eventModel.getCoinTail(lastAddressTxUpdate);
                                _b.label = 1;
                            case 1:
                                _a = !this.stopped;
                                if (!_a) return [3 /*break*/, 3];
                                return [4 /*yield*/, addressTxCursor.hasNext()];
                            case 2:
                                _a = (_b.sent());
                                _b.label = 3;
                            case 3:
                                if (!_a) return [3 /*break*/, 5];
                                return [4 /*yield*/, addressTxCursor.next()];
                            case 4:
                                addressTx = _b.sent();
                                if (addressTx) {
                                    addressCoin = addressTx.payload;
                                    this.addressCoinEvent.emit('coin', addressCoin);
                                    lastAddressTxUpdate = new Date();
                                }
                                return [3 /*break*/, 1];
                            case 5:
                                if (!this.stopped) {
                                    setTimeout(retryAddressTxCursor, 100);
                                }
                                return [2 /*return*/];
                        }
                    });
                }); };
                retryAddressTxCursor();
                return [2 /*return*/];
            });
        });
    };
    EventService.prototype.signalBlock = function (block) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.eventModel.signalBlock(block)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventService.prototype.signalTx = function (tx) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.eventModel.signalTx(tx)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventService.prototype.signalAddressCoin = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.eventModel.signalAddressCoin(payload)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventService = __decorate([
        Loggify_1.LoggifyClass
    ], EventService);
    return EventService;
}());
exports.EventService = EventService;
exports.Event = new EventService();
//# sourceMappingURL=event.js.map