"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pruning = exports.PruningService = void 0;
var stream_1 = require("stream");
var logger_1 = __importDefault(require("../logger"));
var coin_1 = require("../models/coin");
var transaction_1 = require("../models/transaction");
var rpc_1 = require("../rpc");
var parseArgv_1 = __importDefault(require("../utils/parseArgv"));
require("../utils/polyfills");
var config_1 = require("./config");
var _b = process.env, PRUNING_CHAIN = _b.PRUNING_CHAIN, PRUNING_NETWORK = _b.PRUNING_NETWORK, PRUNING_MEMPOOL_AGE = _b.PRUNING_MEMPOOL_AGE, PRUNING_INTERVAL_HRS = _b.PRUNING_INTERVAL_HRS, PRUNING_DESCENDANT_LIMIT = _b.PRUNING_DESCENDANT_LIMIT;
var args = (0, parseArgv_1.default)([], [
    { arg: 'CHAIN', type: 'string' },
    { arg: 'NETWORK', type: 'string' },
    { arg: 'OLD', type: 'bool' },
    { arg: 'INVALID', type: 'bool' },
    { arg: 'EXIT', type: 'bool' },
    { arg: 'DRY', type: 'bool' },
    { arg: 'MEMPOOL_AGE', type: 'int' },
    { arg: 'INTERVAL_HRS', type: 'float' },
    { arg: 'DESCENDANT_LIMIT', type: 'int' },
    { arg: 'VERBOSE', type: 'bool' }
]);
var ONE_MIN = 1000 * 60;
var ONE_HOUR = 60 * ONE_MIN;
var ONE_DAY = 24 * ONE_HOUR;
var CHAIN = args.CHAIN || PRUNING_CHAIN;
var NETWORK = args.NETWORK || PRUNING_NETWORK;
var INTERVAL_HRS = args.INTERVAL_HRS || Number(PRUNING_INTERVAL_HRS) || 12;
var MEMPOOL_AGE = args.MEMPOOL_AGE || Number(PRUNING_MEMPOOL_AGE) || 7;
var DESCENDANT_LIMIT = args.DESCENDANT_LIMIT || Number(PRUNING_DESCENDANT_LIMIT) || 10;
var VERBOSE = Boolean((_a = args.VERBOSE) !== null && _a !== void 0 ? _a : false);
// If --DRY was given w/o a follow arg (i.e. 'true', '0', etc) assume the user wants to run a dry run (safe)
if (Object.keys(args).includes('DRY') && args.DRY === undefined) {
    args.DRY = '1';
}
if (INTERVAL_HRS > 72) {
    throw new Error('INTERVAL_HRS cannot be over 72. Consider using a cron job.');
}
var PruningService = /** @class */ (function () {
    function PruningService(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.transactionModel, transactionModel = _c === void 0 ? transaction_1.TransactionStorage : _c, _d = _b.coinModel, coinModel = _d === void 0 ? coin_1.CoinStorage : _d;
        this.stopping = false;
        this.running = false;
        this.rpcs = [];
        this.transactionModel = transactionModel;
        this.coinModel = coinModel;
    }
    PruningService.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                logger_1.default.info('Starting Pruning Service');
                args.OLD && logger_1.default.info("Pruning mempool txs older than ".concat(MEMPOOL_AGE, " day(s)"));
                args.INVALID && logger_1.default.info('Pruning conflicting mempool txs');
                args.DRY && logger_1.default.info('Pruning service DRY RUN');
                this.registerRpcs();
                if (args.EXIT) {
                    this.detectAndClear().then(function () {
                        process.emit('SIGINT', 'SIGINT');
                    });
                }
                else {
                    logger_1.default.info('Pruning service interval (hours): ' + INTERVAL_HRS);
                    this.interval = setInterval(this.detectAndClear.bind(this), INTERVAL_HRS * ONE_HOUR);
                }
                return [2 /*return*/];
            });
        });
    };
    PruningService.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                logger_1.default.info('Stopping Pruning Service');
                this.stopping = true;
                clearInterval(this.interval);
                return [2 /*return*/];
            });
        });
    };
    PruningService.prototype.registerRpcs = function () {
        var e_1, _a;
        var chainNetworks = CHAIN ? [{ chain: CHAIN, network: NETWORK }] : config_1.Config.chainNetworks();
        try {
            for (var chainNetworks_1 = __values(chainNetworks), chainNetworks_1_1 = chainNetworks_1.next(); !chainNetworks_1_1.done; chainNetworks_1_1 = chainNetworks_1.next()) {
                var chainNetwork = chainNetworks_1_1.value;
                var config = config_1.Config.chainConfig(chainNetwork);
                if (!config.rpc) {
                    continue;
                }
                this.rpcs["".concat(chainNetwork.chain, ":").concat(chainNetwork.network)] = new rpc_1.RPC(config.rpc.username, config.rpc.password, config.rpc.host, config.rpc.port);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (chainNetworks_1_1 && !chainNetworks_1_1.done && (_a = chainNetworks_1.return)) _a.call(chainNetworks_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    PruningService.prototype.detectAndClear = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, chainNetwork, chain, network, _e, _f, e_2_1, err_1;
            var e_2, _g;
            return __generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        if (this.running) {
                            return [2 /*return*/];
                        }
                        this.running = true;
                        _h.label = 1;
                    case 1:
                        _h.trys.push([1, 17, 18, 19]);
                        if (!(CHAIN && NETWORK)) return [3 /*break*/, 6];
                        _a = args.OLD;
                        if (!_a) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.processOldMempoolTxs(CHAIN, NETWORK, MEMPOOL_AGE)];
                    case 2:
                        _a = (_h.sent());
                        _h.label = 3;
                    case 3:
                        _a;
                        _b = args.INVALID;
                        if (!_b) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.processAllInvalidTxs(CHAIN, NETWORK)];
                    case 4:
                        _b = (_h.sent());
                        _h.label = 5;
                    case 5:
                        _b;
                        return [3 /*break*/, 16];
                    case 6:
                        _h.trys.push([6, 14, 15, 16]);
                        _c = __values(config_1.Config.chainNetworks()), _d = _c.next();
                        _h.label = 7;
                    case 7:
                        if (!!_d.done) return [3 /*break*/, 13];
                        chainNetwork = _d.value;
                        chain = chainNetwork.chain, network = chainNetwork.network;
                        if (!chain || !network) {
                            throw new Error('Config structure should contain both a chain and network');
                        }
                        _e = args.OLD;
                        if (!_e) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.processOldMempoolTxs(chain, network, MEMPOOL_AGE)];
                    case 8:
                        _e = (_h.sent());
                        _h.label = 9;
                    case 9:
                        _e;
                        _f = args.INVALID;
                        if (!_f) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.processAllInvalidTxs(chain, network)];
                    case 10:
                        _f = (_h.sent());
                        _h.label = 11;
                    case 11:
                        _f;
                        _h.label = 12;
                    case 12:
                        _d = _c.next();
                        return [3 /*break*/, 7];
                    case 13: return [3 /*break*/, 16];
                    case 14:
                        e_2_1 = _h.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 16];
                    case 15:
                        try {
                            if (_d && !_d.done && (_g = _c.return)) _g.call(_c);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 16: return [3 /*break*/, 19];
                    case 17:
                        err_1 = _h.sent();
                        logger_1.default.error('Pruning Error: ' + err_1.stack || err_1.message || err_1);
                        return [3 /*break*/, 19];
                    case 18:
                        this.running = false;
                        return [7 /*endfinally*/];
                    case 19: return [2 /*return*/];
                }
            });
        });
    };
    PruningService.prototype.processOldMempoolTxs = function (chain, network, days) {
        return __awaiter(this, void 0, void 0, function () {
            var oldTime, count, rmCount;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        oldTime = new Date(Date.now() - days * ONE_DAY);
                        return [4 /*yield*/, this.transactionModel.collection.countDocuments({
                                chain: chain,
                                network: network,
                                blockHeight: -1 /* SpentHeightIndicators.pending */,
                                blockTimeNormalized: { $lt: oldTime }
                            })];
                    case 1:
                        count = _a.sent();
                        logger_1.default.info("Found ".concat(count, " outdated ").concat(chain, " ").concat(network, " mempool txs"));
                        rmCount = 0;
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                _this.transactionModel.collection
                                    .find({ chain: chain, network: network, blockHeight: -1 /* SpentHeightIndicators.pending */, blockTimeNormalized: { $lt: oldTime } })
                                    .sort(count > 5000 ? { chain: 1, network: 1, blockTimeNormalized: 1 } : {})
                                    .pipe(new stream_1.Transform({
                                    objectMode: true,
                                    transform: function (data, _, cb) { return __awaiter(_this, void 0, void 0, function () {
                                        var tx, nodeTx, err_2, outputGenerator, spentTxids, _a, outputGenerator_1, outputGenerator_1_1, coin, e_3_1, uniqueTxids;
                                        var _b, e_3, _c, _d;
                                        return __generator(this, function (_e) {
                                            switch (_e.label) {
                                                case 0:
                                                    if (this.stopping) {
                                                        return [2 /*return*/, cb(new Error('Stopping'))];
                                                    }
                                                    tx = data;
                                                    _e.label = 1;
                                                case 1:
                                                    _e.trys.push([1, 3, , 4]);
                                                    return [4 /*yield*/, this.rpcs["".concat(chain, ":").concat(network)].getTransaction(tx.txid)];
                                                case 2:
                                                    nodeTx = _e.sent();
                                                    if (nodeTx) {
                                                        logger_1.default.warn("Tx ".concat(tx.txid, " is still in the mempool").concat(VERBOSE ? ': %o' : ''), nodeTx);
                                                        return [2 /*return*/, cb()];
                                                    }
                                                    return [3 /*break*/, 4];
                                                case 3:
                                                    err_2 = _e.sent();
                                                    if (err_2.code !== -5) { // -5: No such mempool or blockchain transaction. Use gettransaction for wallet transactions.
                                                        logger_1.default.error("Error checking tx ".concat(tx.txid, " in the mempool: ").concat(err_2.message));
                                                        return [2 /*return*/, cb()];
                                                    }
                                                    return [3 /*break*/, 4];
                                                case 4:
                                                    logger_1.default.info("Finding ".concat(tx.txid, " outputs and dependent outputs"));
                                                    outputGenerator = this.transactionModel.yieldRelatedOutputs(tx.txid);
                                                    spentTxids = new Set();
                                                    _e.label = 5;
                                                case 5:
                                                    _e.trys.push([5, 10, 11, 16]);
                                                    _a = true, outputGenerator_1 = __asyncValues(outputGenerator);
                                                    _e.label = 6;
                                                case 6: return [4 /*yield*/, outputGenerator_1.next()];
                                                case 7:
                                                    if (!(outputGenerator_1_1 = _e.sent(), _b = outputGenerator_1_1.done, !_b)) return [3 /*break*/, 9];
                                                    _d = outputGenerator_1_1.value;
                                                    _a = false;
                                                    try {
                                                        coin = _d;
                                                        if (coin.mintHeight >= 0 || coin.spentHeight >= 0) {
                                                            logger_1.default.error("Cannot prune coin! ".concat(coin.mintTxid));
                                                            return [2 /*return*/, cb()];
                                                        }
                                                        if (coin.spentTxid) {
                                                            spentTxids.add(coin.spentTxid);
                                                            if (spentTxids.size > DESCENDANT_LIMIT) {
                                                                logger_1.default.warn("".concat(tx.txid, " has too many decendants"));
                                                                return [2 /*return*/, cb()];
                                                            }
                                                        }
                                                    }
                                                    finally {
                                                        _a = true;
                                                    }
                                                    _e.label = 8;
                                                case 8: return [3 /*break*/, 6];
                                                case 9: return [3 /*break*/, 16];
                                                case 10:
                                                    e_3_1 = _e.sent();
                                                    e_3 = { error: e_3_1 };
                                                    return [3 /*break*/, 16];
                                                case 11:
                                                    _e.trys.push([11, , 14, 15]);
                                                    if (!(!_a && !_b && (_c = outputGenerator_1.return))) return [3 /*break*/, 13];
                                                    return [4 /*yield*/, _c.call(outputGenerator_1)];
                                                case 12:
                                                    _e.sent();
                                                    _e.label = 13;
                                                case 13: return [3 /*break*/, 15];
                                                case 14:
                                                    if (e_3) throw e_3.error;
                                                    return [7 /*endfinally*/];
                                                case 15: return [7 /*endfinally*/];
                                                case 16:
                                                    spentTxids.add(tx.txid);
                                                    rmCount += spentTxids.size;
                                                    uniqueTxids = Array.from(spentTxids);
                                                    return [4 /*yield*/, this.removeOldMempool(chain, network, uniqueTxids)];
                                                case 17:
                                                    _e.sent();
                                                    logger_1.default.info("Removed tx ".concat(tx.txid, " and ").concat(spentTxids.size - 1, " dependent txs"));
                                                    return [2 /*return*/, cb()];
                                            }
                                        });
                                    }); }
                                }))
                                    .on('finish', resolve)
                                    .on('error', reject);
                            })];
                    case 2:
                        _a.sent();
                        logger_1.default.info("Removed all pending txs older than ".concat(days, " days: ").concat(rmCount));
                        return [2 /*return*/];
                }
            });
        });
    };
    PruningService.prototype.processAllInvalidTxs = function (chain, network) {
        return __awaiter(this, void 0, void 0, function () {
            var count;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.transactionModel.collection.countDocuments({
                            chain: chain,
                            network: network,
                            blockHeight: -3 /* SpentHeightIndicators.conflicting */
                        })];
                    case 1:
                        count = _a.sent();
                        logger_1.default.info("Found ".concat(count, " invalid ").concat(chain, " ").concat(network, " txs"));
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                _this.transactionModel.collection
                                    .find({ chain: chain, network: network, blockHeight: -3 /* SpentHeightIndicators.conflicting */ })
                                    .pipe(new stream_1.Transform({
                                    objectMode: true,
                                    transform: function (data, _, cb) { return __awaiter(_this, void 0, void 0, function () {
                                        var tx, outputGenerator, spentTxids, _a, outputGenerator_2, outputGenerator_2_1, coin, e_4_1, uniqueTxids;
                                        var _b, e_4, _c, _d;
                                        return __generator(this, function (_e) {
                                            switch (_e.label) {
                                                case 0:
                                                    if (this.stopping) {
                                                        return [2 /*return*/, cb(new Error('Stopping'))];
                                                    }
                                                    tx = data;
                                                    logger_1.default.info("Invalidating ".concat(tx.txid, " outputs and dependent outputs"));
                                                    outputGenerator = this.transactionModel.yieldRelatedOutputs(tx.txid);
                                                    spentTxids = new Set();
                                                    _e.label = 1;
                                                case 1:
                                                    _e.trys.push([1, 6, 7, 12]);
                                                    _a = true, outputGenerator_2 = __asyncValues(outputGenerator);
                                                    _e.label = 2;
                                                case 2: return [4 /*yield*/, outputGenerator_2.next()];
                                                case 3:
                                                    if (!(outputGenerator_2_1 = _e.sent(), _b = outputGenerator_2_1.done, !_b)) return [3 /*break*/, 5];
                                                    _d = outputGenerator_2_1.value;
                                                    _a = false;
                                                    try {
                                                        coin = _d;
                                                        if (coin.mintHeight >= 0 || coin.spentHeight >= 0) {
                                                            return [2 /*return*/, cb(new Error("Invalid coin! ".concat(coin.mintTxid, " ")))];
                                                        }
                                                        if (coin.spentTxid) {
                                                            spentTxids.add(coin.spentTxid);
                                                            if (spentTxids.size > DESCENDANT_LIMIT) {
                                                                logger_1.default.warn("".concat(tx.txid, " has too many decendants"));
                                                                return [2 /*return*/, cb()];
                                                            }
                                                        }
                                                    }
                                                    finally {
                                                        _a = true;
                                                    }
                                                    _e.label = 4;
                                                case 4: return [3 /*break*/, 2];
                                                case 5: return [3 /*break*/, 12];
                                                case 6:
                                                    e_4_1 = _e.sent();
                                                    e_4 = { error: e_4_1 };
                                                    return [3 /*break*/, 12];
                                                case 7:
                                                    _e.trys.push([7, , 10, 11]);
                                                    if (!(!_a && !_b && (_c = outputGenerator_2.return))) return [3 /*break*/, 9];
                                                    return [4 /*yield*/, _c.call(outputGenerator_2)];
                                                case 8:
                                                    _e.sent();
                                                    _e.label = 9;
                                                case 9: return [3 /*break*/, 11];
                                                case 10:
                                                    if (e_4) throw e_4.error;
                                                    return [7 /*endfinally*/];
                                                case 11: return [7 /*endfinally*/];
                                                case 12:
                                                    spentTxids.add(tx.txid);
                                                    uniqueTxids = Array.from(spentTxids);
                                                    return [4 /*yield*/, this.clearInvalid(uniqueTxids)];
                                                case 13:
                                                    _e.sent();
                                                    logger_1.default.info("Invalidated tx ".concat(tx.txid, " and ").concat(spentTxids.size - 1, " dependent txs"));
                                                    cb();
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); }
                                }))
                                    .on('finish', resolve)
                                    .on('error', reject);
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PruningService.prototype.clearInvalid = function (invalidTxids) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                logger_1.default.info("".concat(args.DRY ? 'DRY RUN - ' : '', "Invalidating ").concat(invalidTxids.length, " txids"));
                if (args.DRY) {
                    return [2 /*return*/];
                }
                return [2 /*return*/, Promise.all([
                        // Set all invalid txs to conflicting status
                        this.transactionModel.collection.updateMany({ txid: { $in: invalidTxids } }, { $set: { blockHeight: -3 /* SpentHeightIndicators.conflicting */ } }),
                        // Set all coins that were pending to be spent by an invalid tx back to unspent
                        this.coinModel.collection.updateMany({ spentTxid: { $in: invalidTxids } }, { $set: { spentHeight: -2 /* SpentHeightIndicators.unspent */ } }),
                        // Set all coins that were created by invalid txs to conflicting status
                        this.coinModel.collection.updateMany({ mintTxid: { $in: invalidTxids } }, { $set: { mintHeight: -3 /* SpentHeightIndicators.conflicting */ } })
                    ])];
            });
        });
    };
    PruningService.prototype.removeOldMempool = function (chain, network, txids) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                logger_1.default.info("".concat(args.DRY ? 'DRY RUN - ' : '', "Removing ").concat(txids.length, " txids"));
                if (args.DRY) {
                    return [2 /*return*/];
                }
                return [2 /*return*/, Promise.all([
                        this.transactionModel.collection.updateMany({ chain: chain, network: network, txid: { $in: txids }, blockHeight: -1 /* SpentHeightIndicators.pending */ }, { $set: { blockHeight: -5 /* SpentHeightIndicators.expired */ } }),
                        this.coinModel.collection.updateMany({ chain: chain, network: network, mintTxid: { $in: txids }, mintHeight: -1 /* SpentHeightIndicators.pending */ }, { $set: { mintHeight: -5 /* SpentHeightIndicators.expired */ } }),
                        this.coinModel.collection.updateMany({ chain: chain, network: network, spentTxid: { $in: txids }, spentHeight: -1 /* SpentHeightIndicators.pending */ }, { $set: { spentTxid: null, spentHeight: -2 /* SpentHeightIndicators.unspent */ } })
                    ])];
            });
        });
    };
    return PruningService;
}());
exports.PruningService = PruningService;
exports.Pruning = new PruningService();
//# sourceMappingURL=pruning.js.map