"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Socket = exports.SocketService = void 0;
var mongodb_1 = require("mongodb");
var SocketIO = require("socket.io");
var Loggify_1 = require("../decorators/Loggify");
var logger_1 = __importDefault(require("../logger"));
var events_1 = require("../models/events");
var wallet_1 = require("../models/wallet");
var auth_1 = require("../utils/auth");
var config_1 = require("./config");
var event_1 = require("./event");
function SanitizeWallet(x) {
    var sanitized = Object.assign({}, x, { wallets: new Array() });
    if (sanitized.wallets && sanitized.wallets.length > 0) {
        delete sanitized.wallets;
    }
    return sanitized;
}
var SocketService = /** @class */ (function () {
    function SocketService(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.eventService, eventService = _c === void 0 ? event_1.Event : _c, _d = _b.eventModel, eventModel = _d === void 0 ? events_1.EventStorage : _d, _e = _b.configService, configService = _e === void 0 ? config_1.Config : _e;
        this.id = Math.random();
        this.stopped = true;
        this.eventService = eventService;
        this.configService = configService;
        this.serviceConfig = this.configService.for('socket');
        this.eventModel = eventModel;
        this.wireup = this.wireup.bind(this);
        this.start = this.start.bind(this);
        this.signalTx = this.signalTx.bind(this);
        this.signalBlock = this.signalBlock.bind(this);
        this.signalAddressCoin = this.signalAddressCoin.bind(this);
    }
    SocketService.prototype.validateRequest = function (payload) {
        try {
            var valid = auth_1.Auth.verifyRequestSignature(payload);
            return valid;
        }
        catch (e) {
            return false;
        }
    };
    SocketService.prototype.start = function (_a) {
        var _this = this;
        var server = _a.server;
        var bwsKeys = this.serviceConfig.bwsKeys;
        if (this.configService.isDisabled('socket')) {
            logger_1.default.info('Disabled Socket Service');
            return;
        }
        if (this.stopped) {
            this.stopped = false;
            logger_1.default.info('Starting Socket Service');
            this.httpServer = server;
            this.io = SocketIO(server);
            this.io.sockets.on('connection', function (socket) {
                socket.on('room', function (room, payload) {
                    var chainNetwork = room.slice(0, room.lastIndexOf('/') + 1);
                    var roomName = room.slice(room.lastIndexOf('/') + 1);
                    switch (roomName) {
                        case 'wallets':
                            if (bwsKeys.includes(payload.pubKey) && _this.validateRequest(payload)) {
                                socket.join(room);
                            }
                            else {
                                socket.emit('failure', { message: 'Authentication failed' });
                            }
                            break;
                        case 'wallet':
                            if (_this.validateRequest(payload)) {
                                socket.join(chainNetwork + payload.pubKey);
                            }
                            else {
                                socket.emit('failure', { message: 'Authentication failed' });
                            }
                            break;
                        case 'inv':
                        case 'address':
                            socket.join(room);
                            break;
                    }
                });
            });
        }
        this.wireup();
        logger_1.default.info('Started Socket Service');
    };
    SocketService.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                logger_1.default.info('Stopping Socket Service');
                this.stopped = true;
                return [2 /*return*/];
            });
        });
    };
    SocketService.prototype.wireup = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.eventService.txEvent.on('tx', function (tx) { return __awaiter(_this, void 0, void 0, function () {
                    var chain, network, sanitizedTx, objectIds, wallets, wallets_1, wallets_1_1, wallet;
                    var e_1, _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                if (!(!this.stopped && this.io)) return [3 /*break*/, 2];
                                chain = tx.chain, network = tx.network;
                                sanitizedTx = SanitizeWallet(tx);
                                this.io.sockets.in("/".concat(chain, "/").concat(network, "/inv")).emit('tx', sanitizedTx);
                                if (!(tx.wallets && tx.wallets.length)) return [3 /*break*/, 2];
                                objectIds = tx.wallets.map(function (w) { return new mongodb_1.ObjectID(w); });
                                return [4 /*yield*/, wallet_1.WalletStorage.collection.find({ _id: { $in: objectIds } }).toArray()];
                            case 1:
                                wallets = _b.sent();
                                try {
                                    for (wallets_1 = __values(wallets), wallets_1_1 = wallets_1.next(); !wallets_1_1.done; wallets_1_1 = wallets_1.next()) {
                                        wallet = wallets_1_1.value;
                                        this.io.sockets.in("/".concat(chain, "/").concat(network, "/wallets")).emit('tx', { pubKey: wallet.pubKey, tx: tx });
                                        this.io.sockets
                                            .in("/".concat(chain, "/").concat(network, "/").concat(wallet.pubKey))
                                            .emit('tx', { pubKey: wallet.pubKey, tx: sanitizedTx });
                                    }
                                }
                                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                finally {
                                    try {
                                        if (wallets_1_1 && !wallets_1_1.done && (_a = wallets_1.return)) _a.call(wallets_1);
                                    }
                                    finally { if (e_1) throw e_1.error; }
                                }
                                _b.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                }); });
                this.eventService.blockEvent.on('block', function (block) {
                    if (!_this.stopped && _this.io) {
                        var chain = block.chain, network = block.network;
                        _this.io.sockets.in("/".concat(chain, "/").concat(network, "/inv")).emit('block', block);
                    }
                });
                this.eventService.addressCoinEvent.on('coin', function (addressCoin) { return __awaiter(_this, void 0, void 0, function () {
                    var coin, address, chain, network, sanitizedCoin, objectIds, wallets, wallets_2, wallets_2_1, wallet;
                    var e_2, _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                if (!(!this.stopped && this.io)) return [3 /*break*/, 2];
                                coin = addressCoin.coin, address = addressCoin.address;
                                chain = coin.chain, network = coin.network;
                                sanitizedCoin = SanitizeWallet(coin);
                                this.io.sockets.in("/".concat(chain, "/").concat(network, "/address")).emit(address, sanitizedCoin);
                                this.io.sockets.in("/".concat(chain, "/").concat(network, "/inv")).emit('coin', sanitizedCoin);
                                if (!(coin.wallets && coin.wallets.length)) return [3 /*break*/, 2];
                                objectIds = coin.wallets.map(function (w) { return new mongodb_1.ObjectID(w); });
                                return [4 /*yield*/, wallet_1.WalletStorage.collection.find({ _id: { $in: objectIds } }).toArray()];
                            case 1:
                                wallets = _b.sent();
                                try {
                                    for (wallets_2 = __values(wallets), wallets_2_1 = wallets_2.next(); !wallets_2_1.done; wallets_2_1 = wallets_2.next()) {
                                        wallet = wallets_2_1.value;
                                        this.io.sockets.in("/".concat(chain, "/").concat(network, "/wallets")).emit('coin', { pubKey: wallet.pubKey, coin: coin });
                                        this.io.sockets
                                            .in("/".concat(chain, "/").concat(network, "/").concat(wallet.pubKey))
                                            .emit('coin', { pubKey: wallet.pubKey, coin: sanitizedCoin });
                                    }
                                }
                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                finally {
                                    try {
                                        if (wallets_2_1 && !wallets_2_1.done && (_a = wallets_2.return)) _a.call(wallets_2);
                                    }
                                    finally { if (e_2) throw e_2.error; }
                                }
                                _b.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
            });
        });
    };
    SocketService.prototype.signalBlock = function (block) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, events_1.EventStorage.signalBlock(block)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SocketService.prototype.signalTx = function (tx) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, events_1.EventStorage.signalTx(tx)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SocketService.prototype.signalAddressCoin = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, events_1.EventStorage.signalAddressCoin(payload)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SocketService = __decorate([
        Loggify_1.LoggifyClass
    ], SocketService);
    return SocketService;
}());
exports.SocketService = SocketService;
exports.Socket = new SocketService();
//# sourceMappingURL=socket.js.map