"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Storage = exports.StorageService = void 0;
var events_1 = require("events");
var mongodb_1 = require("mongodb");
var mongodb_2 = require("mongodb");
var Loggify_1 = require("../decorators/Loggify");
var logger_1 = __importDefault(require("../logger"));
require("../models");
var wait_1 = require("../utils/wait");
var config_1 = require("./config");
var StorageService = /** @class */ (function () {
    function StorageService(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.configService, configService = _c === void 0 ? config_1.Config : _c;
        this.connected = false;
        this.connection = new events_1.EventEmitter();
        this.modelsConnected = new Array();
        this.configService = configService;
        this.connection.setMaxListeners(30);
    }
    StorageService.prototype.start = function (args) {
        var _this = this;
        if (args === void 0) { args = {}; }
        return new Promise(function (resolve, reject) {
            var options = Object.assign({}, _this.configService.get(), args);
            var dbUrl = options.dbUrl, dbName = options.dbName, dbHost = options.dbHost, dbPort = options.dbPort, dbUser = options.dbUser, dbPass = options.dbPass, dbReadPreference = options.dbReadPreference;
            var auth = dbUser !== '' && dbPass !== '' ? "".concat(dbUser, ":").concat(dbPass, "@") : '';
            var connectUrl = dbUrl
                ? dbUrl
                : "mongodb://".concat(auth).concat(dbHost, ":").concat(dbPort, "/").concat(dbName, "?socketTimeoutMS=3600000&noDelay=true").concat(dbReadPreference ? "?readPreference=".concat(dbReadPreference) : '');
            var attemptConnect = function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, mongodb_2.MongoClient.connect(connectUrl, {
                            keepAlive: true,
                            poolSize: options.maxPoolSize,
                            useNewUrlParser: true
                        })];
                });
            }); };
            var attempted = 0;
            var attemptConnectId = setInterval(function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, err_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 2, , 3]);
                            _a = this;
                            return [4 /*yield*/, attemptConnect()];
                        case 1:
                            _a.client = _b.sent();
                            this.db = this.client.db(dbName);
                            this.connected = true;
                            clearInterval(attemptConnectId);
                            this.connection.emit('CONNECTED');
                            resolve(this.client);
                            return [3 /*break*/, 3];
                        case 2:
                            err_1 = _b.sent();
                            logger_1.default.error('%o', err_1);
                            attempted++;
                            if (attempted > 5) {
                                clearInterval(attemptConnectId);
                                reject(new Error('Failed to connect to database'));
                            }
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            }); }, 5000);
        });
    };
    StorageService.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.client) return [3 /*break*/, 4];
                        logger_1.default.info('Stopping Storage Service');
                        return [4 /*yield*/, (0, wait_1.wait)(5000)];
                    case 1:
                        _a.sent();
                        this.connected = false;
                        return [4 /*yield*/, Promise.all(this.modelsConnected)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.client.close()];
                    case 3:
                        _a.sent();
                        this.connection.emit('DISCONNECTED');
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    StorageService.prototype.validPagingProperty = function (model, property) {
        var defaultCase = property === '_id';
        return defaultCase || model.allowedPaging.some(function (prop) { return prop.key === property; });
    };
    /**
     * castForDb
     *
     * For a given model, return the typecasted value based on a key and the type associated with that key
     */
    StorageService.prototype.typecastForDb = function (model, modelKey, modelValue) {
        var typecastedValue = modelValue;
        if (modelKey) {
            var oldValue = modelValue;
            var optionsType = model.allowedPaging.find(function (prop) { return prop.key === modelKey; });
            if (optionsType) {
                switch (optionsType.type) {
                    case 'number':
                        typecastedValue = Number(oldValue);
                        break;
                    case 'string':
                        typecastedValue = (oldValue || '').toString();
                        break;
                    case 'date':
                        typecastedValue = new Date(oldValue);
                        break;
                }
            }
            else if (modelKey == '_id') {
                typecastedValue = new mongodb_1.ObjectID(oldValue);
            }
        }
        return typecastedValue;
    };
    StorageService.prototype.stream = function (input, req, res) {
        var closed = false;
        req.on('close', function () {
            closed = true;
        });
        res.on('close', function () {
            closed = true;
        });
        input.on('error', function (err) {
            if (!closed) {
                closed = true;
                return res.status(500).end(err.message);
            }
            return;
        });
        var isFirst = true;
        res.type('json');
        input.on('data', function (data) {
            if (!closed) {
                if (isFirst) {
                    res.write('[\n');
                    isFirst = false;
                }
                else {
                    res.write(',\n');
                }
                res.write(JSON.stringify(data));
            }
        });
        input.on('end', function () {
            if (!closed) {
                if (isFirst) {
                    // there was no data
                    res.write('[]');
                }
                else {
                    res.write('\n]');
                }
                res.end();
            }
        });
    };
    StorageService.prototype.apiStream = function (cursor, req, res) {
        var closed = false;
        req.on('close', function () {
            closed = true;
            cursor.close();
        });
        res.on('close', function () {
            closed = true;
            cursor.close();
        });
        cursor.on('error', function (err) {
            if (!closed) {
                closed = true;
                return res.status(500).end(err.message);
            }
            return;
        });
        var isFirst = true;
        res.type('json');
        cursor.on('data', function (data) {
            if (!closed) {
                if (isFirst) {
                    res.write('[\n');
                    isFirst = false;
                }
                else {
                    res.write(',\n');
                }
                res.write(data);
            }
            else {
                cursor.close();
            }
        });
        cursor.on('end', function () {
            if (!closed) {
                if (isFirst) {
                    // there was no data
                    res.write('[]');
                }
                else {
                    res.write('\n]');
                }
                res.end();
            }
        });
    };
    StorageService.prototype.getFindOptions = function (model, originalOptions) {
        var _a, _b;
        var query = {};
        var since = null;
        var options = {};
        if (originalOptions.sort) {
            options.sort = originalOptions.sort;
        }
        if (originalOptions.paging && this.validPagingProperty(model, originalOptions.paging)) {
            if (originalOptions.since !== undefined) {
                since = this.typecastForDb(model, originalOptions.paging, originalOptions.since);
            }
            if (originalOptions.direction && Number(originalOptions.direction) === 1) {
                if (since) {
                    query[originalOptions.paging] = { $gt: since };
                }
                options.sort = Object.assign({}, originalOptions.sort, (_a = {}, _a[originalOptions.paging] = 1, _a));
            }
            else {
                if (since) {
                    query[originalOptions.paging] = { $lt: since };
                }
                options.sort = Object.assign({}, originalOptions.sort, (_b = {}, _b[originalOptions.paging] = -1, _b));
            }
        }
        if (originalOptions.limit) {
            options.limit = Number(originalOptions.limit);
        }
        return { query: query, options: options };
    };
    StorageService.prototype.apiStreamingFind = function (model, originalQuery, originalOptions, req, res, transform) {
        var _a = this.getFindOptions(model, originalOptions), query = _a.query, options = _a.options;
        var finalQuery = Object.assign({}, originalQuery, query);
        var cursor = model.collection
            .find(finalQuery, options)
            .addCursorFlag('noCursorTimeout', true)
            .stream({
            transform: transform || model._apiTransform.bind(model)
        });
        if (options.sort) {
            cursor = cursor.sort(options.sort);
        }
        return this.apiStream(cursor, req, res);
    };
    StorageService = __decorate([
        Loggify_1.LoggifyClass
    ], StorageService);
    return StorageService;
}());
exports.StorageService = StorageService;
exports.Storage = new StorageService();
//# sourceMappingURL=storage.js.map