"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Worker = exports.WorkerService = void 0;
var cluster_1 = __importDefault(require("cluster"));
var events_1 = require("events");
var config_1 = __importDefault(require("../config"));
var Loggify_1 = require("../decorators/Loggify");
var logger_1 = __importDefault(require("../logger"));
var parseArgv_1 = __importDefault(require("../utils/parseArgv"));
var args = (0, parseArgv_1.default)([], [{ arg: 'DEBUG', type: 'bool' }]);
var WorkerService = /** @class */ (function (_super) {
    __extends(WorkerService, _super);
    function WorkerService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.workers = new Array();
        return _this;
    }
    WorkerService.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _loop_1, this_1, worker, startedPromises;
            var _this = this;
            return __generator(this, function (_a) {
                if (cluster_1.default.isPrimary) {
                    logger_1.default.verbose("Master ".concat(process.pid, " is running"));
                    cluster_1.default.on('exit', function (worker) {
                        logger_1.default.warn("worker ".concat(worker.process.pid, " stopped"));
                        process.kill(process.pid);
                    });
                    if (!args.DEBUG) {
                        _loop_1 = function (worker) {
                            var newWorker = cluster_1.default.fork();
                            logger_1.default.verbose("Starting worker number ".concat(worker));
                            newWorker.on('message', function (msg) {
                                _this.emit(msg.id, msg);
                            });
                            var started = new Promise(function (resolve) {
                                newWorker.on('listening', function () {
                                    resolve();
                                });
                            });
                            this_1.workers.push({ worker: newWorker, active: false, started: started });
                        };
                        this_1 = this;
                        for (worker = 0; worker < config_1.default.numWorkers; worker++) {
                            _loop_1(worker);
                        }
                    }
                    startedPromises = this.workers.map(function (worker) { return worker.started; });
                    return [2 /*return*/, Promise.all(startedPromises)];
                }
                else {
                    logger_1.default.verbose("Worker ".concat(process.pid, " started"));
                    return [2 /*return*/];
                }
                return [2 /*return*/];
            });
        });
    };
    WorkerService.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/];
        }); });
    };
    WorkerService.prototype.sendTask = function (task, argument, done) {
        var worker = this.workers.shift();
        if (worker) {
            this.workers.push(worker);
            var id = (Date.now() * Math.random()).toString();
            this.once(id, function (result) {
                done(result.error);
            });
            worker.worker.send({ task: task, argument: argument, id: id });
        }
    };
    WorkerService.prototype.workerCount = function () {
        return this.workers.length;
    };
    WorkerService = __decorate([
        Loggify_1.LoggifyClass
    ], WorkerService);
    return WorkerService;
}(events_1.EventEmitter));
exports.WorkerService = WorkerService;
exports.Worker = new WorkerService();
//# sourceMappingURL=worker.js.map