"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatsUtil = void 0;
var StatsUtil = /** @class */ (function () {
    function StatsUtil() {
    }
    /**
     * @param {Array<T>} array - A sorted array of values to be used for quartiles
     * @param {number} n - which quartile do you want the median from
     * @returns {T} - The median of nth quartile
     */
    StatsUtil.getNthQuartileMedian = function (array, n) {
        if (n < 1 || n > 4) {
            throw new Error('second parameter must be between 1 and 4');
        }
        var quartileLength = Math.floor(array.length / 4);
        var quartileStartPoint = (n - 1) * quartileLength;
        var quartileMidpoint = quartileStartPoint + Math.floor(quartileLength / 2);
        var quartileMedian = array[quartileMidpoint];
        return quartileMedian;
    };
    return StatsUtil;
}());
exports.StatsUtil = StatsUtil;
//# sourceMappingURL=stats.js.map