"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.P2pWorker = void 0;
require("source-map-support/register");
var logger_1 = __importDefault(require("../logger"));
var modules_1 = require("../modules");
var config_1 = require("../services/config");
var event_1 = require("../services/event");
var p2p_1 = require("../services/p2p");
var storage_1 = require("../services/storage");
require("../utils/polyfills");
require('heapdump');
var services = [];
var P2pWorker = function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, chain, network, chainConfig, p2pClass, worker, services_1, services_1_1, service, e_1, e_2_1;
    var e_2, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                process.on('unhandledRejection', function (error) {
                    console.error('Unhandled Rejection at:', error.stack || error);
                    stop();
                });
                process.on('SIGTERM', stop);
                process.on('SIGINT', stop);
                services.push(storage_1.Storage, event_1.Event);
                modules_1.Modules.loadConfigured();
                _a = process.env, chain = _a.CHAIN, network = _a.NETWORK;
                if (chain && network) {
                    chainConfig = config_1.Config.chainConfig({ chain: chain, network: network });
                    p2pClass = p2p_1.P2P.get(chain);
                    worker = new p2pClass({
                        chain: chain,
                        network: network,
                        chainConfig: chainConfig
                    });
                    services.push(worker);
                }
                else {
                    services.push(p2p_1.P2P);
                }
                _c.label = 1;
            case 1:
                _c.trys.push([1, 8, 9, 10]);
                services_1 = __values(services), services_1_1 = services_1.next();
                _c.label = 2;
            case 2:
                if (!!services_1_1.done) return [3 /*break*/, 7];
                service = services_1_1.value;
                _c.label = 3;
            case 3:
                _c.trys.push([3, 5, , 6]);
                return [4 /*yield*/, service.start()];
            case 4:
                _c.sent();
                return [3 /*break*/, 6];
            case 5:
                e_1 = _c.sent();
                logger_1.default.error('P2P Worker died with %o', e_1);
                return [3 /*break*/, 6];
            case 6:
                services_1_1 = services_1.next();
                return [3 /*break*/, 2];
            case 7: return [3 /*break*/, 10];
            case 8:
                e_2_1 = _c.sent();
                e_2 = { error: e_2_1 };
                return [3 /*break*/, 10];
            case 9:
                try {
                    if (services_1_1 && !services_1_1.done && (_b = services_1.return)) _b.call(services_1);
                }
                finally { if (e_2) throw e_2.error; }
                return [7 /*endfinally*/];
            case 10: return [2 /*return*/];
        }
    });
}); };
exports.P2pWorker = P2pWorker;
var stopping = false;
var stop = function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, _b, service, e_3_1;
    var e_3, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                if (stopping) {
                    logger_1.default.warn('Force stopping P2P Worker');
                    process.exit(1);
                }
                stopping = true;
                logger_1.default.info("Shutting down pid ".concat(process.pid));
                _d.label = 1;
            case 1:
                _d.trys.push([1, 6, 7, 8]);
                _a = __values(services.reverse()), _b = _a.next();
                _d.label = 2;
            case 2:
                if (!!_b.done) return [3 /*break*/, 5];
                service = _b.value;
                return [4 /*yield*/, service.stop()];
            case 3:
                _d.sent();
                _d.label = 4;
            case 4:
                _b = _a.next();
                return [3 /*break*/, 2];
            case 5: return [3 /*break*/, 8];
            case 6:
                e_3_1 = _d.sent();
                e_3 = { error: e_3_1 };
                return [3 /*break*/, 8];
            case 7:
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_3) throw e_3.error; }
                return [7 /*endfinally*/];
            case 8:
                setTimeout(function () {
                    logger_1.default.warn('P2P Worker did not shut down gracefully after 30 seconds, exiting');
                    process.exit(1);
                }, 30 * 1000).unref();
                return [2 /*return*/];
        }
    });
}); };
if (require.main === module) {
    (0, exports.P2pWorker)();
}
//# sourceMappingURL=p2p.js.map