"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bitcoreLib = require('bitcore-lib');
var Transaction = bitcoreLib.Transaction, PrivateKey = bitcoreLib.PrivateKey;
var UnspentOutput = Transaction.UnspentOutput;
var config_1 = __importDefault(require("../../src/config"));
var storage_1 = require("../../src/services/storage");
var block_1 = require("../../src/models/block");
var index_js_1 = require("../helpers/index.js");
var crypto = __importStar(require("crypto"));
function randomHash() {
    return crypto.randomBytes(32).toString('hex');
}
function generateBlocks(blockCount, blockSizeMb) {
    var prevBlock, i, tempBlock;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                prevBlock = undefined;
                i = 0;
                _a.label = 1;
            case 1:
                if (!(i < blockCount)) return [3 /*break*/, 4];
                tempBlock = generateBlock(blockSizeMb, prevBlock);
                return [4 /*yield*/, tempBlock];
            case 2:
                _a.sent();
                prevBlock = tempBlock;
                _a.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}
function preGenerateBlocks(blockCount, blockSizeMb) {
    var e_1, _a;
    var blocks = new Array();
    try {
        for (var _b = __values(generateBlocks(blockCount, blockSizeMb)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var block = _c.value;
            blocks.push(block);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return blocks;
}
function generateBlock(blockSizeMb, previousBlock) {
    var e_2, _a;
    var txAmount = 100000;
    var prevHash = previousBlock ? previousBlock.hash : '';
    var block = {
        hash: randomHash(),
        transactions: [],
        toBuffer: function () {
            return { length: 264 };
        },
        header: {
            toObject: function () {
                return {
                    hash: randomHash(),
                    confirmations: 1,
                    strippedsize: 228,
                    size: 264,
                    weight: 948,
                    height: 1355,
                    version: 536870912,
                    versionHex: '20000000',
                    merkleRoot: randomHash(),
                    tx: [randomHash()],
                    time: 1526756523,
                    mediantime: 1526066375,
                    nonce: 2,
                    bits: parseInt('207fffff', 16),
                    difficulty: 4.656542373906925e-10,
                    chainwork: '0000000000000000000000000000000000000000000000000000000000000a98',
                    prevHash: prevHash
                };
            }
        }
    };
    var transactions = new Array();
    if (previousBlock) {
        var _loop_1 = function (transaction) {
            var e_3, _d;
            // each transaction should have one input and one output
            var utxos = transaction.outputs.map(function (output) {
                return new UnspentOutput({
                    txid: transaction.hash,
                    vout: 0,
                    address: output.script.toAddress('mainnet'),
                    scriptPubKey: output.script.toBuffer().toString('hex'),
                    amount: Number(txAmount)
                });
            });
            var newTx = new Transaction().from(utxos);
            try {
                for (var _e = (e_3 = void 0, __values(newTx.inputs)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var _1 = _f.value;
                    newTx.to(newAddress(), txAmount);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_d = _e.return)) _d.call(_e);
                }
                finally { if (e_3) throw e_3.error; }
            }
            transactions.push(newTx);
        };
        try {
            for (var _b = __values(previousBlock.transactions), _c = _b.next(); !_c.done; _c = _b.next()) {
                var transaction = _c.value;
                _loop_1(transaction);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        block.transactions = transactions;
    }
    else {
        var txPerMb = 2500;
        var blockSize = txPerMb * blockSizeMb;
        for (var i = 0; i < blockSize; i++) {
            var newTx = new Transaction().to(newAddress(), txAmount);
            block.transactions.push(newTx);
        }
    }
    return block;
}
var addresses = new Array();
for (var i = 0; i < 100; i++) {
    var privateKey = new PrivateKey();
    var publicKey = privateKey.toPublicKey();
    var address = publicKey.toAddress().toString();
    addresses.push(address);
}
function newAddress() {
    var index = Math.floor(Math.random() * 100);
    return addresses[index];
}
function startBenchmarkDatabase() {
    var storageArgs = {
        dbHost: config_1.default.dbHost,
        dbName: 'bitcore-benchmark'
    };
    return storage_1.Storage.start(storageArgs);
}
function benchmark(blockCount, blockSizeMb) {
    return __awaiter(this, void 0, void 0, function () {
        var blocks, startTime, blocks_1, blocks_1_1, block, e_4_1, endTime, time, seconds;
        var e_4, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, (0, index_js_1.resetDatabase)()];
                case 1:
                    _b.sent();
                    console.log('Generating blocks');
                    blocks = preGenerateBlocks(blockCount, blockSizeMb);
                    startTime = new Date();
                    console.log('Adding blocks');
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 7, 8, 9]);
                    blocks_1 = __values(blocks), blocks_1_1 = blocks_1.next();
                    _b.label = 3;
                case 3:
                    if (!!blocks_1_1.done) return [3 /*break*/, 6];
                    block = blocks_1_1.value;
                    process.stdout.write('.');
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.addBlock({ block: block, chain: 'BENCH', network: 'MARK', initialSyncComplete: false })];
                case 4:
                    _b.sent();
                    _b.label = 5;
                case 5:
                    blocks_1_1 = blocks_1.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_4_1 = _b.sent();
                    e_4 = { error: e_4_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (blocks_1_1 && !blocks_1_1.done && (_a = blocks_1.return)) _a.call(blocks_1);
                    }
                    finally { if (e_4) throw e_4.error; }
                    return [7 /*endfinally*/];
                case 9:
                    process.stdout.write('\n');
                    endTime = new Date();
                    time = endTime.getTime() - startTime.getTime();
                    seconds = time / 1000;
                    console.log("Benchmark for ".concat(blockCount, " (").concat(blockSizeMb, " MB) blocks completed after ").concat(seconds, " s"));
                    console.log("".concat((blockSizeMb * blockCount) / seconds, " MB/s"));
                    console.log("".concat(seconds / blockCount, " Seconds/Block"));
                    return [2 /*return*/];
            }
        });
    });
}
startBenchmarkDatabase()
    .then(function () { return benchmark(80, 1); })
    .then(function () { return benchmark(5, 32); })
    .then(function () { return benchmark(1, 64); })
    .then(function () { return process.exit(); });
//# sourceMappingURL=benchmark.js.map