"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createWallet = void 0;
var bitcore_client_1 = require("bitcore-client");
var _ = __importStar(require("lodash"));
var coin_1 = require("../../src/models/coin");
var storage_1 = require("../../src/services/storage");
function getAllAddressesFromBlocks(start, end) {
    return __awaiter(this, void 0, void 0, function () {
        var coins, uniqueAddresses;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!storage_1.Storage.connected) return [3 /*break*/, 2];
                    return [4 /*yield*/, storage_1.Storage.start({})];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [4 /*yield*/, coin_1.CoinStorage.collection
                        .find({ chain: 'BTC', network: 'mainnet', mintHeight: { $gte: start, $lte: end } })
                        .project({ address: 1 })
                        .toArray()];
                case 3:
                    coins = _a.sent();
                    uniqueAddresses = _.uniq(coins.map(function (c) { return c.address; }));
                    return [2 /*return*/, uniqueAddresses];
            }
        });
    });
}
function createWallet(addresses, iteration, networkName) {
    return __awaiter(this, void 0, void 0, function () {
        var walletName, password, chain, network, baseUrl, lockedWallet, err_1, unlockedWallet, keysToImport;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    walletName = 'Benchmark Wallet' + iteration;
                    password = 'iamsatoshi';
                    chain = 'BTC';
                    network = networkName || 'mainnet';
                    baseUrl = 'http://localhost:3000/api';
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 5]);
                    return [4 /*yield*/, bitcore_client_1.Wallet.loadWallet({ name: walletName })];
                case 2:
                    lockedWallet = _a.sent();
                    return [3 /*break*/, 5];
                case 3:
                    err_1 = _a.sent();
                    return [4 /*yield*/, bitcore_client_1.Wallet.create({
                            name: walletName,
                            chain: chain,
                            network: network,
                            baseUrl: baseUrl,
                            password: password
                        })];
                case 4:
                    lockedWallet = _a.sent();
                    return [3 /*break*/, 5];
                case 5: return [4 /*yield*/, lockedWallet.register({ baseUrl: baseUrl })];
                case 6:
                    _a.sent();
                    if (!(addresses.length > 0)) return [3 /*break*/, 9];
                    return [4 /*yield*/, lockedWallet.unlock(password)];
                case 7:
                    unlockedWallet = _a.sent();
                    keysToImport = addresses.map(function (a) { return ({ address: a }); });
                    return [4 /*yield*/, unlockedWallet.importKeys({ keys: keysToImport })];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9: return [2 /*return*/, lockedWallet];
            }
        });
    });
}
exports.createWallet = createWallet;
function benchMarkUtxoList(unlockedWallet, addresses, includeSpent) {
    if (includeSpent === void 0) { includeSpent = false; }
    return __awaiter(this, void 0, void 0, function () {
        var utxoListStart, utxoStream, utxoBenchmark;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    utxoListStart = new Date();
                    utxoStream = unlockedWallet.getUtxos({ includeSpent: includeSpent });
                    utxoBenchmark = new Promise(function (resolve) {
                        var utxos = new Array();
                        utxoStream
                            .on('data', function (data) {
                            var stringData = data.toString().replace(',\n', '');
                            if (stringData.includes('{') && stringData.includes('}')) {
                                utxos.push(JSON.parse(stringData));
                            }
                        })
                            .on('complete', function () {
                            var includeUnspentMsg = includeSpent ? '(+spent)' : '';
                            console.log("Listed ".concat(includeUnspentMsg, " "), (utxos || []).length, ' utxos for a wallet with', addresses.length, 'addresses. Took ', new Date().getTime() - utxoListStart.getTime(), ' ms');
                            resolve(utxos);
                        });
                    });
                    return [4 /*yield*/, utxoBenchmark];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function bench(iteration, startBlock, endBlock) {
    if (iteration === void 0) { iteration = 0; }
    if (startBlock === void 0) { startBlock = 0; }
    if (endBlock === void 0) { endBlock = 100; }
    return __awaiter(this, void 0, void 0, function () {
        var addresses, walletCreationStart, unlockedWallet, walletTxListStart, txStream, benchmarkComplete;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log('Benchmark', iteration, 'START');
                    return [4 /*yield*/, getAllAddressesFromBlocks(startBlock, endBlock)];
                case 1:
                    addresses = _a.sent();
                    console.log('Collected', addresses.length, 'addresses');
                    walletCreationStart = new Date();
                    return [4 /*yield*/, createWallet(addresses, iteration)];
                case 2:
                    unlockedWallet = _a.sent();
                    console.log('Create a wallet with', addresses.length, 'addresses. Took ', new Date().getTime() - walletCreationStart.getTime(), ' ms');
                    return [4 /*yield*/, benchMarkUtxoList(unlockedWallet, addresses)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, benchMarkUtxoList(unlockedWallet, addresses, true)];
                case 4:
                    _a.sent();
                    walletTxListStart = new Date();
                    txStream = unlockedWallet.listTransactions({ startBlock: startBlock, endBlock: endBlock });
                    benchmarkComplete = new Promise(function (resolve) {
                        var txs = new Array();
                        txStream.on('data', function (data) {
                            var stringData = data.toString().replace(',\n', '');
                            if (stringData.includes('{') && stringData.includes('}')) {
                                txs.push(JSON.parse(stringData));
                            }
                        });
                        txStream.on('complete', function () {
                            console.log('Listed ', txs.length, ' txs for a wallet with', addresses.length, 'addresses. Took ', new Date().getTime() - walletTxListStart.getTime(), ' ms');
                            resolve(txs);
                        });
                    });
                    return [4 /*yield*/, benchmarkComplete];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 1;
                    _a.label = 1;
                case 1:
                    if (!(i < 6)) return [3 /*break*/, 4];
                    return [4 /*yield*/, bench(i, 0, Math.pow(10, i))];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4:
                    process.exit(0);
                    return [2 /*return*/];
            }
        });
    });
}
if (require.main === module) {
    main();
}
//# sourceMappingURL=wallet-benchmark.js.map