"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockModel = exports.mockStorage = exports.mockCollection = exports.resetModel = exports.resetDatabase = void 0;
var sinon_1 = __importDefault(require("sinon"));
var block_1 = require("../../src/models/block");
var cache_1 = require("../../src/models/cache");
var coin_1 = require("../../src/models/coin");
var events_1 = require("../../src/models/events");
var rateLimit_1 = require("../../src/models/rateLimit");
var state_1 = require("../../src/models/state");
var transaction_1 = require("../../src/models/transaction");
var wallet_1 = require("../../src/models/wallet");
var walletAddress_1 = require("../../src/models/walletAddress");
var storage_1 = require("../../src/services/storage");
function resetDatabase() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log('Resetting database');
                    return [4 /*yield*/, Promise.all([
                            resetModel(block_1.BitcoinBlockStorage),
                            resetModel(transaction_1.TransactionStorage),
                            resetModel(coin_1.CoinStorage),
                            resetModel(walletAddress_1.WalletAddressStorage),
                            resetModel(wallet_1.WalletStorage),
                            resetModel(state_1.StateStorage),
                            resetModel(rateLimit_1.RateLimitStorage),
                            resetModel(events_1.EventStorage),
                            resetModel(cache_1.CacheStorage)
                        ])];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.resetDatabase = resetDatabase;
function resetModel(model) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, model.collection.deleteMany({})];
        });
    });
}
exports.resetModel = resetModel;
function mockCollection(toReturn, collectionMethods) {
    if (collectionMethods === void 0) { collectionMethods = {}; }
    var mock = Object.assign({
        find: sinon_1.default.stub().returnsThis(),
        aggregate: sinon_1.default.stub().returnsThis(),
        count: sinon_1.default.stub().returnsThis(),
        sort: sinon_1.default.stub().returnsThis(),
        project: sinon_1.default.stub().returnsThis(),
        insertOne: sinon_1.default.stub().resolves(),
        insertMany: sinon_1.default.stub().resolves(),
        bulkWrite: sinon_1.default.stub().resolves(),
        remove: sinon_1.default.stub().resolves(),
        deleteOne: sinon_1.default.stub().resolves(),
        deleteMany: sinon_1.default.stub().resolves(),
        limit: sinon_1.default.stub().returnsThis(),
        toArray: sinon_1.default.stub().resolves(toReturn instanceof Array ? toReturn : [toReturn]),
        findOne: sinon_1.default.stub().resolves(toReturn),
        update: sinon_1.default.stub().resolves({ result: toReturn }),
        updateOne: sinon_1.default.stub().resolves(toReturn),
        updateMany: sinon_1.default.stub().resolves({ nModified: 1 }),
        addCursorFlag: sinon_1.default.stub().returnsThis()
    }, collectionMethods);
    return mock;
}
exports.mockCollection = mockCollection;
function mockStorage(toReturn, collectionMethods) {
    if (collectionMethods === void 0) { collectionMethods = {}; }
    storage_1.Storage.db = {
        collection: sinon_1.default.stub().returns(mockCollection(toReturn, collectionMethods))
    };
    return storage_1.Storage;
}
exports.mockStorage = mockStorage;
function mockModel(collectionName, toReturn, collectionMethods) {
    if (collectionMethods === void 0) { collectionMethods = {}; }
    if (!storage_1.Storage.db) {
        storage_1.Storage.db = {
            collection: sinon_1.default.stub().returns(mockCollection(toReturn, collectionMethods))
        };
    }
    var collectionFn = storage_1.Storage.db.collection;
    if (collectionFn.withArgs) {
        collectionFn.withArgs(collectionName).returns(mockCollection(toReturn, collectionMethods));
    }
}
exports.mockModel = mockModel;
//# sourceMappingURL=index.js.map