"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var BitcoreClient = __importStar(require("bitcore-client"));
var chai_1 = require("chai");
var crypto_wallet_core_1 = require("crypto-wallet-core");
var sinon_1 = __importDefault(require("sinon"));
var config_1 = __importDefault(require("../../../src/config"));
var cache_1 = require("../../../src/models/cache");
var block_1 = require("../../../src/providers/chain-state/evm/models/block");
var p2p_1 = require("../../../src/providers/chain-state/evm/p2p/p2p");
var api_1 = require("../../../src/services/api");
var wait_1 = require("../../../src/utils/wait");
var helpers_1 = require("../../helpers");
var integration_1 = require("../../helpers/integration");
var StreamUtil = BitcoreClient.StreamUtil;
var chain = 'MATIC';
var network = 'regtest';
var chainConfig = config_1.default.chains[chain][network];
var name = 'PolygonWallet-Ci';
var storageType = 'Level';
var baseUrl = 'http://localhost:3000/api';
var password = '';
var phrase = 'glimpse mystery poverty onion muffin twist live kidney unhappy sort frame muffin';
var accounts = { geth: '0xeC12CD1Ab86F83C1B26C5caa38126Bc4299b6CBa' };
var privKeys = { geth: '0xf9ad2207e910cd649c9a32063dea3656380c32fa07d6bb9be853687ca585a015' };
function getWallet() {
    return __awaiter(this, void 0, void 0, function () {
        var wallet, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 4, , 9]);
                    return [4 /*yield*/, BitcoreClient.Wallet.loadWallet({ name: name, storageType: storageType })];
                case 1:
                    wallet = _a.sent();
                    return [4 /*yield*/, wallet.register()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, wallet.syncAddresses()];
                case 3:
                    _a.sent();
                    return [2 /*return*/, wallet];
                case 4:
                    e_1 = _a.sent();
                    console.log('Creating a new matic wallet');
                    return [4 /*yield*/, BitcoreClient.Wallet.create({
                            name: name,
                            chain: chain,
                            network: network,
                            baseUrl: baseUrl,
                            password: password,
                            phrase: phrase,
                            storageType: storageType
                        })];
                case 5:
                    wallet = _a.sent();
                    return [4 /*yield*/, wallet.unlock(password)];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, wallet.nextAddressPair()];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, wallet.lock()];
                case 8:
                    _a.sent();
                    return [2 /*return*/, wallet];
                case 9: return [2 /*return*/];
            }
        });
    });
}
function sendTransaction(from, to, amount, web3, wallet, nonce) {
    if (nonce === void 0) { nonce = 0; }
    return __awaiter(this, void 0, void 0, function () {
        var gasPrice, _a, tx, signedTx;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!!wallet) return [3 /*break*/, 2];
                    return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _b.sent();
                    _b.label = 2;
                case 2:
                    if (!!nonce) return [3 /*break*/, 4];
                    return [4 /*yield*/, web3.eth.getTransactionCount(accounts[from])];
                case 3:
                    nonce = _b.sent();
                    _b.label = 4;
                case 4:
                    _a = Number;
                    return [4 /*yield*/, web3.eth.getGasPrice()];
                case 5:
                    gasPrice = _a.apply(void 0, [_b.sent()]);
                    return [4 /*yield*/, wallet.newTx({ recipients: [{ address: to, amount: amount }], from: accounts[from], nonce: nonce, gasLimit: 21000, gasPrice: gasPrice })];
                case 6:
                    tx = _b.sent();
                    return [4 /*yield*/, wallet.signTx({ tx: tx, signingKeys: [{ privKey: privKeys[from] }] })];
                case 7:
                    signedTx = _b.sent();
                    return [4 /*yield*/, web3.eth.sendSignedTransaction(signedTx)];
                case 8:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    });
}
describe('Polygon', function () {
    var _this = this;
    var suite = this;
    this.timeout(50000);
    var sandbox = sinon_1.default.createSandbox();
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, integration_1.intBeforeHelper)()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.start()];
                case 3:
                    _a.sent();
                    sandbox.stub(crypto_wallet_core_1.Transactions.get({ chain: chain }), 'getChainId').returns(1337);
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, api_1.Api.stop()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, (0, integration_1.intAfterHelper)(suite)];
                case 2:
                    _a.sent();
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to create a wallet with an address', function () { return __awaiter(_this, void 0, void 0, function () {
        var wallet, addresses;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _a.sent();
                    return [4 /*yield*/, wallet.getAddresses()];
                case 2:
                    addresses = _a.sent();
                    (0, chai_1.expect)(addresses).to.exist;
                    (0, chai_1.expect)(addresses.length).to.eq(1);
                    (0, chai_1.expect)(addresses[0].toLowerCase()).to.equal('0xb875c670b079cce8f6ab4f013bd471359c877ac0');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to get block events from geth', function () { return __awaiter(_this, void 0, void 0, function () {
        var gethOnlyConfig, _a, protocol, host, port, getWeb3Stub, wallet, addresses, worker, sawBlock, web3, nonce;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    gethOnlyConfig = __assign(__assign({}, chainConfig), { provider: chainConfig.providers[0] });
                    _a = gethOnlyConfig.provider, protocol = _a.protocol, host = _a.host, port = _a.port;
                    getWeb3Stub = sinon_1.default.stub(p2p_1.EVMP2pWorker.prototype, 'getWeb3').resolves({ web3: new crypto_wallet_core_1.Web3("".concat(protocol, "://").concat(host, ":").concat(port)) });
                    return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _b.sent();
                    return [4 /*yield*/, wallet.getAddresses()];
                case 2:
                    addresses = _b.sent();
                    worker = new p2p_1.EVMP2pWorker({ chain: chain, network: network, chainConfig: gethOnlyConfig });
                    return [4 /*yield*/, worker.setupListeners()];
                case 3:
                    _b.sent();
                    return [4 /*yield*/, worker.connect()];
                case 4:
                    _b.sent();
                    sawBlock = new Promise(function (resolve) { return worker.events.on('block', resolve); });
                    return [4 /*yield*/, worker.getWeb3()];
                case 5:
                    web3 = (_b.sent()).web3;
                    return [4 /*yield*/, web3.eth.getTransactionCount(accounts['geth'])];
                case 6:
                    nonce = _b.sent();
                    // sending multiple tx to entice geth to mine a block because sometimes it doesn't mine even with automine enabled
                    sendTransaction('geth', addresses[0], web3.utils.toWei('.01', 'ether'), web3, wallet, nonce),
                        sendTransaction('geth', addresses[0], web3.utils.toWei('.01', 'ether'), web3, wallet, nonce + 1);
                    return [4 /*yield*/, sawBlock];
                case 7:
                    _b.sent();
                    return [4 /*yield*/, worker.disconnect()];
                case 8:
                    _b.sent();
                    return [4 /*yield*/, worker.stop()];
                case 9:
                    _b.sent();
                    getWeb3Stub.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to get the balance for the address', function () { return __awaiter(_this, void 0, void 0, function () {
        var wallet, balance, key, cached;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _a.sent();
                    return [4 /*yield*/, wallet.getBalance()];
                case 2:
                    balance = _a.sent();
                    (0, chai_1.expect)(balance.confirmed).to.be.gt(0);
                    key = 'getBalanceForAddress-MATIC-regtest-0xb875c670b079cce8f6ab4f013bd471359c877ac0';
                    return [4 /*yield*/, cache_1.CacheStorage.collection.findOne({ key: key })];
                case 3:
                    cached = _a.sent();
                    (0, chai_1.expect)(cached).to.exist;
                    (0, chai_1.expect)(cached.value).to.deep.eq(balance);
                    return [4 /*yield*/, wallet.lock()];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should update after a send', function () { return __awaiter(_this, void 0, void 0, function () {
        var wallet, addresses, beforeBalance, worker, sawBlock, web3, afterBalance;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _a.sent();
                    return [4 /*yield*/, wallet.getAddresses()];
                case 2:
                    addresses = _a.sent();
                    return [4 /*yield*/, wallet.getBalance()];
                case 3:
                    beforeBalance = _a.sent();
                    worker = new p2p_1.EVMP2pWorker({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.setupListeners()];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, worker.connect()];
                case 5:
                    _a.sent();
                    sawBlock = new Promise(function (resolve) { return worker.events.on('block', resolve); });
                    return [4 /*yield*/, worker.getWeb3()];
                case 6:
                    web3 = (_a.sent()).web3;
                    return [4 /*yield*/, sendTransaction('geth', addresses[0], web3.utils.toWei('.01', 'ether'), web3, wallet)];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, sawBlock];
                case 8:
                    _a.sent();
                    return [4 /*yield*/, worker.disconnect()];
                case 9:
                    _a.sent();
                    return [4 /*yield*/, worker.stop()];
                case 10:
                    _a.sent();
                    return [4 /*yield*/, wallet.getBalance()];
                case 11:
                    afterBalance = _a.sent();
                    (0, chai_1.expect)(afterBalance).to.not.deep.eq(beforeBalance);
                    (0, chai_1.expect)(afterBalance.confirmed).to.be.gt(beforeBalance.confirmed);
                    return [4 /*yield*/, wallet.lock()];
                case 12:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should have receipts on tx history', function () { return __awaiter(_this, void 0, void 0, function () {
        var wallet;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _a.sent();
                    return [4 /*yield*/, new Promise(function (r) {
                            return wallet
                                .listTransactions({})
                                .pipe(StreamUtil.jsonlBufferToObjectMode())
                                .on('data', function (tx) {
                                if (tx.height >= 0) {
                                    (0, chai_1.expect)(tx.receipt).to.exist;
                                    (0, chai_1.expect)(tx.receipt.gasUsed).to.exist;
                                    (0, chai_1.expect)(tx.receipt.gasUsed).to.be.lte(tx.gasLimit);
                                    (0, chai_1.expect)(tx.fee).to.eq(tx.gasPrice * tx.receipt.gasUsed);
                                }
                            })
                                .on('finish', function () {
                                r();
                            });
                        })];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, wallet.lock()];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it.skip('should be able to save blocks to the database', function () { return __awaiter(_this, void 0, void 0, function () {
        var wallet, addresses, worker, done, sawBlock, web3, dbBlocks;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getWallet()];
                case 1:
                    wallet = _a.sent();
                    return [4 /*yield*/, wallet.getAddresses()];
                case 2:
                    addresses = _a.sent();
                    worker = new p2p_1.EVMP2pWorker({ chain: chain, network: network, chainConfig: chainConfig });
                    done = worker.syncDone();
                    sawBlock = new Promise(function (resolve) { return worker.events.on('block', resolve); });
                    return [4 /*yield*/, worker.start()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, (0, wait_1.wait)(1000)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, worker.getWeb3()];
                case 5:
                    web3 = (_a.sent()).web3;
                    return [4 /*yield*/, sendTransaction('geth', addresses[0], web3.utils.toWei('.02', 'ether'), web3, wallet)];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, sawBlock];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, done];
                case 8:
                    _a.sent();
                    return [4 /*yield*/, worker.stop()];
                case 9:
                    _a.sent();
                    return [4 /*yield*/, block_1.EVMBlockStorage.collection.count({ chain: chain, network: network })];
                case 10:
                    dbBlocks = _a.sent();
                    (0, chai_1.expect)(dbBlocks).to.be.gt(0);
                    return [4 /*yield*/, wallet.lock()];
                case 11:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to handle reorgs');
    it('should be able to handle a failed getBlock');
    it('should be able to get tx events from parity');
    it('should be able to save transactions to the database');
});
//# sourceMappingURL=p2p.spec.js.map