"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var logger_1 = __importDefault(require("../../../src/logger"));
var block_1 = require("../../../src/models/block");
var coin_1 = require("../../../src/models/coin");
var transaction_1 = require("../../../src/models/transaction");
var test_block_1 = require("../../data/test-block");
var helpers_1 = require("../../helpers");
var integration_1 = require("../../helpers/integration");
function insertBlocks() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                        chain: 'BTC',
                        network: 'regtest',
                        height: 5,
                        hash: '528f01c17829622ed6a4af51b3b3f6c062f304fa60e66499c9cbb8622c8407f7',
                        version: 100,
                        merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                        time: new Date(1526326784),
                        timeNormalized: new Date(1526326784),
                        transactionCount: 1,
                        reward: 50,
                        nonce: 3,
                        previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                        nextBlockHash: '',
                        size: 264,
                        bits: parseInt('207fffff', 16),
                        processed: true
                    })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                            chain: 'BTC',
                            network: 'regtest',
                            height: 6,
                            hash: '2a883ff89c7d6e9302bb4a4634cd580319a4fd59d69e979b344972b0ba042b86',
                            version: 100,
                            merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                            time: new Date(1526326784),
                            timeNormalized: new Date(1526326784),
                            transactionCount: 1,
                            reward: 50,
                            nonce: 3,
                            previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                            nextBlockHash: '',
                            size: 264,
                            bits: parseInt('207fffff', 16),
                            processed: true
                        })];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                            chain: 'BTC',
                            network: 'regtest',
                            height: 7,
                            hash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                            version: 100,
                            merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                            time: new Date(1526326784),
                            timeNormalized: new Date(1526326784),
                            transactionCount: 1,
                            reward: 50,
                            nonce: 3,
                            previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                            nextBlockHash: '',
                            size: 264,
                            bits: parseInt('207fffff', 16),
                            processed: true
                        })];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                            chain: 'BTC',
                            network: 'regtest',
                            height: 8,
                            hash: '3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9',
                            version: 100,
                            merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                            time: new Date(1526326784),
                            timeNormalized: new Date(1526326784),
                            transactionCount: 1,
                            reward: 50,
                            nonce: 3,
                            previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                            nextBlockHash: '',
                            size: 264,
                            bits: parseInt('207fffff', 16),
                            processed: true
                        })];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
describe('Block Model', function () {
    var _this = this;
    var suite = this;
    this.timeout(30000);
    before(integration_1.intBeforeHelper);
    after(function () { return (0, integration_1.intAfterHelper)(suite); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('addBlock', function () {
        it('should add a block when incoming block references previous block hash', function () { return __awaiter(_this, void 0, void 0, function () {
            var blocks, ownBlock, transaction;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, insertBlocks()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.addBlock({
                                block: test_block_1.TEST_BLOCK,
                                chain: 'BTC',
                                network: 'regtest',
                                initialSyncComplete: false
                            })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .find({ chain: 'BTC', network: 'regtest' })
                                .sort({ height: 1 })
                                .toArray()];
                    case 3:
                        blocks = _a.sent();
                        (0, chai_1.expect)(blocks.length).to.equal(5);
                        ownBlock = blocks[4];
                        (0, chai_1.expect)(ownBlock.chain).to.equal('BTC');
                        (0, chai_1.expect)(ownBlock.hash).to.equal('64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929');
                        (0, chai_1.expect)(ownBlock.network).to.equal('regtest');
                        (0, chai_1.expect)(ownBlock.bits).to.equal(545259519);
                        (0, chai_1.expect)(ownBlock.height).to.equal(9);
                        (0, chai_1.expect)(ownBlock.merkleRoot).to.equal('08e23107e8449f02568d37d37aa76e840e55bbb5f100ed8ad257af303db88c08');
                        (0, chai_1.expect)(ownBlock.nonce).to.equal(2);
                        (0, chai_1.expect)(ownBlock.previousBlockHash).to.equal('3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9');
                        (0, chai_1.expect)(ownBlock.reward).to.equal(0.09765625);
                        (0, chai_1.expect)(ownBlock.size).to.equal(264);
                        (0, chai_1.expect)(ownBlock.version).to.equal(536870912);
                        // TODO: assertion for block times
                        (0, chai_1.expect)(ownBlock.transactionCount).to.equal(1);
                        (0, chai_1.expect)(ownBlock.processed).to.equal(true);
                        logger_1.default.info('new block was successfully added with hash: %o', ownBlock.hash);
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest',
                                blockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929'
                            })
                                .toArray()];
                    case 4:
                        transaction = _a.sent();
                        (0, chai_1.expect)(transaction.length).to.equal(1);
                        (0, chai_1.expect)(transaction[0].chain).to.equal('BTC');
                        (0, chai_1.expect)(transaction[0].network).to.equal('regtest');
                        (0, chai_1.expect)(transaction[0].txid).to.equal('08e23107e8449f02568d37d37aa76e840e55bbb5f100ed8ad257af303db88c08');
                        (0, chai_1.expect)(transaction[0].blockHash).to.equal('64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929');
                        (0, chai_1.expect)(transaction[0].blockHeight).to.equal(9);
                        (0, chai_1.expect)(transaction[0].coinbase).to.equal(true);
                        (0, chai_1.expect)(transaction[0].locktime).to.equal(0);
                        (0, chai_1.expect)(transaction[0].size).to.equal(0);
                        // TODO: assertion for block times
                        (0, chai_1.expect)(transaction[0].wallets.length).to.equal(0);
                        logger_1.default.info("tx: ".concat(transaction[0].txid, " was successfully stored in the TX model"));
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('handleReorg', function () {
        it("should not reorg if the incoming block's prevHash matches the block hash of the current highest block", function () { return __awaiter(_this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                            chain: 'BTC',
                            network: 'regtest',
                            height: 1335,
                            hash: '528f01c17829622ed6a4af51b3b3f6c062f304fa60e66499c9cbb8622c8407f7',
                            version: 100,
                            merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                            time: new Date(1526326784),
                            timeNormalized: new Date(1526326784),
                            transactionCount: 1,
                            reward: 50,
                            nonce: 3,
                            previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                            nextBlockHash: '',
                            size: 264,
                            bits: parseInt('207fffff', 16),
                            processed: true
                        })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                                chain: 'BTC',
                                network: 'regtest',
                                height: 1336,
                                hash: '2a883ff89c7d6e9302bb4a4634cd580319a4fd59d69e979b344972b0ba042b86',
                                version: 100,
                                merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                                time: new Date(1526326784),
                                timeNormalized: new Date(1526326784),
                                transactionCount: 1,
                                reward: 50,
                                nonce: 3,
                                previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                                nextBlockHash: '',
                                size: 264,
                                bits: parseInt('207fffff', 16),
                                processed: true
                            })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                                chain: 'BTC',
                                network: 'regtest',
                                height: 1337,
                                hash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                version: 100,
                                merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                                time: new Date(1526326784),
                                timeNormalized: new Date(1526326784),
                                transactionCount: 1,
                                reward: 50,
                                nonce: 3,
                                previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                                nextBlockHash: '',
                                size: 264,
                                bits: parseInt('207fffff', 16),
                                processed: true
                            })];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg({
                                header: {
                                    prevHash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                    hash: '12c719927ce18f9a61d7c5a7af08d3110cacfa43671aa700956c3c05ed38bdaa',
                                    time: 1526326785,
                                    version: 536870912,
                                    merkleRoot: '8c29860888b915715878b21ce14707a17b43f6c51dfb62a1e736e35bc5d8093f',
                                    bits: parseInt('207fffff', 16),
                                    nonce: 3
                                },
                                chain: 'BTC',
                                network: 'regtest'
                            })];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.find({ chain: 'BTC', network: 'regtest' }).toArray()];
                    case 5:
                        result = _a.sent();
                        (0, chai_1.expect)(result.length).to.equal(3);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should not reorg if localTip height is zero', function () { return __awaiter(_this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg({
                            header: {
                                prevHash: '12c719927ce18f9a61d7c5a7af08d3110cacfa43671aa700956c3c05ed38bdaa',
                                hash: '4c6872bf45ecab2fb8b38c8b8f50fc4a8309c6171d28d479b8226afcb1a99920',
                                time: 1526326785,
                                version: 536870912,
                                merkleRoot: '8c29860888b915715878b21ce14707a17b43f6c51dfb62a1e736e35bc5d8093f',
                                bits: parseInt('207fffff', 16),
                                nonce: 3
                            },
                            chain: 'BTC',
                            network: 'regtest'
                        })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.find({ chain: 'BTC', network: 'regtest' }).toArray()];
                    case 2:
                        result = _a.sent();
                        (0, chai_1.expect)(result.length).to.equal(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should successfully handle reorg', function () { return __awaiter(_this, void 0, void 0, function () {
            var blocks, removedBlock, transaction, removedTransaction, coinModel, removedCoin, unspentCoins;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // setting the Block model
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                            chain: 'BTC',
                            network: 'regtest',
                            height: 5,
                            hash: '528f01c17829622ed6a4af51b3b3f6c062f304fa60e66499c9cbb8622c8407f7',
                            version: 100,
                            merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                            time: new Date(1526326784),
                            timeNormalized: new Date(1526326784),
                            transactionCount: 1,
                            reward: 50,
                            nonce: 3,
                            previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                            nextBlockHash: '',
                            size: 264,
                            bits: parseInt('207fffff', 16),
                            processed: true
                        })];
                    case 1:
                        // setting the Block model
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                                chain: 'BTC',
                                network: 'regtest',
                                height: 6,
                                hash: '2a883ff89c7d6e9302bb4a4634cd580319a4fd59d69e979b344972b0ba042b86',
                                version: 100,
                                merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                                time: new Date(1526326784),
                                timeNormalized: new Date(1526326784),
                                transactionCount: 1,
                                reward: 50,
                                nonce: 3,
                                previousBlockHash: '528f01c17829622ed6a4af51b3b3f6c062f304fa60e66499c9cbb8622c8407f7',
                                nextBlockHash: '',
                                size: 264,
                                bits: parseInt('207fffff', 16),
                                processed: true
                            })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.insertOne({
                                chain: 'BTC',
                                network: 'regtest',
                                height: 7,
                                hash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                version: 100,
                                merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                                time: new Date(1526326784),
                                timeNormalized: new Date(1526326784),
                                transactionCount: 1,
                                reward: 50,
                                nonce: 3,
                                previousBlockHash: '2a883ff89c7d6e9302bb4a4634cd580319a4fd59d69e979b344972b0ba042b86',
                                nextBlockHash: '',
                                size: 264,
                                bits: parseInt('207fffff', 16),
                                processed: true
                            })];
                    case 3:
                        _a.sent();
                        // setting TX model
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne({
                                txid: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919g',
                                chain: 'BTC',
                                network: 'regtest',
                                blockHash: '528f01c17829622ed6a4af51b3b3f6c062f304fa60e66499c9cbb8622c8407f7',
                                blockTime: new Date(1526326784),
                                value: 100000,
                                fee: 100,
                                coinbase: true,
                                locktime: 0,
                                size: 145,
                                inputCount: 1,
                                outputCount: 1,
                                wallets: [],
                                blockHeight: 5
                            })];
                    case 4:
                        // setting TX model
                        _a.sent();
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne({
                                txid: '8c29860888b915715878b21ce14707a17b43f6c51dfb62a1e736e35bc5d8093f',
                                chain: 'BTC',
                                network: 'regtest',
                                blockHash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                blockTime: new Date(1526326785),
                                value: 100000,
                                fee: 100,
                                coinbase: true,
                                locktime: 0,
                                size: 145,
                                inputCount: 1,
                                outputCount: 1,
                                wallets: [],
                                blockHeight: 6
                            })];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne({
                                txid: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                                chain: 'BTC',
                                network: 'regtest',
                                blockHash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                blockTime: new Date(1526326784),
                                value: 100000,
                                fee: 100,
                                coinbase: true,
                                locktime: 0,
                                size: 145,
                                inputCount: 1,
                                outputCount: 1,
                                wallets: [],
                                blockHeight: 7
                            })];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne({
                                txid: '8a351fa9fc3fcd38066b4bf61a8b5f71f08aa224d7a86165557e6da7ee13a826',
                                chain: 'BTC',
                                network: 'regtest',
                                blockHash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                blockTime: new Date(1526326785),
                                value: 100000,
                                fee: 100,
                                coinbase: true,
                                locktime: 0,
                                size: 145,
                                inputCount: 1,
                                outputCount: 1,
                                wallets: [],
                                blockHeight: 7
                            })];
                    case 7:
                        _a.sent();
                        // setting the Coin model
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne({
                                network: 'regtest',
                                chain: 'BTC',
                                mintTxid: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919g',
                                spentTxid: '',
                                mintIndex: 0,
                                spentHeight: -2 /* SpentHeightIndicators.unspent */,
                                mintHeight: 5,
                                coinbase: true,
                                script: Buffer.from(''),
                                wallets: [],
                                value: 500.0,
                                address: 'mkjB6LmjiNfJWgH4aP4v1GkFjRcQTfDSfj'
                            })];
                    case 8:
                        // setting the Coin model
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne({
                                network: 'regtest',
                                chain: 'BTC',
                                mintTxid: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
                                spentTxid: '',
                                mintIndex: 0,
                                spentHeight: -2 /* SpentHeightIndicators.unspent */,
                                mintHeight: 7,
                                coinbase: true,
                                script: Buffer.from(''),
                                wallets: [],
                                value: 500.0,
                                address: 'mkjB6LmjiNfJWgH4aP4v1GkFjRcQTfDSfj'
                            })];
                    case 9:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne({
                                network: 'regtest',
                                chain: 'BTC',
                                mintTxid: '8a351fa9fc3fcd38066b4bf61a8b5f71f08aa224d7a86165557e6da7ee13a826',
                                spentTxid: '',
                                mintIndex: 0,
                                spentHeight: -2 /* SpentHeightIndicators.unspent */,
                                mintHeight: 7,
                                coinbase: true,
                                script: Buffer.from(''),
                                wallets: [],
                                value: 500.0,
                                address: 'mkjB6LmjiNfJWgH4aP4v1GkFjRcQTfDSfj'
                            })];
                    case 10:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne({
                                network: 'regtest',
                                chain: 'BTC',
                                mintTxid: '8c29860888b915715878b21ce14707a17b43f6c51dfb62a1e736e35bc5d8093f',
                                mintIndex: 0,
                                spentHeight: 8,
                                mintHeight: 7,
                                coinbase: true,
                                script: Buffer.from(''),
                                wallets: [],
                                value: 500.0,
                                address: 'mkjB6LmjiNfJWgH4aP4v1GkFjRcQTfDSfj',
                                spentTxid: 'eec8570a0c960b19fa6c86c71a06ebda379b86b5fe0be0e64ba83b2e0a3d05a3'
                            })];
                    case 11:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg({
                                header: {
                                    prevHash: '2a883ff89c7d6e9302bb4a4634cd580319a4fd59d69e979b344972b0ba042b86',
                                    hash: '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312',
                                    time: 1526326785,
                                    version: 536870912,
                                    merkleRoot: '8c29860888b915715878b21ce14707a17b43f6c51dfb62a1e736e35bc5d8093f',
                                    bits: parseInt('207fffff', 16),
                                    nonce: 3
                                },
                                chain: 'BTC',
                                network: 'regtest'
                            })];
                    case 12:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest'
                            })
                                .toArray()];
                    case 13:
                        blocks = _a.sent();
                        (0, chai_1.expect)(blocks.length).to.equal(1);
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest',
                                height: {
                                    $gte: 7
                                }
                            })
                                .toArray()];
                    case 14:
                        removedBlock = _a.sent();
                        (0, chai_1.expect)(removedBlock.length).to.equal(0);
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest'
                            })
                                .toArray()];
                    case 15:
                        transaction = _a.sent();
                        (0, chai_1.expect)(transaction.length).to.equal(1);
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest',
                                blockHeight: {
                                    $gte: 7
                                }
                            })
                                .toArray()];
                    case 16:
                        removedTransaction = _a.sent();
                        (0, chai_1.expect)(removedTransaction.length).to.equal(0);
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest'
                            })
                                .toArray()];
                    case 17:
                        coinModel = _a.sent();
                        (0, chai_1.expect)(coinModel.length).to.equal(1);
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest',
                                mintHeight: {
                                    $gte: 7
                                }
                            })
                                .toArray()];
                    case 18:
                        removedCoin = _a.sent();
                        (0, chai_1.expect)(removedCoin.length).to.equal(0);
                        return [4 /*yield*/, coin_1.CoinStorage.collection
                                .find({
                                chain: 'BTC',
                                network: 'regtest',
                                spentHeight: -2 /* SpentHeightIndicators.unspent */
                            })
                                .toArray()];
                    case 19:
                        unspentCoins = _a.sent();
                        (0, chai_1.expect)(unspentCoins.length).equal(1);
                        (0, chai_1.expect)(unspentCoins[0].chain).to.equal('BTC');
                        (0, chai_1.expect)(unspentCoins[0].network).to.equal('regtest');
                        (0, chai_1.expect)(unspentCoins[0].mintTxid).to.equal('a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919g');
                        (0, chai_1.expect)(unspentCoins[0].mintIndex).to.equal(0);
                        (0, chai_1.expect)(unspentCoins[0].mintHeight).to.equal(5);
                        (0, chai_1.expect)(unspentCoins[0].coinbase).to.equal(true);
                        (0, chai_1.expect)(unspentCoins[0].value).to.equal(500.0);
                        (0, chai_1.expect)(unspentCoins[0].address).to.equal('mkjB6LmjiNfJWgH4aP4v1GkFjRcQTfDSfj');
                        (0, chai_1.expect)(unspentCoins[0].spentTxid).to.equal('');
                        (0, chai_1.expect)(unspentCoins[0].spentHeight).to.equal(-2 /* SpentHeightIndicators.unspent */);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should detect a fault in the block hashes', function () { return __awaiter(_this, void 0, void 0, function () {
            var chain, network, badHash, invalidChain;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = 'BTC';
                        network = 'regtest';
                        return [4 /*yield*/, insertBlocks()];
                    case 1:
                        _a.sent();
                        badHash = '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312';
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.updateOne({ chain: chain, network: network, hash: badHash }, { $set: { previousBlockHash: 'aaaaa' } })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.validateLocatorHashes({ chain: chain, network: network })];
                    case 3:
                        invalidChain = _a.sent();
                        (0, chai_1.expect)(invalidChain[1].hash).to.eq(badHash);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should detect a missing block', function () { return __awaiter(_this, void 0, void 0, function () {
            var chain, network, badHash, lastKnown, invalidChain;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chain = 'BTC';
                        network = 'regtest';
                        return [4 /*yield*/, insertBlocks()];
                    case 1:
                        _a.sent();
                        badHash = '3279069d22ce5af68ef38332d5b40e79e1964b154d466e7fa233015a34c27312';
                        lastKnown = '2a883ff89c7d6e9302bb4a4634cd580319a4fd59d69e979b344972b0ba042b86';
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.deleteOne({ chain: chain, network: network, hash: badHash })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.validateLocatorHashes({ chain: chain, network: network })];
                    case 3:
                        invalidChain = _a.sent();
                        (0, chai_1.expect)(invalidChain[1].hash).to.eq(lastKnown);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=block.spec.js.map