"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bson_1 = require("bson");
var chai_1 = require("chai");
var cache_1 = require("../../../src/models/cache");
var helpers_1 = require("../../helpers");
var integration_1 = require("../../helpers/integration");
var transaction_1 = require("../../../src/providers/chain-state/evm/models/transaction");
var test_ops_1 = require("../../data/test-ops");
describe('Cache Model', function () {
    var _this = this;
    var key = 'key';
    var value = { hello: 'world' };
    var walletKey = 'wallet-key';
    var walletValue = { walletThing: 1 };
    var wallet = new bson_1.ObjectId();
    var otherAddress = '0x9527a556f0D9AA753dE0D1f9Ad024a17dd281B1D';
    var otherKey = "getBalanceForAddress-ETH-testnet-".concat(otherAddress.toLowerCase());
    var suite = this;
    this.timeout(30000);
    before(integration_1.intBeforeHelper);
    after(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, (0, integration_1.intAfterHelper)(suite)];
    }); }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should cache a value', function () { return __awaiter(_this, void 0, void 0, function () {
        var found, got;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.collection.findOne({ key: key })];
                case 2:
                    found = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key)];
                case 3:
                    got = _a.sent();
                    (0, chai_1.expect)(found).to.exist;
                    (0, chai_1.expect)(found.expireTime).to.eq(cache_1.CacheStorage.Times.Hour);
                    (0, chai_1.expect)(got).to.deep.eq(found.value);
                    (0, chai_1.expect)(got).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get the value', function () { return __awaiter(_this, void 0, void 0, function () {
        var got;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key)];
                case 2:
                    got = _a.sent();
                    (0, chai_1.expect)(got).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should expire the key', function () { return __awaiter(_this, void 0, void 0, function () {
        var got;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.expire(key)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key)];
                case 3:
                    got = _a.sent();
                    (0, chai_1.expect)(got).to.eq(null);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should cache the value returned by fn', function () { return __awaiter(_this, void 0, void 0, function () {
        var got, found;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, cache_1.CacheStorage.getGlobalOrRefresh(key, function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                        return [2 /*return*/, value];
                    }); }); }, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    got = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.collection.findOne({ key: key })];
                case 2:
                    found = _a.sent();
                    (0, chai_1.expect)(found).to.exist;
                    (0, chai_1.expect)(found.expireTime).to.eq(cache_1.CacheStorage.Times.Hour);
                    (0, chai_1.expect)(got).to.deep.eq(found.value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should cache the wallet value', function () { return __awaiter(_this, void 0, void 0, function () {
        var found, global, got;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, cache_1.CacheStorage.setForWallet(wallet, walletKey, walletValue, cache_1.CacheStorage.Times.Day)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.collection.findOne({ key: walletKey, wallet: wallet })];
                case 2:
                    found = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(walletKey)];
                case 3:
                    global = _a.sent();
                    (0, chai_1.expect)(global).to.eq(null);
                    return [4 /*yield*/, cache_1.CacheStorage.getForWallet(wallet, walletKey)];
                case 4:
                    got = _a.sent();
                    (0, chai_1.expect)(found).to.exist;
                    (0, chai_1.expect)(found.expireTime).to.eq(cache_1.CacheStorage.Times.Day);
                    (0, chai_1.expect)(got).to.deep.eq(found.value);
                    (0, chai_1.expect)(got).to.deep.eq(walletValue);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should cache the value returned by fn for wallet', function () { return __awaiter(_this, void 0, void 0, function () {
        var got, found;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, cache_1.CacheStorage.getForWalletOrRefresh(wallet, walletKey, function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                        return [2 /*return*/, walletValue];
                    }); }); }, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    got = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.collection.findOne({ key: walletKey, wallet: wallet })];
                case 2:
                    found = _a.sent();
                    (0, chai_1.expect)(found).to.exist;
                    (0, chai_1.expect)(found.expireTime).to.eq(cache_1.CacheStorage.Times.Hour);
                    (0, chai_1.expect)(got).to.deep.eq(found.value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should expire balance cache for ETH to ETH', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, address1, address2, otherAddress, otherKey, key1, key2, op1, op2, got1, got2, gotOther;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chain = 'ETH';
                    network = 'testnet';
                    address1 = '0x60a0c2f0f36020dca97f6214b3c8ff72d50d76db';
                    address2 = '0x3Ec3dA6E14BE9518A9a6e92DdCC6ACfF2CEFf4ef';
                    otherAddress = '0x9527a556f0D9AA753dE0D1f9Ad024a17dd281B1D';
                    otherKey = "getBalanceForAddress-ETH-testnet-".concat(otherAddress.toLowerCase());
                    key1 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address1.toLowerCase());
                    key2 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address2.toLowerCase());
                    op1 = test_ops_1.TEST_OP_ETH_TO_ETH1;
                    op2 = test_ops_1.TEST_OP_ETH_TO_ETH2;
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key1, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key2, value, cache_1.CacheStorage.Times.Hour)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(otherKey, value, cache_1.CacheStorage.Times.Hour)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op1)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op2)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key1)];
                case 6:
                    got1 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key2)];
                case 7:
                    got2 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(otherKey)];
                case 8:
                    gotOther = _a.sent();
                    (0, chai_1.expect)(got1).to.eq(null);
                    (0, chai_1.expect)(got2).to.eq(null);
                    (0, chai_1.expect)(gotOther).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should expire balance cache for transfer ERC20Token to ERC20Token', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, address1, address2, tokenAddress1, tokenAddress2, keyToken1, keyToken2, key1, key2, op1, op2, gotToken1, gotToken2, got1, got2, gotOther;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chain = 'ETH';
                    network = 'testnet';
                    address1 = '0x60a0c2f0f36020dca97f6214b3c8ff72d50d76db';
                    address2 = '0x3Ec3dA6E14BE9518A9a6e92DdCC6ACfF2CEFf4ef';
                    tokenAddress1 = '0x4f96fe3b7a6cf9725f59d353f723c1bdb64ca6aa' // 1 Token address
                    ;
                    tokenAddress2 = '0x4f96fe3b7a6cf9725f59d353f723c1bdb64ca6aa' // 2 Token address
                    ;
                    keyToken1 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address1.toLowerCase(), "-").concat(tokenAddress1.toLowerCase());
                    keyToken2 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address2.toLowerCase(), "-").concat(tokenAddress2.toLowerCase());
                    key1 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address1.toLowerCase());
                    key2 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address2.toLowerCase());
                    op1 = test_ops_1.TEST_OP_TRANSFER_ERC20_TO_ERC201;
                    op2 = test_ops_1.TEST_OP_TRANSFER_ERC20_TO_ERC202;
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(keyToken1, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(keyToken2, value, cache_1.CacheStorage.Times.Hour)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key1, value, cache_1.CacheStorage.Times.Hour)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key2, value, cache_1.CacheStorage.Times.Hour)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(otherKey, value, cache_1.CacheStorage.Times.Hour)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op1)];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op2)];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(keyToken1)];
                case 8:
                    gotToken1 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(keyToken2)];
                case 9:
                    gotToken2 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key1)];
                case 10:
                    got1 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key2)];
                case 11:
                    got2 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(otherKey)];
                case 12:
                    gotOther = _a.sent();
                    (0, chai_1.expect)(gotToken1).to.eq(null);
                    (0, chai_1.expect)(gotToken2).to.eq(null);
                    (0, chai_1.expect)(got1).to.eq(null);
                    (0, chai_1.expect)(got2).to.deep.eq(value); // Nothing to update in Linked ETH2
                    (0, chai_1.expect)(gotOther).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should expire balance cache for swaps ERC20Token to ERC20Token', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, address, tokenAddress1, tokenAddress2, keyToken1, keyToken2, key, op1, op2, gotToken1, gotToken2, got, gotOther;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chain = 'ETH';
                    network = 'testnet';
                    address = '0x60a0c2f0f36020dca97f6214b3c8ff72d50d76db';
                    tokenAddress1 = '0x4f96fe3b7a6cf9725f59d353f723c1bdb64ca6aa' // 1 Token address
                    ;
                    tokenAddress2 = '0xaaf64bfcc32d0f15873a02163e7e500671a4ffcd' // 2 Token address
                    ;
                    keyToken1 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase(), "-").concat(tokenAddress1.toLowerCase());
                    keyToken2 = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase(), "-").concat(tokenAddress2.toLowerCase());
                    key = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase());
                    op1 = test_ops_1.TEST_OP_ERC20_TO_ERC201;
                    op2 = test_ops_1.TEST_OP_ERC20_TO_ERC202;
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(keyToken1, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(keyToken2, value, cache_1.CacheStorage.Times.Hour)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key, value, cache_1.CacheStorage.Times.Hour)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(otherKey, value, cache_1.CacheStorage.Times.Hour)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op1)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op2)];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(keyToken1)];
                case 7:
                    gotToken1 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(keyToken2)];
                case 8:
                    gotToken2 = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key)];
                case 9:
                    got = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(otherKey)];
                case 10:
                    gotOther = _a.sent();
                    (0, chai_1.expect)(gotToken1).to.eq(null);
                    (0, chai_1.expect)(gotToken2).to.eq(null);
                    (0, chai_1.expect)(got).to.eq(null);
                    (0, chai_1.expect)(gotOther).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should expire balance cache for swaps ERC20Token to ETH', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, address, tokenAddress, keyToken, key, op1, op2, gotToken, got, gotOther;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chain = 'ETH';
                    network = 'testnet';
                    address = '0x60a0c2f0f36020dca97f6214b3c8ff72d50d76db';
                    tokenAddress = '0x4f96fe3b7a6cf9725f59d353f723c1bdb64ca6aa' // Token address
                    ;
                    keyToken = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase(), "-").concat(tokenAddress.toLowerCase());
                    key = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase());
                    op1 = test_ops_1.TEST_OP_ERC20Token_TO_ETH1;
                    op2 = test_ops_1.TEST_OP_ERC20Token_TO_ETH2;
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(keyToken, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key, value, cache_1.CacheStorage.Times.Hour)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(otherKey, value, cache_1.CacheStorage.Times.Hour)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op1)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op2)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(keyToken)];
                case 6:
                    gotToken = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key)];
                case 7:
                    got = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(otherKey)];
                case 8:
                    gotOther = _a.sent();
                    (0, chai_1.expect)(gotToken).to.eq(null);
                    (0, chai_1.expect)(got).to.eq(null);
                    (0, chai_1.expect)(gotOther).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should expire balance cache for swaps ETH to ERC20Token', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, address, tokenAddress, keyToken, key, op1, op2, gotToken, got, gotOther;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chain = 'ETH';
                    network = 'testnet';
                    address = '0x60a0c2f0f36020dca97f6214b3c8ff72d50d76db';
                    tokenAddress = '0x4f96fe3b7a6cf9725f59d353f723c1bdb64ca6aa' // Token address
                    ;
                    keyToken = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase(), "-").concat(tokenAddress.toLowerCase());
                    key = "getBalanceForAddress-".concat(chain, "-").concat(network, "-").concat(address.toLowerCase());
                    op1 = test_ops_1.TEST_OP_ETH_TO_ERC201;
                    op2 = test_ops_1.TEST_OP_ETH_TO_ERC202;
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(keyToken, value, cache_1.CacheStorage.Times.Hour)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(key, value, cache_1.CacheStorage.Times.Hour)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.setGlobal(otherKey, value, cache_1.CacheStorage.Times.Hour)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op1)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.EVMTransactionStorage.expireBalanceCache(op2)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(keyToken)];
                case 6:
                    gotToken = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(key)];
                case 7:
                    got = _a.sent();
                    return [4 /*yield*/, cache_1.CacheStorage.getGlobal(otherKey)];
                case 8:
                    gotOther = _a.sent();
                    (0, chai_1.expect)(gotToken).to.eq(null);
                    (0, chai_1.expect)(got).to.eq(null);
                    (0, chai_1.expect)(gotOther).to.deep.eq(value);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=cache.spec.js.map