"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var crypto = __importStar(require("crypto"));
var crypto_wallet_core_1 = require("crypto-wallet-core");
var coin_1 = require("../../../src/models/coin");
var transaction_1 = require("../../../src/models/transaction");
var helpers_1 = require("../../helpers");
var integration_1 = require("../../helpers/integration");
function createNewTxid() {
    var seed = (Math.random() * 10000).toString();
    return crypto
        .createHash('sha256')
        .update(seed + 1)
        .digest()
        .toString('hex');
}
function addTx(tx, outputs) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(tx)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.insertMany(outputs)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function makeMempoolTxChain(chain, network, startingTxid, chainLength) {
    if (chainLength === void 0) { chainLength = 1; }
    return __awaiter(this, void 0, void 0, function () {
        var txid, nextTxid, allTxids, i, badMempoolTx, badMempoolOutputs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    txid = startingTxid;
                    nextTxid = createNewTxid();
                    allTxids = new Array();
                    i = 1;
                    _a.label = 1;
                case 1:
                    if (!(i <= chainLength)) return [3 /*break*/, 4];
                    badMempoolTx = {
                        chain: chain,
                        network: network,
                        blockHeight: -1,
                        txid: txid
                    };
                    badMempoolOutputs = [
                        {
                            chain: chain,
                            network: network,
                            mintHeight: -1,
                            mintTxid: txid,
                            spentTxid: i != chainLength ? nextTxid : '',
                            mintIndex: 0,
                            spentHeight: -1
                        }
                    ];
                    return [4 /*yield*/, addTx(badMempoolTx, badMempoolOutputs)];
                case 2:
                    _a.sent();
                    allTxids.push(txid);
                    txid = nextTxid;
                    nextTxid = createNewTxid();
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, allTxids];
            }
        });
    });
}
describe('Coin Model', function () {
    var _this = this;
    var suite = this;
    this.timeout(30000);
    before(integration_1.intBeforeHelper);
    after(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, (0, integration_1.intAfterHelper)(suite)];
    }); }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    var chain = 'BTC';
    var network = 'integration';
    var blockTx = {
        chain: chain,
        network: network,
        blockHeight: 1,
        txid: '01234'
    };
    var blockTxOutputs = {
        chain: chain,
        network: network,
        mintHeight: 1,
        mintTxid: '01234',
        mintIndex: 0,
        spentHeight: -1,
        spentTxid: '12345'
    };
    var block2TxOutputs = {
        chain: chain,
        network: network,
        mintHeight: 2,
        mintTxid: '123456',
        mintIndex: 0,
        spentHeight: -1
    };
    it('should appropriately mark coins related to transactions that are in mempool, but no longer valid', function () { return __awaiter(_this, void 0, void 0, function () {
        var chainLength, txids, allRelatedCoins, spentOps, badTxs, goodTxs, badNewCoins, goodNewCoins;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // insert a valid tx, with a valid output
                return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(blockTx)];
                case 1:
                    // insert a valid tx, with a valid output
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(blockTxOutputs)];
                case 2:
                    _a.sent();
                    chainLength = 5;
                    return [4 /*yield*/, makeMempoolTxChain(chain, network, blockTxOutputs.spentTxid, chainLength)];
                case 3:
                    txids = _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.findAllRelatedOutputs(blockTxOutputs.spentTxid)];
                case 4:
                    allRelatedCoins = _a.sent();
                    (0, chai_1.expect)(allRelatedCoins.length).to.eq(chainLength);
                    spentOps = new Array();
                    spentOps.push({
                        updateOne: {
                            filter: {
                                chain: chain,
                                network: network,
                                mintIndex: blockTxOutputs.mintIndex,
                                mintTxid: blockTxOutputs.mintTxid,
                                spentHeight: { $lt: 0 }
                            },
                            update: { $set: { spentHeight: block2TxOutputs.mintHeight, spentTxid: block2TxOutputs.mintTxid } }
                        }
                    });
                    return [4 /*yield*/, transaction_1.TransactionStorage.pruneMempool({
                            chain: chain,
                            network: network,
                            initialSyncComplete: true,
                            spendOps: spentOps
                        })];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: { $in: txids } }).toArray()];
                case 6:
                    badTxs = _a.sent();
                    (0, chai_1.expect)(badTxs.length).to.eq(chainLength);
                    (0, chai_1.expect)(badTxs.map(function (tx) { return tx.blockHeight; })).to.deep.eq(new Array(chainLength).fill(-3 /* SpentHeightIndicators.conflicting */));
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: blockTx.txid }).toArray()];
                case 7:
                    goodTxs = _a.sent();
                    (0, chai_1.expect)(goodTxs.length).to.eq(1);
                    (0, chai_1.expect)(goodTxs[0].txid).to.eq(blockTx.txid);
                    (0, chai_1.expect)(goodTxs[0].blockHeight).to.eq(blockTx.blockHeight);
                    return [4 /*yield*/, coin_1.CoinStorage.collection.find({ chain: chain, network: network, mintTxid: { $in: txids } }).toArray()];
                case 8:
                    badNewCoins = _a.sent();
                    (0, chai_1.expect)(badNewCoins.length).to.equal(badNewCoins.filter(function (c) { return c.spentHeight == -1 /* SpentHeightIndicators.pending */; }).length);
                    return [4 /*yield*/, coin_1.CoinStorage.collection.find({ chain: chain, network: network, mintTxid: blockTx.txid }).toArray()];
                case 9:
                    goodNewCoins = _a.sent();
                    (0, chai_1.expect)(goodNewCoins.length).to.equal(goodNewCoins.filter(function (c) { return c.spentHeight == -2 /* SpentHeightIndicators.unspent */; }).length);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should appropriately mark coins related to transactions that are RBFed', function () { return __awaiter(_this, void 0, void 0, function () {
        var privateKey, utxo1, tx1, mempoolTxid, mempoolTx, mempoolOutputs, utxo2, tx2, tx1Outputs, spentCoin, unspentCoins, mempoolCoins;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    privateKey = new crypto_wallet_core_1.BitcoreLib.PrivateKey('L1uyy5qTuGrVXrmrsvHWHgVzW9kKdrp27wBC7Vs6nZDTF2BRUVwy');
                    utxo1 = {
                        txId: createNewTxid(),
                        outputIndex: 0,
                        address: '17XBj6iFEsf8kzDMGQk5ghZipxX49VXuaV',
                        script: '76a91447862fe165e6121af80d5dde1ecb478ed170565b88ac',
                        satoshis: 50000
                    };
                    tx1 = new crypto_wallet_core_1.BitcoreLib.Transaction()
                        .from(utxo1)
                        .to('1Gokm82v6DmtwKEB8AiVhm82hyFSsEvBDK', 15000)
                        .to('1Gokm82v6DmtwKEB8AiVhm82hyFSsEvBDK', 13000)
                        .to('1Gokm82v6DmtwKEB8AiVhm82hyFSsEvBDK', 11000)
                        .sign(privateKey);
                    // import transaction in block 1
                    return [4 /*yield*/, transaction_1.TransactionStorage.batchImport({
                            txs: [tx1],
                            height: 1,
                            initialSyncComplete: true,
                            chain: 'BTC',
                            network: 'integration'
                        })];
                case 1:
                    // import transaction in block 1
                    _a.sent();
                    mempoolTxid = createNewTxid();
                    mempoolTx = {
                        chain: chain,
                        network: network,
                        blockHeight: -1,
                        txid: mempoolTxid
                    };
                    mempoolOutputs = Array.from({ length: 3 }, function (_v, i) { return i; }).map(function (i) {
                        return {
                            chain: chain,
                            network: network,
                            mintHeight: -1,
                            mintTxid: mempoolTxid,
                            mintIndex: i,
                            spentHeight: -2 /* SpentHeightIndicators.unspent */
                        };
                    });
                    return [4 /*yield*/, addTx(mempoolTx, mempoolOutputs)];
                case 2:
                    _a.sent();
                    // update existing outputs to be spent by mempool tx
                    return [4 /*yield*/, coin_1.CoinStorage.collection.updateMany({ chain: chain, network: network, mintTxid: tx1.hash }, { $set: { spentTxid: mempoolTxid, spentHeight: -1 /* SpentHeightIndicators.pending */ } })];
                case 3:
                    // update existing outputs to be spent by mempool tx
                    _a.sent();
                    utxo2 = [
                        {
                            txId: tx1.hash,
                            outputIndex: 0,
                            address: '1Gokm82v6DmtwKEB8AiVhm82hyFSsEvBDK',
                            script: '76a91447862fe165e6121af80d5dde1ecb478ed170565b88ac',
                            satoshis: 15000
                        }
                    ];
                    tx2 = new crypto_wallet_core_1.BitcoreLib.Transaction()
                        .from(utxo2)
                        .to('bc1qm0jxvjvj6pzcc64lu4k7vccsg2x22pj60zke6c', 15000)
                        .sign(privateKey);
                    // import transaction in block 2
                    return [4 /*yield*/, transaction_1.TransactionStorage.batchImport({
                            txs: [tx2],
                            height: 2,
                            initialSyncComplete: true,
                            chain: 'BTC',
                            network: 'integration'
                        })];
                case 4:
                    // import transaction in block 2
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.find({ chain: chain, network: network, mintTxid: tx1.hash }).toArray()];
                case 5:
                    tx1Outputs = _a.sent();
                    spentCoin = tx1Outputs.find(function (c) { return c.spentTxid === tx2.hash && c.spentHeight === 2; });
                    (0, chai_1.expect)(spentCoin).to.exist;
                    unspentCoins = tx1Outputs.filter(function (c) { return c.spentHeight < 0 /* SpentHeightIndicators.minimum */; });
                    (0, chai_1.expect)(unspentCoins.length).to.equal(2);
                    (0, chai_1.expect)(unspentCoins.filter(function (c) { return c.spentHeight === -2 /* SpentHeightIndicators.unspent */ && !c.spentTxid; }).length).to.equal(2);
                    return [4 /*yield*/, coin_1.CoinStorage.collection.find({ chain: chain, network: network, mintTxid: mempoolTxid }).toArray()];
                case 6:
                    mempoolCoins = _a.sent();
                    (0, chai_1.expect)(mempoolCoins.length).to.equal(3);
                    (0, chai_1.expect)(mempoolCoins.filter(function (c) { return c.mintHeight === -3 /* SpentHeightIndicators.conflicting */; }).length).to.equal(3);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=coin.spec.js.map