"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bson_1 = require("bson");
var chai_1 = require("chai");
var crypto = __importStar(require("crypto"));
var coin_1 = require("../../../src/models/coin");
var transaction_1 = require("../../../src/models/transaction");
var walletAddress_1 = require("../../../src/models/walletAddress");
var transaction_2 = require("../../../src/providers/chain-state/evm/models/transaction");
var unprocessedBlocksETH_1 = require("../../data/ETH/unprocessedBlocksETH");
var helpers_1 = require("../../helpers");
var integration_1 = require("../../helpers/integration");
function makeMempoolTxChain(chain, network, startingTxid, chainLength) {
    if (chainLength === void 0) { chainLength = 1; }
    return __awaiter(this, void 0, void 0, function () {
        var txid, nextTxid, allTxids, i, badMempoolTx, badMempoolOutputs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    txid = startingTxid;
                    nextTxid = crypto
                        .createHash('sha256')
                        .update(txid + 1)
                        .digest()
                        .toString('hex');
                    allTxids = new Array();
                    i = 1;
                    _a.label = 1;
                case 1:
                    if (!(i <= chainLength)) return [3 /*break*/, 5];
                    badMempoolTx = {
                        chain: chain,
                        network: network,
                        blockHeight: -1,
                        txid: txid
                    };
                    badMempoolOutputs = {
                        chain: chain,
                        network: network,
                        mintHeight: -1,
                        mintTxid: txid,
                        spentTxid: i != chainLength ? nextTxid : '',
                        mintIndex: 0,
                        spentHeight: -1
                    };
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(badMempoolTx)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(badMempoolOutputs)];
                case 3:
                    _a.sent();
                    allTxids.push(txid);
                    txid = nextTxid;
                    nextTxid = crypto
                        .createHash('sha256')
                        .update(txid + 1)
                        .digest()
                        .toString('hex');
                    _a.label = 4;
                case 4:
                    i++;
                    return [3 /*break*/, 1];
                case 5: return [2 /*return*/, allTxids];
            }
        });
    });
}
describe('Transaction Model', function () {
    var _this = this;
    var suite = this;
    this.timeout(30000);
    before(integration_1.intBeforeHelper);
    after(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, (0, integration_1.intAfterHelper)(suite)];
    }); }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    var chain = 'BCH';
    var network = 'integration';
    var blockTx = {
        chain: chain,
        network: network,
        blockHeight: 1,
        txid: '01234'
    };
    var blockTxOutputs = {
        chain: chain,
        network: network,
        mintHeight: 1,
        mintTxid: '01234',
        mintIndex: 0,
        spentHeight: -1,
        spentTxid: '12345'
    };
    var block2TxOutputs = {
        chain: chain,
        network: network,
        mintHeight: 2,
        mintTxid: '123456',
        mintIndex: 0,
        spentHeight: -1
    };
    it('should mark transactions invalid that were in the mempool, but no longer valid', function () { return __awaiter(_this, void 0, void 0, function () {
        var chainLength, txids, spentOps, badTxs, goodTxs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // insert a valid tx, with a valid output
                return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(blockTx)];
                case 1:
                    // insert a valid tx, with a valid output
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(blockTxOutputs)];
                case 2:
                    _a.sent();
                    chainLength = 1;
                    return [4 /*yield*/, makeMempoolTxChain(chain, network, blockTxOutputs.spentTxid, chainLength)];
                case 3:
                    txids = _a.sent();
                    spentOps = new Array();
                    spentOps.push({
                        updateOne: {
                            filter: {
                                chain: chain,
                                network: network,
                                mintIndex: blockTxOutputs.mintIndex,
                                mintTxid: blockTxOutputs.mintTxid,
                                spentHeight: { $lt: 0 }
                            },
                            update: { $set: { spentHeight: block2TxOutputs.mintHeight, spentTxid: block2TxOutputs.mintTxid } }
                        }
                    });
                    return [4 /*yield*/, transaction_1.TransactionStorage.pruneMempool({
                            chain: chain,
                            network: network,
                            initialSyncComplete: true,
                            spendOps: spentOps
                        })];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: { $in: txids } }).toArray()];
                case 5:
                    badTxs = _a.sent();
                    (0, chai_1.expect)(badTxs.length).to.eq(chainLength);
                    (0, chai_1.expect)(badTxs.map(function (tx) { return tx.blockHeight; })).to.deep.eq(new Array(chainLength).fill(-3 /* SpentHeightIndicators.conflicting */));
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: blockTx.txid }).toArray()];
                case 6:
                    goodTxs = _a.sent();
                    (0, chai_1.expect)(goodTxs.length).to.eq(1);
                    (0, chai_1.expect)(goodTxs[0].txid).to.eq(blockTx.txid);
                    (0, chai_1.expect)(goodTxs[0].blockHeight).to.eq(blockTx.blockHeight);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should mark a chain of transactions invalid that were in the mempool, but no longer valid', function () { return __awaiter(_this, void 0, void 0, function () {
        var chainLength, txids, allRelatedCoins, spentOps, badTxs, goodTxs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // insert a valid tx, with a valid output
                return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(blockTx)];
                case 1:
                    // insert a valid tx, with a valid output
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(blockTxOutputs)];
                case 2:
                    _a.sent();
                    chainLength = 5;
                    return [4 /*yield*/, makeMempoolTxChain(chain, network, blockTxOutputs.spentTxid, chainLength)];
                case 3:
                    txids = _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.findAllRelatedOutputs(blockTxOutputs.spentTxid)];
                case 4:
                    allRelatedCoins = _a.sent();
                    (0, chai_1.expect)(allRelatedCoins.length).to.eq(chainLength);
                    spentOps = new Array();
                    spentOps.push({
                        updateOne: {
                            filter: {
                                chain: chain,
                                network: network,
                                mintIndex: blockTxOutputs.mintIndex,
                                mintTxid: blockTxOutputs.mintTxid,
                                spentHeight: { $lt: 0 }
                            },
                            update: { $set: { spentHeight: block2TxOutputs.mintHeight, spentTxid: block2TxOutputs.mintTxid } }
                        }
                    });
                    return [4 /*yield*/, transaction_1.TransactionStorage.pruneMempool({
                            chain: chain,
                            network: network,
                            initialSyncComplete: true,
                            spendOps: spentOps
                        })];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: { $in: txids } }).toArray()];
                case 6:
                    badTxs = _a.sent();
                    (0, chai_1.expect)(badTxs.length).to.eq(chainLength);
                    (0, chai_1.expect)(badTxs.map(function (tx) { return tx.blockHeight; })).to.deep.eq(new Array(chainLength).fill(-3 /* SpentHeightIndicators.conflicting */));
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: blockTx.txid }).toArray()];
                case 7:
                    goodTxs = _a.sent();
                    (0, chai_1.expect)(goodTxs.length).to.eq(1);
                    (0, chai_1.expect)(goodTxs[0].txid).to.eq(blockTx.txid);
                    (0, chai_1.expect)(goodTxs[0].blockHeight).to.eq(blockTx.blockHeight);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should mark a massive chain of transactions invalid that were in the mempool, but no longer valid', function () { return __awaiter(_this, void 0, void 0, function () {
        var chainLength, txids, allRelatedCoins, spentOps, badTxs, goodTxs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // insert a valid tx, with a valid output
                return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(blockTx)];
                case 1:
                    // insert a valid tx, with a valid output
                    _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(blockTxOutputs)];
                case 2:
                    _a.sent();
                    chainLength = 2000;
                    return [4 /*yield*/, makeMempoolTxChain(chain, network, blockTxOutputs.spentTxid, chainLength)];
                case 3:
                    txids = _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.findAllRelatedOutputs(blockTxOutputs.spentTxid)];
                case 4:
                    allRelatedCoins = _a.sent();
                    (0, chai_1.expect)(allRelatedCoins.length).to.eq(chainLength);
                    spentOps = new Array();
                    spentOps.push({
                        updateOne: {
                            filter: {
                                chain: chain,
                                network: network,
                                mintIndex: blockTxOutputs.mintIndex,
                                mintTxid: blockTxOutputs.mintTxid,
                                spentHeight: { $lt: 0 }
                            },
                            update: { $set: { spentHeight: block2TxOutputs.mintHeight, spentTxid: block2TxOutputs.mintTxid } }
                        }
                    });
                    return [4 /*yield*/, transaction_1.TransactionStorage.pruneMempool({
                            chain: chain,
                            network: network,
                            initialSyncComplete: true,
                            spendOps: spentOps
                        })];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: { $in: txids } }).toArray()];
                case 6:
                    badTxs = _a.sent();
                    (0, chai_1.expect)(badTxs.length).to.eq(chainLength);
                    (0, chai_1.expect)(badTxs.map(function (tx) { return tx.blockHeight; })).to.deep.eq(new Array(chainLength).fill(-3 /* SpentHeightIndicators.conflicting */));
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.find({ chain: chain, network: network, txid: blockTx.txid }).toArray()];
                case 7:
                    goodTxs = _a.sent();
                    (0, chai_1.expect)(goodTxs.length).to.eq(1);
                    (0, chai_1.expect)(goodTxs[0].txid).to.eq(blockTx.txid);
                    (0, chai_1.expect)(goodTxs[0].blockHeight).to.eq(blockTx.blockHeight);
                    return [2 /*return*/];
            }
        });
    }); });
    describe('#batchImport', function () {
        var chain = 'ETH';
        var network = 'regtest';
        var wallet = new bson_1.ObjectId();
        var address = '0x3Ec3dA6E14BE9518A9a6e92DdCC6ACfF2CEFf4ef';
        beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection.insertOne({
                            chain: chain,
                            network: network,
                            wallet: wallet,
                            address: address,
                            processed: true
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should update eth transactions with related wallet id correctly (incoming)', function () { return __awaiter(_this, void 0, void 0, function () {
            var block, walletTxs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        block = unprocessedBlocksETH_1.unprocessedEthBlocks[0];
                        return [4 /*yield*/, transaction_2.EVMTransactionStorage.batchImport(__assign({}, block))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, transaction_2.EVMTransactionStorage.collection.find({ chain: chain, network: network, wallets: wallet }).toArray()];
                    case 2:
                        walletTxs = _a.sent();
                        (0, chai_1.expect)(walletTxs.length).eq(1);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should update erc20 transactions with related wallet id correctly (incoming)', function () { return __awaiter(_this, void 0, void 0, function () {
            var block, walletTxs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        block = unprocessedBlocksETH_1.unprocessedEthBlocks[1];
                        return [4 /*yield*/, transaction_2.EVMTransactionStorage.batchImport(__assign({}, block))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, transaction_2.EVMTransactionStorage.collection.find({ chain: chain, network: network, wallets: wallet }).toArray()];
                    case 2:
                        walletTxs = _a.sent();
                        (0, chai_1.expect)(walletTxs.length).eq(1);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=transaction.spec.js.map