"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bitcore_client_1 = require("bitcore-client");
var chai_1 = require("chai");
var config_1 = __importDefault(require("../../../src/config"));
var wallet_1 = require("../../../src/models/wallet");
var walletAddress_1 = require("../../../src/models/walletAddress");
var rpc_1 = require("../../../src/rpc");
var api_1 = require("../../../src/services/api");
var event_1 = require("../../../src/services/event");
var integration_1 = require("../../helpers/integration");
var lockedWallet;
var walletName = 'Test Wallet';
var password = 'iamsatoshi';
var chain = 'BTC';
var network = 'regtest';
var chainConfig = config_1.default.chains[chain][network];
var creds = chainConfig.rpc;
var rpc = new rpc_1.AsyncRPC(creds.username, creds.password, creds.host, creds.port);
describe('Wallet Model', function () {
    var _this = this;
    var suite = this;
    this.timeout(50000);
    before(integration_1.intBeforeHelper);
    after(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, (0, integration_1.intAfterHelper)(suite)];
    }); }); });
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, event_1.Event.start()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.start()];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, event_1.Event.stop()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.stop()];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('Wallet Create', function () {
        it('should return a locked wallet on create', function () { return __awaiter(_this, void 0, void 0, function () {
            var baseUrl, findCreatedWallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        baseUrl = 'http://localhost:3000/api';
                        return [4 /*yield*/, bitcore_client_1.Wallet.create({
                                name: walletName,
                                chain: chain,
                                network: network,
                                baseUrl: baseUrl,
                                password: password
                            })];
                    case 1:
                        lockedWallet = _a.sent();
                        (0, chai_1.expect)(lockedWallet).to.have.includes({
                            name: walletName,
                            chain: chain,
                            network: network,
                            baseUrl: 'http://localhost:3000/api'
                        });
                        (0, chai_1.expect)(lockedWallet).to.have.property('pubKey');
                        (0, chai_1.expect)(lockedWallet).to.have.property('password');
                        (0, chai_1.expect)(lockedWallet).to.have.property('authKey');
                        (0, chai_1.expect)(lockedWallet).to.have.property('encryptionKey');
                        return [4 /*yield*/, wallet_1.WalletStorage.collection
                                .find({
                                name: walletName,
                                chain: chain,
                                network: network
                            })
                                .toArray()];
                    case 2:
                        findCreatedWallet = _a.sent();
                        (0, chai_1.expect)(findCreatedWallet[0]).to.includes({
                            name: walletName,
                            chain: chain,
                            network: network,
                            path: null,
                            singleAddress: null
                        });
                        (0, chai_1.expect)(findCreatedWallet[0]).to.have.property('pubKey');
                        (0, chai_1.expect)(findCreatedWallet[0]).to.have.property('path');
                        (0, chai_1.expect)(findCreatedWallet[0]).to.have.property('singleAddress');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Wallet functions', function () {
        var address1;
        it('should generate addresses using rpc then import to wallet', function () { return __awaiter(_this, void 0, void 0, function () {
            var importAddressJSON, unlockedWallet, findWalletResult, findAddressResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rpc.getnewaddress('')];
                    case 1:
                        address1 = _a.sent();
                        importAddressJSON = {
                            keys: [{ address: address1 }]
                        };
                        return [4 /*yield*/, lockedWallet.unlock(password)];
                    case 2:
                        unlockedWallet = _a.sent();
                        return [4 /*yield*/, unlockedWallet.importKeys(importAddressJSON)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, wallet_1.WalletStorage.collection.findOne({
                                name: walletName,
                                chain: chain,
                                network: network
                            }, { sort: { _id: -1 } })];
                    case 4:
                        findWalletResult = _a.sent();
                        (0, chai_1.expect)(findWalletResult === null || findWalletResult === void 0 ? void 0 : findWalletResult._id).to.exist;
                        return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection
                                .find({
                                wallet: findWalletResult === null || findWalletResult === void 0 ? void 0 : findWalletResult._id,
                                chain: chain,
                                network: network,
                                address: address1
                            })
                                .toArray()];
                    case 5:
                        findAddressResult = _a.sent();
                        (0, chai_1.expect)(findAddressResult[0]).to.exist;
                        (0, chai_1.expect)(findAddressResult[0]).to.have.deep.property('chain', chain);
                        (0, chai_1.expect)(findAddressResult[0]).to.have.deep.property('network', network);
                        (0, chai_1.expect)(findAddressResult[0]).to.have.deep.property('wallet', findWalletResult === null || findWalletResult === void 0 ? void 0 : findWalletResult._id);
                        (0, chai_1.expect)(findAddressResult[0]).to.have.deep.property('address', address1);
                        (0, chai_1.expect)(findAddressResult[0]).to.have.deep.property('processed', true);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=wallet.spec.js.map