"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var sinon_1 = __importDefault(require("sinon"));
var coin_1 = require("../../../src/models/coin");
var transaction_1 = require("../../../src/models/transaction");
var pruning_1 = require("../../../src/services/pruning");
var Pruning = new pruning_1.PruningService({ transactionModel: transaction_1.TransactionStorage, coinModel: coin_1.CoinStorage });
require("../../../src/utils/polyfills");
var helpers_1 = require("../../helpers");
var integration_1 = require("../../helpers/integration");
var rpc_1 = require("../../../src/rpc");
describe('Pruning Service', function () {
    var _this = this;
    var suite = this;
    this.timeout(30000);
    var sandbox = sinon_1.default.createSandbox();
    before(integration_1.intBeforeHelper);
    after(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, (0, integration_1.intAfterHelper)(suite)];
    }); }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    Pruning.registerRpcs();
                    Pruning.rpcs['BTC:mainnet'] = new rpc_1.RPC('user', 'pw', 'host', 'port');
                    process.env.DRYRUN = 'false';
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () {
        process.env.DRYRUN = undefined;
        sandbox.restore();
    });
    var invalidTx = {
        chain: 'BTC',
        network: 'mainnet',
        blockHeight: -3,
        txid: 'invalidCoin'
    };
    var invalidCoin = {
        chain: 'BTC',
        network: 'mainnet',
        mintTxid: 'invalidCoin',
        spentTxid: 'spentInMempool',
        mintHeight: -1
    };
    var mempoolCoin = {
        chain: 'BTC',
        network: 'mainnet',
        mintHeight: -1,
        mintTxid: 'spentInMempool',
        spentTxid: 'spentInMempoolAgain'
    };
    var mempoolCoin2 = {
        chain: 'BTC',
        network: 'mainnet',
        mintHeight: -1,
        mintTxid: 'spentInMempoolAgain'
    };
    var oldMempoolTx = {
        chain: 'BTC',
        network: 'mainnet',
        blockHeight: -1,
        txid: 'oldMempoolTx',
        blockTimeNormalized: new Date(Date.now() - 30 * 24 * 60 * 60 * 1000)
    };
    var oldMempoolTxOutput = {
        chain: 'BTC',
        network: 'mainnet',
        mintHeight: -1,
        mintTxid: 'oldMempoolTx',
        spentTxid: 'oldMempoolTx2'
    };
    var oldMempoolTx2Output = {
        chain: 'BTC',
        network: 'mainnet',
        mintHeight: -1,
        mintTxid: 'oldMempoolTx2',
        spentTxid: ''
    };
    var parentTxOutput1 = {
        chain: 'BTC',
        network: 'mainnet',
        mintHeight: 1234,
        mintTxid: 'parentTx',
        spentHeight: -1,
        spentTxid: 'oldMempoolTx' // this output is an input for oldMempoolTx
    };
    var parentTxOutput2 = {
        chain: 'BTC',
        network: 'mainnet',
        mintHeight: 1234,
        mintTxid: 'parentTx',
        spentHeight: -1,
        spentTxid: 'imaginaryTx' // another imaginary tx spent this output. This is here to make sure we don't mark this output as unspent
    };
    function modTxid(orig, i) {
        return orig + (i ? '_' + i : '');
    }
    function insertBadCoins() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(invalidTx)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(invalidCoin)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(mempoolCoin)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(mempoolCoin2)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, [invalidCoin, mempoolCoin, mempoolCoin2]];
                }
            });
        });
    }
    function insertOldTx(i) {
        if (i === void 0) { i = 0; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(__assign(__assign({}, parentTxOutput1), { spentTxid: modTxid(parentTxOutput1.spentTxid, i) }))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(__assign(__assign({}, parentTxOutput2), { spentTxid: modTxid(parentTxOutput2.spentTxid, i) }))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, transaction_1.TransactionStorage.collection.insertOne(__assign(__assign({}, oldMempoolTx), { txid: modTxid(oldMempoolTx.txid, i) }))];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(__assign(__assign({}, oldMempoolTxOutput), { mintTxid: modTxid(oldMempoolTxOutput.mintTxid, i), spentTxid: modTxid(oldMempoolTxOutput.spentTxid, i) }))];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, coin_1.CoinStorage.collection.insertOne(__assign(__assign({}, oldMempoolTx2Output), { mintTxid: modTxid(oldMempoolTx2Output.mintTxid, i) }))];
                    case 5:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    it('should detect coins that should be invalid but are not', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, shouldBeInvalid, shouldBeInvalid_1, shouldBeInvalid_1_1, coin;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, insertBadCoins()];
                case 1:
                    _b.sent();
                    chain = invalidCoin.chain, network = invalidCoin.network;
                    return [4 /*yield*/, Pruning.processAllInvalidTxs(chain, network)];
                case 2:
                    _b.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: [invalidCoin.mintTxid, mempoolCoin.mintTxid, mempoolCoin2.mintTxid] } })
                            .toArray()];
                case 3:
                    shouldBeInvalid = _b.sent();
                    try {
                        for (shouldBeInvalid_1 = __values(shouldBeInvalid), shouldBeInvalid_1_1 = shouldBeInvalid_1.next(); !shouldBeInvalid_1_1.done; shouldBeInvalid_1_1 = shouldBeInvalid_1.next()) {
                            coin = shouldBeInvalid_1_1.value;
                            (0, chai_1.expect)(coin.mintHeight).eq(-3);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (shouldBeInvalid_1_1 && !shouldBeInvalid_1_1.done && (_a = shouldBeInvalid_1.return)) _a.call(shouldBeInvalid_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    (0, chai_1.expect)(shouldBeInvalid.length).eq(3);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should mark detected coins as invalid', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, shouldBeInvalid, shouldBeInvalid_2, shouldBeInvalid_2_1, coin;
        var e_2, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, insertBadCoins()];
                case 1:
                    _b.sent();
                    chain = invalidCoin.chain, network = invalidCoin.network;
                    return [4 /*yield*/, Pruning.processAllInvalidTxs(chain, network)];
                case 2:
                    _b.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: [invalidCoin.mintTxid, mempoolCoin.mintTxid, mempoolCoin2.mintTxid] } })
                            .toArray()];
                case 3:
                    shouldBeInvalid = _b.sent();
                    try {
                        for (shouldBeInvalid_2 = __values(shouldBeInvalid), shouldBeInvalid_2_1 = shouldBeInvalid_2.next(); !shouldBeInvalid_2_1.done; shouldBeInvalid_2_1 = shouldBeInvalid_2.next()) {
                            coin = shouldBeInvalid_2_1.value;
                            (0, chai_1.expect)(coin.mintHeight).eq(-3);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (shouldBeInvalid_2_1 && !shouldBeInvalid_2_1.done && (_a = shouldBeInvalid_2.return)) _a.call(shouldBeInvalid_2);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    (0, chai_1.expect)(shouldBeInvalid.length).eq(3);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should remove old transactions', function () { return __awaiter(_this, void 0, void 0, function () {
        var chain, network, count, shouldBeExpiredTx, shouldBeExpiredCoins, parentTxOutputs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sandbox.stub(rpc_1.RPC.prototype, 'getTransaction').resolves(null);
                    return [4 /*yield*/, insertOldTx()];
                case 1:
                    _a.sent();
                    chain = oldMempoolTx.chain, network = oldMempoolTx.network;
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({
                            chain: chain,
                            network: network,
                            blockHeight: -1,
                            blockTimeNormalized: { $lt: new Date() }
                        })];
                case 2:
                    count = _a.sent();
                    (0, chai_1.expect)(count).eq(1);
                    return [4 /*yield*/, Pruning.processOldMempoolTxs(chain, network, 29)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection
                            .find({ chain: chain, network: network, txid: { $in: [oldMempoolTx.txid] } })
                            .toArray()];
                case 4:
                    shouldBeExpiredTx = _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: [oldMempoolTxOutput.mintTxid, oldMempoolTx2Output.mintTxid] } })
                            .toArray()];
                case 5:
                    shouldBeExpiredCoins = _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: parentTxOutput1.mintTxid })
                            .toArray()];
                case 6:
                    parentTxOutputs = _a.sent();
                    (0, chai_1.expect)(shouldBeExpiredTx.length).eq(1);
                    (0, chai_1.expect)(shouldBeExpiredTx.every(function (tx) { return tx.blockHeight === -5; })).to.equal(true);
                    (0, chai_1.expect)(shouldBeExpiredCoins.length).eq(2);
                    (0, chai_1.expect)(shouldBeExpiredCoins.every(function (coin) { return coin.mintHeight === -5; })).to.equal(true);
                    (0, chai_1.expect)(parentTxOutputs.length).eq(2);
                    (0, chai_1.expect)(parentTxOutputs.filter(function (coin) { return coin.spentHeight === -2; }).length).to.equal(1);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should skip removing transactions still in mempool', function () { return __awaiter(_this, void 0, void 0, function () {
        var rpcStub, chain, network, count, processedTxs, processedCoins;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    rpcStub = sandbox.stub(rpc_1.RPC.prototype, 'getTransaction');
                    rpcStub.onCall(0).resolves(null);
                    rpcStub.onCall(1).resolves({});
                    rpcStub.onCall(2).resolves(null);
                    return [4 /*yield*/, insertOldTx(0)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, insertOldTx(1)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, insertOldTx(2)];
                case 3:
                    _a.sent();
                    chain = oldMempoolTx.chain, network = oldMempoolTx.network;
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({
                            chain: chain,
                            network: network,
                            blockHeight: -1,
                            blockTimeNormalized: { $lt: new Date() }
                        })];
                case 4:
                    count = _a.sent();
                    (0, chai_1.expect)(count).eq(3);
                    return [4 /*yield*/, Pruning.processOldMempoolTxs(chain, network, 29)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection
                            .find({ chain: chain, network: network, txid: { $in: [modTxid(oldMempoolTx.txid, 0), modTxid(oldMempoolTx.txid, 1), modTxid(oldMempoolTx.txid, 2)] } })
                            .toArray()];
                case 6:
                    processedTxs = _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: [modTxid(oldMempoolTxOutput.mintTxid, 0), modTxid(oldMempoolTx2Output.mintTxid, 0), modTxid(oldMempoolTxOutput.mintTxid, 1), modTxid(oldMempoolTx2Output.mintTxid, 1), modTxid(oldMempoolTxOutput.mintTxid, 2), modTxid(oldMempoolTx2Output.mintTxid, 2)] } })
                            .toArray()];
                case 7:
                    processedCoins = _a.sent();
                    (0, chai_1.expect)(processedTxs.length).eq(3);
                    (0, chai_1.expect)(processedTxs.filter(function (tx) { return tx.blockHeight === -5; }).length).eq(2);
                    (0, chai_1.expect)(processedTxs.filter(function (tx) { return tx.blockHeight === -1; }).length).eq(1); // still in mempool
                    (0, chai_1.expect)(processedCoins.length).eq(6);
                    (0, chai_1.expect)(processedCoins.filter(function (coin) { return coin.mintHeight === -5; }).length).eq(4);
                    (0, chai_1.expect)(processedCoins.filter(function (coin) { return coin.mintHeight === -1; }).length).eq(2); // still in mempool
                    return [2 /*return*/];
            }
        });
    }); });
    it('should skip removing transactions on rpc error', function () { return __awaiter(_this, void 0, void 0, function () {
        var rpcStub, chain, network, count, shouldBeGoneTx, shouldBeGoneCoins;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    rpcStub = sandbox.stub(rpc_1.RPC.prototype, 'getTransaction');
                    rpcStub.onCall(0).rejects({ code: -1, message: 'hahaha' });
                    return [4 /*yield*/, insertOldTx()];
                case 1:
                    _a.sent();
                    chain = oldMempoolTx.chain, network = oldMempoolTx.network;
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({
                            chain: chain,
                            network: network,
                            blockHeight: -1,
                            blockTimeNormalized: { $lt: new Date() }
                        })];
                case 2:
                    count = _a.sent();
                    (0, chai_1.expect)(count).eq(1);
                    return [4 /*yield*/, Pruning.processOldMempoolTxs(chain, network, 29)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection
                            .find({ chain: chain, network: network, txid: { $in: [oldMempoolTx.txid] } })
                            .toArray()];
                case 4:
                    shouldBeGoneTx = _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: [oldMempoolTxOutput.mintTxid, oldMempoolTx2Output.mintTxid] } })
                            .toArray()];
                case 5:
                    shouldBeGoneCoins = _a.sent();
                    (0, chai_1.expect)(shouldBeGoneTx.length).eq(1);
                    (0, chai_1.expect)(shouldBeGoneCoins.length).eq(2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should skip removing transactions if coin has >0 confs', function () { return __awaiter(_this, void 0, void 0, function () {
        var rpcStub, oldMempoolTx2OutputHeight, chain, network, count, shouldBeGoneTx, shouldBeGoneCoins;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    rpcStub = sandbox.stub(rpc_1.RPC.prototype, 'getTransaction');
                    rpcStub.onCall(0).rejects({ code: -5, message: 'already exists' });
                    oldMempoolTx2OutputHeight = oldMempoolTx2Output.mintHeight;
                    oldMempoolTx2Output.mintHeight = 1;
                    return [4 /*yield*/, insertOldTx()];
                case 1:
                    _a.sent();
                    oldMempoolTx2Output.mintHeight = oldMempoolTx2OutputHeight; // reset
                    chain = oldMempoolTx.chain, network = oldMempoolTx.network;
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({
                            chain: chain,
                            network: network,
                            blockHeight: -1,
                            blockTimeNormalized: { $lt: new Date() }
                        })];
                case 2:
                    count = _a.sent();
                    (0, chai_1.expect)(count).eq(1);
                    return [4 /*yield*/, Pruning.processOldMempoolTxs(chain, network, 29)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection
                            .find({ chain: chain, network: network, txid: { $in: [oldMempoolTx.txid] } })
                            .toArray()];
                case 4:
                    shouldBeGoneTx = _a.sent();
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintTxid: { $in: [oldMempoolTxOutput.mintTxid, oldMempoolTx2Output.mintTxid] } })
                            .toArray()];
                case 5:
                    shouldBeGoneCoins = _a.sent();
                    (0, chai_1.expect)(shouldBeGoneTx.length).eq(1);
                    (0, chai_1.expect)(shouldBeGoneCoins.length).eq(2);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=pruning.integration.js.map