"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var config_1 = __importDefault(require("../../src/config"));
var block_1 = require("../../src/models/block");
var coin_1 = require("../../src/models/coin");
var transaction_1 = require("../../src/models/transaction");
var p2p_1 = require("../../src/modules/bitcoin/p2p");
var VerificationPeer_1 = require("../../src/modules/bitcoin/VerificationPeer");
var rpc_1 = require("../../src/rpc");
var config_2 = require("../../src/services/config");
var wait_1 = require("../../src/utils/wait");
var helpers_1 = require("../helpers");
var integration_1 = require("../helpers/integration");
var chain = 'BTC';
var network = 'regtest';
var address = '2MuYKLUaKCenkEpwPkWUwYpBoDBNA2dgY3t';
var chainConfig = config_1.default.chains[chain][network];
var creds = chainConfig.rpc;
var rpc = new rpc_1.AsyncRPC(creds.username, creds.password, creds.host, creds.port);
function sendBitcoin() {
    return __awaiter(this, void 0, void 0, function () {
        var e_1, ourAddress;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 7]);
                    return [4 /*yield*/, rpc.sendtoaddress(address, 0.1)];
                case 1:
                    _a.sent();
                    console.log('Sending');
                    return [3 /*break*/, 7];
                case 2:
                    e_1 = _a.sent();
                    // Handle insufficent balance issues
                    console.log('Generating blocks');
                    return [4 /*yield*/, rpc.getnewaddress('')];
                case 3:
                    ourAddress = _a.sent();
                    return [4 /*yield*/, rpc.call('generatetoaddress', [130, ourAddress])];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, (0, wait_1.wait)(5000)];
                case 5:
                    _a.sent();
                    console.log('Sending after generating');
                    return [4 /*yield*/, rpc.sendtoaddress(address, 0.1)];
                case 6:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    });
}
function addBlock1() {
    return block_1.BitcoinBlockStorage.collection.insertOne({
        chain: chain,
        network: network,
        height: 8976158,
        hash: '0x9997699519d116dfa89256d0f6ebd1737db13adca583dc80dbd533d90083961c',
        version: 100,
        merkleRoot: 'a2262b524615b6d2f409784ceff898fd46bdde6a584269788c41f26ac4b4919e',
        time: new Date(1526326784),
        timeNormalized: new Date(1526326784),
        transactionCount: 1,
        reward: 50,
        nonce: 3,
        previousBlockHash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
        nextBlockHash: '0xddae2bf21fb5836dec837671afd7bea1cc49d7111462e803ed3efc10570f1858',
        size: 264,
        bits: parseInt('207fffff', 16),
        processed: true
    });
}
function addTx() {
    return transaction_1.TransactionStorage.collection.insertOne({
        chain: chain,
        network: network,
        txid: '0e3e2357e806b6cdb1f70b54c3a3a17b6714ee1f0e68bebb44a74b1efd512098',
        blockHash: '0x9997699519d116dfa89256d0f6ebd1737db13adca583dc80dbd533d90083961c',
        blockHeight: 8976158,
        blockTime: new Date('2009-01-09T02:54:25.000Z'),
        blockTimeNormalized: new Date('2009-01-09T02:54:25.000Z'),
        coinbase: true,
        fee: 0,
        inputCount: 1,
        locktime: 0,
        outputCount: 1,
        size: 134,
        value: 5000000000.0,
        wallets: []
    });
}
function addCoin() {
    return coin_1.CoinStorage.collection.insertOne({
        chain: chain,
        network: network,
        mintIndex: 0,
        mintTxid: '0e3e2357e806b6cdb1f70b54c3a3a17b6714ee1f0e68bebb44a74b1efd512098',
        address: '12c6DSiU4Rq3P4ZxziKxzrL5LmMBrzjrJX',
        coinbase: true,
        mintHeight: 1,
        script: Buffer.from('QQSWtTjoU1GccmoskeYewRYArhOQgTpifGb7i+eUe+Y8Utp1iTeVFdTgpgT4FBeB5iKUchFmv2Iec6gsvyNCyFjurA=='),
        spentHeight: -2,
        spentTxid: '',
        value: 5000000000.0,
        wallets: []
    });
}
describe('VerificationPeer', function () {
    var _this = this;
    var suite = this;
    this.timeout(500000);
    before(integration_1.intBeforeHelper);
    after(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, (0, integration_1.intAfterHelper)(suite)];
    }); }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should not save any mempoool transactions', function () { return __awaiter(_this, void 0, void 0, function () {
        var chainConfig, worker, sawTx, txCount;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chainConfig = config_2.Config.chainConfig({ chain: chain, network: network });
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    sawTx = new Promise(function (r) {
                        worker.events.on('transaction', r);
                    });
                    return [4 /*yield*/, sendBitcoin()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, sawTx];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({ chain: chain, network: network })];
                case 4:
                    txCount = _a.sent();
                    (0, chai_1.expect)(txCount).to.be.eq(0);
                    worker.disconnect();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should save any mempoool transactions', function () { return __awaiter(_this, void 0, void 0, function () {
        var chainConfig, worker, sawTx, txCount;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    chainConfig = config_2.Config.chainConfig({ chain: chain, network: network });
                    worker = new p2p_1.BitcoinP2PWorker({ chain: chain, network: network, chainConfig: chainConfig });
                    worker.isSyncingNode = true;
                    worker.isSyncing = true;
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    sawTx = new Promise(function (r) {
                        worker.events.on('transaction', r);
                    });
                    return [4 /*yield*/, sendBitcoin()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, sawTx];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.countDocuments({ chain: chain, network: network })];
                case 4:
                    txCount = _a.sent();
                    (0, chai_1.expect)(txCount).to.be.gt(0);
                    worker.disconnect();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a fault in a series of blocks', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.updateOne({ hash: '0x9997699519d116dfa89256d0f6ebd1737db13adca583dc80dbd533d90083961c' }, { $unset: { nextBlockHash: '' } })];
                case 5:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 6:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('CORRUPTED_BLOCK');
                    (0, chai_1.expect)(verified.errors[0].payload.txCount).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].payload.foundTxs).to.eq(1);
                    return [4 /*yield*/, worker.disconnect()];
                case 7:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a missing transaction', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 3:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 4:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('CORRUPTED_BLOCK');
                    (0, chai_1.expect)(verified.errors[0].payload.txCount).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].payload.foundTxs).to.eq(0);
                    return [4 /*yield*/, worker.disconnect()];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a dupe transaction', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 5:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 6:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(2);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('CORRUPTED_BLOCK');
                    (0, chai_1.expect)(verified.errors[0].payload.txCount).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].payload.foundTxs).to.eq(2);
                    (0, chai_1.expect)(verified.errors[1].type).to.eq('DUPE_TRANSACTION');
                    (0, chai_1.expect)(verified.errors[1].payload.tx.txid).to.eq('0e3e2357e806b6cdb1f70b54c3a3a17b6714ee1f0e68bebb44a74b1efd512098');
                    return [4 /*yield*/, worker.disconnect()];
                case 7:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a missing transaction output', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 3:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 4:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('MISSING_COIN_FOR_TXID');
                    (0, chai_1.expect)(verified.errors[0].payload.txid).to.eq('0e3e2357e806b6cdb1f70b54c3a3a17b6714ee1f0e68bebb44a74b1efd512098');
                    return [4 /*yield*/, worker.disconnect()];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a dupe transaction output', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 5:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 6:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('DUPE_COIN');
                    (0, chai_1.expect)(verified.errors[0].payload.coin.mintTxid).to.eq('0e3e2357e806b6cdb1f70b54c3a3a17b6714ee1f0e68bebb44a74b1efd512098');
                    return [4 /*yield*/, worker.disconnect()];
                case 7:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a missing block', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 3:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 4:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(1);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('MISSING_BLOCK');
                    (0, chai_1.expect)(verified.errors[0].payload.blockNum).to.eq(8976158);
                    return [4 /*yield*/, worker.disconnect()];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should detect a dupe block', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 5:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 6:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == false);
                    (0, chai_1.expect)(verified.errors.length).to.eq(2);
                    (0, chai_1.expect)(verified.errors[0].type).to.eq('DUPE_BLOCKHEIGHT');
                    (0, chai_1.expect)(verified.errors[0].payload.blockNum).to.eq(8976158);
                    (0, chai_1.expect)(verified.errors[1].type).to.eq('DUPE_BLOCKHASH');
                    (0, chai_1.expect)(verified.errors[1].payload.blockNum).to.eq(8976158);
                    return [4 /*yield*/, worker.disconnect()];
                case 7:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should handle non-linear scanning by ignoring previousBlockHash', function () { return __awaiter(_this, void 0, void 0, function () {
        var worker, tip, verified;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    worker = new VerificationPeer_1.VerificationPeer({ chain: chain, network: network, chainConfig: chainConfig });
                    return [4 /*yield*/, worker.connect()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, addBlock1()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, addTx()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, addCoin()];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.updateOne({ hash: '0x9997699519d116dfa89256d0f6ebd1737db13adca583dc80dbd533d90083961c' }, { $set: { previousBlockHash: 'abcdefg' } })];
                case 5:
                    _a.sent();
                    tip = 8976159;
                    return [4 /*yield*/, worker.validateDataForBlock(8976154, tip, true)];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, worker.validateDataForBlock(8976158, tip, true)];
                case 7:
                    verified = _a.sent();
                    (0, chai_1.expect)(verified.success == true);
                    return [4 /*yield*/, worker.disconnect()];
                case 8:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=verification.spec.js.map