"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bitcore_client_1 = require("bitcore-client");
var chai_1 = require("chai");
var mongodb_1 = require("mongodb");
var io = __importStar(require("socket.io-client"));
var config_1 = __importDefault(require("../../src/config"));
var coin_1 = require("../../src/models/coin");
var transaction_1 = require("../../src/models/transaction");
var wallet_1 = require("../../src/models/wallet");
var walletAddress_1 = require("../../src/models/walletAddress");
var p2p_1 = require("../../src/modules/bitcoin/p2p");
var rpc_1 = require("../../src/rpc");
var api_1 = require("../../src/services/api");
var event_1 = require("../../src/services/event");
var wait_1 = require("../../src/utils/wait");
var wallet_benchmark_1 = require("../benchmark/wallet-benchmark");
var helpers_1 = require("../helpers");
var integration_1 = require("../helpers/integration");
var chain = 'BTC';
var network = 'regtest';
var chainConfig = config_1.default.chains[chain][network];
var creds = chainConfig.rpc;
var rpc = new rpc_1.AsyncRPC(creds.username, creds.password, creds.host, creds.port);
function checkWalletExists(pubKey, expectedAddress) {
    return __awaiter(this, void 0, void 0, function () {
        var dbWallet, foundAddresses;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, wallet_1.WalletStorage.collection.findOne({
                        chain: chain,
                        network: network,
                        pubKey: pubKey
                    })];
                case 1:
                    dbWallet = _a.sent();
                    return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection
                            .find({
                            chain: chain,
                            network: network,
                            wallet: dbWallet._id
                        })
                            .toArray()];
                case 2:
                    foundAddresses = _a.sent();
                    (0, chai_1.expect)(foundAddresses.length).to.eq(1);
                    (0, chai_1.expect)(foundAddresses[0].address).to.eq(expectedAddress);
                    return [2 /*return*/, dbWallet];
            }
        });
    });
}
function getWalletUtxos(wallet) {
    return __awaiter(this, void 0, void 0, function () {
        var utxos;
        return __generator(this, function (_a) {
            utxos = new Array();
            return [2 /*return*/, new Promise(function (resolve) {
                    return wallet
                        .getUtxos()
                        .pipe(new bitcore_client_1.ParseApiStream())
                        .on('data', function (utxo) {
                        utxos.push(utxo);
                    })
                        .on('end', function () { return resolve(utxos); });
                })];
        });
    });
}
function checkWalletUtxos(wallet, expectedAddress) {
    return __awaiter(this, void 0, void 0, function () {
        var utxos;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getWalletUtxos(wallet)];
                case 1:
                    utxos = _a.sent();
                    (0, chai_1.expect)(utxos.length).to.eq(1);
                    (0, chai_1.expect)(utxos[0].address).to.eq(expectedAddress);
                    return [2 /*return*/, utxos];
            }
        });
    });
}
function verifyCoinSpent(coin, spentTxid, wallet) {
    return __awaiter(this, void 0, void 0, function () {
        var wallet1Coin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, coin_1.CoinStorage.collection.findOne({ _id: new mongodb_1.ObjectId(coin._id) })];
                case 1:
                    wallet1Coin = _a.sent();
                    (0, chai_1.expect)(wallet1Coin.spentTxid).to.eq(spentTxid);
                    (0, chai_1.expect)(wallet1Coin.wallets[0].toHexString()).to.eq(wallet._id.toHexString());
                    return [2 /*return*/];
            }
        });
    });
}
function checkWalletReceived(receivingWallet, txid, address, sendingWallet) {
    return __awaiter(this, void 0, void 0, function () {
        var broadcastedOutput, broadcastedTransaction, txWallets;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, coin_1.CoinStorage.collection.findOne({
                        chain: chain,
                        network: network,
                        mintTxid: txid,
                        address: address
                    })];
                case 1:
                    broadcastedOutput = _a.sent();
                    (0, chai_1.expect)(broadcastedOutput.address).to.eq(address);
                    (0, chai_1.expect)(broadcastedOutput.wallets.length).to.eq(1);
                    (0, chai_1.expect)(broadcastedOutput.wallets[0].toHexString()).to.eq(receivingWallet._id.toHexString());
                    return [4 /*yield*/, transaction_1.TransactionStorage.collection.findOne({ chain: chain, network: network, txid: txid })];
                case 2:
                    broadcastedTransaction = _a.sent();
                    (0, chai_1.expect)(broadcastedTransaction.txid).to.eq(txid);
                    (0, chai_1.expect)(broadcastedTransaction.fee).gt(0);
                    txWallets = broadcastedTransaction.wallets.map(function (w) { return w.toHexString(); });
                    (0, chai_1.expect)(txWallets.length).to.eq(2);
                    (0, chai_1.expect)(txWallets).to.include(receivingWallet._id.toHexString());
                    (0, chai_1.expect)(txWallets).to.include(sendingWallet._id.toHexString());
                    return [2 /*return*/];
            }
        });
    });
}
describe('Wallet Benchmark', function () {
    var _this = this;
    var suite = this;
    this.timeout(5000000);
    var p2pWorker;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, integration_1.intBeforeHelper)()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, event_1.Event.start()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.start()];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, event_1.Event.stop()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.stop()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, (0, integration_1.intAfterHelper)(suite)];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!p2pWorker) return [3 /*break*/, 2];
                    return [4 /*yield*/, p2pWorker.stop()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); });
    describe('Wallet import', function () {
        it('should be able to create two wallets and have them interact', function () { return __awaiter(_this, void 0, void 0, function () {
            var seenCoins, socket, connected, address1, address2, anAddress, wallet1, wallet2, dbWallet1, dbWallet2, utxos, tx, fundedTx, signedTx, broadcastedTx, e_1;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        seenCoins = new Set();
                        socket = io.connect('http://localhost:3000', { transports: ['websocket'] });
                        connected = new Promise(function (r) {
                            socket.on('connect', function () {
                                var room = "/".concat(chain, "/").concat(network, "/inv");
                                socket.emit('room', room);
                                console.log('Connected to socket');
                                r();
                            });
                        });
                        return [4 /*yield*/, connected];
                    case 1:
                        _b.sent();
                        socket.on('coin', function (coin) {
                            seenCoins.add(coin.mintTxid);
                        });
                        p2pWorker = new p2p_1.BitcoinP2PWorker({
                            chain: chain,
                            network: network,
                            chainConfig: chainConfig
                        });
                        return [4 /*yield*/, p2pWorker.start()];
                    case 2:
                        _b.sent();
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 3:
                        address1 = _b.sent();
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 4:
                        address2 = _b.sent();
                        anAddress = 'mkzAfSHtmTh5Xsc352jf6TBPj55Lne5g21';
                        _b.label = 5;
                    case 5:
                        _b.trys.push([5, 29, , 30]);
                        return [4 /*yield*/, rpc.call('generatetoaddress', [1, address1])];
                    case 6:
                        _b.sent();
                        return [4 /*yield*/, rpc.call('generatetoaddress', [1, address2])];
                    case 7:
                        _b.sent();
                        return [4 /*yield*/, rpc.call('generatetoaddress', [100, anAddress])];
                    case 8:
                        _b.sent();
                        return [4 /*yield*/, p2pWorker.syncDone()];
                    case 9:
                        _b.sent();
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)([address1], 0, network)];
                    case 10:
                        wallet1 = _b.sent();
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)([address2], 1, network)];
                    case 11:
                        wallet2 = _b.sent();
                        return [4 /*yield*/, checkWalletExists(wallet1.authPubKey, address1)];
                    case 12:
                        dbWallet1 = _b.sent();
                        return [4 /*yield*/, checkWalletExists(wallet2.authPubKey, address2)];
                    case 13:
                        dbWallet2 = _b.sent();
                        return [4 /*yield*/, checkWalletUtxos(wallet1, address1)];
                    case 14:
                        utxos = _b.sent();
                        return [4 /*yield*/, checkWalletUtxos(wallet2, address2)];
                    case 15:
                        _b.sent();
                        return [4 /*yield*/, rpc.call('createrawtransaction', [
                                utxos.map(function (utxo) { return ({ txid: utxo.mintTxid, vout: utxo.mintIndex }); }),
                                (_a = {}, _a[address1] = 0.1, _a[address2] = 0.1, _a)
                            ])];
                    case 16:
                        tx = _b.sent();
                        return [4 /*yield*/, rpc.call('fundrawtransaction', [tx])];
                    case 17:
                        fundedTx = _b.sent();
                        return [4 /*yield*/, rpc.signrawtx(fundedTx.hex)];
                    case 18:
                        signedTx = _b.sent();
                        return [4 /*yield*/, rpc.call('sendrawtransaction', [signedTx.hex])];
                    case 19:
                        broadcastedTx = _b.sent();
                        _b.label = 20;
                    case 20:
                        if (!!seenCoins.has(broadcastedTx)) return [3 /*break*/, 22];
                        console.log('...WAITING...'); // TODO
                        return [4 /*yield*/, (0, wait_1.wait)(1000)];
                    case 21:
                        _b.sent();
                        return [3 /*break*/, 20];
                    case 22: return [4 /*yield*/, verifyCoinSpent(utxos[0], broadcastedTx, dbWallet1)];
                    case 23:
                        _b.sent();
                        return [4 /*yield*/, checkWalletReceived(dbWallet1, broadcastedTx, address1, dbWallet2)];
                    case 24:
                        _b.sent();
                        return [4 /*yield*/, checkWalletReceived(dbWallet2, broadcastedTx, address2, dbWallet1)];
                    case 25:
                        _b.sent();
                        return [4 /*yield*/, (0, wait_1.wait)(1000)];
                    case 26:
                        _b.sent();
                        return [4 /*yield*/, socket.disconnect()];
                    case 27:
                        _b.sent();
                        return [4 /*yield*/, p2pWorker.stop()];
                    case 28:
                        _b.sent();
                        return [3 /*break*/, 30];
                    case 29:
                        e_1 = _b.sent();
                        console.log('Error : ', e_1);
                        (0, chai_1.expect)(e_1).to.be.undefined;
                        return [3 /*break*/, 30];
                    case 30: return [2 /*return*/];
                }
            });
        }); });
        it('should be able to create two wallets and have them interact, while syncing', function () { return __awaiter(_this, void 0, void 0, function () {
            var seenCoins, socket, connected, address1, address2, anAddress, wallet1, wallet2, dbWallet1, dbWallet2, utxos, tx, fundedTx, signedTx, broadcastedTx, e_2;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        seenCoins = new Set();
                        socket = io.connect('http://localhost:3000', { transports: ['websocket'] });
                        connected = new Promise(function (r) {
                            socket.on('connect', function () {
                                var room = "/".concat(chain, "/").concat(network, "/inv");
                                socket.emit('room', room);
                                console.log('Connected to socket');
                                r();
                            });
                        });
                        return [4 /*yield*/, connected];
                    case 1:
                        _b.sent();
                        socket.on('coin', function (coin) {
                            seenCoins.add(coin.mintTxid);
                        });
                        p2pWorker = new p2p_1.BitcoinP2PWorker({
                            chain: chain,
                            network: network,
                            chainConfig: chainConfig
                        });
                        return [4 /*yield*/, p2pWorker.start()];
                    case 2:
                        _b.sent();
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 3:
                        address1 = _b.sent();
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 4:
                        address2 = _b.sent();
                        anAddress = 'mkzAfSHtmTh5Xsc352jf6TBPj55Lne5g21';
                        _b.label = 5;
                    case 5:
                        _b.trys.push([5, 30, , 31]);
                        return [4 /*yield*/, rpc.call('generatetoaddress', [1, address1])];
                    case 6:
                        _b.sent();
                        return [4 /*yield*/, rpc.call('generatetoaddress', [1, address2])];
                    case 7:
                        _b.sent();
                        // mature coins
                        return [4 /*yield*/, rpc.call('generatetoaddress', [100, anAddress])];
                    case 8:
                        // mature coins
                        _b.sent();
                        return [4 /*yield*/, p2pWorker.syncDone()];
                    case 9:
                        _b.sent();
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)([address1], 2, network)];
                    case 10:
                        wallet1 = _b.sent();
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)([address2], 3, network)];
                    case 11:
                        wallet2 = _b.sent();
                        return [4 /*yield*/, checkWalletExists(wallet1.authPubKey, address1)];
                    case 12:
                        dbWallet1 = _b.sent();
                        return [4 /*yield*/, checkWalletExists(wallet2.authPubKey, address2)];
                    case 13:
                        dbWallet2 = _b.sent();
                        return [4 /*yield*/, checkWalletUtxos(wallet1, address1)];
                    case 14:
                        utxos = _b.sent();
                        return [4 /*yield*/, checkWalletUtxos(wallet2, address2)];
                    case 15:
                        _b.sent();
                        return [4 /*yield*/, rpc.call('createrawtransaction', [
                                utxos.map(function (utxo) { return ({ txid: utxo.mintTxid, vout: utxo.mintIndex }); }),
                                (_a = {}, _a[address1] = 0.1, _a[address2] = 0.1, _a)
                            ])];
                    case 16:
                        tx = _b.sent();
                        return [4 /*yield*/, rpc.call('fundrawtransaction', [tx])];
                    case 17:
                        fundedTx = _b.sent();
                        return [4 /*yield*/, rpc.signrawtx(fundedTx.hex)];
                    case 18:
                        signedTx = _b.sent();
                        return [4 /*yield*/, rpc.call('generatetoaddress', [100, anAddress])];
                    case 19:
                        _b.sent();
                        p2pWorker.sync();
                        (0, chai_1.expect)(p2pWorker.isSyncing).to.be.true;
                        return [4 /*yield*/, rpc.call('sendrawtransaction', [signedTx.hex])];
                    case 20:
                        broadcastedTx = _b.sent();
                        (0, chai_1.expect)(p2pWorker.isSyncing).to.be.true;
                        _b.label = 21;
                    case 21:
                        if (!!seenCoins.has(broadcastedTx)) return [3 /*break*/, 23];
                        console.log('...WAITING...'); // TODO
                        return [4 /*yield*/, (0, wait_1.wait)(1000)];
                    case 22:
                        _b.sent();
                        return [3 /*break*/, 21];
                    case 23: return [4 /*yield*/, verifyCoinSpent(utxos[0], broadcastedTx, dbWallet1)];
                    case 24:
                        _b.sent();
                        return [4 /*yield*/, checkWalletReceived(dbWallet1, broadcastedTx, address1, dbWallet2)];
                    case 25:
                        _b.sent();
                        return [4 /*yield*/, checkWalletReceived(dbWallet2, broadcastedTx, address2, dbWallet1)];
                    case 26:
                        _b.sent();
                        return [4 /*yield*/, (0, wait_1.wait)(1000)];
                    case 27:
                        _b.sent();
                        return [4 /*yield*/, socket.disconnect()];
                    case 28:
                        _b.sent();
                        return [4 /*yield*/, p2pWorker.stop()];
                    case 29:
                        _b.sent();
                        return [3 /*break*/, 31];
                    case 30:
                        e_2 = _b.sent();
                        console.log('Error : ', e_2);
                        (0, chai_1.expect)(e_2).to.be.undefined;
                        return [3 /*break*/, 31];
                    case 31: return [2 /*return*/];
                }
            });
        }); });
        it('should import all addresses and verify in database while below 300 mb of heapUsed memory', function () { return __awaiter(_this, void 0, void 0, function () {
            var smallAddressBatch, mediumAddressBatch, largeAddressBatch, i, address, i, address, i, address, importedWallet1, importedWallet2, importedWallet3, foundSmallAddressBatch, smallAddresses, smallAddressBatch_1, smallAddressBatch_1_1, address, foundMediumAddressBatch, mediumAddresses, mediumAddressBatch_1, mediumAddressBatch_1_1, address, foundLargeAddressBatch, largeAddresses, largeAddressBatch_1, largeAddressBatch_1_1, address, heapUsed;
            var e_3, _a, e_4, _b, e_5, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        smallAddressBatch = new Array();
                        mediumAddressBatch = new Array();
                        largeAddressBatch = new Array();
                        console.log('Generating small batch of addresses');
                        i = 0;
                        _d.label = 1;
                    case 1:
                        if (!(i < 10)) return [3 /*break*/, 4];
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 2:
                        address = _d.sent();
                        smallAddressBatch.push(address);
                        _d.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        console.log('Generating medium batch of addresses');
                        (0, chai_1.expect)(smallAddressBatch.length).to.deep.equal(10);
                        i = 0;
                        _d.label = 5;
                    case 5:
                        if (!(i < 100)) return [3 /*break*/, 8];
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 6:
                        address = _d.sent();
                        mediumAddressBatch.push(address);
                        _d.label = 7;
                    case 7:
                        i++;
                        return [3 /*break*/, 5];
                    case 8:
                        (0, chai_1.expect)(mediumAddressBatch.length).to.deep.equal(100);
                        console.log('Generating large batch of addresses');
                        i = 0;
                        _d.label = 9;
                    case 9:
                        if (!(i < 1000)) return [3 /*break*/, 12];
                        return [4 /*yield*/, rpc.getnewaddress('')];
                    case 10:
                        address = _d.sent();
                        largeAddressBatch.push(address);
                        _d.label = 11;
                    case 11:
                        i++;
                        return [3 /*break*/, 9];
                    case 12:
                        (0, chai_1.expect)(largeAddressBatch.length).to.deep.equal(1000);
                        console.log('Checking');
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)(smallAddressBatch, 0, network)];
                    case 13:
                        importedWallet1 = _d.sent();
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)(mediumAddressBatch, 1, network)];
                    case 14:
                        importedWallet2 = _d.sent();
                        return [4 /*yield*/, (0, wallet_benchmark_1.createWallet)(largeAddressBatch, 2, network)];
                    case 15:
                        importedWallet3 = _d.sent();
                        (0, chai_1.expect)(importedWallet1).to.not.be.null;
                        (0, chai_1.expect)(importedWallet2).to.not.be.null;
                        (0, chai_1.expect)(importedWallet3).to.not.be.null;
                        return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection
                                .find({
                                chain: chain,
                                network: network,
                                address: { $in: smallAddressBatch }
                            })
                                .toArray()];
                    case 16:
                        foundSmallAddressBatch = _d.sent();
                        smallAddresses = foundSmallAddressBatch.map(function (wa) { return wa.address; });
                        try {
                            for (smallAddressBatch_1 = __values(smallAddressBatch), smallAddressBatch_1_1 = smallAddressBatch_1.next(); !smallAddressBatch_1_1.done; smallAddressBatch_1_1 = smallAddressBatch_1.next()) {
                                address = smallAddressBatch_1_1.value;
                                (0, chai_1.expect)(smallAddresses.includes(address)).to.be.true;
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (smallAddressBatch_1_1 && !smallAddressBatch_1_1.done && (_a = smallAddressBatch_1.return)) _a.call(smallAddressBatch_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        (0, chai_1.expect)(foundSmallAddressBatch.length).to.have.deep.equal(smallAddressBatch.length);
                        return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection
                                .find({
                                chain: chain,
                                network: network,
                                address: { $in: mediumAddressBatch }
                            })
                                .toArray()];
                    case 17:
                        foundMediumAddressBatch = _d.sent();
                        mediumAddresses = foundMediumAddressBatch.map(function (wa) { return wa.address; });
                        try {
                            for (mediumAddressBatch_1 = __values(mediumAddressBatch), mediumAddressBatch_1_1 = mediumAddressBatch_1.next(); !mediumAddressBatch_1_1.done; mediumAddressBatch_1_1 = mediumAddressBatch_1.next()) {
                                address = mediumAddressBatch_1_1.value;
                                (0, chai_1.expect)(mediumAddresses.includes(address)).to.be.true;
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (mediumAddressBatch_1_1 && !mediumAddressBatch_1_1.done && (_b = mediumAddressBatch_1.return)) _b.call(mediumAddressBatch_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        (0, chai_1.expect)(foundMediumAddressBatch.length).to.have.deep.equal(mediumAddressBatch.length);
                        return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection
                                .find({
                                chain: chain,
                                network: network,
                                address: { $in: largeAddressBatch }
                            })
                                .toArray()];
                    case 18:
                        foundLargeAddressBatch = _d.sent();
                        largeAddresses = foundLargeAddressBatch.map(function (wa) { return wa.address; });
                        try {
                            for (largeAddressBatch_1 = __values(largeAddressBatch), largeAddressBatch_1_1 = largeAddressBatch_1.next(); !largeAddressBatch_1_1.done; largeAddressBatch_1_1 = largeAddressBatch_1.next()) {
                                address = largeAddressBatch_1_1.value;
                                (0, chai_1.expect)(largeAddresses.includes(address)).to.be.true;
                            }
                        }
                        catch (e_5_1) { e_5 = { error: e_5_1 }; }
                        finally {
                            try {
                                if (largeAddressBatch_1_1 && !largeAddressBatch_1_1.done && (_c = largeAddressBatch_1.return)) _c.call(largeAddressBatch_1);
                            }
                            finally { if (e_5) throw e_5.error; }
                        }
                        (0, chai_1.expect)(foundLargeAddressBatch.length).to.have.deep.equal(largeAddressBatch.length);
                        heapUsed = process.memoryUsage().heapUsed;
                        (0, chai_1.expect)(heapUsed).to.be.below(3e8);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=wallet-benchmark.spec.js.map