"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var sinon_1 = __importDefault(require("sinon"));
var io = require("socket.io-client");
var config_1 = __importDefault(require("../../src/config"));
var p2p_1 = require("../../src/modules/bitcoin/p2p");
var rpc_1 = require("../../src/rpc");
var api_1 = require("../../src/services/api");
var event_1 = require("../../src/services/event");
var helpers_1 = require("../helpers");
var PrivateKey = require('bitcore-lib').PrivateKey;
var chain = 'BTC';
var network = 'regtest';
var chainConfig = config_1.default.chains[chain][network];
var creds = chainConfig.rpc;
var rpc = new rpc_1.AsyncRPC(creds.username, creds.password, creds.host, creds.port);
var bitcore_client_1 = require("bitcore-client");
var wallet_1 = require("../../src/models/wallet");
var walletAddress_1 = require("../../src/models/walletAddress");
var socket_1 = require("../../src/services/socket");
var wait_1 = require("../../src/utils/wait");
var integration_1 = require("../helpers/integration");
function getSocket() {
    var socket = io.connect('http://localhost:3000', { transports: ['websocket'] });
    return socket;
}
var p2pWorker;
var socket = getSocket();
var bwsPrivKey = new PrivateKey();
var bwsKey = bwsPrivKey.publicKey.toString('hex');
var authKey = new PrivateKey();
var pubKey = authKey.publicKey.toString('hex');
var address = '2MuYKLUaKCenkEpwPkWUwYpBoDBNA2dgY3t';
var sandbox = sinon_1.default.createSandbox();
describe('Websockets', function () {
    var _this = this;
    var suite = this;
    this.timeout(60000);
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        var inserted;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, integration_1.intBeforeHelper)();
                    sandbox.stub(socket_1.Socket.serviceConfig, 'bwsKeys').value([bwsKey]);
                    return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, event_1.Event.start()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.start()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, wallet_1.WalletStorage.collection.insertOne({
                            chain: chain,
                            network: network,
                            name: 'WalletSocketTest',
                            singleAddress: false,
                            pubKey: pubKey,
                            path: ''
                        })];
                case 4:
                    inserted = _a.sent();
                    return [4 /*yield*/, walletAddress_1.WalletAddressStorage.collection.insertOne({
                            address: address,
                            chain: chain,
                            network: network,
                            processed: true,
                            wallet: inserted.insertedId
                        })];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, event_1.Event.stop()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, api_1.Api.stop()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, (0, helpers_1.resetDatabase)()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, (0, integration_1.intAfterHelper)(suite)];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        var connected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    socket = getSocket();
                    connected = new Promise(function (r) {
                        socket.on('connect', function () {
                            console.log('Socket connected');
                            r();
                        });
                    });
                    return [4 /*yield*/, connected];
                case 1:
                    _a.sent();
                    p2pWorker = new p2p_1.BitcoinP2PWorker({
                        chain: chain,
                        network: network,
                        chainConfig: chainConfig
                    });
                    console.log('Starting p2p worker');
                    p2pWorker.start();
                    if (!p2pWorker.isSyncing) return [3 /*break*/, 3];
                    console.log('Worker is syncing. Waiting til done');
                    return [4 /*yield*/, p2pWorker.syncDone()];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    console.log('Waiting til p2p done');
                    return [4 /*yield*/, p2pWorker.waitTilSync()];
                case 4:
                    _a.sent();
                    console.log('P2P done');
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    console.log('Stopping p2p worker');
                    return [4 /*yield*/, p2pWorker.stop()];
                case 1:
                    _a.sent();
                    console.log('Disconnecting socket');
                    return [4 /*yield*/, socket.disconnect()];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    console.log('Error stopping p2p worker');
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    it('should get websocket events', function () { return __awaiter(_this, void 0, void 0, function () {
        var hasSeenTxEvent, hasSeenBlockEvent, hasSeenCoinEvent, anAddress, sawEvents;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    socket.emit('room', '/BTC/regtest/inv');
                    hasSeenTxEvent = false;
                    hasSeenBlockEvent = false;
                    hasSeenCoinEvent = false;
                    return [4 /*yield*/, rpc.getnewaddress('')];
                case 1:
                    anAddress = _a.sent();
                    sawEvents = new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    socket.on('block', function () {
                                        hasSeenBlockEvent = true;
                                        console.log('Block event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent && hasSeenBlockEvent) {
                                            resolve();
                                        }
                                    });
                                    socket.on('tx', function () {
                                        hasSeenTxEvent = true;
                                        console.log('Transaction event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent && hasSeenBlockEvent) {
                                            resolve();
                                        }
                                    });
                                    socket.on('coin', function () {
                                        hasSeenCoinEvent = true;
                                        console.log('Coin event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent && hasSeenBlockEvent) {
                                            resolve();
                                        }
                                    });
                                    _a.label = 1;
                                case 1:
                                    if (!!hasSeenBlockEvent) return [3 /*break*/, 3];
                                    console.log('WAITING FOR BLOCK EVENT ON SOCKET');
                                    if (hasSeenTxEvent && hasSeenCoinEvent && hasSeenBlockEvent) {
                                        return [2 /*return*/, resolve()];
                                    }
                                    return [4 /*yield*/, (0, wait_1.wait)(1000)];
                                case 2:
                                    _a.sent();
                                    return [3 /*break*/, 1];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    console.log('Generating 100 blocks');
                    return [4 /*yield*/, rpc.call('generatetoaddress', [101, anAddress])];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, p2pWorker.syncDone()];
                case 3:
                    _a.sent();
                    console.log('Sync done, generating new block');
                    return [4 /*yield*/, rpc.call('generatetoaddress', [1, anAddress])];
                case 4:
                    _a.sent();
                    console.log('Sending bitcoin');
                    return [4 /*yield*/, rpc.sendtoaddress(address, 0.1)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, sawEvents];
                case 6:
                    _a.sent();
                    (0, chai_1.expect)(hasSeenBlockEvent).to.equal(true);
                    (0, chai_1.expect)(hasSeenTxEvent).to.equal(true);
                    (0, chai_1.expect)(hasSeenCoinEvent).to.equal(true);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get wallet events', function () { return __awaiter(_this, void 0, void 0, function () {
        var authClient, payload, authPayload, chain, network, roomPrefix, hasSeenTxEvent, hasSeenCoinEvent, sawEvents;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    authClient = new bitcore_client_1.Client({ apiUrl: 'http://localhost:3000/api', authKey: authKey });
                    payload = { method: 'socket', url: 'http://localhost:3000/api' };
                    authPayload = { pubKey: pubKey, message: authClient.getMessage(payload), signature: authClient.sign(payload) };
                    chain = 'BTC';
                    network = 'regtest';
                    roomPrefix = "/".concat(chain, "/").concat(network, "/");
                    socket.emit('room', roomPrefix + 'wallet', authPayload);
                    hasSeenTxEvent = false;
                    hasSeenCoinEvent = false;
                    sawEvents = new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    socket.on('tx', function () {
                                        hasSeenTxEvent = true;
                                        console.log('Transaction event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent) {
                                            resolve();
                                        }
                                    });
                                    socket.on('coin', function () {
                                        hasSeenCoinEvent = true;
                                        console.log('Coin event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent) {
                                            resolve();
                                        }
                                    });
                                    _a.label = 1;
                                case 1:
                                    if (!!hasSeenTxEvent) return [3 /*break*/, 3];
                                    console.log('WAITING FOR TX EVENT ON SOCKET');
                                    if (hasSeenTxEvent && hasSeenCoinEvent) {
                                        return [2 /*return*/, resolve()];
                                    }
                                    return [4 /*yield*/, (0, wait_1.wait)(1000)];
                                case 2:
                                    _a.sent();
                                    return [3 /*break*/, 1];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, rpc.sendtoaddress(address, 0.1)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, sawEvents];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(hasSeenTxEvent).to.equal(true);
                    (0, chai_1.expect)(hasSeenCoinEvent).to.equal(true);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get all wallet events', function () { return __awaiter(_this, void 0, void 0, function () {
        var authClient, payload, authPayload, chain, network, roomPrefix, hasSeenTxEvent, hasSeenCoinEvent, sawEvents;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    authClient = new bitcore_client_1.Client({ apiUrl: 'http://localhost:3000/api', authKey: bwsPrivKey });
                    payload = { method: 'socket', url: 'http://localhost:3000/api' };
                    authPayload = {
                        pubKey: bwsKey,
                        message: authClient.getMessage(payload),
                        signature: authClient.sign(payload)
                    };
                    chain = 'BTC';
                    network = 'regtest';
                    roomPrefix = "/".concat(chain, "/").concat(network, "/");
                    socket.emit('room', roomPrefix + 'wallets', authPayload);
                    hasSeenTxEvent = false;
                    hasSeenCoinEvent = false;
                    sawEvents = new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    socket.on('tx', function () {
                                        hasSeenTxEvent = true;
                                        console.log('Transaction event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent) {
                                            resolve();
                                        }
                                    });
                                    socket.on('coin', function () {
                                        hasSeenCoinEvent = true;
                                        console.log('Coin event received');
                                        if (hasSeenTxEvent && hasSeenCoinEvent) {
                                            resolve();
                                        }
                                    });
                                    _a.label = 1;
                                case 1:
                                    if (!!hasSeenTxEvent) return [3 /*break*/, 3];
                                    console.log('WAITING FOR Wallet-TX EVENT ON SOCKET');
                                    if (hasSeenTxEvent && hasSeenCoinEvent) {
                                        return [2 /*return*/, resolve()];
                                    }
                                    return [4 /*yield*/, (0, wait_1.wait)(1000)];
                                case 2:
                                    _a.sent();
                                    return [3 /*break*/, 1];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, rpc.sendtoaddress(address, 0.1)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, sawEvents];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(hasSeenTxEvent).to.equal(true);
                    (0, chai_1.expect)(hasSeenCoinEvent).to.equal(true);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get an error when the key does not match the bwsKey', function () { return __awaiter(_this, void 0, void 0, function () {
        var pubKey, wrongKey, authClient, payload, authPayload, chain, network, roomPrefix, failed;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pubKey = authKey.publicKey.toString('hex');
                    wrongKey = new PrivateKey();
                    authClient = new bitcore_client_1.Client({ apiUrl: 'http://localhost:3000/api', authKey: wrongKey });
                    payload = { method: 'socket', url: 'http://localhost:3000/api' };
                    authPayload = { pubKey: pubKey, message: authClient.getMessage(payload), signature: authClient.sign(payload) };
                    chain = 'BTC';
                    network = 'regtest';
                    roomPrefix = "/".concat(chain, "/").concat(network, "/");
                    failed = new Promise(function (resolve) {
                        socket.on('failure', function (e) {
                            (0, chai_1.expect)(e.message).to.include('Authentication failed');
                            resolve();
                        });
                    });
                    socket.emit('room', roomPrefix + 'wallets', authPayload);
                    return [4 /*yield*/, failed];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get an error when the signature is invalid', function () { return __awaiter(_this, void 0, void 0, function () {
        var wrongKey, authClient, payload, authPayload, chain, network, roomPrefix, failed;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    wrongKey = new PrivateKey();
                    authClient = new bitcore_client_1.Client({ apiUrl: 'http://localhost:3000/api', authKey: wrongKey });
                    payload = { method: 'socket', url: 'http://localhost:3000/api' };
                    authPayload = { pubKey: pubKey, message: authClient.getMessage(payload), signature: 'invalid' };
                    chain = 'BTC';
                    network = 'regtest';
                    roomPrefix = "/".concat(chain, "/").concat(network, "/");
                    failed = new Promise(function (resolve) {
                        socket.on('failure', function (e) {
                            (0, chai_1.expect)(e.message).to.include('Authentication failed');
                            resolve();
                        });
                    });
                    socket.emit('room', roomPrefix + 'wallet', authPayload);
                    return [4 /*yield*/, failed];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=websocket.spec.js.map