"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var mongodb_1 = require("mongodb");
var sinon = __importStar(require("sinon"));
var block_1 = require("../../../src/models/block");
var coin_1 = require("../../../src/models/coin");
var transaction_1 = require("../../../src/models/transaction");
var chain_state_1 = require("../../../src/providers/chain-state");
var storage_1 = require("../../../src/services/storage");
var test_block_1 = require("../../data/test-block");
var helpers_1 = require("../../helpers");
var index_js_1 = require("../../helpers/index.js");
var unit_1 = require("../../helpers/unit");
describe('Block Model', function () {
    var _this = this;
    before(unit_1.unitBeforeHelper);
    after(unit_1.unitAfterHelper);
    var addBlockParams = {
        chain: 'BTC',
        network: 'regtest',
        block: test_block_1.TEST_BLOCK,
        height: 1355,
        initialSyncComplete: false,
        processed: true
    };
    describe('addBlock', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should be able to add a block', function () { return __awaiter(_this, void 0, void 0, function () {
            var newBlock, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        newBlock = Object.assign({ save: function () { return Promise.resolve(); } }, block_1.BitcoinBlockStorage, addBlockParams);
                        (0, helpers_1.mockStorage)(newBlock);
                        sandbox.stub(block_1.BitcoinBlockStorage, 'handleReorg').resolves();
                        sandbox.stub(transaction_1.TransactionStorage, 'batchImport').resolves();
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.addBlock(addBlockParams)];
                    case 1:
                        result = _a.sent();
                        (0, chai_1.expect)(result);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('BlockModel find options', function () {
        it('should be able to create query options', function () {
            var id = new mongodb_1.ObjectID();
            var _a = storage_1.Storage.getFindOptions(block_1.BitcoinBlockStorage, {
                since: id,
                paging: '_id',
                limit: 100,
                direction: -1
            }), query = _a.query, options = _a.options;
            (0, chai_1.expect)(options.limit).to.be.eq(100);
            (0, chai_1.expect)(query._id).to.be.deep.eq({ $lt: id });
            (0, chai_1.expect)(options.sort).to.be.deep.eq({ _id: -1 });
        });
        it('should default to descending', function () {
            var id = new mongodb_1.ObjectID();
            var _a = storage_1.Storage.getFindOptions(block_1.BitcoinBlockStorage, {
                since: id,
                paging: '_id',
                limit: 100
            }), query = _a.query, options = _a.options;
            (0, chai_1.expect)(options.sort).to.be.deep.eq({ _id: -1 });
            (0, chai_1.expect)(options.limit).to.be.eq(100);
            (0, chai_1.expect)(query._id).to.be.deep.eq({ $lt: id });
        });
        it('should allow ascending', function () {
            var id = new mongodb_1.ObjectID();
            var _a = storage_1.Storage.getFindOptions(block_1.BitcoinBlockStorage, {
                since: id,
                paging: '_id',
                limit: 100,
                direction: 1
            }), query = _a.query, options = _a.options;
            (0, chai_1.expect)(options.sort).to.be.deep.eq({ _id: 1 });
            (0, chai_1.expect)(options.limit).to.be.eq(100);
            (0, chai_1.expect)(query._id).to.be.deep.eq({ $gt: id });
        });
    });
    describe('getLocalTip', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should return the new tip', function () { return __awaiter(_this, void 0, void 0, function () {
            var newBlock, params, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        newBlock = Object.assign({ save: function () { return Promise.resolve(); } }, block_1.BitcoinBlockStorage, addBlockParams);
                        (0, helpers_1.mockStorage)(newBlock);
                        params = { chain: 'BTC', network: 'regtest' };
                        return [4 /*yield*/, chain_state_1.ChainStateProvider.getLocalTip(params)];
                    case 1:
                        result = _a.sent();
                        (0, chai_1.expect)(result.height).to.deep.equal(addBlockParams.height);
                        (0, chai_1.expect)(result.chain).to.deep.equal(addBlockParams.chain);
                        (0, chai_1.expect)(result.network).to.deep.equal(addBlockParams.network);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getPoolInfo', function () {
        xit('should return pool info given a coinbase string');
    });
    describe('getLocatorHashes', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should return 65 zeros if there are no processed blocks for the chain and network', function () { return __awaiter(_this, void 0, void 0, function () {
            var params, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = { chain: 'BTC', network: 'regtest' };
                        return [4 /*yield*/, chain_state_1.ChainStateProvider.getLocatorHashes(params)];
                    case 1:
                        result = _a.sent();
                        (0, chai_1.expect)(result).to.deep.equal([Array(65).join('0')]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('handleReorg', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should return if localTip hash equals the previous hash', function () { return __awaiter(_this, void 0, void 0, function () {
            var blockModelRemoveSpy, transactionModelRemoveSpy, coinModelRemoveSpy, coinModelUpdateSpy, params;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Object.assign(block_1.BitcoinBlockStorage.collection, (0, index_js_1.mockCollection)(null));
                        Object.assign(transaction_1.TransactionStorage.collection, (0, index_js_1.mockCollection)(null));
                        Object.assign(coin_1.CoinStorage.collection, (0, index_js_1.mockCollection)(null));
                        blockModelRemoveSpy = block_1.BitcoinBlockStorage.collection.deleteMany;
                        transactionModelRemoveSpy = transaction_1.TransactionStorage.collection.deleteMany;
                        coinModelRemoveSpy = coin_1.CoinStorage.collection.deleteMany;
                        coinModelUpdateSpy = coin_1.CoinStorage.collection.updateMany;
                        params = {
                            header: {
                                prevHash: '3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9',
                                hash: '64bfb3eda276ae4ae5b64d9e36c9c0b629bc767fb7ae66f9d55d2c5c8103a929',
                                time: 1526756523,
                                version: 536870912,
                                merkleRoot: '08e23107e8449f02568d37d37aa76e840e55bbb5f100ed8ad257af303db88c08',
                                bits: parseInt('207fffff', 16),
                                nonce: 2
                            },
                            chain: 'BTC',
                            network: 'regtest'
                        };
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg(params)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(blockModelRemoveSpy.notCalled).to.be.true;
                        (0, chai_1.expect)(transactionModelRemoveSpy.notCalled).to.be.true;
                        (0, chai_1.expect)(coinModelRemoveSpy.notCalled).to.be.true;
                        (0, chai_1.expect)(coinModelUpdateSpy.notCalled).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return if localTip height is zero', function () { return __awaiter(_this, void 0, void 0, function () {
            var blockModelRemoveSpy, transactionModelRemoveSpy, coinModelRemoveSpy, coinModelUpdateSpy, blockMethodParams, params;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        blockModelRemoveSpy = block_1.BitcoinBlockStorage.collection.deleteMany;
                        transactionModelRemoveSpy = transaction_1.TransactionStorage.collection.deleteMany;
                        coinModelRemoveSpy = coin_1.CoinStorage.collection.deleteMany;
                        coinModelUpdateSpy = coin_1.CoinStorage.collection.updateMany;
                        blockMethodParams = {
                            chain: 'BTC',
                            network: 'regtest',
                            block: test_block_1.TEST_BLOCK,
                            height: 1355
                        };
                        params = Object.assign(block_1.BitcoinBlockStorage, blockMethodParams);
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg(params)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(blockModelRemoveSpy.notCalled).to.be.true;
                        (0, chai_1.expect)(transactionModelRemoveSpy.notCalled).to.be.true;
                        (0, chai_1.expect)(coinModelRemoveSpy.notCalled).to.be.true;
                        (0, chai_1.expect)(coinModelUpdateSpy.notCalled).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should call blockModel deleteMany', function () { return __awaiter(_this, void 0, void 0, function () {
            var blockMethodParams, params, removeSpy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        (0, helpers_1.mockStorage)({
                            height: 1,
                            previousBlockHash: '3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9'
                        });
                        blockMethodParams = {
                            chain: 'BTC',
                            network: 'regtest',
                            block: test_block_1.TEST_BLOCK,
                            height: 1355
                        };
                        params = Object.assign(block_1.BitcoinBlockStorage, blockMethodParams);
                        removeSpy = block_1.BitcoinBlockStorage.collection.deleteMany;
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg(params)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(removeSpy.called).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should call transactionModel deleteMany', function () { return __awaiter(_this, void 0, void 0, function () {
            var blockMethodParams, params, removeSpy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        (0, helpers_1.mockStorage)({
                            height: 1,
                            previousBlockHash: '3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9'
                        });
                        blockMethodParams = {
                            chain: 'BTC',
                            network: 'regtest',
                            block: test_block_1.TEST_BLOCK,
                            height: 1355
                        };
                        params = Object.assign(block_1.BitcoinBlockStorage, blockMethodParams);
                        removeSpy = transaction_1.TransactionStorage.collection.deleteMany;
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg(params)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(removeSpy.called).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should call coinModel deleteMany', function () { return __awaiter(_this, void 0, void 0, function () {
            var blockMethodParams, params, collectionSpy, removeSpy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        (0, helpers_1.mockStorage)({
                            height: 1,
                            previousBlockHash: '3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9'
                        });
                        blockMethodParams = {
                            chain: 'BTC',
                            network: 'regtest',
                            block: test_block_1.TEST_BLOCK,
                            height: 1355
                        };
                        params = Object.assign(block_1.BitcoinBlockStorage, blockMethodParams);
                        collectionSpy = storage_1.Storage.db.collection;
                        removeSpy = coin_1.CoinStorage.collection.deleteMany;
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg(params)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(collectionSpy.calledOnceWith('coins'));
                        (0, chai_1.expect)(removeSpy.callCount).to.eq(3);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should call coinModel update', function () { return __awaiter(_this, void 0, void 0, function () {
            var blockMethodParams, params, collectionSpy, updateSpy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        (0, helpers_1.mockStorage)({
                            height: 1,
                            previousBlockHash: '3420349f63d96f257d56dd970f6b9079af9cf2784c267a13b1ac339d47031fe9'
                        });
                        blockMethodParams = {
                            chain: 'BTC',
                            network: 'regtest',
                            block: test_block_1.TEST_BLOCK,
                            height: 1355
                        };
                        params = Object.assign(block_1.BitcoinBlockStorage, blockMethodParams);
                        collectionSpy = storage_1.Storage.db.collection;
                        updateSpy = coin_1.CoinStorage.collection.updateMany;
                        return [4 /*yield*/, block_1.BitcoinBlockStorage.handleReorg(params)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(collectionSpy.calledOnceWith('coins'));
                        (0, chai_1.expect)(updateSpy.called).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('_apiTransform', function () {
        it('should return the transform object with block values', function () {
            var block = {
                chain: 'BTC',
                network: 'mainnet',
                height: 1,
                hash: 'abcd',
                version: 1,
                merkleRoot: 'deff',
                time: new Date(),
                timeNormalized: new Date(),
                nonce: 1,
                previousBlockHash: 'aabb',
                nextBlockHash: 'bbcc',
                transactionCount: 1,
                size: 255,
                bits: 256,
                reward: 5000000000,
                processed: true
            };
            var result = block_1.BitcoinBlockStorage._apiTransform(block, { object: true });
            (0, chai_1.expect)(result.hash).to.be.equal(block.hash);
            (0, chai_1.expect)(result.height).to.be.equal(block.height);
            (0, chai_1.expect)(result.version).to.be.equal(block.version);
            (0, chai_1.expect)(result.size).to.be.equal(block.size);
            (0, chai_1.expect)(result.merkleRoot).to.be.equal(block.merkleRoot);
            (0, chai_1.expect)(result.time).to.equal(block.time);
            (0, chai_1.expect)(result.timeNormalized).to.equal(block.timeNormalized);
            (0, chai_1.expect)(result.nonce).to.be.equal(block.nonce);
            (0, chai_1.expect)(result.bits).to.be.equal(block.bits);
            (0, chai_1.expect)(result.previousBlockHash).to.be.equal(block.previousBlockHash);
            (0, chai_1.expect)(result.nextBlockHash).to.be.equal(block.nextBlockHash);
            (0, chai_1.expect)(result.transactionCount).to.be.equal(block.transactionCount);
            (0, chai_1.expect)(result).to.not.have.property('processed');
        });
    });
});
//# sourceMappingURL=block.spec.js.map