"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var mongodb_1 = require("mongodb");
var sinon_1 = __importDefault(require("sinon"));
var block_1 = require("../../../src/models/block");
var coin_1 = require("../../../src/models/coin");
var index_js_1 = require("../../helpers/index.js");
var unit_1 = require("../../helpers/unit");
describe('Coin Model', function () {
    var _this = this;
    before(unit_1.unitBeforeHelper);
    after(unit_1.unitAfterHelper);
    describe('_apiTransform', function () {
        it('should return the transform object with coin info', function () {
            var id = new mongodb_1.ObjectId();
            var coin = {
                _id: id,
                network: 'regtest',
                chain: 'BTC',
                mintTxid: '81f24ac62a6ffb634b74e6278997f0788f3c64e844453f8831d2a526dc3ecb13',
                mintIndex: 0,
                mintHeight: 1,
                coinbase: true,
                value: 5000000000.0,
                address: 'n1ojJtS98D2VRLcTkaHH4YXLG4ytCyS7AL',
                script: Buffer.from(''),
                wallets: [],
                spentTxid: '',
                spentHeight: -2 /* SpentHeightIndicators.unspent */
            };
            var result = coin_1.CoinStorage._apiTransform(coin, { object: false });
            var parseResult = JSON.parse(result.toString());
            (0, chai_1.expect)(parseResult).to.deep.equal({
                _id: id.toHexString(),
                mintTxid: '81f24ac62a6ffb634b74e6278997f0788f3c64e844453f8831d2a526dc3ecb13',
                mintHeight: 1,
                network: 'regtest',
                confirmations: -1,
                mintIndex: 0,
                chain: 'BTC',
                spentTxid: '',
                address: 'n1ojJtS98D2VRLcTkaHH4YXLG4ytCyS7AL',
                coinbase: true,
                script: '',
                spentHeight: -2 /* SpentHeightIndicators.unspent */,
                value: 5000000000.0
            });
        });
        it('should return the raw transform object if options field exists and set to true', function () {
            var id = new mongodb_1.ObjectId();
            var coin = {
                _id: id,
                network: 'regtest',
                chain: 'BTC',
                mintTxid: '81f24ac62a6ffb634b74e6278997f0788f3c64e844453f8831d2a526dc3ecb13',
                mintIndex: 0,
                mintHeight: 1,
                coinbase: true,
                value: 5000000000.0,
                address: 'n1ojJtS98D2VRLcTkaHH4YXLG4ytCyS7AL',
                script: Buffer.from(''),
                sequenceNumber: undefined,
                wallets: [],
                spentTxid: '',
                spentHeight: -2 /* SpentHeightIndicators.unspent */
            };
            var result = coin_1.CoinStorage._apiTransform(coin, { object: true });
            (0, chai_1.expect)(result).to.deep.equal({
                _id: id.toHexString(),
                mintTxid: '81f24ac62a6ffb634b74e6278997f0788f3c64e844453f8831d2a526dc3ecb13',
                network: 'regtest',
                chain: 'BTC',
                spentTxid: '',
                mintHeight: 1,
                mintIndex: 0,
                spentHeight: -2 /* SpentHeightIndicators.unspent */,
                address: 'n1ojJtS98D2VRLcTkaHH4YXLG4ytCyS7AL',
                coinbase: true,
                confirmations: -1,
                script: '',
                sequenceNumber: undefined,
                value: 5000000000.0
            });
        });
    });
    describe('getBalanceAtTime', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon_1.default.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should return an object with confirmed, unconfirmed, and balance when additional time parameter is passed in', function () { return __awaiter(_this, void 0, void 0, function () {
            var id, chain, network, time, query, matchObject, blockModelHeight, coinModelAggregateSpy, blockModelFindSpy, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = new mongodb_1.ObjectId('5c364e342ab5602e97a56f0e');
                        chain = 'BTC';
                        network = 'regtest';
                        time = new Date().toISOString();
                        query = { wallets: id, 'wallets.0': { $exists: true } };
                        matchObject = {
                            $or: [
                                {
                                    spentHeight: {
                                        $gt: 123
                                    }
                                },
                                {
                                    spentHeight: {
                                        $lt: 0
                                    }
                                }
                            ],
                            mintHeight: {
                                $lte: 123
                            },
                            wallets: new mongodb_1.ObjectId('5c364e342ab5602e97a56f0e'),
                            'wallets.0': { $exists: true }
                        };
                        blockModelHeight = { height: 123 };
                        (0, index_js_1.mockModel)('coins', [
                            { _id: 'confirmed', balance: 123123 },
                            { _id: 'unconfirmed', balance: 1 }
                        ]);
                        (0, index_js_1.mockModel)('blocks', blockModelHeight);
                        coinModelAggregateSpy = coin_1.CoinStorage.collection.aggregate;
                        blockModelFindSpy = block_1.BitcoinBlockStorage.collection.find;
                        return [4 /*yield*/, coin_1.CoinStorage.getBalanceAtTime({ query: query, time: time, chain: chain, network: network })];
                    case 1:
                        result = _a.sent();
                        (0, chai_1.expect)(coinModelAggregateSpy.called).to.deep.equal(true, 'CoinStorage.aggregation should have been called');
                        (0, chai_1.expect)(blockModelFindSpy.called).to.deep.equal(true, 'BlockModel.find should have been called');
                        (0, chai_1.expect)(coinModelAggregateSpy.getCall(0).args[0][0].$match).to.deep.equal(matchObject);
                        (0, chai_1.expect)(result).to.has.property('confirmed');
                        (0, chai_1.expect)(result).to.has.property('unconfirmed');
                        (0, chai_1.expect)(result).to.has.property('balance');
                        (0, chai_1.expect)(result).to.deep.equal({ confirmed: 123123, unconfirmed: 1, balance: 123124 });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getBalance', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon_1.default.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should return an object with confirmed, unconfirmed, and balance', function () { return __awaiter(_this, void 0, void 0, function () {
            var id, query, coinModelAggregateSpy, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = new mongodb_1.ObjectId('5c364e342ab5602e97a56f0e');
                        query = {
                            wallets: id,
                            'wallets.0': { $exists: true },
                            spentHeight: { $lt: 0 },
                            mintHeight: { $gt: -3 }
                        };
                        (0, index_js_1.mockStorage)([
                            { _id: 'confirmed', balance: 123123 },
                            { _id: 'unconfirmed', balance: 1 }
                        ]);
                        coinModelAggregateSpy = coin_1.CoinStorage.collection.aggregate;
                        return [4 /*yield*/, coin_1.CoinStorage.getBalance({ query: query })];
                    case 1:
                        result = _a.sent();
                        (0, chai_1.expect)(coinModelAggregateSpy.called).to.deep.equal(true, 'CoinStorage.aggregation should have been called');
                        (0, chai_1.expect)(coinModelAggregateSpy.getCall(0).args[0][0].$match).to.deep.equal(query);
                        (0, chai_1.expect)(result).to.has.property('confirmed');
                        (0, chai_1.expect)(result).to.has.property('unconfirmed');
                        (0, chai_1.expect)(result).to.has.property('balance');
                        (0, chai_1.expect)(result).to.deep.equal({ confirmed: 123123, unconfirmed: 1, balance: 123124 });
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=coin.spec.js.map