"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bson_1 = require("bson");
var chai_1 = require("chai");
var sinon = __importStar(require("sinon"));
var wallet_1 = require("../../../src/models/wallet");
var walletAddress_1 = require("../../../src/models/walletAddress");
var index_js_1 = require("../../helpers/index.js");
var unit_1 = require("../../helpers/unit");
describe('Wallet Model', function () {
    var _this = this;
    before(unit_1.unitBeforeHelper);
    after(unit_1.unitAfterHelper);
    describe('_apiTransform', function () {
        it('should return the transform object with wallet info', function () {
            var wallet = {
                name: 'Wallet1',
                singleAddress: true,
                pubKey: 'xpub661MyMwAqRbcFa63vSTa3vmRiVWbpLWhgUsyvjfMFP7ePR5osC1rtPUkgJrB94V1YEQathfWLm9U5zaZttYPDPWhASwJGUvYvPGtofqnTGN',
                path: "m/44'/0'/0'"
            };
            var result = wallet_1.WalletStorage._apiTransform(wallet, { object: false });
            var parseResult = JSON.parse(result.toString());
            (0, chai_1.expect)(parseResult).to.deep.equal({
                name: 'Wallet1',
                pubKey: 'xpub661MyMwAqRbcFa63vSTa3vmRiVWbpLWhgUsyvjfMFP7ePR5osC1rtPUkgJrB94V1YEQathfWLm9U5zaZttYPDPWhASwJGUvYvPGtofqnTGN'
            });
        });
        it('should return the raw transform object if options field exists and set to true', function () {
            var wallet = {
                name: 'Wallet1',
                singleAddress: true,
                pubKey: 'xpub661MyMwAqRbcFa63vSTa3vmRiVWbpLWhgUsyvjfMFP7ePR5osC1rtPUkgJrB94V1YEQathfWLm9U5zaZttYPDPWhASwJGUvYvPGtofqnTGN',
                path: "m/44'/0'/0'"
            };
            var result = wallet_1.WalletStorage._apiTransform(wallet, { object: true });
            (0, chai_1.expect)(result).to.deep.equal({
                name: 'Wallet1',
                pubKey: 'xpub661MyMwAqRbcFa63vSTa3vmRiVWbpLWhgUsyvjfMFP7ePR5osC1rtPUkgJrB94V1YEQathfWLm9U5zaZttYPDPWhASwJGUvYvPGtofqnTGN'
            });
        });
    });
    describe('updateCoins', function () {
        var sandbox;
        beforeEach(function () {
            sandbox = sinon.sandbox.create();
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('should call wallet address model update coins', function () { return __awaiter(_this, void 0, void 0, function () {
            var walletAddressModelSpy, wallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Object.assign(walletAddress_1.WalletAddressStorage.collection, (0, index_js_1.mockCollection)([]));
                        walletAddressModelSpy = sandbox.stub(walletAddress_1.WalletAddressStorage, 'updateCoins').returns({
                            wallet: sandbox.stub().returnsThis(),
                            addresses: sandbox.stub().returnsThis()
                        });
                        wallet = {
                            _id: new bson_1.ObjectID(),
                            name: 'Wallet1',
                            singleAddress: true,
                            pubKey: 'xpub661MyMwAqRbcFa63vSTa3vmRiVWbpLWhgUsyvjfMFP7ePR5osC1rtPUkgJrB94V1YEQathfWLm9U5zaZttYPDPWhASwJGUvYvPGtofqnTGN',
                            path: "m/44'/0'/0'",
                            chain: 'BTC',
                            network: 'regtest'
                        };
                        return [4 /*yield*/, wallet_1.WalletStorage.updateCoins(wallet)];
                    case 1:
                        _a.sent();
                        (0, chai_1.expect)(walletAddressModelSpy.calledOnce).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=wallet.spec.js.map