"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var walletAddress_1 = require("../../../src/models/walletAddress");
var unit_1 = require("../../helpers/unit");
describe('WalletAddress Model', function () {
    before(unit_1.unitBeforeHelper);
    after(unit_1.unitAfterHelper);
    describe('_apiTransform', function () {
        it('should return transform object with wallet addresses', function () {
            var walletAddress = {
                address: '2NA2xTdQH6CG73Gc26oQZ7FEmvTx9Kwo7uf'
            };
            var result = walletAddress_1.WalletAddressStorage._apiTransform(walletAddress, {
                object: false
            }).toString();
            var parseResult = JSON.parse(result);
            (0, chai_1.expect)(parseResult).to.deep.equal({ address: '2NA2xTdQH6CG73Gc26oQZ7FEmvTx9Kwo7uf' });
        });
        it('should return the raw transform object if options field exists and set to true', function () {
            var walletAddress = {
                address: '2NA2xTdQH6CG73Gc26oQZ7FEmvTx9Kwo7uf'
            };
            var result = walletAddress_1.WalletAddressStorage._apiTransform(walletAddress, {
                object: true
            });
            (0, chai_1.expect)(result).to.deep.equal({ address: '2NA2xTdQH6CG73Gc26oQZ7FEmvTx9Kwo7uf' });
        });
    });
});
//# sourceMappingURL=walletAddress.spec.js.map