"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bson_1 = require("bson");
var chai_1 = require("chai");
var events_1 = require("events");
var sinon = __importStar(require("sinon"));
var csp_1 = require("../../../../src/modules/ethereum/api/csp");
var csp_2 = require("../../../../src/providers/chain-state/evm/api/csp");
var helpers_1 = require("../../../helpers");
describe('ETH Chain State Provider', function () {
    var _this = this;
    var chain = 'ETH';
    var network = 'regtest';
    it('should be able to get web3', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, web3Stub, web3, block, stub;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    web3Stub = { eth: { getBlockNumber: sandbox.stub().resolves(1) } };
                    sandbox.stub(csp_2.BaseEVMStateProvider, 'rpcs').value({ ETH: (_a = {}, _a[network] = { web3: web3Stub, rpc: sinon.stub() }, _a) });
                    return [4 /*yield*/, csp_1.ETH.getWeb3(network)];
                case 1:
                    web3 = (_b.sent()).web3;
                    return [4 /*yield*/, web3.eth.getBlockNumber()];
                case 2:
                    block = _b.sent();
                    stub = web3.eth.getBlockNumber;
                    (0, chai_1.expect)(stub.callCount).to.eq(2);
                    (0, chai_1.expect)(block).to.eq(1);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should make a new web3 if getBlockNumber fails', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, web3Stub, web3, stub;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    web3Stub = { eth: { getBlockNumber: sandbox.stub().throws('Block number fails') } };
                    sandbox.stub(csp_2.BaseEVMStateProvider, 'rpcs').value({ ETH: (_a = {}, _a[network] = { web3: web3Stub, rpc: sinon.stub() }, _a) });
                    return [4 /*yield*/, csp_1.ETH.getWeb3(network)];
                case 1:
                    web3 = (_b.sent()).web3;
                    stub = web3.eth.getBlockNumber;
                    (0, chai_1.expect)(stub.callCount).to.not.exist;
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get ERC20 information', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, expected, tokenStub, token;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    expected = {
                        name: 'Test Token',
                        decimals: 10,
                        symbol: 'TST'
                    };
                    tokenStub = {
                        methods: {
                            name: function () { return ({ call: sandbox.stub().resolves(expected.name) }); },
                            decimals: function () { return ({ call: sandbox.stub().resolves(expected.decimals) }); },
                            symbol: function () { return ({ call: sandbox.stub().resolves(expected.symbol) }); }
                        }
                    };
                    sandbox.stub(csp_1.ETH, 'erc20For').resolves(tokenStub);
                    return [4 /*yield*/, csp_1.ETH.getERC20TokenInfo(network, '0x123')];
                case 1:
                    token = _a.sent();
                    (0, chai_1.expect)(token.name).to.eq(expected.name);
                    (0, chai_1.expect)(token.symbol).to.eq(expected.symbol);
                    (0, chai_1.expect)(token.decimals).to.eq(expected.decimals);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to find an ETH transaction', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, mockTx, found;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    mockTx = {
                        _id: new bson_1.ObjectId(),
                        chain: 'ETH',
                        network: 'testnet',
                        txid: '123',
                        blockHeight: 1,
                        gasPrice: 10,
                        data: Buffer.from('')
                    };
                    sandbox.stub(csp_1.ETH, 'getReceipt').resolves({ gasUsed: 21000 });
                    sandbox.stub(csp_1.ETH, 'getLocalTip').resolves({ height: 1 });
                    (0, helpers_1.mockModel)('transactions', mockTx);
                    return [4 /*yield*/, csp_1.ETH.getTransaction({ chain: 'ETH', network: 'testnet', txId: '123' })];
                case 1:
                    found = _a.sent();
                    (0, chai_1.expect)(found).to.exist;
                    (0, chai_1.expect)(found.fee).to.eq(21000 * 10);
                    (0, chai_1.expect)(found.confirmations).to.eq(1);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to broadcast an array of txs', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, web3Stub, txids;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    web3Stub = {
                        eth: {
                            getBlockNumber: sandbox.stub().resolves(1),
                            sendSignedTransaction: sandbox.stub().callsFake(function (tx) {
                                var emitter = new events_1.EventEmitter();
                                emitter.catch = sandbox.stub().returnsThis();
                                setTimeout(function () {
                                    emitter.emit('transactionHash', tx);
                                }, 10);
                                return emitter;
                            })
                        }
                    };
                    sandbox.stub(csp_2.BaseEVMStateProvider, 'rpcs').value({ ETH: (_a = {}, _a[network] = { web3: web3Stub, rpc: sinon.stub() }, _a) });
                    return [4 /*yield*/, csp_1.ETH.broadcastTransaction({ chain: chain, network: network, rawTx: ['123', '456'] })];
                case 1:
                    txids = _b.sent();
                    (0, chai_1.expect)(web3Stub.eth.sendSignedTransaction.calledWith('123')).to.eq(true);
                    (0, chai_1.expect)(web3Stub.eth.sendSignedTransaction.calledWith('456')).to.eq(true);
                    (0, chai_1.expect)(txids).to.deep.eq(['123', '456']);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to broadcast a single tx', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, web3Stub, txid;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    web3Stub = {
                        eth: {
                            getBlockNumber: sandbox.stub().resolves(1),
                            sendSignedTransaction: sandbox.stub().callsFake(function (tx) {
                                var emitter = new events_1.EventEmitter();
                                emitter.catch = sandbox.stub().returnsThis();
                                setTimeout(function () {
                                    emitter.emit('transactionHash', tx);
                                }, 10);
                                return emitter;
                            })
                        }
                    };
                    sandbox.stub(csp_2.BaseEVMStateProvider, 'rpcs').value({ ETH: (_a = {}, _a[network] = { web3: web3Stub, rpc: sinon.stub() }, _a) });
                    return [4 /*yield*/, csp_1.ETH.broadcastTransaction({ chain: chain, network: network, rawTx: '123' })];
                case 1:
                    txid = _b.sent();
                    (0, chai_1.expect)(web3Stub.eth.sendSignedTransaction.calledWith('123')).to.eq(true);
                    (0, chai_1.expect)(txid).to.eq('123');
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should stop broadcasting txs on error', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, shouldThrow, web3Stub, thrown, e_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    shouldThrow = false;
                    web3Stub = {
                        eth: {
                            getBlockNumber: sandbox.stub().resolves(1),
                            sendSignedTransaction: sandbox.stub().callsFake(function () {
                                var emitter = new events_1.EventEmitter();
                                var err = new Error('fake error');
                                emitter.catch = function (cb) { return cb(err); };
                                if (!shouldThrow) {
                                    setTimeout(function () {
                                        emitter.emit('transactionHash');
                                    }, 10);
                                    shouldThrow = true;
                                }
                                else {
                                    setTimeout(function () {
                                        emitter.emit('error', err);
                                    }, 10);
                                }
                                return emitter;
                            })
                        }
                    };
                    sandbox.stub(csp_2.BaseEVMStateProvider, 'rpcs').value({ ETH: (_a = {}, _a[network] = { web3: web3Stub, rpc: sinon.stub() }, _a) });
                    thrown = false;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, csp_1.ETH.broadcastTransaction({ chain: chain, network: network, rawTx: ['123', '456'] })];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _b.sent();
                    thrown = true;
                    return [3 /*break*/, 4];
                case 4:
                    (0, chai_1.expect)(thrown).to.eq(true);
                    (0, chai_1.expect)(web3Stub.eth.sendSignedTransaction.calledWith('123')).to.eq(true);
                    (0, chai_1.expect)(web3Stub.eth.sendSignedTransaction.calledWith('456')).to.eq(false);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to find an ETH block', function () { return __awaiter(_this, void 0, void 0, function () {
        var sandbox, mockBlock, found;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sandbox = sinon.createSandbox();
                    mockBlock = {
                        _id: new bson_1.ObjectId(),
                        hash: '55555',
                        height: 1
                    };
                    (0, helpers_1.mockModel)('blocks', mockBlock);
                    return [4 /*yield*/, csp_1.ETH.getBlocks({ chain: chain, network: network, blockId: mockBlock.hash })];
                case 1:
                    found = _a.sent();
                    (0, chai_1.expect)(found).to.exist;
                    (0, chai_1.expect)(found[0]).to.exist;
                    (0, chai_1.expect)(found[0].hash).to.eq(mockBlock.hash);
                    (0, chai_1.expect)(found[0].height).to.eq(mockBlock.height);
                    sandbox.restore();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('estimateGas', function () {
        var sandbox = sinon.createSandbox();
        var web3Stub = {
            utils: {
                toHex: function (val) { return val && Buffer.from(val.toString()).toString('hex'); }
            },
            eth: {
                getBlockNumber: sandbox.stub().resolves(1)
            },
            currentProvider: {
                send: sandbox.stub()
            }
        };
        beforeEach(function () {
            var _a;
            sandbox.stub(csp_2.BaseEVMStateProvider, 'rpcs').value({ ETH: (_a = {}, _a[network] = { web3: web3Stub, rpc: sinon.stub() }, _a) });
        });
        afterEach(function () {
            sandbox.restore();
        });
        it('it should return gas', function () { return __awaiter(_this, void 0, void 0, function () {
            var gas;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, null, { result: '12345' });
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network, to: '0x123', from: '0xabc', gasPrice: 123, value: 'lorem' })];
                    case 1:
                        gas = _a.sent();
                        (0, chai_1.expect)(gas).to.equal(12345);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return gas for optional params', function () { return __awaiter(_this, void 0, void 0, function () {
            var gas;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, null, { result: '1234' });
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network })];
                    case 1:
                        gas = _a.sent();
                        (0, chai_1.expect)(gas).to.equal(1234);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should reject an error response', function () { return __awaiter(_this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, 'Unavailable server', null); // body is null
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network })];
                    case 2:
                        _a.sent();
                        throw new Error('should have thrown');
                    case 3:
                        err_1 = _a.sent();
                        (0, chai_1.expect)(err_1).to.equal('Unavailable server');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should reject if response body is missing result', function () { return __awaiter(_this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, null, { message: 'need some param' });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network })];
                    case 2:
                        _a.sent();
                        throw new Error('should have thrown');
                    case 3:
                        err_2 = _a.sent();
                        (0, chai_1.expect)(err_2).to.deep.equal({ message: 'need some param' });
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should reject if response body is missing result and has error', function () { return __awaiter(_this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, null, { error: { code: 2, message: 'need some param' } });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network })];
                    case 2:
                        _a.sent();
                        throw new Error('should have thrown');
                    case 3:
                        err_3 = _a.sent();
                        (0, chai_1.expect)(err_3).to.deep.equal({ code: 2, message: 'need some param' });
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should reject on unexpected error', function () { return __awaiter(_this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, null, { result: '12345' });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: 'unexpected' })];
                    case 2:
                        _a.sent();
                        throw new Error('should have thrown');
                    case 3:
                        err_4 = _a.sent();
                        (0, chai_1.expect)(err_4.message).to.equal('Please provide a valid protocol');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should reject on unexpected error in callback', function () { return __awaiter(_this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3Stub.currentProvider.send.callsArgWith(1, null, null); // body is null
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, csp_1.ETH.estimateGas({ network: network })];
                    case 2:
                        _a.sent();
                        throw new Error('should have thrown');
                    case 3:
                        err_5 = _a.sent();
                        (0, chai_1.expect)(err_5.message).to.equal('Cannot read properties of null (reading \'result\')');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=csp.spec.js.map