"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var config_1 = require("../../../src/services/config");
var unit_1 = require("../../helpers/unit");
describe('Config', function () {
    before(unit_1.unitBeforeHelper);
    after(unit_1.unitAfterHelper);
    it('should have a test which runs', function () {
        (0, chai_1.expect)(true).to.equal(true);
    });
    it('should give the chain config', function () {
        var e_1, _a, e_2, _b;
        var chains = config_1.Config.chains();
        try {
            for (var chains_1 = __values(chains), chains_1_1 = chains_1.next(); !chains_1_1.done; chains_1_1 = chains_1.next()) {
                var chain = chains_1_1.value;
                var networks = config_1.Config.networksFor(chain);
                try {
                    for (var networks_1 = (e_2 = void 0, __values(networks)), networks_1_1 = networks_1.next(); !networks_1_1.done; networks_1_1 = networks_1.next()) {
                        var network = networks_1_1.value;
                        var chainConfig = config_1.Config.chainConfig({ chain: chain, network: network });
                        (0, chai_1.expect)(chainConfig).to.exist;
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (networks_1_1 && !networks_1_1.done && (_b = networks_1.return)) _b.call(networks_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (chains_1_1 && !chains_1_1.done && (_a = chains_1.return)) _a.call(chains_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
    it('should be able to update config', function () {
        var _a, _b;
        var originalConfig = config_1.Config.get();
        var chain = 'BTC';
        var network = 'testnet';
        var testConfig = (_a = {},
            _a[chain] = (_b = {},
                _b[network] = {
                    title: 'test'
                },
                _b),
            _a);
        config_1.Config.updateConfig({ chains: testConfig });
        var testnetConfig = config_1.Config.chainConfig({ chain: chain, network: network });
        (0, chai_1.expect)(testnetConfig.title).to.exist;
        (0, chai_1.expect)(testnetConfig).to.deep.eq(testConfig[chain][network]);
        config_1.Config.updateConfig(originalConfig);
    });
});
//# sourceMappingURL=config.spec.js.map