#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var stream_1 = require("stream");
var block_1 = require("../../src/models/block");
var coin_1 = require("../../src/models/coin");
var transaction_1 = require("../../src/models/transaction");
var modules_1 = require("../../src/modules");
var config_1 = require("../../src/services/config");
var storage_1 = require("../../src/services/storage");
var verification_1 = require("../../src/services/verification");
(function () { return __awaiter(void 0, void 0, void 0, function () {
    function getLinesFromChunk(chunk) {
        return chunk.toString().split('\n');
    }
    function repairLineIfValidJson(line) {
        return __awaiter(this, void 0, void 0, function () {
            var dataStr, parsedData, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dataStr = line.trim();
                        if (!(dataStr && dataStr.length > 2)) return [3 /*break*/, 4];
                        if (!(dataStr.startsWith('{') && dataStr.endsWith('}'))) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        parsedData = JSON.parse(line);
                        console.log('Inspecting...');
                        console.log(dataStr);
                        return [4 /*yield*/, handleRepair(parsedData)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    function transformFileChunks(chunk, _, cb) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, line, e_1_1;
            var e_1, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 7]);
                        _a = __values(getLinesFromChunk(chunk)), _b = _a.next();
                        _d.label = 1;
                    case 1:
                        if (!!_b.done) return [3 /*break*/, 4];
                        line = _b.value;
                        return [4 /*yield*/, repairLineIfValidJson(line)];
                    case 2:
                        _d.sent();
                        _d.label = 3;
                    case 3:
                        _b = _a.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 7:
                        cb();
                        return [2 /*return*/];
                }
            });
        });
    }
    var _a, CHAIN, NETWORK, FILE, _b, DRYRUN, dry, chain, network, chainConfig, workerClass, worker, handleRepair, getFileContents;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = process.env, CHAIN = _a.CHAIN, NETWORK = _a.NETWORK, FILE = _a.FILE, _b = _a.DRYRUN, DRYRUN = _b === void 0 ? true : _b;
                if (!CHAIN || !NETWORK || !FILE) {
                    console.log('CHAIN, NETWORK, and FILE env variable are required');
                    process.exit(1);
                }
                dry = DRYRUN && DRYRUN !== 'false';
                chain = CHAIN || '';
                network = NETWORK || '';
                return [4 /*yield*/, storage_1.Storage.start()];
            case 1:
                _c.sent();
                modules_1.Modules.loadConfigured();
                chainConfig = config_1.Config.chainConfig({ chain: chain, network: network });
                workerClass = verification_1.Verification.get(chain);
                worker = new workerClass({ chain: chain, network: network, chainConfig: chainConfig });
                return [4 /*yield*/, worker.connect()];
            case 2:
                _c.sent();
                handleRepair = function (data) { return __awaiter(void 0, void 0, void 0, function () {
                    var tip, _a, tx, dupeTxs, toKeep_1, wouldBeDeleted, coin, forkCoins, wouldBeDeleted, coin, dupeCoins, toKeep_2, spentCoin, wouldBeDeleted, mintIndex, mintTxid, blockHeight, success, _b, success_1, errors, dupeBlock, toKeepBlock_1, processedBlock, wouldBeDeletedBlock, e_2;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                _c.trys.push([0, 30, , 31]);
                                return [4 /*yield*/, block_1.BitcoinBlockStorage.getLocalTip({ chain: chain, network: network })];
                            case 1:
                                tip = _c.sent();
                                _a = data.type;
                                switch (_a) {
                                    case 'DUPE_TRANSACTION': return [3 /*break*/, 2];
                                    case 'FORK_PRUNE_COIN': return [3 /*break*/, 7];
                                    case 'DUPE_COIN': return [3 /*break*/, 12];
                                    case 'COIN_HEIGHT_MISMATCH': return [3 /*break*/, 17];
                                    case 'CORRUPTED_BLOCK': return [3 /*break*/, 17];
                                    case 'MISSING_BLOCK': return [3 /*break*/, 17];
                                    case 'MISSING_TX': return [3 /*break*/, 17];
                                    case 'MISSING_COIN_FOR_TXID': return [3 /*break*/, 17];
                                    case 'VALUE_MISMATCH': return [3 /*break*/, 17];
                                    case 'COIN_SHOULD_BE_SPENT': return [3 /*break*/, 17];
                                    case 'NEG_FEE': return [3 /*break*/, 17];
                                    case 'DUPE_BLOCKHEIGHT': return [3 /*break*/, 23];
                                    case 'DUPE_BLOCKHASH': return [3 /*break*/, 23];
                                }
                                return [3 /*break*/, 28];
                            case 2:
                                tx = data.payload.tx;
                                return [4 /*yield*/, transaction_1.TransactionStorage.collection
                                        .find({ chain: tx.chain, network: tx.network, txid: tx.txid })
                                        .sort({ blockHeight: -1 })
                                        .toArray()];
                            case 3:
                                dupeTxs = _c.sent();
                                if (dupeTxs.length < 2) {
                                    console.log('No action required.', dupeTxs.length, 'transaction');
                                    return [2 /*return*/];
                                }
                                toKeep_1 = dupeTxs[0];
                                wouldBeDeleted = dupeTxs.filter(function (c) { return c._id != toKeep_1._id; });
                                if (!dry) return [3 /*break*/, 4];
                                console.log('WOULD DELETE');
                                console.log(wouldBeDeleted);
                                return [3 /*break*/, 6];
                            case 4:
                                console.log('Deleting', wouldBeDeleted.length, 'transactions');
                                return [4 /*yield*/, transaction_1.TransactionStorage.collection.deleteMany({
                                        chain: chain,
                                        network: network,
                                        _id: { $in: wouldBeDeleted.map(function (c) { return c._id; }) }
                                    })];
                            case 5:
                                _c.sent();
                                _c.label = 6;
                            case 6: return [3 /*break*/, 29];
                            case 7:
                                coin = data.payload.coin;
                                return [4 /*yield*/, coin_1.CoinStorage.collection
                                        .find({ chain: chain, network: network, mintTxid: coin.mintTxid, mintIndex: coin.mintIndex, spentHeight: -2 })
                                        .sort({ mintHeight: -1, spentHeight: -1 })
                                        .toArray()];
                            case 8:
                                forkCoins = _c.sent();
                                if (forkCoins.length === 0) {
                                    console.log('No action required. Coin already pruned');
                                    return [2 /*return*/];
                                }
                                wouldBeDeleted = forkCoins;
                                if (!dry) return [3 /*break*/, 9];
                                console.log('WOULD DELETE');
                                console.log(wouldBeDeleted);
                                return [3 /*break*/, 11];
                            case 9:
                                console.log('Deleting', wouldBeDeleted.length, 'coins');
                                return [4 /*yield*/, coin_1.CoinStorage.collection.deleteMany({
                                        chain: chain,
                                        network: network,
                                        _id: { $in: wouldBeDeleted.map(function (c) { return c._id; }) }
                                    })];
                            case 10:
                                _c.sent();
                                _c.label = 11;
                            case 11: return [3 /*break*/, 29];
                            case 12:
                                coin = data.payload.coin;
                                return [4 /*yield*/, coin_1.CoinStorage.collection
                                        .find({ chain: chain, network: network, mintTxid: coin.mintTxid, mintIndex: coin.mintIndex })
                                        .sort({ mintHeight: -1, spentHeight: -1 })
                                        .toArray()];
                            case 13:
                                dupeCoins = _c.sent();
                                if (dupeCoins.length < 2) {
                                    console.log('No action required.', dupeCoins.length, 'coin');
                                    return [2 /*return*/];
                                }
                                toKeep_2 = dupeCoins[0];
                                spentCoin = dupeCoins.find(function (c) { return c.spentHeight > toKeep_2.spentHeight; });
                                toKeep_2 = spentCoin || toKeep_2;
                                wouldBeDeleted = dupeCoins.filter(function (c) { return c._id != toKeep_2._id; });
                                if (!dry) return [3 /*break*/, 14];
                                console.log('WOULD DELETE');
                                console.log(wouldBeDeleted);
                                return [3 /*break*/, 16];
                            case 14:
                                mintIndex = toKeep_2.mintIndex, mintTxid = toKeep_2.mintTxid;
                                console.log('Deleting', wouldBeDeleted.length, 'coins');
                                return [4 /*yield*/, coin_1.CoinStorage.collection.deleteMany({
                                        chain: chain,
                                        network: network,
                                        mintTxid: mintTxid,
                                        mintIndex: mintIndex,
                                        _id: { $in: wouldBeDeleted.map(function (c) { return c._id; }) }
                                    })];
                            case 15:
                                _c.sent();
                                _c.label = 16;
                            case 16: return [3 /*break*/, 29];
                            case 17:
                                blockHeight = Number(data.payload.blockNum);
                                return [4 /*yield*/, worker.validateDataForBlock(blockHeight, tip.height)];
                            case 18:
                                success = (_c.sent()).success;
                                if (success) {
                                    console.log('No errors found, repaired previously');
                                    return [2 /*return*/];
                                }
                                if (!dry) return [3 /*break*/, 19];
                                console.log('WOULD RESYNC BLOCKS', blockHeight, 'to', blockHeight + 1);
                                console.log(data.payload);
                                return [3 /*break*/, 22];
                            case 19:
                                console.log('Resyncing Blocks', blockHeight, 'to', blockHeight + 1);
                                return [4 /*yield*/, worker.resync(blockHeight - 1, blockHeight + 1)];
                            case 20:
                                _c.sent();
                                return [4 /*yield*/, worker.validateDataForBlock(blockHeight, tip.height)];
                            case 21:
                                _b = _c.sent(), success_1 = _b.success, errors = _b.errors;
                                if (success_1) {
                                    console.log('REPAIR SOLVED ISSUE');
                                }
                                else {
                                    console.log('REPAIR FAILED TO SOLVE ISSUE');
                                    console.log(JSON.stringify(errors, null, 2));
                                }
                                _c.label = 22;
                            case 22: return [3 /*break*/, 29];
                            case 23: return [4 /*yield*/, block_1.BitcoinBlockStorage.collection
                                    .find({ chain: chain, network: network, height: data.payload.blockNum })
                                    .toArray()];
                            case 24:
                                dupeBlock = _c.sent();
                                if (dupeBlock.length < 2) {
                                    console.log('No action required.', dupeBlock.length, 'block');
                                    return [2 /*return*/];
                                }
                                toKeepBlock_1 = dupeBlock[0];
                                processedBlock = dupeBlock.find(function (b) { return b.processed === true; });
                                toKeepBlock_1 = processedBlock || toKeepBlock_1;
                                wouldBeDeletedBlock = dupeBlock.filter(function (c) { return c._id !== toKeepBlock_1._id; });
                                if (!dry) return [3 /*break*/, 25];
                                console.log('WOULD DELETE');
                                console.log(wouldBeDeletedBlock);
                                return [3 /*break*/, 27];
                            case 25:
                                console.log('Deleting', wouldBeDeletedBlock.length, 'block');
                                return [4 /*yield*/, block_1.BitcoinBlockStorage.collection.deleteMany({
                                        chain: chain,
                                        network: network,
                                        _id: { $in: wouldBeDeletedBlock.map(function (c) { return c._id; }) }
                                    })];
                            case 26:
                                _c.sent();
                                _c.label = 27;
                            case 27: return [3 /*break*/, 29];
                            case 28:
                                console.log('skipping');
                                _c.label = 29;
                            case 29: return [3 /*break*/, 31];
                            case 30:
                                e_2 = _c.sent();
                                console.error(e_2);
                                return [3 /*break*/, 31];
                            case 31: return [2 /*return*/];
                        }
                    });
                }); };
                getFileContents = function (FILE) {
                    fs_1.default.createReadStream(FILE)
                        .pipe(new stream_1.Transform({
                        write: transformFileChunks
                    }))
                        .on('end', function () {
                        process.exit(0);
                    })
                        .on('finish', function () {
                        process.exit(0);
                    });
                };
                getFileContents(FILE);
                return [2 /*return*/];
        }
    });
}); })();
//# sourceMappingURL=db-repair.js.map