#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var block_1 = require("../../src/models/block");
var modules_1 = require("../../src/modules");
var config_1 = require("../../src/services/config");
var storage_1 = require("../../src/services/storage");
var verification_1 = require("../../src/services/verification");
if (require.main === module) {
    (function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, _b, CHAIN, _c, NETWORK, HEIGHT, VERIFYSPENDS, resumeHeight, chain, network, chainConfig, worker, workerClass, tip, i, success;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _a = process.env, _b = _a.CHAIN, CHAIN = _b === void 0 ? '' : _b, _c = _a.NETWORK, NETWORK = _c === void 0 ? '' : _c, HEIGHT = _a.HEIGHT, VERIFYSPENDS = _a.VERIFYSPENDS;
                    resumeHeight = Number(HEIGHT) || 1;
                    chain = CHAIN || '';
                    network = NETWORK || '';
                    modules_1.Modules.loadConfigured();
                    chainConfig = config_1.Config.chainConfig({ chain: chain, network: network });
                    if (!verification_1.Verification.get(CHAIN)) return [3 /*break*/, 6];
                    workerClass = verification_1.Verification.get(CHAIN);
                    worker = new workerClass({ chain: chain, network: network, chainConfig: chainConfig });
                    worker.connect();
                    if (VERIFYSPENDS) {
                        worker.enableDeepScan();
                    }
                    return [4 /*yield*/, storage_1.Storage.start()];
                case 1:
                    _d.sent();
                    if (!chain || !network) {
                        console.log('Please provide a CHAIN and NETWORK environment variable');
                        process.exit(1);
                    }
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.getLocalTip({ chain: chain, network: network })];
                case 2:
                    tip = _d.sent();
                    if (!tip) return [3 /*break*/, 6];
                    i = resumeHeight;
                    _d.label = 3;
                case 3:
                    if (!(i <= tip.height)) return [3 /*break*/, 6];
                    return [4 /*yield*/, worker.validateDataForBlock(i, tip.height, true)];
                case 4:
                    success = (_d.sent()).success;
                    console.log({ block: i, success: success });
                    _d.label = 5;
                case 5:
                    i++;
                    return [3 /*break*/, 3];
                case 6:
                    process.exit(0);
                    return [2 /*return*/];
            }
        });
    }); })();
}
//# sourceMappingURL=db-verify.js.map