#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var block_1 = require("../../src/models/block");
var coin_1 = require("../../src/models/coin");
var modules_1 = require("../../src/modules");
var config_1 = require("../../src/services/config");
var storage_1 = require("../../src/services/storage");
if (require.main === module) {
    (function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, _b, CHAIN, _c, NETWORK, HEIGHT, chain, network, startHeight, chainConfig, FORKHEIGHT, FORKFROM, forkHeight, tip, i, success, unspentForkCoinsForBlock, unspentForkCoinsForBlock_1, unspentForkCoinsForBlock_1_1, forkCoin, toPrune, shouldPrune, error, e_1_1;
        var e_1, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _a = process.env, _b = _a.CHAIN, CHAIN = _b === void 0 ? '' : _b, _c = _a.NETWORK, NETWORK = _c === void 0 ? '' : _c, HEIGHT = _a.HEIGHT;
                    chain = CHAIN || '';
                    network = NETWORK || '';
                    startHeight = Number(HEIGHT) || 0;
                    chainConfig = config_1.Config.chainConfig({ chain: chain, network: network });
                    FORKHEIGHT = chainConfig.forkHeight;
                    FORKFROM = chainConfig.parentChain;
                    forkHeight = Number(FORKHEIGHT);
                    if (!FORKFROM || !FORKHEIGHT) {
                        console.log("There is no forkHeight or parentChain on the config for ".concat(chain, " ").concat(network));
                    }
                    if (!chain || !network) {
                        console.log('Please provide a CHAIN and NETWORK environment variable');
                        process.exit(1);
                    }
                    console.log('Searching for coins that can be removed from', chain, network, 'comparing against', FORKFROM, '<', forkHeight);
                    modules_1.Modules.loadConfigured();
                    return [4 /*yield*/, storage_1.Storage.start()];
                case 1:
                    _e.sent();
                    return [4 /*yield*/, block_1.BitcoinBlockStorage.getLocalTip({ chain: chain, network: network })];
                case 2:
                    tip = _e.sent();
                    if (!tip) return [3 /*break*/, 14];
                    i = startHeight;
                    _e.label = 3;
                case 3:
                    if (!(i <= forkHeight)) return [3 /*break*/, 14];
                    success = true;
                    return [4 /*yield*/, coin_1.CoinStorage.collection
                            .find({ chain: chain, network: network, mintHeight: i, spentHeight: -2 })
                            .toArray()];
                case 4:
                    unspentForkCoinsForBlock = _e.sent();
                    _e.label = 5;
                case 5:
                    _e.trys.push([5, 10, 11, 12]);
                    unspentForkCoinsForBlock_1 = (e_1 = void 0, __values(unspentForkCoinsForBlock)), unspentForkCoinsForBlock_1_1 = unspentForkCoinsForBlock_1.next();
                    _e.label = 6;
                case 6:
                    if (!!unspentForkCoinsForBlock_1_1.done) return [3 /*break*/, 9];
                    forkCoin = unspentForkCoinsForBlock_1_1.value;
                    return [4 /*yield*/, coin_1.CoinStorage.collection.findOne({
                            chain: FORKFROM,
                            network: network,
                            mintTxid: forkCoin.mintTxid,
                            mintIndex: forkCoin.mintIndex
                        })];
                case 7:
                    toPrune = _e.sent();
                    shouldPrune = toPrune && toPrune.spentHeight <= forkHeight && toPrune.spentHeight > 0;
                    if (shouldPrune) {
                        success = false;
                        error = {
                            model: 'coin',
                            err: true,
                            type: 'FORK_PRUNE_COIN',
                            payload: { coin: forkCoin, blockNum: i }
                        };
                        console.log(JSON.stringify(error));
                    }
                    _e.label = 8;
                case 8:
                    unspentForkCoinsForBlock_1_1 = unspentForkCoinsForBlock_1.next();
                    return [3 /*break*/, 6];
                case 9: return [3 /*break*/, 12];
                case 10:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 11:
                    try {
                        if (unspentForkCoinsForBlock_1_1 && !unspentForkCoinsForBlock_1_1.done && (_d = unspentForkCoinsForBlock_1.return)) _d.call(unspentForkCoinsForBlock_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 12:
                    console.log(JSON.stringify({ block: i, success: success, forkCoins: unspentForkCoinsForBlock.length }));
                    _e.label = 13;
                case 13:
                    i++;
                    return [3 /*break*/, 3];
                case 14:
                    process.exit(0);
                    return [2 /*return*/];
            }
        });
    }); })();
}
//# sourceMappingURL=prune-fork.js.map