import { RpcTransaction } from '../../src/modules/ripple/types';


// These are real transactions from the XRP mainnet. You may need to access a historical node to find them.
export const RippleTxs: RpcTransaction[] = [
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "4492823",
    DeliverMax: "4492823",
    Destination: "rKpTKoJSFbCoZkwydRv7NWTiBgNrdTXJ24",
    Fee: "12",
    Flags: 2147483648,
    InvoiceID: "F6751F266C7E664CB3CDAE77D091ED73E3D365591D8FA769BEA9F694C5C4A5DF",
    Sequence: 9,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "3045022100A2D1E2A0B0E01EAAA36F67F650463391E4390F9F540D4C7553E1698F866A16E002201C5CB68137805ECC73F2D4459E7840842C255065A716475CDDFCA007EA570A15",
    ctid: "C3281DBD00130000",
    date: 633208670,
    hash: "2AF40DACE9FD4FABEC690F3B54742F50E9A938FF38EFCEA6733B7B7BECBE415E",
    inLedger: 52960701,
    ledger_index: 52960701,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rKpTKoJSFbCoZkwydRv7NWTiBgNrdTXJ24",
              Balance: "159358305",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 8,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "3D770688B305A3DB581E9410411441F6DBFEFCA133AE500FB285621F5809F2CA",
            PreviousFields: {
              Balance: "154865482",
            },
            PreviousTxnID: "A47BE13328EBC2D15BBD46BF41125DA386A4142A85759A4B8A1E5939D18D1A8A",
            PreviousTxnLgrSeq: 52958408,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "61822034",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 10,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "66314869",
              Sequence: 9,
            },
            PreviousTxnID: "81346F435D877B24948AB2EBF2F8F6D98A58DAC36435395B62B38422D3A48FE4",
            PreviousTxnLgrSeq: 52889891,
          },
        },
      ],
      TransactionIndex: 19,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "4492823",
    },
    validated: true,
  },
  {
    Account: "rLNaPoKeeBjZe2qs6x52yVPZpZ8td4dc6w",
    Amount: "42238648",
    DeliverMax: "42238648",
    Destination: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Fee: "40",
    Flags: 2147483648,
    LastLedgerSequence: 52889897,
    Sequence: 465729,
    SigningPubKey: "020A46D8D02AC780C59853ACA309EAA92E7D8E02DD72A0B6AC315A7D18A6C3276A",
    TransactionType: "Payment",
    TxnSignature: "304402203904395E1E615517F449989644C59540FE6E628A5219A4D474DCEF588922F96E02202A6A5027E3A04B2127B3B5EE0CD6C42F75C248FE1D25A3D54D2BB7792F117E00",
    ctid: "C327092300100000",
    date: 632936150,
    hash: "81346F435D877B24948AB2EBF2F8F6D98A58DAC36435395B62B38422D3A48FE4",
    inLedger: 52889891,
    ledger_index: 52889891,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rLNaPoKeeBjZe2qs6x52yVPZpZ8td4dc6w",
              Balance: "19746722754480",
              Flags: 131072,
              OwnerCount: 0,
              Sequence: 465730,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "140FA03FE8C39540CA8189BC7A7956795C712BC0A542C6409C041150703C8574",
            PreviousFields: {
              Balance: "19746764993168",
              Sequence: 465729,
            },
            PreviousTxnID: "E15CE2C7396341A15AB3119599775847C035D799A5721A64321FEE6B859E62C8",
            PreviousTxnLgrSeq: 52889888,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "66314869",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 9,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "24076221",
            },
            PreviousTxnID: "6BA909FFC1CFFA080299698B1303E9BF9F5BA78C8DAF939AC4808CE10BF9DFC5",
            PreviousTxnLgrSeq: 52805982,
          },
        },
      ],
      TransactionIndex: 16,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "42238648",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "10000000",
    DeliverMax: "10000000",
    Destination: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 8,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "3044022064EBEE23A9262836F3B5D4BED5639B1EAC53A721392BEED4581735F16BFECF240220741E4B51D3CCC68C9F4F59953ADE51AFB16DB12B5876DD3C63DF24E245A0D265",
    ctid: "C325C15E00160000",
    date: 632609870,
    hash: "6BA909FFC1CFFA080299698B1303E9BF9F5BA78C8DAF939AC4808CE10BF9DFC5",
    inLedger: 52805982,
    ledger_index: 52805982,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "24076221",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 9,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "34076233",
              Sequence: 8,
            },
            PreviousTxnID: "4E4758301FBDC47A8881065DF51CC516BDD3738132A568B5A78DCD7CEB00871E",
            PreviousTxnLgrSeq: 52805924,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
              Balance: "35319625",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 4,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "FA3E20DA374003D322B4B8AB5F8A170EA2903DE7EF36EBE22CA305D4DFEBB3C7",
            PreviousFields: {
              Balance: "25319625",
            },
            PreviousTxnID: "20810F9832D068F31EAD97F1790BFDC01C41F72CA7CD32AEC61D5ECEC643165C",
            PreviousTxnLgrSeq: 52805962,
          },
        },
      ],
      TransactionIndex: 22,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "10000000",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "14076233",
    DeliverMax: "14076233",
    Destination: "rsxLvBBjMxnL6nzTHUHVyo8Zw3QuK4NTrn",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 7,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "304402206E1D207384C72B8ED2B32A8DDCD1503EE72406A80E521CCAAF64DC197F242D17022009845AA2856E12DF0B3D89060401F5CFA67E371C167EFA204218D41F751C5E64",
    ctid: "C325C12400250000",
    date: 632609641,
    hash: "4E4758301FBDC47A8881065DF51CC516BDD3738132A568B5A78DCD7CEB00871E",
    inLedger: 52805924,
    ledger_index: 52805924,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "34076233",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 8,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "34076245",
              Sequence: 7,
            },
            PreviousTxnID: "BF374F05643E4F4F5E467965BEB83D68FA9D709350D5400CD36701ECA645E9E8",
            PreviousTxnLgrSeq: 52805912,
          },
        },
      ],
      TransactionIndex: 37,
      TransactionResult: "tecNO_DST_INSUF_XRP",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "14076245",
    DeliverMax: "14076245",
    Destination: "rsxLvBBjMxnL6nzTHUHVyo8Zw3QuK4NTrn",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 6,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "304402206D750054DDC2C04D1ABA62A463486A1D30A114B83586CB469CBC37718C922A5502204AEDB3FEDCB7D967A94D050DDC0F31A9315CDD4923876191CB922CDE01591C23",
    ctid: "C325C11800120000",
    date: 632609592,
    hash: "BF374F05643E4F4F5E467965BEB83D68FA9D709350D5400CD36701ECA645E9E8",
    inLedger: 52805912,
    ledger_index: 52805912,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "34076245",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 7,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "34076257",
              Sequence: 6,
            },
            PreviousTxnID: "2C36DF881E7DCB91F469BF64E4931EE546322143D7FDEAC6DA164356A772D8AC",
            PreviousTxnLgrSeq: 52650425,
          },
        },
      ],
      TransactionIndex: 18,
      TransactionResult: "tecNO_DST_INSUF_XRP",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "1000000",
    DeliverMax: "1000000",
    Destination: "rEqj9WKSH7wEkPvWf6b4gCi26Y3F7HbKUF",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 5,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "304402206DDB3BDBCEDE604AF57B548F238AF2D00423DDDF82CE3DBBA3BF3C39A2E7022A022066079E0B0C6B57276970022A743720A21971F77D60C1EAC86C6CCC5B6B836106",
    ctid: "C32361B900100000",
    date: 632009320,
    hash: "2C36DF881E7DCB91F469BF64E4931EE546322143D7FDEAC6DA164356A772D8AC",
    inLedger: 52650425,
    ledger_index: 52650425,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "34076257",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 6,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "35076269",
              Sequence: 5,
            },
            PreviousTxnID: "87D9B5A01108424521AB8CEAFCA5736D2B254F6F2305C91BF5EBB83A64987834",
            PreviousTxnLgrSeq: 52650171,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rEqj9WKSH7wEkPvWf6b4gCi26Y3F7HbKUF",
              Balance: "37354220",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 5,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5D6C4EC5CA5C64FB8094AE2F52ECDBF191636AA8CFA396AB6A5C9CAB0EE0E2E9",
            PreviousFields: {
              Balance: "36354220",
            },
            PreviousTxnID: "DA660C7212BB532E029B1154F935384F275BD5F10349050E2BEE217C3F45C581",
            PreviousTxnLgrSeq: 52646842,
          },
        },
      ],
      TransactionIndex: 16,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "1000000",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "1000000",
    DeliverMax: "1000000",
    Destination: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 4,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "3045022100ABD5D77372CC5C9621504139AD565BF7B8059825ED264C52494A15C69E9292D70220210B4BAC514653C3BCF2529F95832FC4D4507A40428F57357E579511378E967A",
    ctid: "C32360BB00080000",
    date: 632008352,
    hash: "87D9B5A01108424521AB8CEAFCA5736D2B254F6F2305C91BF5EBB83A64987834",
    inLedger: 52650171,
    ledger_index: 52650171,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "35076269",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 5,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "36076281",
              Sequence: 4,
            },
            PreviousTxnID: "DC3EA31DED91E5CEFD3204855BE585EE4529C1C482634241B4F8C4303A0296BB",
            PreviousTxnLgrSeq: 52649960,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
              Balance: "25319649",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 2,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "FA3E20DA374003D322B4B8AB5F8A170EA2903DE7EF36EBE22CA305D4DFEBB3C7",
            PreviousFields: {
              Balance: "24319649",
            },
            PreviousTxnID: "DC3EA31DED91E5CEFD3204855BE585EE4529C1C482634241B4F8C4303A0296BB",
            PreviousTxnLgrSeq: 52649960,
          },
        },
      ],
      TransactionIndex: 8,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "1000000",
    },
    validated: true,
  },
  {
    Account: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
    Amount: "1000000",
    DeliverMax: "1000000",
    Destination: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 1,
    SigningPubKey: "031F4FE1AF209827F18D91A61739054BE9E529E4A4B1F7E2CD1913125568FE7B9E",
    TransactionType: "Payment",
    TxnSignature: "304502210087298E6F333326DD05852EEDA2C55C7CA392B4300E8A9E3265FF6B77829654A80220398D215A0B99C489C9421E59075F92D6AF04E06F927097511ABB3DE10A73AEE6",
    ctid: "C3235FE800070000",
    date: 632007542,
    hash: "DC3EA31DED91E5CEFD3204855BE585EE4529C1C482634241B4F8C4303A0296BB",
    inLedger: 52649960,
    ledger_index: 52649960,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "36076281",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 4,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "35076281",
            },
            PreviousTxnID: "5D2C1A96F5D9C9F359089830A527137C1A2BFBAF0F996059E6B0CCDD2BB9D5AF",
            PreviousTxnLgrSeq: 52649616,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
              Balance: "24319649",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 2,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "FA3E20DA374003D322B4B8AB5F8A170EA2903DE7EF36EBE22CA305D4DFEBB3C7",
            PreviousFields: {
              Balance: "25319661",
              Sequence: 1,
            },
            PreviousTxnID: "BB8BDBE21AE1C852E2039C97E3341031A5E3762F132B2ADA450139EB1E712CC3",
            PreviousTxnLgrSeq: 52649893,
          },
        },
      ],
      TransactionIndex: 7,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "1000000",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "1000000",
    DeliverMax: "1000000",
    Destination: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 3,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "304502210083083BEBC35AA0C716D336744E71D3379F3F38BE9EBB3BB3D8C37268379BB6DB022011A4659FDC5454A6BB529088BE0F0A0C83167AADFF7B3574B3D809C19C724B5E",
    ctid: "C3235E90001D0000",
    date: 632006240,
    hash: "5D2C1A96F5D9C9F359089830A527137C1A2BFBAF0F996059E6B0CCDD2BB9D5AF",
    inLedger: 52649616,
    ledger_index: 52649616,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "35076281",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 4,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "35076293",
              Sequence: 3,
            },
            PreviousTxnID: "BFF02EF98C13F011F73D36504458AFF5576B5FB4A870C5699DDDEC6755CA00C8",
            PreviousTxnLgrSeq: 52646823,
          },
        },
      ],
      TransactionIndex: 29,
      TransactionResult: "tecNO_DST_INSUF_XRP",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "1000000",
    DeliverMax: "1000000",
    Destination: "r9tDMLYTPEj3DX4SmhKW2U8cFApg7RHXZk",
    Fee: "12",
    Flags: 2147483648,
    Sequence: 2,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "304402204D5450C70519BDF7E53FD5D8F6DCC8DC6387E54E8EC5F087897300D9026B13E702200938E9A49CEC50242CAC0CFD523B8ECC7EA18EA4DA5B7B30491188F4B253C4DB",
    ctid: "C32353A7001D0000",
    date: 631995511,
    hash: "BFF02EF98C13F011F73D36504458AFF5576B5FB4A870C5699DDDEC6755CA00C8",
    inLedger: 52646823,
    ledger_index: 52646823,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "35076293",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 3,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "35076305",
              Sequence: 2,
            },
            PreviousTxnID: "6EB25C965056F8F004C83CF2D731A6BA17594D5FD17166C29C6A0DF977D64849",
            PreviousTxnLgrSeq: 52623307,
          },
        },
      ],
      TransactionIndex: 29,
      TransactionResult: "tecNO_DST_INSUF_XRP",
    },
    validated: true,
  },
  {
    Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Amount: "4923683",
    DeliverMax: "4923683",
    Destination: "rKpTKoJSFbCoZkwydRv7NWTiBgNrdTXJ24",
    Fee: "12",
    Flags: 2147483648,
    InvoiceID: "CA97FA86465F1D9B551FC9326D53315D4D171D2AE9792F4ED255D3CE539BA6CC",
    Sequence: 1,
    SigningPubKey: "030834A2B07BD552337FEA00C32E8DDDDB541BC7353DA7E982B4C191BFE432D3BE",
    TransactionType: "Payment",
    TxnSignature: "3045022100E185A7DFF32138C82C12370A6D05D48930865D2D5F5AB4938998063076C0D58202206BC28F8D274FA31B48C22E1A54A3456BCE0262A298CC4726B7B2A3165215FCA1",
    ctid: "C322F7CB00000000",
    date: 631903860,
    hash: "6EB25C965056F8F004C83CF2D731A6BA17594D5FD17166C29C6A0DF977D64849",
    inLedger: 52623307,
    ledger_index: 52623307,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rKpTKoJSFbCoZkwydRv7NWTiBgNrdTXJ24",
              Balance: "39456225",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 1,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "3D770688B305A3DB581E9410411441F6DBFEFCA133AE500FB285621F5809F2CA",
            PreviousFields: {
              Balance: "34532542",
            },
            PreviousTxnID: "D986D027D405229183A4FACD9F9A0CD4F1C3FF0F031878933932B69BF4A304B3",
            PreviousTxnLgrSeq: 52605493,
          },
        },
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "35076305",
              Flags: 0,
              OwnerCount: 0,
              Sequence: 2,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            PreviousFields: {
              Balance: "40000000",
              Sequence: 1,
            },
            PreviousTxnID: "7DDB2FF110CC94E1C21DAD6C56FE03792B38A6ECB2BC79B53F2BFB224AFDBE0F",
            PreviousTxnLgrSeq: 52623260,
          },
        },
      ],
      TransactionIndex: 0,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "4923683",
    },
    validated: true,
  },
  {
    Account: "rLNaPoKeeBjZe2qs6x52yVPZpZ8td4dc6w",
    Amount: "40000000",
    DeliverMax: "40000000",
    Destination: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
    Fee: "40",
    Flags: 2147483648,
    LastLedgerSequence: 52623267,
    Sequence: 444151,
    SigningPubKey: "020A46D8D02AC780C59853ACA309EAA92E7D8E02DD72A0B6AC315A7D18A6C3276A",
    TransactionType: "Payment",
    TxnSignature: "3044022044F25F9746BAF73197C77046D64271F1C101C8D66341CDA748E4F2BC77AB48BA022033D96C9B0DFD495C249A7025AED8A288A874CD3F300ACDBF0FAC3630BBF0B304",
    ctid: "C322F79C00650000",
    date: 631903670,
    hash: "7DDB2FF110CC94E1C21DAD6C56FE03792B38A6ECB2BC79B53F2BFB224AFDBE0F",
    inLedger: 52623260,
    ledger_index: 52623260,
    meta: {
      AffectedNodes: [
        {
          ModifiedNode: {
            FinalFields: {
              Account: "rLNaPoKeeBjZe2qs6x52yVPZpZ8td4dc6w",
              Balance: "19124296636480",
              Flags: 131072,
              OwnerCount: 0,
              Sequence: 444152,
            },
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "140FA03FE8C39540CA8189BC7A7956795C712BC0A542C6409C041150703C8574",
            PreviousFields: {
              Balance: "19124336636520",
              Sequence: 444151,
            },
            PreviousTxnID: "E16819F247091887ECFC5D68EC34E8CCCF7A62126B3AE029537DFCF47F88A904",
            PreviousTxnLgrSeq: 52623254,
          },
        },
        {
          CreatedNode: {
            LedgerEntryType: "AccountRoot",
            LedgerIndex: "5B384B0472A2532E14BE2CB6643A5B5386A1EA8F15177D288E9B0F96765F652F",
            NewFields: {
              Account: "rN33DVnneYUUgTmcxXnXvgAL1BECuLZ8pm",
              Balance: "40000000",
              Sequence: 1,
            },
          },
        },
      ],
      TransactionIndex: 101,
      TransactionResult: "tesSUCCESS",
      delivered_amount: "40000000",
    },
    validated: true,
  }
];
